
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 1024
int n,m,N,M,P,T,K;
int d[MAXN];
PI p[MAXN];
int adj[MAXN][MAXN];

const int cp(const PI &A,const PI &B,const PI &C)
{ int dx1=B.x-A.x,dy1=B.y-A.y,dx2=C.x-A.x,dy2=C.y-A.y; return dx1*dy2-dx2*dy1;  }

int around,idxinadj[MAXN][MAXN];
bool cmp(int a,int b)
{
	if (p[a].y>=p[around].y && p[b].y<p[around].y) return 0;
	if (p[a].y<p[around].y && p[b].y>=p[around].y) return 1;
	if (p[a].y==p[around].y && p[b].y==p[around].y) return p[a].x>p[around].x && p[b].x<p[around].x;
	return cp(p[around],p[a],p[b])>0;
//	return atan2(p[a].y-p[around].y,p[a].x-p[around].x)<atan2(p[b].y-p[around].y,p[b].x-p[around].x);
}

int used[MAXN];
bool banned[MAXN];

inline bool allaretotheright(const PI &A,const PI &B)
{
	  for (int i=1;i<=N;i++) if (cp(A,B,p[i])>0) return 0;
	  return 1;
}

int main()
{
    scanf("%d",&N);
    for (int i=1;i<=N;i++)
     {
			scanf("%d%d",&p[i].x,&p[i].y);
			scanf("%d",&d[i]);
			Repj(d[i])
			 scanf("%d",&adj[i][j]);
	 }
	scanf("%d",&K);
	 
	Repi(N)
	 {
	   around=i+1;
	   sort(adj[i+1],adj[i+1]+d[i+1],cmp);
	   Repj(d[i+1])
	    idxinadj[i+1][adj[i+1][j]]=j;
	 }
	
	int ans=0;
	for (int i=1;i<=N;i++)
	 {
			int next,id,total,cur,prev;
			memset(used,0,sizeof(used)); 
			memset(banned,0,sizeof(banned)); 
			Repj(d[i])
			 {
					if (banned[adj[i][j]]) continue;
					total=1;
					bool two=0,border=0;
					for(cur=adj[i][j],prev=i;cur!=i;prev=cur,cur=next)
					 {
							total++;
							if (allaretotheright(p[prev],p[cur])) border=1; //don't count the boundary!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! you missed that one..........................................................
							if (d[cur]>2) two=1;
							if (used[cur]==j+1 || total>K || cur<i) //don't repeat points, don't exceed K and make sure the starting point is with the lowest index
							    goto again;
							used[cur]=j+1;
							id=idxinadj[cur][prev];
							id--; if (id<0) id=d[cur]-1;
							next=adj[cur][id]; //go left
					 }
					if (!two) banned[prev]=1; //if they're arranged in a circle, we would otherwise count it twice (once in both directions)
					id=idxinadj[cur][prev]; id--; if (id<0) id=d[cur]-1; //otherwise we are safe because of always chosing the leftmost edge
					if (id!=j) continue; 
					if (allaretotheright(p[prev],p[cur])) border=1; //check last edge for boundary as well
					
					if (total==K && !border) ans++;
					again:;
			 }
	 }
	 
	cout<<ans<<"\n";
	
    return 0;
}
