// dp[x] = answer if we're in stop s[x] at exactly a[x] o'clock
// ...the solution that works out a dynamic is commented below
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define F(i,n) for (int i=0;i<n;i++)

#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXM 100001
#define INF 1000000001
int n,m,N,M,P,T,K;
int a[MAXM],b[MAXM],c[MAXM],d[MAXM],s[MAXM],t[MAXM];
int all[MAXM];
VI stop[MAXM],stopa[MAXM];
int posinstop[MAXM];
int dp[MAXM];

bool cmp(int x1,int x2)
{ return a[x1]<a[x2]; }

int main()
{
    scanf("%d%d%d%d",&N,&M,&P,&T);
    Repi(M)
     {
			scanf("%d%d%d%d%d%d",s+i,t+i,a+i,b+i,c+i,d+i);
			all[i]=i;
	 }
	sort(all,all+M,cmp);
	Repi(M)
	 {
			int x=all[i];
			posinstop[x]=stop[s[x]].SZ;
			stop[s[x]].PB(x);
			stopa[s[x]].PB(a[x]);
	 }
	
	memset(dp,63,sizeof(dp));
	for (int i=M-1;i>=0;i--)
	  {
			int x=all[i];
			if (s[x]==P) dp[x]=T-a[x];
			if (posinstop[x]<(int)stop[s[x]].SZ-1)
			 {
			   int next=stop[s[x]][posinstop[x]+1];
               dp[x]=min(dp[x],dp[next]+a[next]-a[x]);
			 }
			if (d[x]>T) continue;
			if (t[x]==P) dp[x]=min(dp[x],T-c[x]+b[x]-a[x]);
			if (!stop[t[x]].SZ) continue;
			if (stopa[t[x]][stopa[t[x]].SZ-1]<d[x]) continue;
			
			
			// comment the following 4 lines and uncomment the ones below to obtain a solution that works for a dynamic plan (which can be improved using rmq to cut the cycle)
			
			int y=lower_bound(stopa[t[x]].begin(),stopa[t[x]].end(),d[x])-stopa[t[x]].begin();
			if (y==stop[t[x]].SZ) continue;
			int next=stop[t[x]][y];
			dp[x]=min(dp[x],dp[next]+b[x]-a[x]+a[next]-c[x]); 
			
			
		/*	int y=lower_bound(stopa[t[x]].begin(),stopa[t[x]].end(),c[x])-stopa[t[x]].begin();
			if (y==stop[t[x]].SZ) continue;
			cout<<"     first stop after earliest arrive in "<<t[x]<<" : "<<stop[t[x]][y]<<"\n";			
			int takebusx=0;
			for (int j=y;j<stop[t[x]].SZ;j++)
			 {
					int next=stop[t[x]][j],preva=(j==y)?c[x]:a[stop[t[x]][j-1]];
					takebusx=max(takebusx,dp[next]+a[next]-preva);
					cout<<"            what if go to "<<next<<" (preva="<<preva<<") = "<<dp[next]+a[next]-preva<<"  takebusx= "<<takebusx<<"\n";
					if (a[next]>=d[x]) break;
			 }
			takebusx+=b[x]-a[x];
			cout<<"  takebusx = "<<takebusx<<"\n";
			dp[x]=min(dp[x],takebusx); */
			
			
	  }
	
	if (!stop[1].SZ)
	 {
			if (P==1) printf("%d\n",T);
			else printf("-1\n");
			return 0;
	 }
	int x=stop[1][0];
	int ans=a[x]+dp[x];
	if (dp[x]>=INF) printf("-1\n");
	else printf("%d\n",ans);
    
    return 0;
}
