//try to set each bit starting from most significant one      {1}
//choose most appropriate* v in each interval to be with that bit set      {2}
//then fix intervals:     {3}
//if interval is for a chosen v, then remove all numbers with that bit not set from the interval (<bit)    {4}
//then substract that bit from each interval (if all of its numbers have it set, that is A[i]>=bit)    {5}
//or don't alter interval if no number from it has that bit set (B[i]<bit)     {6}
//or if it has both numbers with that bit set and not set, then it surely contains the number 111...11(2) == bit-1      {7}
//which completely satisfies us for the next bits and we can fix that interval to contain only that number       
//* - we choose v trying to leave at least one interfal satisfying the last from the above contitions (containing bit-1) and       {8}
//also trying to leave the largest numbers possible for the next bits     
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N,P,K[128],A[128],B[128];
int gr[128];
bool chosenones[128];

int main()
{
    int i,j,k,l;
    scanf("%d%d",&N,&P);
    Repi(P) scanf("%d",K+i);
    Repi(N)
     scanf("%d%d",A+i,B+i);
    int br=0,gr1=0;
    Repi(N)
     {
			gr[i]=gr1;
			br++; if (br==K[gr1]) { gr1++; br=0; }
	 }
    
    int ans=0;
    for (int bit=1<<30;bit;bit>>=1) // {1}
     {
			gr1=0;
			int chosen=-1;
			memset(chosenones,0,sizeof(chosenones));
			Repi(N)
			 {
					if (gr[i]!=gr1)
					 {
 					        if (chosen>-1)
					         chosenones[chosen]=1;  // {2}
					        else break;
							chosen=-1;
							gr1=gr[i];
					 }
					
					if (B[i]&bit)
					 if (chosen==-1 || (chosen>-1 && A[chosen]<bit) || (chosen>-1 && A[i]>=bit && B[i]>A[i]))  // {2} , {8} 
					  chosen=i;
			 }
			 
	        if (chosen>-1)
	         {
	           chosenones[chosen]=1;
	           ans|=bit;
			 }
			else
			 memset(chosenones,0,sizeof(chosenones));
	         
            Repi(N) // {3}
             {
               if (chosenones[i]) // {4}
                { A[i]>?=bit; }
               if (A[i]>=bit) // {5}
                { A[i]-=bit; B[i]-=bit; }
               else if (B[i]>=bit) // {7}
                { A[i]=B[i]=bit-1; }
			 }
	 }
	cout<<ans<<"\n";
    
    return 0;
}
