#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

typedef VI chislo;
int n,m,a[128][128]; 
const int osn=1000000000; const int osnc=9;
chislo d[128][128];
bool u[128][128];

void plusravno(chislo &ret,chislo &add)
{
	ret.resize(max(ret.SZ,add.SZ));
	int o=0;
	Repi(add.SZ)
	 {
			o=o+ret[i]+add[i];
			ret[i]=o%osn;
			o/=osn;
	 }
	for (int i=add.SZ;i<ret.SZ;i++)
	 {
			o=o+ret[i];
			ret[i]=o%osn;
			o/=osn;
	 }
	if (o)
	 ret.PB(o);
}

void izvedi(chislo &num)
{
	ostringstream ss;
	for (int i=num.SZ-1;i>=0;i--)
	 {
	   ss.str(""); ss<<num[i];
	   if (i<num.SZ-1)
	    Repj(osnc-ss.str().SZ)
	     cout<<"0";
	   cout<<num[i];
	 }
}

void solve(int r,int c)
{
	if (u[r][c]) return;
	u[r][c]=1;
	chislo &ret=d[r][c];
	int rm=max(r-10,0),cm=max(c-10,0);
	for (int i=r-1;i>=rm;i--)
	 if (a[i][c]==r-i)
	  {
//			cout<<i<<" "<<c<<" to "<<r<<" "<<c<<endl;
            solve(i,c);
			plusravno(ret,d[i][c]);
	  }
	for (int i=c-1;i>=cm;i--)
	 if (a[r][i]==c-i)
	  {
//			cout<<r<<" "<<i<<" to "<<r<<" "<<c<<endl;
            solve(r,i);
			plusravno(ret,d[r][i]);
	  }
//	cout<<"---"<<r<<" "<<c<<" = "; izvedi(ret); cout<<endl;
}

int main()
{
    int i,j,k,l;
    scanf("%d",&n);
    Repi(n)
     Repj(n)
      scanf("%d",&a[i][j]);
   
    d[0][0].PB(1); u[0][0]=1;
    solve(n-1,n-1); izvedi(d[n-1][n-1]); cout<<"\n";
    
    /*
    Repi(n)
     {
			Repj(n)
			 cout<<d[i][j]<<" ";
			cout<<endl;
	 }
    */
    /*chislo tmp(5),ad(2);
    tmp[0]=tmp[1]=tmp[2]=tmp[3]=tmp[4]=9;
    ad[0]=4; ad[1]=8;
    izvedi(tmp); cout<<endl;
    izvedi(ad); cout<<endl;
    plusravno(ad,tmp);
    izvedi(ad);*/
    
    return 0;
}
