#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

//#define DBG
#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 307 
int n,m,N,M,P,T,K;
char a[MAXN][MAXN];
char **win[MAXN*MAXN][2]; //erase from level positions wchich suck 
vector<PI> level[2][MAXN*MAXN];
short int lev[2][MAXN][MAXN],levi[2][MAXN][MAXN];
int D; PI startA,startB;
PI dir[4];

inline bool sux(int x,int y)
{  return x<0 || x>=N || y<0 || y>=N; }

PI q[MAXN*MAXN];

void bfs0(int who)
{
    PI start;
    if (who) start=startB; else start=startA;
    q[0]=start; int x,y;
    lev[who][start.x][start.y]=0;
    for (int s=0,e=1;s<e;s++)
     {
            PI &v=q[s];
            Repi(4)
             {
                    x=v.x+dir[i].x,y=v.y+dir[i].y;
                    if (sux(x,y)) continue;
                    if (lev[who][x][y]>-1 || a[x][y]=='#') continue;
                    lev[who][x][y]=lev[who][v.x][v.y]+1;
                    q[e++]=MP(x,y);
             }
     }
}

bool used[MAXN][MAXN];
void bfs(int who)
{ 
    PI start;
    if (who) start=startB; else start=startA;
    q[0]=start; int x,y;
    level[who][0].PB(start);
    levi[who][start.x][start.y]=0;
    memset(used,0,sizeof(used));
    for (int s=0,e=1;s<e;s++)
     {
            PI &v=q[s];
            Repi(4)
             {
                    x=v.x+dir[i].x,y=v.y+dir[i].y;
                    if (sux(x,y)) continue;
                    if (lev[who][x][y]!=lev[who][v.x][v.y]+1 || used[x][y]) continue;
                    used[x][y]=1;
                    if (lev[who][x][y]<=(D>>1) && lev[who][x][y]+lev[!who][x][y]==D-1)
                     { vector<PI> &ll=level[who][lev[who][x][y]];
                       ll.PB(MP(x,y));
                       levi[who][x][y]=ll.SZ-1;
                     }
                    q[e++]=MP(x,y);
             }
     }
    
}






char solve(int mvs,int ai,int bi,bool turn)
{
    char &ret=win[mvs][turn][ai][bi];
    if (ret>-1) return ret;
    
    int x,y,nai,nbi,tres;
    PI &posA=level[0][mvs+turn][ai],&posB=level[1][mvs][bi];
#ifdef DBG
    cout<<"in "<<mvs<<" "<<ai<<" "<<bi<<" "<<turn<<" - A "<<posA.x<<" "<<posA.y<<"  B "<<posB.x<<" "<<posB.y<<endl;
#endif
    if (mvs==(D>>1))
     {
            if (posA==posB)
          //   if (D&1)  //read below
              {
#ifdef DBG
                    cout<<"                                declare as terminal - A is losing (B jumps over A)\n";
#endif
                    return ret=0;
              }
          /*   else //this is useless since we know that if D%2==0 , A always wins
              {
#ifdef DBG
                    cout<<"                                declare as terminal - winning (A jumps over B)\n";
#endif
                    return ret=1;
              }   */
#ifdef DBG
            cout<<"                                         declare A as winning - paths don't collide\n";
#endif
            return ret=1;
     } 
    if ((mvs<<1)+turn+abs(posA.x-posB.x)+abs(posA.y-posB.y)+1>D) 
     {
#ifdef DBG
            cout<<"                                 declare A as winning - no chance for A and B to meet\n";
#endif
            return ret=!turn;
     }
    if (!turn)
     {
            Repi(4)
             {
                    x=posA.x+dir[i].x,y=posA.y+dir[i].y;
                    if (sux(x,y)) continue;
                    if (lev[0][x][y]+lev[1][x][y]>=D || lev[0][x][y]<=mvs) continue;
                    nai=levi[0][x][y];
                    tres=solve(mvs,nai,bi,1);
#ifdef DBG
                    cout<<" from "<<mvs<<": "<<posA.x<<","<<posA.y<<" "<<posB.x<<","<<posB.y<<" 0  move A to  "<<mvs<<": "<<x<<","<<y<<" "<<posB.x<<","<<posB.y<<" ,1 = "<<tres<<endl;
#endif
                    if (!tres)
                     {
#ifdef DBG
                            cout<<"                                          declare as winning!\n";
#endif
                            return ret=1;
                        }
             }
#ifdef DBG
            cout<<"                                          declare "<<mvs<<" "<<ai<<" "<<bi<<" "<<turn<<" as losing... \n";
#endif
            return ret=0;
     }
    else
     {
            Repi(4)
             {
                    x=posB.x+dir[i].x,y=posB.y+dir[i].y;
                    if (sux(x,y)) continue;
                    if (lev[1][x][y]+lev[0][x][y]>=D || lev[1][x][y]<=mvs) continue;
                    nbi=levi[1][x][y];
                    tres=solve(mvs+1,ai,nbi,0);
#ifdef DBG
                    cout<<" from "<<mvs<<": "<<posA.x<<","<<posA.y<<" "<<posB.x<<","<<posB.y<<" 1  move B to  "<<mvs+1<<": "<<posA.x<<","<<posA.y<<" "<<x<<","<<y<<" , 0 = "<<tres<<endl;
#endif
                    if (!tres)
                     {
#ifdef DBG
                            cout<<"                                                          declare as winning!\n";
#endif
                            return ret=1;
                        }
             }
#ifdef DBG
            cout<<"                                          declare "<<mvs<<" "<<ai<<" "<<bi<<" "<<turn<<" as losing... \n";
#endif
            return ret=0;
     }
}




int main()
{
    int t;
    dir[0]=MP(-1,0); dir[1]=MP(1,0); dir[2]=MP(0,-1); dir[3]=MP(0,1);
    scanf("%d",&t);
for (;t;t--)
{
            scanf("%d",&N);
            Repi(N)
             scanf("%s",a[i]);
            Repi(N)
             Repj(N)
              if (a[i][j]=='A')
               startA=MP(i,j);
              else
               if (a[i][j]=='B')
                startB=MP(i,j);
    memset(lev,-1,sizeof(lev));
    bfs0(0);  bfs0(1);
    D=lev[1][startA.x][startA.y]+1;
    Repi((D>>1)+1) level[0][i].clear(),level[1][i].clear();
    if (!(D&1)) { cout<<"A\n"; continue; }
    bfs(0);  bfs(1);
    Repi((D>>1)+1)
     {
       win[i][0]=new char*[level[0][i].SZ+1];
       Repj(level[0][i].SZ+1)
        { win[i][0][j]=new char[level[1][i].SZ+1];
          memset(win[i][0][j],-1,level[1][i].SZ+1);
        }

       win[i][1]=new char*[level[0][i+1].SZ+1];
       Repj(level[0][i+1].SZ+1) 
        {
            win[i][1][j]=new char[level[1][i].SZ+1];
            memset(win[i][1][j],-1,level[1][i].SZ+1);
        }
     }
   
#ifdef DBG
cout<<" distance "<<D<<endl;
Repk(2)
{
    Repi(N)     {      Repj(N)       cout<<setw(2)<<lev[k][i][j];      cout<<endl;     } cout<<endl;
    Repi(N)     {      Repj(N)       cout<<setw(2)<<levi[k][i][j];      cout<<endl;     } cout<<endl;
    Repi(N+3)    {     cout<<i<<" -> ";     Repj(level[k][i].SZ)      cout<<level[k][i][j].x<<" "<<level[k][i][j].y<<" ; "; cout<<endl;    }
    cout<<"\n\n\n\n\n\n\n\n";
}
#endif
    cout<<((solve(0,0,0,0))?'A':'B')<<endl;
    
}
    return 0;
}
