//dp with compressed states
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

#define MAXN 310
const int mv[4][2]={{-1,0},{1,0},{0,-1},{0,1}};
int n,m,t;
char a[MAXN][MAXN];
vector<PI> levA[MAXN*MAXN],levB[MAXN*MAXN];
PI aA[MAXN][MAXN],aB[MAXN][MAXN];


PI q[MAXN*MAXN]; int lev[MAXN][MAXN];
void bfs(PI start,vector<PI> levels[],PI pos[][MAXN])
{
	memset(lev,-1,sizeof(lev));
	q[0]=start;
	levels[0].PB(start);
	int levc=0;
	lev[start.x][start.y]=0;
	pos[start.x][start.y]=MP(0,0);
	int x,y;
	for (int s=0,e=1;s<e;s++)
	 {
			PI &v=q[s];
			Repj(4)
			 {
					x=v.x+mv[j][0]; y=v.y+mv[j][1];
					if (x<0 || x>=n || y<0 || y>=n) continue;
					if (lev[x][y]>-1 || a[x][y]=='#') continue;
					q[e++]=MP(x,y);
					lev[x][y]=lev[v.x][v.y]+1;
					if (levc<lev[x][y]) { levels[lev[x][y]].clear(); levc=lev[x][y]; }
					pos[x][y]=MP(lev[x][y],levels[lev[x][y]].SZ);
					levels[lev[x][y]].PB(MP(x,y));
			 }
	 }
}





int dist;
int **mem[MAXN*MAXN][2];

int winning(int lev,bool turn,int apos,int bpos)
{
	int &ret=mem[lev][turn][apos][bpos];
	if (ret>-1) return ret;
	if (lev==dist) //turn==0
	 {
	   //cout<<"   trivial: "<<lev<<" "<<turn<<" "<<apos<<" "<<bpos<<" = "<<(levA[lev][apos]!=levB[lev][bpos])<<endl;
	   return ret=(levA[lev][apos]!=levB[lev][bpos]);
	 }
	
	if (!turn)
	 {
			int x,y;
			PI &at=levA[lev][apos];
			Repi(4)
			 {
					x=at.x+mv[i][0],y=at.y+mv[i][1];
					if (x<0 || x>=n || y<0 || y>=n) continue;
					if (aA[x][y].x!=lev+1 || aB[x][y].x!=aB[at.x][at.y].x-1) continue;
				//	cout<<"   from "<<lev<<" "<<turn<<" "<<apos<<" "<<bpos<<" to "<<aA[x][y].y<<"\n";
					if (!winning(lev,1,aA[x][y].y,bpos)) 
					 {
	 	 	            //    cout<<lev<<" "<<turn<<" "<<apos<<" "<<bpos<<" = 1\n";
							return ret=1;
					 }
			 }
		//	cout<<lev<<" "<<turn<<" "<<apos<<" "<<bpos<<" = 0\n";
			return ret=0;
	 }
	else
	 {
			int x,y;
			PI &at=levB[lev][bpos];
			Repi(4)
			 {
					x=at.x+mv[i][0],y=at.y+mv[i][1];
					if (x<0 || x>=n || y<0 || y>=n) continue;
					if (aB[x][y].x!=lev+1 || aA[x][y].x!=aA[at.x][at.y].x-1) continue;
				//	cout<<"   from "<<lev<<" "<<turn<<" "<<apos<<" "<<bpos<<" to "<<aB[x][y].y<<"\n";
					if (!winning(lev+1,0,apos,aB[x][y].y))
					 {
	 	 	               //  cout<<lev<<" "<<turn<<" "<<apos<<" "<<bpos<<" = 1\n";
							 return ret=1;
					 }
			 }
			//cout<<lev<<" "<<turn<<" "<<apos<<" "<<bpos<<" = 0\n";
			return ret=0;
	 }
}




char solve()
{
	PI A,B;
	Repi(n)
	 Repj(n)
	  if (a[i][j]=='A') A=MP(i,j);
	  else if (a[i][j]=='B') B=MP(i,j);
	
	bfs(A,levA,aA); dist=aA[B.x][B.y].x; if (dist%2) return 'A'; dist/=2;
//	Repi(n) { Repj(n) cout<<setw(3)<<aA[i][j].x; cout<<endl; } cout<<endl;
//	Repi(n) { Repj(n) cout<<setw(3)<<aA[i][j].y; cout<<endl; } cout<<endl<<endl;
	bfs(B,levB,aB); 
//	Repi(n) { Repj(n) cout<<setw(3)<<aB[i][j].x; cout<<endl; } cout<<endl;
//	Repi(n) { Repj(n) cout<<setw(3)<<aB[i][j].y; cout<<endl; } cout<<endl;
    Repi(dist+1)
     {
			int szA=levA[i].SZ+2,szB=levB[i].SZ+2;
			mem[i][0]=new int*[szA];
			Repj(szA) { mem[i][0][j]=new int[szB]; memset(mem[i][0][j],255,szB*sizeof(int)); }
			szA=levA[i+1].SZ+2;
			mem[i][1]=new int*[szA];
			Repj(szA) { mem[i][1][j]=new int[szB]; memset(mem[i][1][j],255,szB*sizeof(int)); }
	 }
	if (winning(0,0,0,0)) return 'A'; return 'B';
}

int main()
{
    int i,j,k,l;
    scanf("%d",&t);
    Repi(t)
     {
			scanf("%d",&n);
			Repj(n)
			 scanf("%s",a[j]);
			
			//cout<<"CASE "<<i<<":\n";
			printf("%c\n",solve());
			//cout<<endl<<endl;
	 }
    
    return 0;
}
