//1. ignore time by calculating batch costs as if each batch starts from time zero, BUT add to its original cost the cost it will add all jobs after it
// which is, in a way, treating each batch as the last one. that way we don't give a damn about the real time of each new batch because we've taken care of it in previous batches
//2. optimization : don't place new batch before where you have placed the previous one
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 10100
int N,S,T[MAXN],F[MAXN];
int sumT[MAXN],sumF[MAXN];
int dp[MAXN],prev[MAXN];
int tim[MAXN];

int main()
{
    scanf("%d%d",&N,&S);
    Repi(N) scanf("%d%d",T+i+1,F+i+1);
    sumF[0]=sumT[0]=0; Repi(N) sumF[i+1]=sumF[i]+F[i+1],sumT[i+1]=sumT[i]+T[i+1];
    
    int batchtime,newdp,batchcost;
    memset(dp,255,sizeof(dp)); dp[0]=tim[0]=0;  prev[0]=0;
    for (int i=1;i<=N;i++)
     {
            for (int j=prev[i-1];j<i;j++)
             {
                    batchtime=sumT[i]-sumT[j]+S;
                    batchcost=(sumF[N]-sumF[j])*batchtime;
                    newdp=dp[j]+batchcost;
                    if (dp[i]==-1 || dp[i]>newdp)
                     {
                         dp[i]=newdp,tim[i]=tim[j]+batchtime;
                         prev[i]=j;
                     }
             }
    }
    printf("%d\n",dp[N]);
    cout<<Time<<endl;
    
    return 0;
}
