#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define F(i,n) for (int i=0;i<n;i++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

struct row{int a,b,c; row(){}; row(int _a,int _b,int _c){a=_a,b=_b,c=_c;}  };

struct rows{string a,b,c; rows(){}; rows(string _a,string _b,string _c){a=_a,b=_b,c=_c;}  };

const int MAXN=1024;
int N,M;
rows A[2][MAXN];
row B[MAXN];
map<string,int> vars;
ULL hh[2][MAXN][MAXN];
int sz[2][MAXN][MAXN];

void read(int N,int w)
{
    Repi(N)
     {
			string x,y,z,s1;
			cin>>x>>s1>>y>>s1>>z;
			A[w][i]=rows(x,y,z);
		//  cout<<" who "<<w<<" row "<<i<<" : "<<x<<" = "<<y<<" + "<<z<<"\n";
	 }
}

map<string,VI> poss;

inline bool cmp(int N,int w,int pos,const string &s1,const string &s2)
{
	VI &a=poss[s1],&b=poss[s2];
	VI::iterator i1=lower_bound(a.begin(),a.end(),pos*2) , i2=lower_bound(b.begin(),b.end(),pos*2);
	for (; i1!=a.end() && i2!=b.end(); i1++,i2++)
	 if (*i1<*i2) return 1;
	 else if (*i1>*i2) return 0;
	if (i2==b.end()) return 1;
	return 0;
	
	/*
	VI::iterator it=lower_bound(poss[s].begin(),poss[s].end(),pos);
	if (it==poss[s].end()) return N;
	return *it;
	
/*	for (int j=pos;j<N;j++)
	 if (A[w][j].a==s) return j;
	return N; */
}

void hash(int N,int w)
{
	//cout<<"\n\n hash "<<w<<"\n";
	poss.clear();
	Repi(N) 
	 {
			poss[A[w][i].a].PB(i*2);
			poss[A[w][i].b].PB(i*2+1);
			poss[A[w][i].c].PB(i*2+1);
     } 
	Repi(N)
	 {
			LL has=0; LL cnt;
			//cout<<"  from row "<<i<<"\n";
			vars.clear();
			for (int j=i;j<N;j++)
			 {
					if ( vars.find(A[w][j].a)==vars.end() )
							vars[A[w][j].a]=B[j-i].a=vars.SZ;
					else B[j-i].a=vars[A[w][j].a];
					
					bool bb=0,cc=0;
					if (vars.find(A[w][j].b)==vars.end())
							vars[A[w][j].b]=B[j-i].b=vars.SZ,bb=1;
					else B[j-i].b=vars[A[w][j].b];
					
					if (vars.find(A[w][j].c)==vars.end())
							vars[A[w][j].c]=B[j-i].c=vars.SZ,cc=1;
					else B[j-i].c=vars[A[w][j].c];
					
					if (B[j-i].c<B[j-i].b) swap(B[j-i].b,B[j-i].c);
					if (bb && cc && cmp(N,w,j+1,A[w][j].c,A[w][j].b) )
					 swap(vars[A[w][j].c],vars[A[w][j].b]);
					
					cnt=sz[w][i][j-i]=vars.SZ+1;
					has=hh[w][i][j-i]=((has*cnt + (LL)B[j-i].a)*cnt + (LL)B[j-i].b)*cnt + (LL)B[j-i].c;
			 }
		//	Repj(N-i)
		//	 cout<<"       "<<j<<" -> "<<B[j].a<<" = "<<B[j].b<<" + "<<B[j].c<<"   ;;; ahsh "<<hh[w][i][j]<<" (sz "<<sz[w][i][j]<<")\n";
	 }
}

int main()
{
	cin>>N>>M;
	read(N,0); read(M,1);
	
	hash(N,0); hash(M,1);
	
//	cout<<"\n\n\n";
	int ans=0;
//	PI res;
	Repi(N)
	 Repj(M)
	  {
			int l=0,r=min(N-i-1,M-j-1);
		///	cout<<"  cmp "<<i<<" "<<j<<" : "<<l<<" "<<r<<"\n";
			while (l+1<r) 
		     {
					int m=(l+r)/2;
					if (hh[0][i][m]==hh[1][j][m])
					 l=m;
					else r=m-1;
			 }
			if (hh[0][i][r]==hh[1][j][r]) 
			 {
			//		cout<<"            lengthr "<<r+1<<"\n";
					ans=max(ans,r+1);
				//	if (r+1==ans) res=MP(i,j);
			 }
			else
			if (hh[0][i][l]==hh[1][j][l]) 
			 {
			//		cout<<"            lengthl "<<l+1<<"\n";
					ans=max(ans,l+1);
				//	if (l+1==ans) res=MP(i,j);
			 }
	  }
	  
	cout<<ans<<"\n";


//	Repi(ans)	 {			cout<<A[0][i+res.x].a<<" = "<<A[0][i+res.x].b<<" + "<<A[0][i+res.x].c<<"  <=>  "<<A[1][i+res.y].a<<" = "<<A[1][i+res.y].b<<" + "<<A[1][i+res.y].c<<"\n";	 }
	fprintf(stderr,"%.4lf\n",(double)clock()/CLOCKS_PER_SEC);
    return 0;
}
