//N^3 - fix x1, y1, x2 and find y2 in O(1) using 
//dp[i] = first Y such that all squares (x,y): x1<=x<=x2 && y<=Y  sum to i    and
//sum[i] = sum of all squares (x,y): x1<=x<=x2 && y<=i
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N,M,K;
int a[256][256];
int d[10100],sum[256],s[256];
PI rose[6000];
int mincl[256],minru[256],mincr[256],minrd[256]; // min row/col right/left / up/down

inline void rect(int x1,int y1,int x2,int y2)
{
	int P=(y2-y1+1)*2+(x2-x1+1)*2;
	minrd[x1]<?=P;
	minru[x2]<?=P;
	mincr[y1]<?=P;
	mincl[y2]<?=P;
//	cout<<"add "<<x1<<" "<<y1<<" "<<x2<<" "<<y2<<endl;
}

int main()
{
    int i,j,k,l;
    scanf("%d%d%d%d",&N,&M,&m,&K);
    Repi(m)
     {
			scanf("%d%d",&rose[i].x,&rose[i].y);
			rose[i].x--; rose[i].y--;
			a[rose[i].x][rose[i].y]++;
	 }
/*	Repi(N) 
	{
	 Repj(M)
	  cout<<a[i][j]<<" ";
	  cout<<endl;
	}
	cout<<endl;*/
	
	memset(mincl,127,sizeof(mincl));
	memset(minru,127,sizeof(minru));
	memset(mincr,127,sizeof(mincr));
	memset(minrd,127,sizeof(minrd));
	for (int j=0;j<N;j++)
	 {
			memset(sum,0,sizeof(sum)); //optimize - memorize sums
			for (int k=j;k>=0;k--)
			 {
					memset(d,255,sizeof(d));
					memset(s,0,sizeof(s));
					s[0]=a[k][0];
					for (int i=1;i<M;i++) s[i]=s[i-1]+a[k][i];
					Repi(M) { sum[i]+=s[i]; if (d[sum[i]]==-1) d[sum[i]]=i; }
					
					//cout<<j<<" "<<k<<" : ";	Repi(M) cout<<sum[i]<<" "; cout<<endl;
					if (d[K]>-1) rect(k,0,j,d[K]);
					Repi(M-1)
					 if (d[K+sum[i]]>-1) //memorize... + optimize rect()
					  rect(k,i+1,j,d[K+sum[i]]);
			 }
	 }
	 
	for (int i=1;i<N;i++) minru[i]<?=minru[i-1];
	for (int i=N-2;i>=0;i--) minrd[i]<?=minrd[i+1];
	for (int i=1;i<M;i++) mincl[i]<?=mincl[i-1];
	for (int i=M-2;i>=0;i--) mincr[i]<?=mincr[i+1];
	
	int ans=INF;
	for (int i=0;i<N-1;i++)
	 ans<?=minru[i]+minrd[i+1];
	for (int i=0;i<M-1;i++)
	 ans<?=mincl[i]+mincr[i+1];
    
    if (ans==INF) { cout<<"NO\n"; return 0; }
    cout<<ans<<"\n";
    
    return 0;
}
