//perfectly clean dynamic interval tree :) 
//works fine in memory & time limits like this (without deleting nodes)
//note: trying to split wherever it is convenient for us at the moment causes a MAJOR fucking up of time, memory etc
//note: no need to keep startx,endx but calc them on the go - less memory
//note: no need to merge intervals!!!!!!! this only slows down the solution!!!!!!!!!!!!!!!!!!
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL int
#define LL1 long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")


using namespace std;

int n;

struct node{ int startx,endx,deltay,maxheight; bool simple;
             node *l,*r;
             node(){};
             node(int sx,int ex,int dy,int mh,bool ss){ startx=sx,endx=ex,deltay=dy,maxheight=mh,simple=ss; l=r=0; };
           };
node *root;

void printnode(node *tree)
{
    cout<<"["<<tree->startx<<","<<tree->endx<<"]"<<tree->simple<<" "<<tree->deltay<<" "<<tree->maxheight;
}
void printree(node *tree,int lev)
{
    if (!tree->simple && tree->r) printree(tree->r,lev+1);
    Repi(lev) cout<<"     ";
    printnode(tree); cout<<endl;
    if (!tree->simple && tree->l) printree(tree->l,lev+1);
}

int sx,ex,D;

inline void splitnode(node *tree)
{
    tree->simple=0;
    if (!tree->l) tree->l=new node;
    if (!tree->r) tree->r=new node;
    int deltadeltay=tree->deltay/(tree->endx-tree->startx);
    int mid=(tree->endx+tree->startx)>>1;
    *tree->l=node(tree->startx,mid,666,1313,1); 
      tree->l->deltay=deltadeltay*(tree->l->endx-tree->l->startx);
      tree->l->maxheight=tree->l->deltay; 
    *tree->r=node(mid,tree->endx,tree->deltay-tree->l->deltay,666,1); tree->r->maxheight=tree->r->deltay;
}

void deltree(node *&tree)
{
    if (!tree) return;
    deltree(tree->l); deltree(tree->r);
    delete tree;
    tree=0;
}

inline void mergenode(node *tree)
{
    tree->maxheight=max(tree->l->maxheight,tree->r->maxheight+tree->l->deltay);
    tree->deltay=tree->l->deltay+tree->r->deltay;
//fuck merging!!!
/*    if (tree->l->deltay/(tree->l->endx-tree->l->startx)==tree->r->deltay/(tree->r->endx-tree->r->startx)
        && tree->l->simple && tree->r->simple)
      { tree->simple=1; //deltree(tree->l); deltree(tree->r);                //uncomment delete shits only if we have insufficent memory (time increases of course...)
      }
      */
}

void update(node *tree)
{
    if (tree->startx>=ex || tree->endx<=sx) return;
    if (tree->startx>=sx && tree->endx<=ex) //entire node is in interval
     {
       tree->simple=1;
       tree->maxheight=tree->deltay=D*(tree->endx-tree->startx);
     }
    else //...it's not
     {
       if (tree->simple)
        splitnode(tree);
       update(tree->l); update(tree->r);
       mergenode(tree);
     }
}

inline int query(int H)
{
    if (root->maxheight<=H) return n;
    node *tree=root;
    while (1)
     {
        if (tree->simple)
         {
           int dist=H/(tree->deltay/(tree->endx-tree->startx));
           return tree->startx+dist;
         }
        else
         if (tree->l->maxheight<=H)
          H-=tree->l->deltay,tree=tree->r;
         else 
           tree=tree->l;
     }
}


int main()
{
    scanf("%d\n",&n);
    char com; int H;
    root=new node; *root=node(0,n,0,0,1);
    
    while (1)
     {
            scanf("%c ",&com);
            if (com=='I')
             {
                    scanf("%d%d%d\n",&sx,&ex,&D);
                    sx--;
                    update(root);
             }
            else if (com=='Q')
             {
                    scanf("%d\n",&H);
                    printf("%d\n",query(H));
             }
            else break;
     }
    cout<<(double)clock()/CLOCKS_PER_SEC<<endl;
    return 0;
}
