//dp [current][next_opposite][direction]
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N,M;
VI adj[1024];
bool conn[1024][1024];
int d[1024][1024][2];

struct state{int x,y,dir; state(){}; state(int xx,int yy,int dirr):x(xx),y(yy),dir(dirr){}; };
int come[1024][1024][2];
state ans;

inline bool direction(int F,int S,int w)
{
	S=(S+N-F)%N; w=(w+N-F)%N;
	if (w>S) return 1; return 0;
}



int solve(int F,int S,int dir)
{
	int &ret=d[F][S][dir];
	if (ret>-1) return ret;
	if (F==S) return ret=1;
	ret=0;
	if (dir)
	 {
	   if (conn[F][(F+N-1)%N] && solve((F+N-1)%N,S,dir)) { come[F][S][dir]=0; return ret=1; }
	   if (conn[F][S] && solve(S,(F+N-1)%N,dir^1)) { come[F][S][dir]=1; return ret=1; }
	 }
	else
	 {
	   if (conn[F][(F+1)%N] && solve((F+1)%N,S,dir)) { come[F][S][dir]=0; return ret=1; }
	   if (conn[F][S] && solve(S,(F+1)%N,dir^1)) { come[F][S][dir]=1; return ret=1; }
	 }
	
	//cout<<F<<" "<<S<<" "<<dir<<" = "<<ret<<endl;
	return ret;
}

int main()
{
    int i,j,k,l;
    scanf("%d%d",&N,&M);
    Repi(M)
     {
			scanf("%d%d",&j,&k);
			j--; k--;
			conn[j][k]=conn[k][j]=1;
	 }
	memset(d,255,sizeof(d));
	ans.x=-1;
	bool found=0;
    Repi(N)
     {
			int i1=(i+1)%N;
			if (solve(i,i1,1)) { ans=state(i,i1,1); break; }
			if (solve(i1,i,0)) { ans=state(i1,i,0); break; }
	 }
	 
	 
	int F,S,dir;
    F=ans.x; S=ans.y; dir=ans.dir;
//    cout<<F<<" "<<S<<" "<<dir<<endl;
    if (F==-1) { cout<<"-1\n"; return 0; }
    printf("%d\n",F+1);
    while(1)
     {
       if (dir)
        {
			if (come[F][S][dir])
			 { F=(F+N-1)%N; dir^=1; swap(F,S); }
			else
			 { F=(F+N-1)%N; }
		}
       else
        {
			if (come[F][S][dir])
			 { F=(F+1)%N; dir^=1; swap(F,S); }
			else
			 { F=(F+1)%N; }
		}
      // cout<<F<<" "<<S<<" "<<dir<<endl;
       printf("%d\n",F+1);
       if (F==S) break;
	 }
    
    
    return 0;
}

