#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N;
struct tri{ int A,B,C,P,chi; bool col; tri(){}; tri(int a,int b,int c,int p,int ch,bool co):A(a),B(b),C(c),P(p),chi(ch),col(co){}; };
struct point{ int x,y,par; bool col; point(){}; point(int _x,int _y,bool _col):x(_x),y(_y),col(_col){}; };

#define MAXTR 3000000
#define MAXN 100100
tri tr[MAXTR];
point pts[MAXN];
bool u[MAXN];

int par[MAXN];
VI adj[MAXN];

//long long !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
inline int cp(int A,int B,int C)
{
	int dx1=pts[B].x-pts[A].x;
	int dx2=pts[C].x-pts[A].x;
	int dy1=pts[B].y-pts[A].y;
	int dy2=pts[C].y-pts[A].y;
	return sign((LL)dx1*dy2-(LL)dx2*dy1);
}

inline void connect(int u,int v)
{ //if (adj[u].SZ && adj[v].SZ && adj[u][adj[u].SZ-1]==v || adj[v][adj[v].SZ-1]==u) return;
  if (pts[u].col!=pts[v].col) return;
  adj[u].PB(v); adj[v].PB(u);
 // cout<<u<<"==="<<v<<endl;
}

void dfs(int v)
{
	u[v]=1;
	Repi(adj[v].SZ)
	 if (!u[adj[v][i]])
	  {
			par[adj[v][i]]=v;
			dfs(adj[v][i]);
	  }
}

int main()
{
    int i,j,k,l;
    scanf("%d",&n);
    Repi(n)
     {
			scanf("%d%d",&pts[i].x,&pts[i].y);
			pts[i].par=-1;pts[i].col=0;
	 }
    scanf("%d",&m);
    Repi(m)
     {
			scanf("%d%d",&pts[i+n].x,&pts[i+n].y);
			pts[i+n].par=-1; pts[i+n].col=1;
	 }
	
	memset(tr,-1,sizeof(tr));

	tr[0]=tri(0,n,n+1,-1,2,0); connect(0,n); connect(0,n+1); connect(n,n+1);
	tr[1]=tri(0,n+1,1,-1,5,1); connect(0,1); connect(1,n+1);
	u[0]=u[1]=u[n]=u[n+1]=1;

	int mem=8;
	N=n+m;
    Repi(N)
     if (!u[i])
 	  if (cp(0,n+1,i)>0)
      {
			pts[i].par=1;
			if (tr[1].P==-1 && tr[1].col==pts[i].col) { tr[1].P=i; u[i]=1; connect(tr[1].A,i); connect(tr[1].B,i); connect(tr[1].C,i); }
	  }
	  else
	  if (cp(0,n+1,i)<0)
	   {
			pts[i].par=0;
			if (tr[0].P==-1 && tr[0].col==pts[i].col) { tr[0].P=i; u[i]=1; connect(tr[0].A,i); connect(tr[0].B,i); connect(tr[0].C,i); }
	   }

    int lev=0,A,B,C,P,t,tt;
    bool ima;
    while(1)
     {
	//		cout<<"\nlevel "<<lev<<" - "<<mem<<endl; lev++;
			ima=0;
			Repi(N)
			 if (!u[i])
			  {
					t=pts[i].par;
					if (tr[t].P==-1)
					  { tr[t].P=i; u[i]=1; 
					    connect(tr[t].A,i); connect(tr[t].B,i); connect(tr[t].C,i);
  			//		    cout<<"                                         settt "<<i<<" of "<<t<<endl;
					    continue;
				      } //in case no good point was found (all siblings are the same color)
					ima=1;
					A=tr[t].A; B=tr[t].B; C=tr[t].C; P=tr[t].P;
					
					//assign new triangle
					if (cp(A,P,i)>0)
					 {
							if (cp(P,C,i)>0)
							 pts[i].par=tr[t].chi;
							else
							 pts[i].par=tr[t].chi+1;
					 }
					else
					 {
							if (cp(P,B,i)>0)
							 pts[i].par=tr[t].chi+1;
							else
							 pts[i].par=tr[t].chi+2;
					 }
					 
			//	    cout<<"                         "<<i<<" in "<<pts[i].par<<endl;
				    //create if doesn't exist
					tt=pts[i].par;
					if (tr[tt].A==-1)
					 {
							switch (tt-tr[t].chi)
							{
								case 0:
									 tr[tt]=tri(A,P,C,-1,mem,pts[A].col^pts[P].col^pts[C].col);
				//					 cout<<"new1 "<<tt<<" - "<<A<<" "<<P<<" "<<C<<" ; "<<mem<<" "<<tr[tt].col<<endl;
									 break;
								case 1:
									 tr[tt]=tri(C,P,B,-1,mem,pts[C].col^pts[P].col^pts[B].col);
				//					 cout<<"new2 "<<tt<<" - "<<C<<" "<<P<<" "<<B<<" ; "<<mem<<" "<<tr[tt].col<<endl;
									 break;
								case 2:
									 tr[tt]=tri(A,B,P,-1,mem,pts[A].col^pts[B].col^pts[P].col);
			//						 cout<<"new3 "<<tt<<" - "<<A<<" "<<B<<" "<<P<<" ; "<<mem<<" "<<tr[tt].col<<endl;
							}
						   mem+=3;
					 }
					
					//assign div point
					if (tr[tt].P==-1 && tr[tt].col==pts[i].col)
					 {	tr[tt].P=i; u[i]=1;
					    connect(tr[tt].A,i); connect(tr[tt].B,i); connect(tr[tt].C,i);
			//		    cout<<"                                         set "<<i<<" of "<<tt<<endl;
					 }
			  }
			if (!ima) break;
	 }
    
    memset(u,0,sizeof(u));
    par[0]=par[n]=-1;
    dfs(0);
    dfs(n);
    Repi(N)
     if (par[i]>-1)
      if (i>n)
        cout<<i-n+1<<" "<<par[i]-n+1<<" r\n";
      else
        cout<<i+1<<" "<<par[i]+1<<" g\n";
    
    return 0;
}
