#include <iostream>
#include <string> 

using namespace std;

unsigned int MIN=1,MAX;
unsigned int realM,Xc,Yc;

#define PI pair<int,int>
#define x first
#define y second
int col;

inline bool isin(unsigned int x,unsigned int y)
{
       if (x>=Xc-realM/2 && x<=Xc+realM/2 && y>=Yc-realM/2 && y<=Yc+realM/2) return true; return false;
       }

inline string check(unsigned int x,unsigned int y)
{
          if (isin(x+2*realM,y-2*realM))  return "true";
          if (isin(x+0*realM,y-2*realM))  return "true";
          if (isin(x-2*realM,y-2*realM))  return "true";
          if (isin(x+1*realM,y-1*realM)) return "true";
          if (isin(x-1*realM,y-1*realM))  return "true";
          if (isin(x+2*realM,y-0*realM))  return "true";
          if (isin(x+0*realM,y-0*realM))  return "true";
          if (isin(x-2*realM,y-0*realM))  return "true";
          if (isin(x+1*realM,y+1*realM))  return "true";
          if (isin(x-1*realM,y+1*realM))  return "true";
          if (isin(x+2*realM,y+2*realM))  return "true";
          if (isin(x+0*realM,y+2*realM))  return "true";
          if (isin(x-2*realM,y+2*realM)) return "true";
          return "false";
 }

inline unsigned int query(unsigned int x,unsigned int y)
{
       string s;
       if (x>=MIN && x<=MAX && y>=MIN && y<=MAX) {
                    cout<<"examine "<<x<<" "<<y<<endl;
//                    cin>>s;
 s=check(x,y); cout<<s<<endl;
                    if (s=="true") col=1; else col=0;
                     }
                    else    col=0;
       return col;
}

int coord[13][2]=
{
    { 2,-2 },
    { 0,-2 },
    { -2,-2 },
    { 1,-1 },
    { -1,-1 },
    { 2,0 },
    { 0,0 },
    { -2,0 },
    { 1,1 },
    { -1,1 },
    { 2,2 },
    { 0,2 },
    { -2,2 },
};

int main()
{
    pair<unsigned int,unsigned int> p;
    unsigned int l,r,i,j,k,m,M;
    
//    cin>>MAX>>p.x>>p.y;
  cin>>MAX>>realM>>p.x>>p.y>>Xc>>Yc;
    
    int st;
    
    i=1;
    while (p.x-i>=MIN)
    {
       query( p.x-i,p.y);
       if (col==0) break;
       i*=2;
    }
    if (p.x-i<MIN) i=p.x-MIN;
    l=p.x-i; r=p.x-i/2;
    if (p.x>=i)
    while (r-l>1)
     {
          m=(unsigned int)(l+r)/(unsigned int)2;
          query( m,p.y);
          if (col==0) l=m; else r=m;
     }
    st=r; 
       
    i=1;
    while (p.x+i<=MAX)
    {
       query( p.x+i,p.y);
       if (col==0) break;
       i*=2;
    }
    if (p.x+i>MAX) i=MAX-p.x;
    r=p.x+i; l=p.x+i/2;
    while (r-l>1)
     {
          m=(unsigned int)(l+r)/(unsigned int)2;
          query(m,p.y);
          if (col==0) r=m; else l=m;
     }
    M=l-st+1;
    
    string s="0000000000000";   
    s[0]=query(p.x-2*M,p.y+2*M)+'0';
    s[1]=query(p.x-0*M,p.y+2*M)+'0';
    s[2]=query(p.x+2*M,p.y+2*M)+'0';
    s[3]=query(p.x-1*M,p.y+1*M)+'0';
    s[4]=query(p.x+1*M,p.y+1*M)+'0';
    s[5]=query(p.x-2*M,p.y+0*M)+'0';
    s[6]='1';
    s[7]=query(p.x+2*M,p.y+0*M)+'0';
    s[8]=query(p.x-1*M,p.y-1*M)+'0';
    s[9]=query(p.x+1*M,p.y-1*M)+'0';
    s[10]=query(p.x-2*M,p.y-2*M)+'0';
    s[11]=query(p.x-0*M,p.y-2*M)+'0';
    s[12]=query(p.x+2*M,p.y-2*M)+'0';
    
    int sty;
    i=1;
    while (p.y-i>=MIN)
    {
       query( p.x,p.y-i);
       if (col==0) break;
       i*=2;
    }
    if (p.y-i<MIN) i=p.y-MIN;
    l=p.y-i; r=p.y-i/2;
 //   if (p.y)
   if (p.y>=i)
    while (r-l>1)
     {
          m=(l+r)/2;
          query( p.x,m);
          if (col==0) l=m; else r=m;
     }
    sty=r; 

    if (s=="1101011000000") i=12;
    if (s=="1111111100000") i=11;
    if (s=="0110101100000") i=10;
    if (s=="1101111011000") i=9;
    if (s=="0111101111000") i=8;
    if (s=="1101011010110") i=7;
    if (s=="1111111111111") i=6;
    if (s=="0110101101011") i=5;
    if (s=="0001111011110") i=4;
    if (s=="0001101111011") i=3;
    if (s=="0000011010110") i=2;
    if (s=="0000011111111") i=1;
    if (s=="0000001101011") i=0;
    
 int ansX=coord[i][0]*M + st + M/2;
 int ansY=coord[i][1]*M + sty + M/2;
 cout<<M<<endl;
    cout<<"solution "<<ansX<<" "<<ansY<<endl;
    
    if (ansX==Xc && ansY==Yc) cout<<"CORRECT\n"<<endl; else cout<<"WRONG\n";
    
    system("pause");
    return 0;
}
