#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define PI pair<int,int>
#define PD pair<double,double>
#define VI vector<int>
#define SI set<int>
#define VVI vector<vector<int> >
#define LL long long
#define IT iterator

#define Rep(n) for (int i=0; i<n; i++)
#define Repp(n) for (int j=0; j<n; j++)
#define INF 1e9
#define EPS 1e-6
#define pause system("pause")

#define up 0
#define left 1
#define down 2
#define right 3

using namespace std;

int n,m;
PI p[100100];
int e[100100][4],E[100100][4],c[100100],go[100100];
int dp[4][4]={
{3,0,1,2},
{0,1,2,3},
{1,2,3,0},
{2,3,0,1}};

bool cmp(int a,int b)
{
     if (p[a].y>p[b].y || (p[a].y==p[b].y && p[a].x<p[b].x)) return 1;
     return 0;
}

bool u[100100];

inline void del(int a,int b)
{
//       cout<<"deleting "<<a<<" "<<b<<endl;
       if (E[a][0]==b) E[a][0]=0; else
       if (E[a][1]==b) E[a][1]=0; else
       if (E[a][2]==b) E[a][2]=0; else
       if (E[a][3]==b) E[a][3]=0;
       if (E[b][0]==a) E[b][0]=0; else
       if (E[b][1]==a) E[b][1]=0; else
       if (E[b][2]==a) E[b][2]=0; else
       if (E[b][3]==a) E[b][3]=0;
}

inline void dell(int a,int b)
{
 //      cout<<"using "<<a<<" "<<b<<endl;
       if (e[a][0]==b) e[a][0]=0; else
       if (e[a][1]==b) e[a][1]=0; else
       if (e[a][2]==b) e[a][2]=0; else
       if (e[a][3]==b) e[a][3]=0;
       if (e[b][0]==a) e[b][0]=0; else
       if (e[b][1]==a) e[b][1]=0; else
       if (e[b][2]==a) e[b][2]=0; else
       if (e[b][3]==a) e[b][3]=0;
}

inline bool neighb(int a,int b)
{
//       cout<<"neighb "<<a<<" "<<b<<endl;
//       cout<<e[a][0]<<" "<<e[a][1]<<" "<<e[a][2]<<" "<<e[a][3]<<"     "
//           <<e[b][0]<<" "<<e[b][1]<<" "<<e[b][2]<<" "<<e[b][3]<<endl;
       if (E[a][0]==b) return true;
       if (E[a][1]==b) return true;
       if (E[a][2]==b) return true;
       if (E[a][3]==b) return true;
       return false;
}
int fl=0;
void dfs(int v,char dir)
{
     int v1,l;
     if (v==15160) fl++;
     if (fl==2) 
      cout<<"in "<<endl;
     Rep(4)
     {
      v1=e[v][dp[dir][i]];
      dell(v,v1);
      if (v1)
       if (!go[v1])
        {
                   go[v]=dp[dir][i]+1; c[v1]=v;
                   dfs(v1,go[v]-1);
        }
       else if (v1!=c[v] && E[v1][go[v1]-1])
        {
            l=v; //cout<<"cycle: "<<v<<" ";
            while (l!=v1)
            {  del(l,c[l]); go[l]=0; l=c[l]; //cout<<l<<" ";
             }
     //        cout<<endl;
            del(v,v1); go[v1]=0;
        } 
     }
     go[v]=0; //cout<<"out "<<v<<endl;
}

map<PI,int> w;

int main()
{
    int i,j,k,l; int d[100100];
    FILE * f=fopen("flood.in.14a","r");
    fscanf(f,"%d",&n);
    Rep(n) { fscanf(f,"%d%d",&p[i+1].x,&p[i+1].y); d[i+1]=i+1; }
    fscanf(f,"%d",&m);
    Rep(m) { fscanf(f,"%d%d",&j,&k); w[MP(k,j)]=i+1; w[MP(j,k)]=i+1;
    if (p[j].x<p[k].x) { e[j][right]=k; e[k][left]=j; }
    if (p[j].x>p[k].x) { e[j][left]=k; e[k][right]=j; }
    if (p[j].y<p[k].y) { e[j][up]=k; e[k][down]=j; }
    if (p[j].y>p[k].y) { e[j][down]=k; e[k][up]=j; }
    };
    fclose(f);
    
    sort(d+1,d+n+1,cmp);
    
    Rep(n)
     Repp(4)
      E[i+1][j]=e[i+1][j];
    
       cout<<"so far so good..."<<endl;

    Rep(n)
     if (e[d[i+1]][down])
       dfs(d[i+1],down);
       
       cout<<"so far so good..."<<endl;
       
//    vector<PI> ans;
    vector<int> ans1;
    Rep(n)
     Repp(4)
      if (E[i+1][j]!=0)
       {
//                  ans.PB(MP(i+1,E[i+1][j]));
                  ans1.PB(w[MP(i+1,E[i+1][j])]);
                  E[E[i+1][j]][(j+2)%4]=0;
       }
       
//    Rep(ans.SZ) printf("%d %d\n",ans[i].x,ans[i].y);

    printf("%d\n",ans1.SZ);
//    Rep(ans1.SZ) printf("%d\n",ans1[i]);
    
    return 0;
}
