#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>

#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define PI pair<int,int>
#define PD pair<double,double>
#define VI vector<int>
#define SI set<int>
#define VVI vector<vector<int> >
#define LL long long
#define IT iterator

#define Rep(n) for (int i=0; i<n; i++)
#define Repp(n) for (int j=0; j<n; j++)
#define INF 1e9
#define EPS 1e-6
#define pause system("pause")

using namespace std;

int n,N;
PI m[100100];
int d[100100];
int a[262144],b[262144];

int start(int p)
{
    if (p==1) return 1;
    p+=N-1;
    while (d[a[p]]==0 && p>1) 
     {
          p--;
          p>>=1;
          if (d[a[p]]!=0) break;
     }
    return a[p];
}

int end(int p)
{
    if (p==N) return N;
    p+=N-1;
    while (d[b[p]]==0 && p>1) 
     {
          p++;
          p>>=1;
          if (d[b[p]]!=0) break;
     }
    return b[p];
}

int update(int st,int en)
{
//    cout<<"updating "<<st<<" "<<en<<endl;
    en++;
    d[st]++; d[en]--;
    int s=st+N-1,e=en+N-1;
    while (s>1)
     {
          s>>=1;
          a[s]=0;
          if (d[a[s<<1]]!=0) a[s]=a[s<<1];
          if (d[a[(s<<1)+1]]!=0) a[s]=a[(s<<1)+1];
     }
    while (e>1)
     {
          e>>=1;
          a[e]=0;
          if (d[a[e<<1]]!=0) a[e]=a[e<<1];
          if (d[a[(e<<1)+1]]!=0) a[e]=a[(e<<1)+1];
     }
    s=st+N-1; e=en+N-1; 
    while (s>1)
     {
          s>>=1;
          b[s]=0;
          if (d[b[(s<<1)+1]]!=0) b[s]=b[(s<<1)+1];
          if (d[b[s<<1]]!=0) b[s]=b[s<<1];
     }
    while (e>1)
     {
          e>>=1;
          b[e]=0;
          if (d[b[(e<<1)+1]]!=0) b[e]=b[(e<<1)+1];
          if (d[b[e<<1]]!=0) b[e]=b[e<<1];
     }
}

int main()
{
    int i,j,k,l,st,en,st1,en1;
    scanf("%d",&n);
    Rep(n)
     scanf("%d%d",&m[i].x,&m[i].y);
    sort(m,m+n); 
    
    N=1; while (m[n-1].x+1>N) { a[N]=1; N*=2; }
    l=2; while (N>=l) { b[l-1]=N; l*=2; }
    Rep(N) { a[i+N]=i+1; b[i+N]=i+1; }
//          Rep(N*2) cout<<a[i]<<" "; cout<<endl;
    a[0]=1; b[0]=N; d[N]=-1;
    
    Rep(n)
    {
          j=m[i].x-m[i].y+1;
//          cout<<"adding "<<m[i].x<<" "<<m[i].y<<endl;
          if (d[j])
          { //cout<<"normal\n";
           update(j,m[i].x); }
          else
           {
              k=start(j); l=end(j);
//              cout<<"group is "<<k<<" "<<l<<endl;
              if (m[i].x<l)
              {
//                 cout<<"fully in group\n";
                 st=k; en=st+m[i].y-1;
                 update(st,en);
              }
              else
              {
//                 cout<<"partly in group\n";
                 st=k; en=k+l-j-1;
                 update(st,en);
                 st=l; en=m[i].x;
                 update(st,en);
              }
           } 
//          Rep(N) cout<<d[i+1]<<" "; cout<<endl;
//          Rep(N*2) cout<<a[i]<<" "; cout<<endl;
//          Rep(N*2) cout<<b[i]<<" "; cout<<endl;
    }
    
    int t=0; long long S=0;
    Rep(m[n-1].x)
    { t+=d[i+1]; //cout<<t<<" ";
      S+=(LL)t*(LL)((LL)t-(LL)1)/(LL)2; }
//      cout<<endl;
      cout<<S<<endl;
//    printf("%Ld\n",S);
    
    return 0;
}
