/*
ID: pascala1
PROG: 
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
int d[16][16];

void print()
{
			Repi(n)
			 {
			  Repj(m)
			   cout<<setw(3)<<d[i][j];
			  cout<<"\n";
			 }
}

bool tryfill(int r,int c,int col)
{
//	cout<<r<<" "<<c<<" "<<col<<":\n";     print(); system("pause");

	if (r==n-1)
	 { if (col==m*n/3+1) return 1; return 0; }
	if (c==m)
	 return tryfill(r+1,0,col);
	if (d[r][c]) return tryfill(r,c+1,col);
	d[r][c]=col;
	if (c<m-1)
	 {
			if (!d[r][c+1])
			 {
			   d[r][c+1]=col; d[r+1][c+1]=col; if (tryfill(r,c+2,col+1)) return 1;
			   d[r+1][c+1]=0;
		     }
			if (!d[r+1][c])
			 {
					d[r+1][c]=col;
					if (d[r][c+1]==col) if (tryfill(r,c+2,col+1)) return 1;
					                    else d[r][c+1]=0;
					d[r+1][c+1]=col; if (tryfill(r,c+1,col+1)) return 1;
					d[r+1][c+1]=0;
			 }
			else d[r][c+1]*=(d[r][c+1]!=col);
	 }
	if (c && !d[r+1][c-1])
	 {
	   d[r+1][c-1]=col; d[r+1][c]=col; if (tryfill(r,c+1,col+1)) return 1;
	   d[r+1][c-1]=0;
	 }
    d[r+1][c]=0; d[r][c]=0;
	return 0;
}

char dp[15][15][1<<15][2];
bool banned[15][15];

char solve(int r,int c,int mask,int below)
{
	char &ret=dp[r][c][mask][below];
	if (ret>-1) return ret;
	if (c==m) return ret=solve(r+1,0,mask,0);
	
	if (mask&(1<<c) || banned[r][c]) 
	 {
//	        cout<<r<<": forced from "<<c<<" "<<bitset<4>(mask)<<" "<<below<<"   to   "<<c+1<<" "<<bitset<4>((mask^((!banned[r][c])<<c))|(below<<c))<<" 0\n";
			return ret=solve(r,c+1,(mask^((!banned[r][c])<<c))|(below<<c),0);
		}
	
	ret=0;

	if (c<m-1 && !(mask&(1<<c+1)) && !banned[r+1][c+1] && !banned[r][c+1]) { 
//	 cout<<r<<": 0from "<<c<<" "<<bitset<4>(mask)<<" "<<below<<"   to   "<<c+2<<" "<<bitset<4>( (mask|(1<<c+1)) | (below<<c))<<" 0\n"; 
	 ret>?=solve(r,c+2,( (mask|(1<<c+1)) | (below<<c)),0); 
	 }

	if (c<m-1 && !(mask&(1<<c+1)) && !below && !banned[r+1][c] && !banned[r][c+1]) {
//	 cout<<r<<": 1from "<<c<<" "<<bitset<4>(mask)<<" "<<below<<"   to   "<<c+2<<" "<<bitset<4>(mask|(1<<c))<<" 0\n"; 
     ret>?=solve(r,c+2,mask|(1<<c),0); 
	 }

	if (c<m-1 && !below && !banned[r+1][c+1] && !banned[r+1][c]) { 
//	 cout<<r<<": 2from "<<c<<" "<<bitset<4>(mask)<<" "<<below<<"   to   "<<c+1<<" "<<bitset<4>(mask|(1<<c))<<" 1\n"; 
      ret>?=solve(r,c+1,mask|(1<<c),1);
	 }

	if (c && !(mask&(1<<c-1)) && !below && !banned[r+1][c-1] && !banned[r+1][c]) { 
//	 cout<<r<<": 3from "<<c<<" "<<bitset<4>(mask)<<" "<<below<<"   to   "<<c+1<<" "<<bitset<4>(mask|(3<<c-1))<<" 0\n"; 
      ret>?=solve(r,c+1,mask|(3<<c-1),0); 
	 }
	
//	cout<<"                  =====         "<<r<<" "<<c<<" "<<bitset<4>(mask)<<" "<<below<<"  -  "<<(int)ret<<endl;
	return ret;
}

void init()
{
			    memset(dp[n-1],0,sizeof(dp[n-1]));
			    dp[n-1][0][(1<<m)-1][0]=1;
}

vector<PI> a1,ra1;
vector<pair<PI,PI> > a2,ra2;

int equiv(PI A,PI B)
{
	int ret=0;
	if (A==B) ret|=1;
    A.x=n-A.x-1;
	if (A==B) ret|=2;
    A.y=m-A.y-1;
	if (A==B) ret|=4;
    A.x=n-A.x-1;
	if (A==B) ret|=8;
	
	if (n==m)
	 {
	   A=MP(m-A.y-1,A.x);
	if (A==B) ret|=16;
    A.x=n-A.x-1;
	if (A==B) ret|=32;
    A.y=m-A.y-1;
	if (A==B) ret|=64;
    A.x=n-A.x-1;
	if (A==B) ret|=128;
	 }
	
	
	return ret;
}

int main()
{
    int i,j,k,l;
    scanf("%d%d",&n,&m);
    
    if (n*m%3==0)
     {
			if (!tryfill(0,0,1)) {  cout<<"0\n"; return 0; }
			print();
//			init();	cout<<(int)solve(0,0,0,0)<<"\n";
	 }
	else 
	 if (n*m%3==1)
	 {
			    memset(dp,255,sizeof(dp));
			for (int tryx=0;tryx<=n/2+n%2;tryx++)
			 for (int tryy=0;tryy<=m/2+n%2;tryy++)
			  {
				init();
				Repi(tryx+1)
				 memset(d[i],255,sizeof(d[i]));
				
				banned[tryx][tryy]=1;
			    if (solve(0,0,0,0))
			     a1.PB(MP(tryx,tryy));
			    banned[tryx][tryy]=0;
			  }
			sort(ALL(a1));
			Repi(a1.SZ)
			 { bool ad=1;
			   Repj(i)
			    if (equiv(a1[i],a1[j])) {ad=0; break;}
			   if (ad) ra1.PB(a1[i]);
			 }
			cout<<ra1.SZ<<"\n";
			
			Repi(ra1.SZ) cout<<ra1[i].x+1<<" "<<ra1[i].y+1<<"\n";
	 }
	else
	 {
//			int tryx=0,tryy=0,tryx1=1,tryy1=0;
			    memset(dp,255,sizeof(dp));
  		    for (int tryx=0;tryx<=n/2+1;tryx++)
			 for (int tryy=0;tryy<=m/2+1;tryy++)
			  for (int tryx1=0;tryx1<=n/2+1;tryx1++)
			   for (int tryy1=0;tryy1<=m/2+1;tryy1++) 
			    if (abs(tryx1-tryx)+abs(tryy1-tryy)==1) 
			    {
				 bool imago=0;
				 Repi(a2.SZ) if ((equiv(MP(tryx,tryy),a2[i].x)&equiv(MP(tryx1,tryy1),a2[i].y)) || (equiv(MP(tryx,tryy),a2[i].y)&equiv(MP(tryx1,tryy1),a2[i].x))) {imago=1; break;}
				 if (imago) continue;
				 init(); //optimize - memset-vai s 0 samo do reda tryx
				 Repi(max(tryx,tryx1)+1)
				  memset(dp[i],255,sizeof(dp[i]));
				 banned[tryx][tryy]=1;
				 banned[tryx1][tryy1]=1;
				 dp[n-1][0][((1<<m)-1)^((tryx==n-1)<<tryy)^((tryx1==n-1)<<tryy1)][0]=1;
			     if (solve(0,0,0,0))
						a2.PB(MP(MP(tryx,tryy),MP(tryx1,tryy1)));
			     banned[tryx][tryy]=0;
			     banned[tryx1][tryy1]=0;
			    }
			
			sort(ALL(a2));
	//		Repi(a2.SZ) cout<<a2[i].x.x<<" "<<a2[i].x.y<<" "<<a2[i].y.x<<" "<<a2[i].y.y<<"\n";	cout<<"dfgdgdsgsdgdsgdsfg\n";
			
/*			
			Repi(a2.SZ)
			{
			 bool add=1;
			 Repj(i)
			  {
//			   cout<<i<<" "<<j<<" -> "<<equiv(a2[i].x,a2[j].x)<<" "<<equiv(a2[i].y,a2[j].y)<<"  ;  "<<equiv(a2[i].y,a2[j].x)<<" "<<equiv(a2[i].x,a2[j].y)<<endl;
			   if ((equiv(a2[i].x,a2[j].x)&equiv(a2[i].y,a2[j].y)) ||
			       (equiv(a2[i].y,a2[j].x)&equiv(a2[i].x,a2[j].y)) ) {add=0; break;}
			  }
			 if (add) ra2.PB(a2[i]);
			} */
			
			cout<<a2.SZ<<"\n";
			Repi(a2.SZ)
			 cout<<a2[i].x.x+1<<" "<<a2[i].x.y+1<<"  "<<a2[i].y.x+1<<" "<<a2[i].y.y+1<<"\n";  
	 }
    
 //   system("pause");
    return 0;
}
