#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
#define MAXN 10100
pair<PI,PI> p[MAXN];

inline int cp(PI &A,PI &B,PI &C)
{
	int dx1=B.x-A.x;
	int dy1=B.y-A.y;
	int dx2=C.x-A.x;
	int dy2=C.y-A.y;
	return dx1*dy2-dx2*dy1;
}

inline bool isin(pair<double,double> &X,PI &A,PI &B)
{
    return (X.x>=(double)min(A.x,B.x)-1e-7 && X.x<=(double)max(A.x,B.x)+1e-7 && X.y>=(double)min(A.y,B.y)-1e-7 && X.y<=(double)max(A.y,B.y)+1e-7); //EPS
}

inline bool intersect(PI &A,PI &B,PI &C,PI &D)
{
	int num1=cp(A,C,D),den1=cp(A,C,B)+cp(A,B,D);
	int num2=cp(C,B,A),den2=cp(C,B,D)+cp(C,D,A);
//	cout<<num<<" "<<den<<endl;
	if (!den1)
	 {
			if (cp(A,C,D)) return 0;
			if ((A.x>=C.x && A.x<=D.x) || (C.x>=A.x && C.x<=B.x)) return 1;
			return 0;
	 }
/*	pair<double,double> X;
	X.x=(double)A.x+(double)(B.x-A.x)*num/den;
	X.y=(double)A.y+(double)(B.y-A.y)*num/den;
	return isin(X,A,B)&&isin(X,C,D); */
//	cout<<num1<<" "<<den1<<"    "<<num2<<" "<<den2<<endl;
	return abs(num1)<=abs(den1) && abs(num2)<=abs(den2) && sign(num1)==sign(den1) && sign(num2)==sign(den2);
}

int main()
{
    int i=0,j,k,l;
    while (scanf("%d%d%d%d",&p[i].x.x,&p[i].x.y,&p[i].y.x,&p[i].y.y)!=EOF) i++;
    n=i;
    Repi(n) if (p[i].x>p[i].y) swap(p[i].x,p[i].y);
    sort(p,p+n); reverse(p,p+n);
    
	 
	int ans=0;
    Repi(n)
     for (int j=i-1;j>=0;j--)
      if (p[j].x.x>p[i].y.x) break;
      else ans+=intersect(p[i].x,p[i].y,p[j].x,p[j].y);
    cout<<ans<<endl;
    return 0;
}
