//root[i][j] = k : dp[i][k-1]+dp[k+1][j] + tam cenata da se smuknat s 1n level nadolu da e minimalno
//nqma smisal da tarsi6 k predi root[i][j-1] i sled root[i+1][j]
//aa i cost-funkciqta BAVI....
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;
#define MAXN 2048

int S[MAXN],sum[MAXN];
int dp[MAXN][MAXN];
int root[MAXN][MAXN];

inline int cost(int st,int en)
{	return (st>en)?0:dp[st][en]+sum[en]-sum[st-1]; }

int par[MAXN];
char lr[MAXN];

void buildtree(int st,int en,int parent)
{
	if (st>en) return;
//	par[root[st][en]]=parent;
	lr[root[st][en]]=(parent>en)?'<':'>';
	if (parent)
	 printf("%d %d %c\n",root[st][en],parent,lr[root[st][en]]);
	buildtree(st,root[st][en]-1,root[st][en]);
	buildtree(root[st][en]+1,en,root[st][en]);
}

int main()
{
    scanf("%d%d",&N,&M);
    Repi(N)
     {
       scanf("%d",S+i+1);
       sum[i+1]=sum[i]+S[i+1];
	 }
     
    memset(dp,127,sizeof(dp));
    for (int i=1;i<=N;i++) dp[i][i]=0,root[i][i]=i;
    
      int tmp,j;
      for (int step=2;step<=N;step++)
       for (int i=1;i<=N-step+1;i++)
        {
		 j=i+step-1;
	//	 cout<<i<<" "<<j<<" -> ";
         for (int k=root[i][j-1];k<=root[i+1][j];k++)
          {
		   tmp=(i<k)*(dp[i][k-1]+sum[k-1]-sum[i-1]) + (k<j)*(dp[k+1][j]+sum[j]-sum[k]);
		   //  cost(i,k-1)+cost(k+1,j);
		 //  cout<<tmp<<" ";
           if (dp[i][j]>tmp)
            {
	 		 dp[i][j]=tmp;
	 		 root[i][j]=k;
	        }
		  }
	     //cout<<"= "<<dp[i][j]<<" , "<<root[i][j]<<endl;
	    }
    
    printf("%d\n",root[1][N]);
    buildtree(1,N,0);
    
    cout<<Time<<endl;
    return 0;
}
