//bf with optim:
//keep sorted list of available vertices to connect and successively try all consequtive triples (n1,n2,n3) by removing n2 from list and adding
//a n1-n3 diagonal to current solution. preserve uniqueness by adding each new triangle to multiset<PI> where it->x and it->y are the ordered smaller two
//two sides of the triangle (in terms of number-of-vertices-distance). also, keep list of accessed sets of triangles for each level to avoid duplication as early as possible
//runtime: WOW (last optimization really razbi!)
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N;

set<multiset<PI> > used[32];
vector<vector<PI> > ans;
multiset<PI> curh;
vector<PI> cur;
set<int> available;

void bruteforce(int lev)
{
	if (used[lev].find(curh)!=used[lev].end()) return;
	used[lev].insert(curh);
	if (available.SZ==2)
	 {
			ans.PB(cur);
	//		Repi(cur.SZ) cout<<cur[i].x<<" "<<cur[i].y<<" "; cout<<"\n"; cout<<" = "; for (multiset<PI>::IT it=curh.begin(); it!=curh.end(); it++) cout<<it->x<<","<<it->y<<" "; cout<<endl;
			return;
	 }
	set<int>::IT it;
	int n1,n2,n3;
	VI ds,tr;
	for (it=available.begin(); it!=available.end(); it++) tr.PB(*it);
	for (int i=1;i<tr.SZ-1;i++ )
	 {
			n2=tr[i]; n1=tr[(i-1+tr.SZ)%tr.SZ]; n3=tr[(i+1)%tr.SZ];
			ds.clear();
			ds.PB(min(abs(n1-n2),N-abs(n1-n2)));
			ds.PB(min(abs(n2-n3),N-abs(n2-n3)));
			ds.PB(min(abs(n1-n3),N-abs(n1-n3)));
			sort(ALL(ds));

		//	cout<<"     try "<<n1<<" "<<n2<<" "<<n3<<" : "; Repj(3) cout<<ds[j]<<" "; cout<<endl;
			
			cur.PB(MP(n1,n3));
			curh.insert(MP(ds[0],ds[1]));
			available.erase(n2);
			
			bruteforce(lev+1);
			
			available.insert(n2);
			cur.pop_back();
			curh.erase(curh.find(MP(ds[0],ds[1])));
	 }
}

int main()
{
    int i,j,k,l;
    
    cin>>N; N+=2;
    Repi(N) available.insert(i);
    bruteforce(0);
    
    cout<<ans.SZ<<endl;
    Repj(ans.SZ)
    {
     Repi(ans[j].SZ-1) cout<<ans[j][i].x+1<<" "<<ans[j][i].y+1<<" "; cout<<"\n";
	}
    
    //pause;
    return 0;
}
