//try all vertices: dijkstra + check all edges if still burning after last burnt vertex
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,M,N;
VI a[128],c[128];
int d[128];
double best;
int val[128];
bool u[128];

void dijkstra(int v)
{
	memset(d,63,sizeof(d));
	memset(u,0,sizeof(u));
	PQ<PI,vector<PI>,greater<PI> > q;
	d[v]=0;
	PI t;
	q.push(MP(0,v));
	while (!q.empty())
	 {
			t=q.top();
			q.pop();
			if (u[t.y]) continue;
			u[t.y]=1;
			t.x=d[t.y]=d[t.y]+val[t.y];
			Repi(a[t.y].SZ) 
			 {
					v=a[t.y][i];
					if (d[v]>t.x+c[t.y][i] && !u[v])
					 {
							d[v]=t.x+c[t.y][i];
							q.push(MP(d[v],v));
					 }
			 }
	 }
}

int main()
{
    int i,j,k,l;
    scanf("%d%d",&N,&M);
    memset(a,63,sizeof(a));
    Repi(M)
     {
			scanf("%d%d%d",&j,&k,&l);
			a[j].PB(k); a[k].PB(j);
			c[j].PB(l); c[k].PB(l);
			val[j]++; val[k]++;
	 }
	 
	best=1e100; double L,x;
	for (int v=1;v<=N;v++)
	 {
			dijkstra(v);
	//		cout<<v<<": ";
			double ret=0;
			Repi(N) ret>?=d[i+1];
			
		//	Repi(N) cout<<d[i+1]<<" "; cout<<endl;
			for (int i=1;i<=N;i++)
			 Repj(a[i].SZ)
			  {
					k=a[i][j]; L=c[i][j];
					if (k<i || d[i]+L<ret || d[k]+L<ret) continue;
					x=(double)(d[k]-d[i]+L)*.5;
					ret>?=d[i]+x;
			//		cout<<i<<" "<<k<<" -> "<<" "<<d[i]<<" + "<<x<<" = "<<d[k]<<" + "<<L-x<<endl;
			  }
		//	cout<<ret<<endl;
			best<?=ret;
	 }
	printf("%.1lf\n",best);
    
    return 0;
}
