//dp + optim:
//go backward from i & keep most "poking" edges from both coasts to check whether j is visible from i
//if they overlap (the "pokers":) - terminate
//MORE: don't search before from[i-1] !!!!! - key optimization
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
double d[21000];
PI a[21000];
pair<PI,int> all[21000];
int from[21000];

PI A,B,C;
inline int cp(int a,int b,int c)
{
	A=all[a].x; B=all[b].x; C=all[c].x;
	int dx1=B.x-A.x;
	int dx2=C.x-A.x;
	int dy1=B.y-A.y;
	int dy2=C.y-A.y;
	return dx1*dy2-dx2*dy1;
}
inline int cp(PI A,PI B,PI C)
{
	int dx1=B.x-A.x;
	int dx2=C.x-A.x;
	int dy1=B.y-A.y;
	int dy2=C.y-A.y;
	return dx1*dy2-dx2*dy1;
}

inline double dist(int p1,int p2)
{ return hypot(all[p1].x.x-all[p2].x.x,all[p1].x.y-all[p2].x.y);   }

bool cmp(const pair<PD,int> &a,const pair<PD,int> &b)
{
	return (a.x.y==b.x.y)?(a.x.x<b.x.x):(a.x.y<b.x.y);
}

bool sepresi4at(PI A,PI B,PI C,PI D)
{
	int n1=cp(A,C,D),d1=cp(A,C,B)+cp(A,B,D);
	int n2=cp(C,B,A),d2=cp(C,B,D)+cp(C,D,A);
	if (sign(d1)!=sign(n1) || sign(d2)!=sign(n2)) return 0;
	if (abs(n1)<abs(d1) && abs(n2)<abs(d2)) 
	
	{
		cout<<"                             "<<n1<<" "<<d1<<" "<<n2<<" "<<d2<<endl;
			return 1;
		}
	return 0;
}

int main()
{
    int i,j,k,l;
    scanf("%d%d",&n,&m);
    Repi(n)
    {
		scanf("%d%d",&a[i].x,&a[i].y);
		all[i]=MP(a[i],-i-1);
	}
    Repi(m)
    {
		scanf("%d%d",&a[i+n].x,&a[i+n].y);
		all[i+n]=MP(a[i+n],i+1);
	}
	sort(all,all+n+m,cmp);

    int l1,l2;
    from[0]=from[1]=0;
    d[1]=a[n].x-a[0].x;
    for (int i=2;i<n+m;i++)
    {
  	  l1=l2=i;
      d[i]=1e100; double nd;
  	   for (int j=i-1;j>=from[i-1];j--)
  	    {
	        if (cp(i,l2,j)<=0 && cp(i,l1,j)>=0) 
			 {   nd=d[j]+dist(i,j); 
			     if (d[i]>nd) {d[i]=nd; from[i]=j;}
			     if (all[j].y<0) l1=j;
			     else l2=j;
			 }
			else if ((all[j].y>0 && cp(i,l1,j)<0) || (all[j].y<0 && cp(i,l2,j)>0)) break;
			if ((l2>l1 && cp(i,l2,l1)>0) || (l1>l2 && cp(i,l1,l2)<0)) break;
		} 
     
     /*
     if (from[i]>-1)
     {
      Repk(n-1)
       if (sepresi4at(all[i].x,all[fr].x,a[k],a[k+1])) { cout<<all[i].y<<" from "<<all[fr].y<<" fucked by "<<-k-1<<"!\n"; break;}
      Repk(m-1)
       if (sepresi4at(all[i].x,all[fr].x,a[k+n],a[k+n+1])) { cout<<all[i].y<<" from "<<all[fr].y<<" fucked by "<<k+1<<"!\n"; break;}
	 }
	 from[i]=fr; */
//  	  cout<<"in "<<i<<": "<<all[i].x.x<<" "<<all[i].x.y<<" "<<all[i].y<<" ; "<<" = "<<d[i]<<" ("<<fr<<")"<<endl;
	}
	
    printf("%.5lf\n",d[n+m-1]);
    return 0;
}
