/*
ID: pascala1
PROG: 
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N,M;
VD cost[1024];
VI adj[1024];
double d[1024][1024];
double ANS=1e100,tans;
vector<pair<PI,double> > E;
int L[1024],Lj,Lk;

void dijkstra(int v,double d[])
{
	Repi(N) d[i]=1e100;
	bitset<1024> u;
	d[v]=0;
	PQ<pair<double,int>,vector<pair<double,int> >,greater<pair<double,int> > > q;
	q.push(MP(0,v));
	while (!q.empty())
	 {
			pair<double,int> t=q.top();
			q.pop();
			if (u[t.y]) continue;
			tans=max(tans,t.x);
		//	if (tans>ANS) return;
			u[t.y]=1;
			Repi(adj[t.y].SZ)
			 {
			    v=adj[t.y][i];
			    if (!u[v] && d[v]>t.x+cost[t.y][i])
			     {
						d[v]=t.x+cost[t.y][i];
						q.push(MP(d[v],v));
				 }
			 }
	 }
}

VI J;
inline double calcmax(int j,int k,double x,double y)
{
	double ret=0;
	Repi(J.SZ)
			ret=max(ret,min( d[j][J[i]]+x , d[k][J[i]]+y ));
	return ret;
}

int main()
{
    int i,j,k,l; double xax,x;
    scanf("%d%d",&N,&M);
    Repi(M)
     {
			scanf("%d%d%lf",&j,&k,&xax); j--; k--;
			adj[j].PB(k);
			adj[k].PB(j);
			cost[j].PB(xax);
			cost[k].PB(xax);
			E.PB(MP(MP(j,k),xax));
	 }
    
    Repi(N)
     {
	   tans=0;
       dijkstra(i,d[i]);
  //     cout<<i<<" -> "; Repj(N) cout<<d[i][j]<<" "; cout<<endl;
       L[i]=0; Repj(N) if (d[i][j]>d[i][L[i]]) L[i]=j;
       ANS<?=tans;
	 }

//	cout<<setprecision(4)<<fixed<<ANS<<endl;
	
	Repi(M)
	 {
			j=E[i].x.x,k=E[i].x.y,xax=E[i].y;
			J.clear();
			for (int l=0;l<N;l++) if (d[j][l]+xax>ANS || d[k][l]+xax>ANS) J.PB(l);
			double L=0,R=xax,L1,R1;
			if (calcmax(j,k,0,xax)<calcmax(j,k,1e-6,xax-1e-6)) continue;
			
			while (R-L>1e-6)
			 {
					L1=(L*2.+R)/3.;
					R1=(L+R*2.)/3.;
					if (calcmax(j,k,L1,xax-L1)<calcmax(j,k,R1,xax-R1))
					 R=R1;
					else
					 L=L1;
			 }
			ANS=min(ANS,calcmax(j,k,L,xax-L));

			/*
			//fa6ta dosta slu4ai, ma e gre6no!
			for (int l=0;l<N;l++) if (d[j][l]>d[j][Lj] || (d[j][l]==d[j][Lj] && d[k][l]<d[k][Lj])) Lj=l;
			for (int l=0;l<N;l++) if (d[k][l]>d[k][Lk] || (d[k][l]==d[k][Lk] && d[j][l]<d[j][Lk])) Lk=l;
			if (d[j][Lk]<ANS && d[k][Lj]<ANS)
			 {
					x=(d[k][Lj]+xax-d[j][Lk])/2.;
					cout<<j<<" "<<k<<" ("<<xax<<") - "<<d[j][Lj]<<" "<<d[k][Lk]<<" ; "<<d[j][Lk]<<" "<<d[k][Lj]<<" ; "<<x<<" "<<ANS<<endl;
					ANS<?=d[j][Lk]+x; 
					cout<<"     "<<Lj<<" "<<Lk<<" : "; for (int l=0;l<N;l++) cout<<min(d[j][l]+x,d[k][l]+xax-x)<<" "; cout<<endl;
			 }
			 */
	 }

	cout<<setprecision(4)<<fixed<<ANS<<endl;
    
    return 0;
}
