//1vo praim DAG posle za seki (kraen) vrah longest path + second longest path ot vs varhove sled kato sme mahnali ku6tite ot 1viq
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

#define MAXN 2048
int n,m;
int d[MAXN],come[MAXN],val[MAXN],out[MAXN],oval[MAXN],od[MAXN];
VI adj[MAXN],radj[MAXN],nadj[MAXN];
int N;
bool u[MAXN];
int gr[MAXN],grc;
int st[MAXN],stc;
bool M[MAXN][MAXN];

//strongly connected component

void dfs1(int v)
{
	u[v]=1;
	Repi(adj[v].SZ)
	 if (!u[adj[v][i]])
	  dfs1(adj[v][i]);
	st[stc++]=v;
}

void dfs2(int v)
{
	u[v]=1;
	gr[v]=grc; val[grc]++;
	Repi(radj[v].SZ)
	 if (!u[radj[v][i]])
	  dfs2(radj[v][i]);
}

//dp

int solve1(int v,bool fuckcome) // ako e slow - 2 funkcii
{
	if (d[v]>-1) return d[v];
	d[v]=0; if (!fuckcome) come[v]=-1;
	Repi(nadj[v].SZ)
	 {
	  int w=nadj[v][i];
	  if (solve1(w,fuckcome)>d[v])
	   {
			if (!fuckcome) come[v]=w;
			d[v]=solve1(w,fuckcome);
	   }
	 }
	d[v]+=val[v];
	return d[v];
}

int main()
{
    int i,j,k,l;
    scanf("%d%d",&N,&m);
    Repi(m)
     {
			scanf("%d%d",&j,&k); j--; k--;
			adj[j].PB(k);
			radj[k].PB(j);
	 }
    
    Repi(N)
     if (!u[i])
      dfs1(i);
    reverse(st,st+N);
    
    memset(u,0,sizeof(u));
    Repi(N)
     if (!u[st[i]])
      {
			dfs2(st[i]);
			grc++;
	  }
  
  //	Repi(N) cout<<val[i]<<" "; cout<<endl;
  	
  	int w,v;
  	Repi(N)
  	 Repj(adj[i].SZ)
  	  {
	   v=gr[i],w=gr[adj[i][j]];
  	   if (v!=w && !M[v][w])
  	    {
			nadj[w].PB(v);
			out[v]++;
		//	cout<<v<<" -> "<<w<<endl;
			M[v][w]=1;
	    }
	  }
	
	//work with connected components only  
	
	N=grc;
	memset(d,255,sizeof(d));
	Repi(N)
	 d[i]=solve1(i,0);
    
//    Repi(N) cout<<i<<" "<<d[i]<<" "<<come[i]<<endl;
    
    memcpy(oval,val,sizeof(int)*N);
    memcpy(od,d,sizeof(int)*N);
    int ans=0;
    Repi(N)
     if (!out[i])
      {
			v=i;
			while (v>-1) { val[v]=0; v=come[v]; }
//			cout<<i<<" "<<od[i]<<": "; Repj(N) cout<<val[j]<<" "; cout<<endl;
			
			memset(d,255,sizeof(d));
			
			Repj(N)
			 if (!out[j])
			  ans=max(ans,od[i]+solve1(j,1));
			
			memcpy(val,oval,sizeof(int)*N);
	  }
    cout<<ans<<endl;
    
    return 0;
}
