#include <iostream>
#include <fstream>

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

using namespace std;

#define MAXN 150
#define INF 2000000000

int N,M,a[MAXN][MAXN];
int d[MAXN][MAXN][MAXN];

int solve(int diag,int r1,int r2)
{
	int c1=diag-r1,c2=diag-r2;
	if (r1<0 || c1<0 || r2<0 || c2<0) return -INF;
	int &r=d[diag][r1][r2];
	if (r>-1) return r;
	r>?=solve(diag-1,r1,r2);
	r>?=solve(diag-1,r1-1,r2);
	r>?=solve(diag-1,r1,r2-1);
	r>?=solve(diag-1,r1-1,r2-1);
	r+=a[r1][c1]+a[r2][c2]*(r1!=r2 || c1!=c2); //spoko - nqma 6ans da se okajat minali prez 1no i su6to kvadrat4e po razli4no vreme prosto 6toto
	//sbora ot koordinatite im vinagi e 1n i su6t i prez 1n diagonal minavat po 1no i su6to vreme i nqma kak da stane nomera :)
//	cout<<r1<<" "<<c1<<" "<<r2<<" "<<c2<<" = "<<r<<endl;
	return r;
}



int main()
{
	scanf("%d%d",&N,&M);
	Repi(N)
	 Repj(M)
	  scanf("%d",&a[i][j]);

    memset(d,255,sizeof(d));
    d[0][0][0]=a[0][0];
    cout<<solve(N+M-2,N-1,N-1)<<"\n";
}
