#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,k1,k2,k3;
int maxx=20;
typedef pair<int,LL> tip4e;

set<tip4e> d[103][103]; // MAP >?!?!?!!!?
bool u[103][103];
string znaci;

inline int dig(LL num)
{
	if (num<0) num=-num;
	int ret=0; while(num) {ret++; num/=10LL;}
	return max(1,ret);
}

void solve(int st,int en)
{
	if (u[st][en]) return;
	set<tip4e>::iterator i1,i2,it;
	tip4e tmp;
	for (int i=st;i<en;i++)
	 {
			solve(st,i); solve(i+1,en);
					for (i1=d[st][i].begin(); i1!=d[st][i].end(); i1++)
					 for (i2=d[i+1][en].begin(); i2!=d[i+1][en].end(); i2++)
					  {
//	cout<<"in "<<st<<" "<<en<<" : "<<i1->y<<" "<<znaci[i]<<" "<<i2->y<<" "<<i1->x<<" "<<i2->x<<endl;
							if (d[st][en].SZ==maxx) { it=d[st][en].end(); it--; } //tva nz dali e po-dobre ili po-zle
							if (znaci[i]=='+') tmp=MP( i1->x+i2->x+(dig(i1->y)+dig(i2->y))*k1 , i1->y+i2->y );
							else if (znaci[i]=='-') tmp=MP( i1->x+i2->x+(dig(i1->y)+dig(i2->y))*k2 , i1->y-i2->y );
							else tmp=MP( i1->x+i2->x+dig(i1->y)*dig(i2->y)*k3 , i1->y*i2->y );
						    if (d[st][en].SZ==maxx && tmp>*it) break;
							d[st][en].insert(tmp);
					  }
			while (d[st][en].SZ>maxx) { it=d[st][en].end(); d[st][en].erase(--it); }
	 }
//	cout<<st<<" "<<en<<" -> ";
//	for (it=d[st][en].begin(); it!=d[st][en].end(); it++) cout<<it->x<<" "<<it->y<<" ; ";
//	cout<<endl;
}

int main()
{
    int i,j,k,l;
    string s;
    cin>>s>>k1>>k2>>k3;
//    s="1+4*4"; k1=10; k2=1; k3=1;
    
    Repi(s.SZ/2+1) { u[i][i]=1;  d[i][i].insert(MP(0,s[i*2]-'0'));  }
    Repi(s.SZ/2) znaci+=s[i*2+1];
    
    maxx=10000000/(s.SZ*s.SZ*s.SZ);
    maxx<?=30;
    cout<<maxx<<endl;
    
    
    solve(0,s.SZ/2);
    
    cout<<d[0][s.SZ/2].begin()->x<<endl;
    
//    system("pause");
    return 0;
}
