#include <iostream>
#include <fstream>
#include <vector>
#include <iomanip>
#include <bitset>
#include <queue>

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

using namespace std;

#define MAXN 150
#define INF 2000000000
#define VI vector<int>
#define PB push_back
#define SZ size()
#define MP make_pair
#define PI pair<int,int>
#define x first
#define y second

int N,T;
PI ppl[15];

/*
int d[2][1<<14];
int solve(bool hah,int state)
{
	int &r=d[hah][state];
	if (r>-1) return r;
	r=INF;
	
	for (int i=1;i<(1<<N);i++)
	 if ((i|state)==state)
	  {
			int pay=0,weight=0;
			Repj(N) if ((1<<j)&i) { pay>?=ppl[j].x; weight+=ppl[j].y; }
			if (T<weight) continue;
			int tmp=(~(i^state))&((1<<N)-1);
	        cout<<hah<<" "<<bitset<4>(state)<<" <?= "<<pay<<" + "<<(hah^1)<<" "<<bitset<4>(tmp)<<" ("<<bitset<4>(i)<<" moved)"<<endl;
			r<?=pay+solve(hah^1, (~(i^state))&((1<<N)-1) );
	  }
	
	cout<<hah<<" "<<bitset<4>(state)<<" = "<<r<<endl;
	return r;
}
*/

int d[1<<15];
bool u[1<<15];
int pay[1<<14];
bool can[1<<14];

int dijkstra(int start,int dest)
{
	priority_queue<PI,vector<PI>,greater<PI> > q;
    memset(d,127,sizeof(d));
	PI t; int go;
	q.push(MP(0,start));
	d[start]=0;
	while (!q.empty())
	 {
			t=q.top();
			q.pop();
			if (u[t.y]) continue;
			if (t.y==dest) break;
			u[t.y]=1;
			int cutt=t.y&((1<<N)-1);
			for (int i=1;i<=cutt;i++)
			 if ((i|t.y)==t.y && can[i])
			  {
					go=(~(i^t.y))&((1<<N)-1); go|=((1<<N)&t.y)^(1<<N);
					if (d[t.y]+pay[i]<d[go])
					 {
							d[go]=d[t.y]+pay[i];
			//		        cout<<"from "<<bitset<5>(t.y)<<" to "<<bitset<5>(go)<<"   :   "<<d[go]<<" = "<<d[t.y]<<" + "<<pay<<endl;
							q.push(MP(d[go],go));
					 }
			  }
	 }
	return d[dest];
}

int main()
{
	scanf("%d%d",&N,&T);
	Repi(N)
	  scanf("%d%d",&ppl[i].x,&ppl[i].y);
	 
/*
	memset(d,255,sizeof(d));
	d[0][(1<<N)-1]=0;
	int ans=solve(1,(1<<N)-1);
	if (ans==INF) ans=0;
	cout<<ans<<endl;
*/

    Repi(1<<N)
     {
			int wei=0;
			Repj(N) if ((1<<j)&i) { pay[i]>?=ppl[j].x; wei+=ppl[j].y; }
			can[i]=wei<=T;
	 }
    int ans=dijkstra((1<<N)-1,(1<<N+1)-1);
    if (ans>=INF) ans=0;
    cout<<ans<<endl;
	
	return 0;
}
