#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <numeric>
#include <utility>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <string>

using namespace std;

#define Repi(n) for (int i=0;i<(n);i++)
#define Repj(n) for (int j=0;j<(n);j++)
#define Repk(n) for (int k=0;k<(n);k++)
#define sign(x) (((x)>0)-((x)<0))
#define PI pair<int,int>
#define PD pair<double,double>
#define MP make_pair
#define UI unsigned int
#define x first
#define y second
#define ALL(v) (v).begin(),(v).end()
#define IT iterator
#define VI vector<int>
#define VD vector<double>
#define PB push_back
#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define pause system("pause")
#define LL long long
#define PQ priority_queue
#define INF 2000000000
#define SZ size()

#define MAXN 20001000

const int basec=1;
LL base=11;
UI mod[3]={6661327,6661349,6661313};
UI *pows[basec];
UI *hash[basec];

int N,M,n,m,K;
char s[MAXN];

//overflow!!!!!

inline UI quickpow(UI a,int p,int mod)
{
	UI ans=1;
	while (p)
	 {
			if (p&1) ans=((LL)ans*(LL)a%(LL)mod);
			a=(LL)a*(LL)a%(LL)mod; p>>=1;
	 }
	return ans;
}

inline UI inverse(UI x,int mod)
{
    int u1=1,u2=0,u3=x,v1=0,v2=1,v3=mod,t1,t2,t3,q;
    while (u3%v3)
     {
			q=u3/v3;
			t1=u1-q*v1,t2=u2-q*v2,t3=u3-q*v3;
			u1=v1,u2=v2,u3=v3;
			v1=t1,v2=t2,v3=t3;
	 }
//	cout<<"     inv gcd "<<x<<" -> "<<v1<<"*"<<x<<" + "<<v2<<"*"<<mod<<" = 1    = "<<v1*x+v2*mod<<endl;
	return (v1+mod)%mod; //?!?!?!?!?!?
}

inline UI geosum(UI a1,UI q,int cnt,int mod,int i)
{
	UI num1=((LL)a1*(LL)(pows[i][N]-1)%(LL)mod);
	UI num=num1;
	UI den=q-1;
//	cout<<"\n sum "<<(pows[i][N]-1)<<" "<<a1<<" "<<q<<" "<<cnt<<" ("<<quickpow(q,cnt,mod)<<") = "<<num<<"/"<<den<<endl;
//	cout<<"1/"<<den<<" = "<<inverse(den,mod)<<endl;
	return (LL)num*(LL)inverse(den,mod)%(LL)mod;
}

clock_t st;
int solve()
{
	Repi(basec) { hash[i][0]=0; pows[i][0]=1; }
	for (int i=1;i<=N;i++)
	 Repj(basec)
	  {
	   hash[j][i]=((LL)hash[j][i-1]*base+(UI)(s[i]-'0'))%mod[j];
	   pows[j][i]=(LL)pows[j][i-1]*base%(LL)mod[j];
	  }
	
	cout<<"hashed\n"; st=clock();
//	Repi(N+1) cout<<hash[0][i]<<" "; cout<<endl;
//	Repi(N+1) cout<<hash[1][i]<<" "; cout<<endl;
//	Repi(N+1) cout<<pows[0][i]<<" "; cout<<endl;
//	Repi(N+1) cout<<pows[1][i]<<" "; cout<<endl;
	
	bool ok;
	for (int i=1;i<N;i++)
	 if (N%i==0) 
	  {
		ok=1;
	//	cout<<i<<"("<<s[i]<<") -> "; 
		Repj(basec)
		 {
		//   cout<<geosum(hash[j][i],pows[j][i],N/i,mod[j],j)<<" ";
	       if ( geosum(hash[j][i],pows[j][i],N/i,mod[j],j) != hash[j][N] ) {ok=0; break;}
		 }
//		cout<<endl;
	    if (ok) return i;
	 }
	//cout<<"DFGG\n";
	return N;
}

int main()
{
	scanf("%s",s+1);
	
	N=strlen(s+1);
	//resize basec 
	cout<<"read!\n";
	Repi(basec) pows[i]=new UI[N+10];
	Repi(basec) hash[i]=new UI[N+10];
	
	printf("%d\n",solve());
	
	cout<<(double)(clock()-st)/CLOCKS_PER_SEC<<endl;
	
    return 0;
}
