//dp - left, right + BIT za next state
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;
#define MAXN 2048

int n,m,N,all;
int a[MAXN],b[MAXN];
int bit[MAXN*5];

inline void push(int pos)
{
	all++;
	for (;pos<=n;pos+=pos&(-pos))
	 bit[pos]++;
}

inline int query(int pos)
{
	int ret=0;
	for (;pos;pos-=pos&(-pos))
	 ret+=bit[pos];
	return ret;
}

inline int qry(int start,int end)
{ return query(end)-query(start);  }

int d[MAXN][MAXN];

int main()
{
    
    scanf("%d",&N);
    Repi(N)
     scanf("%d",a+i);
    Repi(N)
     scanf("%d",b+i);
    
    n=1;
    while (n<=2*N) n*=2;
    
    memset(d,127,sizeof(d)); d[0][0]=0;
    int tmp;
    for (int A=0;A<=N;A++)
    {
	  memset(bit,0,sizeof(bit));
	  all=0;
	  Repi(A) push(a[i]);
      for (int B=0;B<=N;B++)
       {
			tmp=qry(0,a[A]);
			d[A+1][B]<?=d[A][B]+min(tmp,all-tmp); //optimize * <?=
		//	cout<<A<<" "<<B<<" ("<<d[A][B]<<") -> "<<A+1<<" "<<B<<" <?= "<<d[A][B]<<" + "<<tmp<<" , "<<all-tmp<<" = "<<d[A+1][B]<<"\n";
			tmp=(b[B]<=N)?qry(b[B],N):qry(N,b[B]);
			d[A][B+1]<?=d[A][B]+min(tmp,all-tmp);
		//	cout<<A<<" "<<B<<" ("<<d[A][B]<<") -> "<<A<<" "<<B+1<<" <?= "<<d[A][B]<<" + "<<tmp<<" , "<<all-tmp<<" = "<<d[A][B+1]<<"\n";
			if (B<N) push(b[B]);
	   }
	}
	cout<<d[N][N]<<endl;
    return 0;
}
