//try each vertice + pair of neighbours to be the separation point of the two sms path and the first edges of the ongoing two paths
//same as 50 points, only that we also choose where to advance
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

#define MAXN 4096
int n,m,N,A,B,C;
VI adj[MAXN],badj[MAXN],cost[MAXN],bcost[MAXN];
int d[MAXN],come[MAXN],comecost[MAXN],dC[MAXN],comeC[MAXN],comecostC[MAXN],dB[MAXN],comeB[MAXN],comecostB[MAXN];
bool used[MAXN];

void bdijkstra(int v,int d[],int come[],int comecost[])
{
    PQ<PI,vector<PI>,greater<PI> > q;
    memset(used,0,sizeof(used));
    q.push(MP(0,v)); PI t;
    memset(d,127,sizeof(int)*(N+1)); d[v]=0;
    while (!q.empty())
     {
			t=q.top();
			q.pop();
			if (used[t.y]) continue;
			used[t.y]=1;
			Repi(badj[t.y].SZ)
			 {
					v=badj[t.y][i];
				//	cout<<"from "<<t.y<<" to "<<v<<" - "<<used[v]<<" "<<d[v]<<" > "<<d[t.y]<<" + "<<bcost[t.y][i]<<endl;
					if (!used[v] && bcost[t.y][i]+d[t.y]<d[v])
					 {
							come[v]=t.y;
							comecost[v]=bcost[t.y][i];
							d[v]=bcost[t.y][i]+d[t.y];
							q.push(MP(d[v],v));
					 }
			 }
	 }
}

int main()
{
    int i,j,k,l,v;
    scanf("%d%d%d%d",&N,&A,&B,&C);
    Repi(N)
     {
			scanf("%d",&l);
			adj[i+1].resize(l); cost[i+1].resize(l);
			Repj(l)
			 {
					scanf("%d%d",&adj[i+1][j],&cost[i+1][j]);
					badj[adj[i+1][j]].PB(i+1); bcost[adj[i+1][j]].PB(cost[i+1][j]);
			 }
	 }
	 
    PQ<PI,vector<PI>,greater<PI> > q;
    memset(used,0,sizeof(used));
    q.push(MP(0,A)); PI t;
    memset(d,127,sizeof(d)); d[A]=0;
    while (!q.empty())
     {
			t=q.top();
			q.pop();
			if (used[t.y]) continue;
			used[t.y]=1;
			Repj(adj[t.y].SZ)
			 {
					int v=adj[t.y][j];
					if (!used[v] && cost[t.y][j]+d[t.y]<d[v])
					 {
							come[v]=t.y;
							comecost[v]=cost[t.y][j];
							d[v]=cost[t.y][j]+d[t.y];
							q.push(MP(d[v],v));
					 }
			 }
	 }
	bdijkstra(B,dB,comeB,comecostB);
	bdijkstra(C,dC,comeC,comecostC);

    int best=INF,bmed=0,bnextC,bnextB,nextC,nextB,btmp;
    for (int med=1;med<=N;med++)
     {
			int tek=0,tmp;
			l=med;
			while (l!=A)
			 {
					tek+=comecost[l];
					l=come[l];
					if (!l) {tek=-1; break;}
			 }
			if (tek==-1 || tek>best) continue;
			
			for (int j=0;j<adj[med].SZ;j++)
			 for (int k=0;k<adj[med].SZ;k++)
			  {
					tmp=max(cost[med][j],cost[med][k]);
					nextB=adj[med][j],nextC=adj[med][k];
					if (dB[nextB]>INF || dC[nextC]>INF) continue;
					if (tek+tmp+dB[nextB]+dC[nextC]<best)
					 {
							best=tek+tmp+dB[nextB]+dC[nextC];
							bmed=med; btmp=tmp;
							bnextB=nextB; bnextC=nextC;
					 }
			  }
			if (med==B && tek+dC[med]<best)
			 {
					best=tek+dC[med];
					bmed=med; btmp=comecostC[med];
					bnextB=0; bnextC=comeC[med];
			 }
			if (med==C && tek+dB[med]<best)
			 {
					best=tek+dB[med];
					bmed=med; btmp=comecostB[med];
					bnextB=comeB[med]; bnextC=0;
			 }
	 }
	 
	vector<PI> ans;
	
	l=bmed;
	while (l!=A)
	 {
			ans.PB(MP(come[l],comecost[l]));
			l=come[l];
	 }
	reverse(ALL(ans));
	
	l=bmed;
	ans.PB(MP(l,btmp));
	
	l=bnextB;
	while (l && l!=B)
	 {
			ans.PB(MP(l,comecostB[l]));
			l=comeB[l];
	 }
	l=bnextC;
	while (l && l!=C)
	 {
			ans.PB(MP(l,comecostC[l]));
			l=comeC[l];
	 }
	 
	
	printf("%d %d\n",ans.SZ,best);
	Repi(ans.SZ)
	 {
			printf("%d %d\n",ans[i].x,ans[i].y);
	 }

    return 0;
}
