#include <iostream>
#include <bitset>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define SI short int

SI N,R,C,R1,C1,R2,C2,T;

struct pos{ SI R,C,R1,C1,R2,C2,time1,time2; bool super; 
pos() {};
pos(SI _R,SI _C,SI _R1,SI _C1,SI _R2,SI _C2,bool _super,SI _time1,SI _time2):
	  R(_R),C(_C),R1(_R1),C1(_C1),R2(_R2),C2(_C2),super(_super),time1(_time1),time2(_time2) {};
};

bool trap[8][8];
int maze[8][8];
int come[1<<25];
pos a[10000];

inline int code(pos &a)
{	return a.R+(a.C<<3)+(a.R1<<6)+(a.C1<<9)+(a.R2<<12)+(a.C2<<15)+(a.super<<18)+(a.time1<<19)+(a.time2<<22); }

inline void decode(int X,pos &a)
{
	a.R=X&7;
	a.C=(X>>3)&7;
	a.R1=(X>>6)&7;
	a.C1=(X>>9)&7;
	a.R2=(X>>12)&7;
	a.C2=(X>>15)&7;
	a.super=(X>>18)&1;
	a.time1=(X>>19)&7;
	a.time2=(X>>22)&7;
}

int q[2000000],hod[2000000];
int mv[4][2]={{0,-1},{0,1},{-1,0},{1,0}};

void print(pos n)
{
	for (int i=1; i<=N; i++)
	{
	 for (int j=1; j<=N; j++)
	  if (i==n.R1 && j==n.C1)
	   if (n.super)
	    cout<<"S"; else cout<<"1";
	  else if (i==n.R2 && j==n.C2 && !n.super)
	   cout<<"2";
	  else if (i==n.R && j==n.C)
	   cout<<"I";
	  else if (trap[i][j]) cout<<"*";
	  else cout<<"-";
	 cout<<endl;
    }
}

int main()
{
	int j,k,l;
	scanf("%d%d%d%d%d%d%d%d",&N,&R,&C,&R1,&C1,&R2,&C2,&T);
	Repi(T)
	{
	 scanf("%d%d",&j,&k);
	 trap[j][k]=1;
	}
	Repi(N)
	 Repj(N)
	  scanf("%d",&maze[i+1][j+1]);

	memset(come,255,sizeof(come));
	pos t=pos(R,C,R1,C1,R2,C2,0,0,0),n;
	q[0]=code(t); hod[0]=0; int ans=0;
	int end=-1,start=q[0];
	for (int s=0,e=1;s<e;s++) //rotating queue?
	 {
		//	if (s>5) break;
			decode(q[s],t);
		  //  cout<<"hod "<<hod[s]<<" !!!!!!!!!!!!!!! AT "<<t.R<<","<<t.C<<", "<<t.R1<<","<<t.C1<<" "<<t.R2<<","<<t.C2<<" "<<t.super<<" "<<t.time1<<" "<<t.time2<<endl;
		  //  print(t);
			Repi(4)
			{
			 n=t; n.R+=mv[i][0]; n.C+=mv[i][1];
			 if (!trap[n.R][n.C] && !(maze[t.R][t.C]&(1<<i)))
			  {
					bool dead=false;
 				    int dc,dr,nc,nr,or1,oc;
		//			cout<<"-GO HERO!\n";
				    if (!n.super)
				     {
							if (n.time1) n.time1--;
							if (n.time2) n.time2--;
							Repj(2)
							 {
							  if (!n.time1)
							   {
								or1=n.R1; oc=n.C1;
								if (n.C1>n.C) { dc=-1; nc=1; }
								else
								if (n.C1<n.C) { dc=1; nc=2; }
								if (n.R1>n.R) { dr=-1; nr=4; }
								else
								if (n.R1<n.R) { dr=1; nr=8; }
								
								if (n.C1==n.C || maze[n.R1][n.C1]&nc)
								 { if (n.R1!=n.R && !(maze[n.R1][n.C1]&nr))
								    n.R1+=dr; }
								else
								 n.C1+=dc;
								if (n.C1==n.C && n.R1==n.R) {dead=1; break;}
								if (trap[n.R1][n.C1] && (n.C1!=oc || n.R1!=or1)) n.time1=4;
							   }

								 
							  if (!n.time2)
							   {
								or1=n.R2; oc=n.C2;
								if (n.C2>n.C) { dc=-1; nc=1; }
								else
								if (n.C2<n.C) { dc=1; nc=2; }
								if (n.R2>n.R) { dr=-1; nr=4; }
								else
								if (n.R2<n.R) { dr=1; nr=8; }
								
								if (n.C2==n.C || maze[n.R2][n.C2]&nc)
								 { if (n.R2!=n.R && !(maze[n.R2][n.C2]&nr))
								    n.R2+=dr; }
								else
								 n.C2+=dc;
								if (n.C2==n.C && n.R2==n.R) {dead=1; break;}
								if (trap[n.R2][n.C2] && (n.C2!=oc || n.R2!=or1)) n.time2=4;
							   }

				//				cout<<"monsters : "<<n.R1<<","<<n.C1<<" "<<n.R2<<","<<n.C2<<" "<<n.super<<" "<<n.time1<<" "<<n.time2<<endl;
								if (n.R1==n.R2 && n.C1==n.C2) { n.super=1; break; }
							 }
					 }
					else 
					 {
							Repj(3)
							  {
								if (n.C1>n.C) { dc=-1; nc=1; }
								else
								if (n.C1<n.C) { dc=1; nc=2; }
								if (n.R1>n.R) { dr=-1; nr=4; }
								else
								if (n.R1<n.R) { dr=1; nr=8; }
								
								if (n.C1==n.C || maze[n.R1][n.C1]&nc)
								 { if (n.R1!=n.R && !(maze[n.R1][n.C1]&nr))
								    n.R1+=dr; }
								else
								 n.C1+=dc;
								if (n.C1==n.C && n.R1==n.R) {dead=1; break;}
								
							  }
					 }
				 //   print(n);
				 //   cout<<"hero is "; if (!dead) cout<<"ALIVE :)\n\n"; else cout<<"DEAD :(\n\n";
					int tmp=code(n);
					if (n.R<1 || n.C<1 || n.R>N || n.C>N) { end=tmp; come[end]=q[s]; ans=hod[s]+1; break;}
					if (!dead && come[tmp]==-1)
					 { come[tmp]=q[s]; hod[e]=hod[s]+1; q[e++]=tmp; }
			  }
			}
			if (end!=-1) break;
	 }
	
	int ac=0;
	while (end!=start)
	 { decode(end,a[ac++]); end=come[end]; }
	decode(start,a[ac++]);
	reverse(a,a+ac); 

//	Repi(ac) { print(a[i]); cout<<endl; }


    R=a[0].R; C=a[0].C;
	cout<<ans<<endl;
	for (int i=1; i<ac; i++)
	 {
			if (R-1==a[i].R && C==a[i].C) { R--; cout<<"0\n"; }
			if (R+1==a[i].R && C==a[i].C) { R++; cout<<"1\n"; }
			if (R==a[i].R && C-1==a[i].C) { C--; cout<<"2\n"; }
			if (R==a[i].R && C+1==a[i].C) { C++; cout<<"3\n"; }
	 }
	
	return 0;
}
