#include <iostream>
#include <fstream>
#include <set>
#include <vector>

using namespace std;

#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define MP make_pair
#define x first
#define y second
#define PB push_back
#define VI vector<int>
#define ALL(v) (v).begin(),(v).end()
#define SZ size()
#define PI pair<int,int>
#define pause system("pause")
#define LL long long

#define tip VI
const int osn=1000000000,osnc=9;

void izvedi(tip a)
{
     int k=a.SZ-1,l,p,M;
     while (a[k]==0 && k>0) k--; M=k;
     for (;k>=0;k--)
      {
                    l=a[k]; p=(a[k]==0);
                    while (l>0) { p++; l/=10; }
                    if (k!=M) Repi(osnc-p) cout<<"0";
                    cout<<a[k];
      }
}


tip plus1(tip a,tip b)
{
    tip c;
    a.resize(max(a.SZ,b.SZ)); b.resize(a.SZ); c.resize(a.SZ);
    int o=0;
    Repi(a.SZ)
     {
              c[i]=(a[i]+b[i]+o)%osn;
              o=(a[i]+b[i]+o)/osn;
     }
    if (o>0 || a.SZ==0) c.PB(o);
 //   izvedi(a); cout<<" + "; izvedi(b); cout<<" = "; izvedi(c); cout<<endl;
    return c;
}

tip operator+(const tip &a,const tip &b)
{ return plus1(a,b); }

tip mul1(tip &a,long b)
{
    tip c;
    c.resize(a.SZ);
    int o=0;
    Repi(a.SZ)
    {
              c[i]=((LL)a[i]*(LL)b+(LL)o)%(LL)osn;
              o=((LL)a[i]*(LL)b+(LL)o)/(LL)osn;
    }
    if (o>0 || a.SZ==0)
     c.PB(o);
    return c; 
}

tip operator*(tip &a,const long b)
{ return mul1(a,b); }

tip mul(tip a,tip b)
{
    if (a.SZ>b.SZ) swap(a,b);
    tip ans,t; ans.PB(0);
    Repi(a.SZ)
    {
      t=mul1(b,a[i]);
      Repj(i) t=t*1000000000;
      ans=ans+t;
    }
    return ans;
}

tip operator*(tip &a,tip &b)
{ return mul(a,b); }

void izv1(tip &a)
{
    int i=0;
    while (a[i]==0) { i++; a[i]==osn-1; }
    a[i]--;
}

tip del1(tip &a,long b)
{
    tip c;
    long long o=0;
    for (int i=a.SZ-1; i>=0; i--)
    {
        o*=(LL)osn; o+=(LL)a[i];
        if (o<b && i>0) { i--; o*=(LL)osn; o+=(LL)a[i]; 
          if (c.SZ!=0) c.PB(0); }
        if (o<b) { c.PB(0); break; }
        c.PB(o/(LL)b);
        o%=(LL)b;
    }
    reverse(ALL(c));
    return c;
}

tip operator/(tip &a,const int b)
{ return del1(a,b); }

int n,m,N,W;

tip d[128][64][64],d1[128][64][64];

tip comb(int k,int n)
{
    k=max(k,n-k); tip ans; ans.PB(1);
    for (int i=k+1,j=1; i<=n; i++,j++)
     { ans=ans*i; ans=ans/j; }
    return ans; 
}

int main()
{
    int i,j,k,l;
    
    cin>>n; char c;
    Repi(n)
     { cin>>c; 
       if (c=='N') N++;
       if (c=='W') W++;
     }

/*    tip a,b; a.PB(999999999); a.PB(11);
    izvedi(a); cout<<endl;
    b.PB(1); b.PB(123456789); b.PB(1);
    izvedi(b); cout<<endl;
    tip C=a+b,B;
    izvedi(C); cout<<endl;
    C=C*983412456;
    izvedi(C); cout<<endl;
    C=C/983412456;
    izvedi(C); cout<<endl;
    pause;
*/
    Repi(N*2+1)
     Repj(N+1)
      Repk(N+1)
       if (i!=0 || j!=0 || k!=0)
        d[i][j][k].PB(0);

    d[0][0][0].PB(1);
    for (int pos=0; pos<N*2+1; pos++)
     for (i=0; i<=N; i++)
      for (j=0; j<=N; j++)
       {
         //       cout<<pos<<" "<<i<<" "<<j<<" = "; izvedi(d[pos][i][j]); cout<<"\n";
                if (i<N) d[pos+1][i+1][j]=d[pos][i][j]+d[pos+1][i+1][j];
                if (i>j) d[pos+1][i][j+1]=d[pos][i][j]+d[pos+1][i][j+1];
                d[pos+1][i][j]=d[pos][i][j]+d[pos+1][i][j];
       }

//  cout<<endl;

    d1[0][0][0].PB(1);
    for (int pos=0; pos<W*2+1; pos++)
     for (i=0; i<=W; i++)
      for (j=0; j<=W; j++)
       {
        //        cout<<pos<<" "<<i<<" "<<j<<" = "; izvedi(d1[pos][i][j]); cout<<"\n";
                if (i<W) d1[pos+1][i+1][j]=d1[pos+1][i+1][j]+d1[pos][i][j];
                if (i>j) d1[pos+1][i][j+1]=d1[pos+1][i][j+1]+d1[pos][i][j];
                d1[pos+1][i][j]=d1[pos+1][i][j]+d1[pos][i][j];
       }
       
    tip ans,CC=comb(N*2,n); ans.PB(1);   
    ans=ans*CC;
    ans=ans*d[N*2][N][N];
    ans=ans*d1[W*2][W][W];
izv1(ans);
   izvedi(ans); cout<<"\n";

    return 0;
}
