#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <iomanip>
using namespace std;

struct point {
       int x,y;
       };
point rrr[5100];
  int i,j,k,l,n;
  double d=0;

double dist(point p1,point p2)
{  return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y)); }

int cp(point p0,point p1,point p2)
{ int dx1=p1.x-p0.x;
  int dx2=p2.x-p0.x;
  int dy1=p1.y-p0.y;
  int dy2=p2.y-p0.y;
  return dx1*dy2-dx2*dy1;
}

bool cmp(point p1, point p2)
{   int RT=cp(rrr[1],p1,p2);
    return (RT==0)?min(dist(rrr[1],p1),dist(rrr[1],p2)):RT<0; }
void simplepath(int n, point p[])
{ int min=1;
  for (int i=2; i<=n; i++)
   if (p[i].x<p[min].x) min=i;
  swap(p[1],p[min]);  sort(p+2,p+n+1,cmp);
}

int main()
{
  ifstream f;
  f.open("moat.in");
  f>>n;
  for (i=1; i<=n; i++) f>>rrr[i].x>>rrr[i].y;
  f.close();
  
  simplepath(n,rrr);
   
  rrr[n+1]=rrr[1];
  int m=2;
  for (int i=3;i<=n+1;i++)
  { while (cp(rrr[m],rrr[m-1],rrr[i])<0) 
     m--;
    m++; 
    swap(rrr[i],rrr[m]);
  }
  
  rrr[m+1]=rrr[1];
    for (i=1; i<=m; i++) d+=dist(rrr[i],rrr[i+1]);
  
  ofstream of;
  of.open("moat.out");
  of << setprecision(2) << fixed <<d<<"\n";
  of.close();
  return 0;         
}
