/*
ID:pascala1
TASK:wormhole
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <vector>
#include <set>

using namespace std;

int n,f,m,w;
set<pair<int,int> > d[600];
int a[510][510],r[510];
bool u[510];

bool dfs(int v)
{  u[v]=true; int i,j; cout<<v<<endl;
   set<pair<int,int> >::iterator it;
   for (it=d[v].begin(); it!=d[v].end(); it++)
    if (!u[it->first]) 
     { r[it->first]=r[v]+it->second; if (dfs(it->first)) return true; }
    else
    { i=it->second; j=it->first;
     if (it->second+r[v]<r[it->first]) 
      return true; } 
   u[v]=false; 
   return false;
}

int main()
{
    int i,j,k,l,s,e,t;
    ifstream ff("wormhole.in");
    ofstream of("wormhole.out");
    ff>>f; bool fl;
    for (l=0; l<f; l++)
    {
        for (i=1; i<=n; i++) { d[i].clear(); u[i]=false; r[i]=0; }
        for (i=1; i<=n; i++) for (j=1; j<=n; j++) a[i][j]=0;
        ff>>n>>m>>w;
        for (i=0; i<m; i++)
         { ff>>s>>e>>t;
           d[s].insert(make_pair(e,t));
           d[e].insert(make_pair(s,t));
           a[s][e]=t;
           a[e][s]=t;
         }
        for (i=0; i<w; i++)
         { ff>>s>>e>>t;
           d[s].erase(make_pair(e,a[s][e]));
           d[s].insert(make_pair(e,a[s][e]-t));
           a[s][e]-=t;
         }
       
       fl=false;
       for (i=1; i<=n; i++)  
        if (!u[i])
         if (dfs(i))
          { fl=true; break; }
       if (fl) of<<"YES\n"; else of<<"NO\n";
    }
        
    
    return 0;
}
