/*
ID:pascala1
TASK:lineupg
LANG:C++
*/
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <algorithm>

#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>

#define EPS 1e-9;
#define INF 1e9;

#define PB push_back
#define SZ size()
#define REP(lo, hi) for (int i=lo; i<(hi); i++)
#define REPP(lo, hi) for (int i=((hi)-1); i>=lo; i--)
#define Ri(hi) for (int i=0; i<(hi); i++)
#define FOR(var, lo, hi) for (int var=(lo); var<(hi); var++)
#define FORR(var, lo ,hi) for (int var=((hi)-1); var>=(lo); var--)

using namespace std;

typedef vector<bool> VB;
typedef vector<int> VI;
typedef vector<VI> VVI;
typedef vector<long> VL;
typedef vector<VL> VVL;
typedef vector<string> VS;

typedef unsigned long long ULL;
typedef unsigned long UL;


const unsigned long n=65536;

VL a(n*2+1,2000000);
VL b(n*2+1,-1);

void pusha(long i,long j)
{
     i=n+i-1; a[i]=j;
     while (i>1)
     { 
       i>>=1;
       a[i]=min(a[i<<1],a[(i<<1)+1]);
     }
}

void pushb(long i,long j)
{
     i=n+i-1; b[i]=j;
     while (i>1)
     { 
       i>>=1;
       b[i]=max(b[i<<1],b[(i<<1)+1]);
     }
}

long Min(long j,long k)
{
   j+=n-1; k+=n-1;
   long m=a[k];
   long i=k,l,ll=0;
   while (i>1)
    {
         l=(i>>1)<<1;
         if (i!=l)
          if ((l<<ll)>=j)
           { if (a[l]<m) m=a[l]; }
          else break; 
         i>>=1;
         ll++;
    }    
    i=j; ll=0;
    if (a[j]<m) m=a[j];
    while (i>1)
    {
         l=((i>>1)<<1)+1;
         if (i!=l)
          if (((l+1)<<ll)-1<=k)
           { if (a[l]<m) m=a[l]; }
          else break; 
         i>>=1;
         ll++;
    }
    return m;
}

long Max(long j,long k)
{
   j+=n-1; k+=n-1;
   long m=b[k];
   long i=k,l,ll=0;
   while (i>1)
    {
         l=(i>>1)<<1;
         if (i!=l)
          if ((l<<ll)>=j)
           { if (b[l]>m) m=b[l]; }
          else break; 
         i>>=1;
         ll++;
    }    
    i=j; ll=0;
    if (b[j]>m) m=b[j];
    while (i>1)
    {
         l=((i>>1)<<1)+1;
         if (i!=l)
          if (((l+1)<<ll)-1<=k)
           { if (b[l]>m) m=b[l]; }
          else break; 
         i>>=1;
         ll++;
    }
    return m;
}

long N,Q;

int main()
{
    long i,j,k,l;
    FILE * ff;
    ff=fopen("lineupg.in","r");
    fscanf(ff,"%d %d",&N,&Q);
    for (i=0; i<N; i++) { fscanf(ff,"%d",&j); pusha(i+1,j); pushb(i+1,j); }
    
    FILE * of;
    of=fopen("lineupg.out","w");
     for (i=0; i<Q; i++)
    { 
      fscanf(ff,"%d %d",&j,&k);
      fprintf(of,"%d\n",Max(j,k)-Min(j,k));
    }
    fclose(ff);
    
    fclose(of);
    return 0;
}
