/*
TASK:connect
LANG:C++
ID:pascala1
*/
#include <iostream>
#include <fstream>
#define MP make_pair
#define R first
#define C second

using namespace std;

bool a[2][16384][4];
pair<int,int> q[22000];
bool u[2][16384];

inline void connect(int r1,int c1,int r2,int c2,bool fl)
{
       r1--; c1--; r2--; c2--;
       if (r1==r2 && c1==c2-1) { a[r1][c1][0]=fl; a[r2][c2][2]=fl; }
       if (r1==r2+1 && c1==c2) { a[r1][c1][1]=fl; a[r2][c2][3]=fl; }
       if (r1==r2 && c1==c2+1) { a[r1][c1][2]=fl; a[r2][c2][0]=fl; }
       if (r1==r2-1 && c1==c2) { a[r1][c1][3]=fl; a[r2][c2][1]=fl; }
}

inline bool areconnected(int r1,int c1,int r2,int c2)
{
       r1--; c1--; r2--; c2--;
       if (r1==r2 && c1==c2-1 && a[r1][c1][0]) return true;
       if (r1==r2+1 && c1==c2 && a[r1][c1][1]) return true;
       if (r1==r2 && c1==c2+1 && a[r1][c1][2]) return true;
       if (r1==r2-1 && c1==c2 && a[r1][c1][3]) return true;
       return false;
}

inline bool bfs(int r1,int c1,int r2,int c2)
{
     r1--; c1--; r2--; c2--;
     if (c2<c1) { swap(c1,c2); swap(r1,r2); }
     memset(u,false,sizeof(u));
     u[r1][c1]=true;
     q[0]=MP(r1,c1);
     int s,e=0,i,j,k,r,c;
     for (s=0; s<=e; s++)
     {
         r=q[s].R; c=q[s].C;
         if (a[r][c][0] && !u[r][c+1] && c+1<=c2) { q[++e]=MP(r,c+1); u[r][c+1]=true; } 
         if (a[r][c][1] && !u[r-1][c] && r-1>=0) { q[++e]=MP(r-1,c); u[r-1][c]=true; } 
         if (a[r][c][2] && !u[r][c-1] && c-1>=c1) { q[++e]=MP(r,c-1); u[r][c-1]=true; } 
         if (a[r][c][3] && !u[r+1][c] && r+1<=1) { q[++e]=MP(r+1,c); u[r+1][c]=true; } 
         if (u[r2][c2]) break;
     }
     return u[r2][c2];
}

int main()
{
    int n,i,j,k,l,r1,r2,c1,c2;
    ifstream f("connect.in");
    f>>n;
    for (i=0; i<n; i++)
    {
        f>>r1>>c1>>r2>>c2;
        connect(r1,c1,r2,c2,true);
    }
    f.close();
    
    char c; bool fl;
    while(1)
    {
            cin>>c;
            if (c=='E') break;
            if (c=='C') { cin>>r1>>c1>>r2>>c2; connect(r1,c1,r2,c2,false); }
            if (c=='O') { cin>>r1>>c1>>r2>>c2; connect(r1,c1,r2,c2,true); }
            if (c=='T')
            {  cin>>r1>>c1>>r2>>c2;
               fl=bfs(r1,c1,r2,c2);
               if (fl) cout<<"Y\n"<<flush;
               else cout<<"N\n"<<flush;
            }
    }
    
    return 0;
}
