/*
ID: pascala1
PROG: sumsums
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,T,c[50100]; LL MOD=98765431LL,ans[50100];

inline LL power(LL q,int N)
{
       LL ans=1,tek=q,st=1;
       while (N>0)
        {
             for (;st<=__builtin_ctz(N);st++) { tek*=tek; tek%=MOD; }
             ans*=tek;
             ans%=MOD;
             N^=(1<<__builtin_ctz(N));
        }
       return ans;
}

inline LL power1(LL q,int N)
{
       LL ans=1;
       Repi(N) { ans*=q; ans%=MOD; }
       return ans;
}

PLL ext_gcd(LL a,LL b)
{
  if (a%b==0LL) return MP(0LL,1LL);
  PLL t=ext_gcd(b,a%b);
  return MP(t.y,t.x-t.y*(a/b));
}
LL gcd(LL a,LL b)
{ return (b==0LL)?a:gcd(b,a%b); }


LL geosum(LL a1,LL q,int N)
{
    cout<<a1<<"*("<<power(q,N)<<"-1)/"<<(q-1LL)<<endl;
    return (a1*(power(q,N)-1LL))%MOD;
}

int main()
{
    int i,j,k,l;
    FILE *f=fopen("sumsums.in","r");
    fscanf(f,"%d%d",&n,&T);
    Repi(n) fscanf(f,"%d",c+i);
    fclose(f);
    
    PLL yey;
    LL x=(n-1),C,D,E,Q;
    LL A,B,OA;
    if (T%2==0)
     { 
       Q=x*x%MOD;     
       A=geosum(x,Q,T/2)-geosum(Q,Q,T/2-1);
       Q--; Q+=MOD; Q%=MOD;
       yey=ext_gcd(Q,MOD);
//       cout<<Q<<"*"<<yey.x<<"+"<<MOD<<"*"<<yey.y<<"="<<gcd(Q,MOD)<<endl;
       cout<<A<<endl;
       OA=(A+MOD)%MOD;
       A=yey.x*A/gcd(Q,MOD)%MOD; A+=MOD; A%=MOD;
       cout<<A<<endl;
   //    for (A=0; A<MOD; A++)
   //     if (A*Q%MOD==OA) break;
       cout<<A<<endl;
       A--; B=+1; }
    else
     {
      Q=x*x%MOD;
      A=geosum(x*x%MOD,x*x%MOD,T/2)-geosum(x,x*x%MOD,T/2);
      Q--; Q+=MOD; Q%=MOD;
      yey=ext_gcd(Q,MOD);
//      cout<<Q<<"*"<<yey.x<<"+"<<MOD<<"*"<<yey.y<<"="<<gcd(Q,MOD)<<endl;
      cout<<A<<endl;
      OA=(A+MOD)%MOD;
      A=yey.x*A/gcd(Q,MOD)%MOD; A+=MOD; A%=MOD;
      cout<<A<<endl;
  //    for (A=0; A<MOD; A++)
  //     if (A*Q%MOD==OA) break;
  //    cout<<A<<" "<<Q<<" "<<A*Q<<" "<<A*Q%MOD<<endl;
      A++; B=-1; }
    A+=MOD; A%=MOD;
     
  //  cout<<geosum(x,x*x%MOD,T/2)<<"-"<<geosum(x*x%MOD,x*x%MOD,T/2-1)<<"-1="<<A<<endl;
  //  cout<<A<<" "<<B<<endl; 
    LL sum=0;
    Repi(n) { sum+=(LL)c[i]; sum%=MOD; }
 
    Repi(n)
     ans[i]=(sum*A+B*(LL)c[i])%MOD;
 
    f=fopen("sumsums.out","w");
    Repi(n)
     fprintf(f,"%d\n",ans[i]);
    fclose(f);
    
    pause;
    return 0;
}
