/*
ID: pascala1
PROG: treasure
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
VI adj[100100],an;
int par[100100];
VI chi[100100];
VI label[700],labeladd[700],plabel[700],plabeladd[700],flabel[700];
PI arc;
VVI final[4];
int inc[100100],st[100100];

ULL base,pows[100100],Tmp,Aad;
int basec=3;
ULL Label[100100],Labeladd[100100],Plabel[100100],Plabeladd[100100],Flabel[100100];
vector<ULL> Final[4];


void buildtree(int v)
{
  //   cout<<"in "<<v<<endl;
     Repi(adj[v].SZ)
      if (!par[adj[v][i]])
       {
                    //      cout<<"from "<<v<<" to "<<adj[v][i]<<endl;
                          par[adj[v][i]]=v;
                          chi[v].PB(adj[v][i]);
                          buildtree(adj[v][i]);
       }
      else
       if (adj[v][i]!=par[v] && arc.x==0) 
        {
                      //        cout<<"back from "<<v<<" to "<<adj[v][i]<<endl;
                              arc=MP(adj[v][i],v);
        }
}

VI tmp,aad;

void childlabel(int v)
{
     Repi(chi[v].SZ)
      {
                    childlabel(chi[v][i]);
                    tmp=label[chi[v][i]];
                    for (int i=n; i>0; i--)
                     tmp[i]=tmp[i-1];
                    Repi(n)
                     label[v][i]+=tmp[i];
      }
     label[v][0]=1;
     if (inc[v]>-1)
      {
                   for (int i=0; i<n; i++) tmp[i]=0;
                   for (int i=an.SZ/2+1; i<n; i++)
                    tmp[i]-=label[an[inc[v]]][i-(an.SZ/2+1)];
           //      cout<<"tmp -> "; Repi(n) cout<<tmp[i]<<" "; cout<<endl;
                   Repi(n) aad[i]=aad[i+1];
                   int l=an.SZ-(an.SZ/2+1),w=an[inc[v]];
                   Repj(chi[w].SZ)
                    if (inc[v]==0 || chi[w][j]!=an[inc[v]-1])
                     for (int i=l+1; i<n; i++)
                      aad[i]+=label[chi[w][j]][i-l-1];
                   aad[l]++;  
         //      cout<<"aad -> "; Repi(n) cout<<aad[i]<<" "; cout<<endl;
                   Repi(n)
                    labeladd[v][i]=aad[i]+tmp[i];
        //       cout<<"add -> "; Repi(n) cout<<labeladd[v][i]<<" "; cout<<endl;
      }
     if (v==an[an.SZ-1])
      Repi(an.SZ) Repj(n) label[an[i]][j]+=labeladd[an[i]][j];
  //   cout<<v<<" -> "; Repi(n) cout<<label[v][i]<<" "; cout<<endl;
}

void parentlabel(int v)
{
     if (par[v]>-1)
     {
                   int l=par[v];
                   Repi(chi[l].SZ)
                    if (chi[l][i]!=v)
                     for (int j=2; j<n; j++)
                      plabel[v][j]+=label[chi[l][i]][j-2];
                   for (int i=1; i<n; i++)
                    plabel[v][i]+=plabel[l][i-1];
                   if (inc[v]>-1)
                    {
                         for (int i=0; i<n; i++) tmp[i]=0;
                         int w=an[inc[v]];
                         for (int i=an.SZ/2+1; i<n; i++)
                          {
                            tmp[i]-=plabel[w][i-(an.SZ/2+1)];
                            Repj(chi[w].SZ)
                             if (i>an.SZ/2+1 && chi[w][j]!=an[inc[v]+1])
                              tmp[i]-=label[chi[w][j]][i-(an.SZ/2+1)-1];
                          }
            //           cout<<"tmp -> "; Repi(n) cout<<tmp[i]<<" "; cout<<endl;
                         Repi(n) aad[i]=aad[i+1];
                         int l=an.SZ-(an.SZ/2+1);
                         Repj(chi[w].SZ)
                          if (inc[v]==an.SZ-1 || chi[w][j]!=an[inc[v]+1])
                           for (int i=l+1; i<n; i++)
                            aad[i]+=label[chi[w][j]][i-l-1];
         //      cout<<"aad -> "; Repi(n) cout<<aad[i]<<" "; cout<<endl;
                         if (inc[v]==0)
                          for (int i=l; i<n; i++)
                           aad[i]+=plabel[w][i-l];
                         else aad[l]++;  
        //       cout<<"aad -> "; Repi(n) cout<<aad[i]<<" "; cout<<endl;
                         Repi(n) plabeladd[v][i]=aad[i]+tmp[i];
        //       cout<<"add -> "; Repi(n) cout<<plabeladd[v][i]<<" "; cout<<endl;
                    }
     }
     plabel[v][0]=1;
     
     if (v==an[an.SZ-1])
      Repi(an.SZ) Repj(n) plabel[an[i]][j]+=plabeladd[an[i]][j];
  //   cout<<v<<" => "; Repi(n) cout<<plabel[v][i]<<" "; cout<<endl;

     Repi(chi[v].SZ)
      parentlabel(chi[v][i]);
}


void Childlabel(int v)
{
     Repi(chi[v].SZ)
      {
                    Childlabel(chi[v][i]);
                    Label[v]+=Label[chi[v][i]]*base;
      }
     Label[v]++;
     if (inc[v]>-1)
      {
                   Tmp=0;
                   Tmp-=Label[an[inc[v]]]*pows[an.SZ/2+1];
                   Aad=Aad/base; //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                   int l=an.SZ-(an.SZ/2+1),w=an[inc[v]];
                   Repj(chi[w].SZ)
                    if (inc[v]==0 || chi[w][j]!=an[inc[v]-1])
                     Aad+=Label[chi[w][j]]*pows[l+1];
                   Aad+=pows[l];
                   Labeladd[v]=Aad+Tmp;
      }
     if (v==an[an.SZ-1])
      Repi(an.SZ) Label[an[i]]+=Labeladd[an[i]];
}

void Parentlabel(int v)
{
     if (par[v]>-1)
     {
                   int l=par[v];
                   Repi(chi[l].SZ)
                    if (chi[l][i]!=v)
                     Plabel[v]+=Label[chi[l][i]]*pows[2];
                   Plabel[v]+=Plabel[l]*base;
                   if (inc[v]>-1)
                    {
                         Tmp=0;
                         int w=an[inc[v]];
                         Tmp-=Plabel[w]*pows[(an.SZ/2+1)];
                         Repj(chi[w].SZ)
                          if (chi[w][j]!=an[inc[v]+1])
                           Tmp-=Label[chi[w][j]]*pows[an.SZ/2+2];
                         Aad=Aad/base; //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                         int l=an.SZ-(an.SZ/2+1);
                         Repj(chi[w].SZ)
                          if (inc[v]==an.SZ-1 || chi[w][j]!=an[inc[v]+1])
                           Aad+=Label[chi[w][j]]*pows[l+1];
                         if (inc[v]==0)
                          Aad+=Plabel[w]*pows[l];
                         else Aad+=pows[l];
                         Plabeladd[v]=Aad+Tmp;
                    }
     }
     Plabel[v]++;
     
     if (v==an[an.SZ-1])
      Repi(an.SZ) Plabel[an[i]]+=Plabeladd[an[i]];

     Repi(chi[v].SZ)
      Parentlabel(chi[v][i]);
}

PULL ext_gcd(ULL a,ULL b)
{
  if (a%b==0LL) return MP(0LL,1LL);
  PULL t=ext_gcd(b,a%b);
  return MP(t.y,t.x-t.y*(a/b));
}

int main()
{
    int i,j,k,l;
    FILE *f=fopen("treasure.in","r");
    fscanf(f,"%d",&n);
    Repi(n)
     {
           fscanf(f,"%d%d",&k,&l);
           adj[k].PB(l); adj[l].PB(k);
           st[l]++; st[k]++;
     }
    fclose(f);
    
    par[1]=-1;
    buildtree(1);
    l=arc.y;
    while (l!=arc.x) { an.PB(l); l=par[l]; }
    an.PB(l);
//    cout<<an[an.SZ/2+1]<<endl; pause;
    memset(inc,255,sizeof(inc));
    for (int i=an.SZ/2+1,j=0; i<an.SZ; i++,j++) inc[an[i]]=j;
    

     int ans=0;
   if (n<666)
     {
                Repi(n) { label[i+1].resize(n+1); labeladd[i+1].resize(n+1); }
                tmp.resize(n+1);
                aad=tmp;
                childlabel(1);
                Repi(n) { plabel[i+1].resize(n+1);  plabeladd[i+1].resize(n+1);  }
                cout<<endl;
                reverse(ALL(an));
                memset(inc,255,sizeof(inc));
                for (int i=an.SZ/2+1,j=0; i<an.SZ; i++,j++) inc[an[i]]=j;
                Repi(n) aad[i]=0;
                parentlabel(1);
//                pause;
    
      cout<<endl;
      for (int i=1; i<=n; i++)
       {
    //    cout<<i<<" : ";
        flabel[i].resize(n+1);
        Repj(n)
         {
               flabel[i][j]=label[i][j]+plabel[i][j];
       //        cout<<flabel[i][j]<<" ";
         }
    //    cout<<endl;
       }
     //  pause;
    
       for (int i=1; i<=n; i++)
        if (st[i]<4)
          final[st[i]-1].PB(flabel[i]);
        VVI::IT it;
    Repi(3)
     {
           sort(ALL(final[i]));
           it=unique(ALL(final[i]));
           ans+=it-final[i].begin();
     }
    }
    else
    {
        basec=3;
        base=n+1;
        pows[0]=1;
        for (int j=1; j<=n; j++) pows[j]=pows[j-1]*base;
        Childlabel(1);
        reverse(ALL(an));
  //  cout<<(double)clock()/(double)CLOCKS_PER_SEC<<endl;
        memset(inc,255,sizeof(inc));
        for (int i=an.SZ/2+1,j=0; i<an.SZ; i++,j++) inc[an[i]]=j;
        Aad=0;
        Parentlabel(1);
        
  //  cout<<(double)clock()/(double)CLOCKS_PER_SEC<<endl; 
        for (int i=1; i<=n; i++)
         if (st[i]<4)
          Final[st[i]-1].PB(Plabel[i]+Label[i]);
        vector<ULL>::IT it;
    Repi(3)
     {
           sort(ALL(Final[i]));
           it=unique(ALL(Final[i]));
           ans+=it-Final[i].begin();
     }
   //     for (int i=1; i<=n; i++)
//         cout<<Plabel[0][i]+Label[0][i]<<endl;
  //      pause;
    }
    
    
    
    
    ofstream of("treasure.out");
    of<<ans<<"\n";
    of.close();
    
//    cout<<(double)clock()/(double)CLOCKS_PER_SEC<<endl; pause;
    
    return 0;
}
