/*
ID: pascala1
PROG: bclgold
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
char s[32000],ans[32000];
pair<int,char> L[32000],R[32000];

bool LEFT(int left,int right)
{
     int l=left; int r=right; int ol=left; int oR=right; int M;
     l=L[left].x; r=R[right].x;
     while(l<=r)
     {
//             cout<<"   "<<s[l]<<" ? "<<s[r]<<endl;
             M=min(l-ol,oR-r);
             if (s[ol+M]!=s[oR-M])
              return s[ol+M]<s[oR-M];
             ol=l; oR=r; l=L[l].x; r=R[r].x;
     }
     return 1;
}

int main()
{
    int i,j,k,l;
    FILE *f=fopen("bclgold.in","r");
    fscanf(f,"%d\n",&n);
    Repi(n) fscanf(f,"%c\n",&s[i]);
    fclose(f);
    
    l=0;int r=strlen(s)-1;
    pair<int,char> t1=MP(-1,0),t=t1;
    Repi(n)
     if (t.y!=s[i])
      {
                   R[i]=t;
                   t1=t;
                   t=MP(i,s[i]);
      }
     else { R[i]=t1; t.x++; }
     
    t1=MP(n,0); t=t1; 
    for (int i=r; i>=0; i--) 
     if (t.y!=s[i])
      {
                   L[i]=t;
                   t1=t;
                   t=MP(i,s[i]);
      }
     else { L[i]=t1; t.x--; }
     
    int left,right;
//    printf("%s\n",s);
    Repi(n) 
    {
            if (s[l]<s[r])
             {
                          ans[i]=s[l];
                          l++;
             }
            else if (s[r]<s[l]) 
             {
                 ans[i]=s[r];
                 r--;
             }
            else
             if (LEFT(l,r)) { ans[i]=s[l]; l++; } else {ans[i]=s[r]; r--;}
//            cout<<l<<" "<<r<<endl;
    }
             
//    printf("%s\n",ans);
//    pause;
    f=fopen("bclgold.out","w");
    Repi(strlen(ans))
     {
                     fprintf(f,"%c",ans[i]);
                     if (i%80==79 || i==strlen(ans)-1) fprintf(f,"\n");
     }
    fclose(f);
    
    return 0;
}
