/*
ID: pascala1
PROG: gourmet
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
PI C[100100],G[100100];

int main()
{
    int i,j,k,l;
    FILE *f=fopen("gourmet.in","r");
    fscanf(f,"%d%d",&n,&m);
    Repi(n)
     fscanf(f,"%d%d",&C[i].x,&C[i].y);
    Repi(m)
     fscanf(f,"%d%d",&G[i].x,&G[i].y);
    sort(C,C+n);  sort(G,G+m);
    fclose(f);
    
    l=0;
    set<PI> b;
    set<PI>::IT it;
    LL ans=0;
    Repi(m)
     {
           while (l<n && C[l].x<=G[i].x) { b.insert(MP(C[l].y,l)); l++; }
           if (b.SZ==0) continue;
           
//           cout<<G[i].x<<" "<<G[i].y<<endl;
//           for (it=b.begin(); it!=b.end(); it++) cout<<it->x<<" "<<it->y<<" ; "; cout<<endl;
           
           it=b.upper_bound(MP(G[i].y,INF));
           if (it==b.begin()) continue;
           it--;
           ans+=(LL)G[i].x;// cout<<"add "<<it->y<<": "<<C[it->y].x<<" "<<C[it->y].y<<endl;
           b.erase(it);
//           cout<<endl;
     }
//    cout<<ans<<endl; pause;
    ofstream of("gourmet.out");
    if (b.SZ==0)
     of<<ans<<"\n";
    else
     of<<"-1\n"; 
    of.close();
    
    return 0;
}
