/*
ID: pascala1
PROG: alake
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,H[100100],W[100100];

struct level{
       int x,y,W,H;
       level(){};
       level(int _x,int _y,int _W,int _H): x(_x),y(_y),W(_W),H(_H) {};
       };

list<level> B;
list<level>::IT Max;
int mi; LL flowed; long long ans[100100];

void flow() //right
{
     list<level>::IT cur=Max,cur1,next,prev; 
     int j,k,l,ad;
     level tmp;
     
     
while(1)
{
     cur1=cur; cur1++; 
     while (cur->H>cur1->H) { cur=cur1; cur1++; }
     prev=cur; prev--;
     if (H[cur->x]<H[cur->y]) l=cur->y; else l=cur->x;
     if (!ans[l] || l==mi) ans[l]=flowed+(LL)cur->W;
     cout<<"cur: "<<cur->x<<" "<<cur->y<<" "<<cur->W<<" "<<cur->H<<endl;
     cout<<"flow: "<<flowed<<endl;
     cout<<"ans["<<l<<"]="<<ans[l]<<endl;
     if (cur->H==H[mi]) break;
     if (prev->H<cur1->H)
      {
                         tmp=level(prev->x,cur->y,cur->W+prev->W,prev->H);
                         cout<<"merge left: "<<tmp.x<<" "<<tmp.y<<" "<<tmp.W<<" "<<tmp.H<<endl;
                         flowed+=(LL)(prev->H-cur->H)*(LL)cur->W;
                         cout<<"flow: "<<flowed<<endl;
                         ans[prev->y]=flowed+(LL)cur->W+(LL)prev->W;
                         cout<<"ans["<<prev->y<<"]="<<ans[prev->y]<<endl;
                         B.erase(prev);
                         *cur=tmp;
      }
     else
      {
                         tmp=level(cur->x,cur1->y,cur->W+cur1->W,cur1->H);
                         cout<<"merge right: "<<tmp.x<<" "<<tmp.y<<" "<<tmp.W<<" "<<tmp.H<<endl;
                         flowed+=(LL)(cur1->H-cur->H)*(LL)cur->W;
                         cout<<"flow: "<<flowed<<endl;
                         B.erase(cur1);
                         *cur=tmp;
      }
     cout<<endl; 
}

}

int main()
{
    int i,j,k,l;
    FILE *f=fopen("alake.in","r");
    fscanf(f,"%d",&n);
    int M=0;
    W[0]=0; H[0]=INF; W[n+1]=0; H[n+1]=INF;
    B.PB(level(0,0,0,INF));
    for (int i=1; i<=n; i++)
    {
     fscanf(f,"%d%d",W+i,H+i);
     if (H[i]>M) {M=H[i]; mi=i;}
     B.PB(level(i,i,W[i],H[i]));
    }
    B.PB(level(0,0,0,INF));
    fclose(f);
    
    int dir=-1,r=INF; l=INF;
    i=mi+1;
    while (H[i]<r) {r=H[i]; i++;}
    i=mi-1;
    while (H[i]<l) {l=H[i]; i--;}
    

    if (l<r) reverse(ALL(B));

    for (Max=B.begin();Max->H!=M;Max++) {};
    
    flow();
    cout<<"\n--------------------------------------------------\n\n";
    
    reverse(ALL(B));
    for (Max=B.begin();Max!=B.end();Max++) swap(Max->x,Max->y);
    for (Max=B.begin();Max->H!=M;Max++) {};
   
    flow();
    
    pause;
    f=fopen("alake.out","w");
    Repi(n)
     fprintf(f,"%d -> %.0lf\n",i+1,(double)ans[i+1]);
    fclose(f);
    
    return 0;
}
