/*
ID: pascala1
PROG: bales
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,N,Q,qry[26000];
set<int> u;

struct interval{int x,y,val,qry;
interval(){};
interval(int _x,int _y,int _val,int _qry): x(_x),y(_y),val(_val),qry(_qry) {};
};

bool operator<(interval a,interval b)
{
     if (a.x<b.x) return 1;
     if (a.x>b.x) return 0;
     if (a.y<b.y) return 1;
     return 0;
}

int main()
{
    int i,j,k,l,st,en,val;
    FILE *f=fopen("bales.in","r");
    fscanf(f,"%d%d",&N,&Q);
    set<interval> s,s1;
    set<interval>::IT i1,ii;
    interval tmp,tmp1,tmp2,tt;
    fscanf(f,"%d%d%d",&st,&en,&val);
    s.insert(interval(st,en,val,0));
    qry[0]=1; int ans=0;
    u.insert(val);
    Repi(Q-1)
     {
           fscanf(f,"%d%d%d",&st,&en,&val);
           bool stava=1;
           tmp=interval(st,en,val,i); tt=tmp;
           i1=s.lower_bound(interval(st,en,0,0));
           if (i1!=s.begin()) i1--; bool ittt=0;
           for (;i1!=s.end() && i1->x<=en; i1++) 
            {
               ittt=1; 
               if (i1->x<=st && i1->y>=st && i1->y<=en) // ([)]
                {
                              cout<<"case ([)]\n";
                              if (val>i1->val)
                               {
                                  cout<<"subcase 1\n";
                                  tmp1=*i1; tmp1.y=st-1;
                                  if (tmp1.x>tmp1.y) { qry[tmp1.qry]--; 
                                                      if (qry[tmp1.qry]<=0) stava=0;
                                                    }
                                  else s.insert(tmp1);
                                  s.erase(i1); break;
                               }
                              else
                              if (val<i1->val)
                               {
                                  cout<<"subcase 2\n";
                                  tmp.x=i1->y+1;
                                  if (tmp.x>tmp.y) stava=0;
                               }
                              else
                               {
                                  cout<<"subcase 3\n";
                                  tmp.y=i1->y;
                                  if (tmp.x>tmp.y) stava=0;
                                  s.erase(i1); break;
                               }
                }
               else 
               if (i1->x<=st && i1->y>en) // ([])
                {
                              cout<<"case ([])\n";
                              if (val>i1->val)
                               {
                                  cout<<"subcase 1\n";
                                  tmp1=*i1; tmp1.y=st-1;
                                  tmp2=*i1; tmp2.x=en+1;
                                  qry[tmp1.qry]++;
                                  if (tmp1.x<=tmp1.y) s.insert(tmp1); else qry[tmp1.qry]--;
                                  if (tmp2.x<=tmp2.y) s.insert(tmp2); else qry[tmp2.qry]--;
                                  if (qry[tmp1.qry]<=0) stava=0;
                                  s.erase(i1); break;
                               }
                              else
                              if (val<i1->val)
                               {
                                  cout<<"subcase 2\n";
                                              stava=0;
                               }
                              else
                               {
                                  cout<<"subcase 3\n";
                                              s.erase(i1); break;
                               }
                }
               else
               if (i1->x>=st && i1->y<=en) // [()]
                {
                              cout<<"case [()]\n";
                              if (val>i1->val)
                               {
                                  cout<<"subcase 1\n";
                                              stava=0;
                               }
                              else
                              if (val<i1->val)
                               {
                                  cout<<"subcase 2\n";
                                  tmp1=*i1; tmp1.y=st-1;
                                  tmp2=*i1; tmp2.x=en+1;
                                  qry[tmp1.qry]++;
                                  if (tmp1.x<=tmp1.y) s.insert(tmp1); else qry[tmp1.qry]--;
                                  if (tmp2.x<=tmp2.y) s.insert(tmp2); else qry[tmp2.qry]--;
                                  if (qry[tmp1.qry]<=0) stava=0;
                                  s.erase(i1); break;
                               }
                              else
                               {
                                  cout<<"subcase 3\n";
                                              tmp.x=i1->x; tmp.y=i1->y;
                                              s.erase(i1); break;
                               }
                }
               else 
               if (i1->x>=st && i1->x<=en && i1->y>=en) // [(])
                {
                              cout<<"case [(]) ; ";
                              if (val>i1->val)
                               {
                                  cout<<"subcase 1\n";
                                  tmp1=*i1; tmp1.x=en+1;
                                  if (tmp1.x>tmp1.y) { qry[tmp1.qry]--; 
                                                      if (qry[tmp1.qry]<=0) stava=0;
                                                    }
                                  else s.insert(tmp1);
                                  s.erase(i1); break;
                               }
                              else
                              if (val<i1->val)
                               {
                                  cout<<"subcase 2\n";
                                  tmp.y=i1->x-1;
                                  if (tmp.x>tmp.y) stava=0;
                               }
                              else
                               {
                                  cout<<"subcase 3\n";
                                  tmp.x=i1->x;
                                  if (tmp.x>tmp.y) stava=0;
                                  s.erase(i1); break;
                               }
                }
               else
                if (u.find(val)!=u.end()) stava=0; //ima go no ne se zasi4at
            }
          s.insert(tmp);
          s1.insert(tt);
          if (u.find(val)!=u.end() && !ittt) stava=0; //ima go no ne se zasi4at
          u.insert(val);
          for (i1=s1.begin(); i1!=s1.end(); i1++)
          {
           if (i1->x>=st && i1->y<=en && i1->val<val) stava=0;
           else
           if (i1->x<=st && i1->y>=en && i1->val>val) stava=0;
          }
          
          for (i1=s.begin(); i1!=s.end(); i1++)
           cout<<i1->x<<" "<<i1->y<<" "<<i1->val<<" "<<i1->qry<<endl;
          cout<<endl;
            
          if (!stava) {ans=i+2; break;}
     }
    fclose(f);
    
    cout<<ans<<endl;
    pause;
    
    ofstream of("bales.out");
    of<<ans<<"\n";
    of.close();
    return 0;
}
