/*
ID: pascala1
PROG: acquire
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m; PI a[50100],b[50100];
LL d[50100];

struct envelope{double x,slope,offs;
envelope(double X,int Slope,int Offs){x=X;slope=Slope;offs=Offs;}
};

list<envelope> env;
list<envelope>::IT it;

void insert(PI L)
{
	if (!env.SZ)
	 {
			env.PB(envelope(1000001,L.x,L.y));
			return;
	 }
	int lastx=0,b1=L.x,d1=L.y,b2,d2;
	for (it=env.begin(); it!=env.end(); it++)
	 {
			 b2=it->slope; d2=it->offs;
			 double x=(b1==b2)?INF:(double)(d1-d2)/(double)(b2-b1);
			 if (x<it->x+EPS && x>lastx-EPS)
			 lastx=it->x;
	 }
}

int main()
{
    int i,j,k,l;
    FILE *f=fopen("acquire.in","r");
    fscanf(f,"%d",&n);
    Repi(n)
     fscanf(f,"%d%d",&a[i].x,&a[i].y);
    sort(a,a+n);
    fclose(f);
    
    m=1; b[0]=a[0];
    Repi(n)
     {
			while (m && a[i].x>=b[m-1].x && a[i].y>=b[m-1].y)
			 m--;
			b[m++]=a[i];
	 }
	
//	Repi(n) cout<<a[i].x<<" "<<a[i].y<<" ; "; cout<<endl;
//	Repi(m) cout<<b[i].x<<" "<<b[i].y<<" ; ";cout<<endl;
	
	Repi(m+1) d[i]=2000000000000000000LL;
	d[0]=0;
	for (int i=0;i<m;i++)
	 {
			for (int j=0; j<=i; j++)
			 d[i+1]<?=d[j]+(LL)b[i].x*(LL)b[j].y;
	 }

//	pause;
	
	ofstream of("acquire.out");
	of<<d[m]<<"\n";
	of.close();
    
    return 0;
}
