/*
ID: pascala1
PROG: cowjog
LANG: C++
*/

#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>

//#define NDEBUG
#include <assert.h>

#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N,M,K;
VI a[1024],c[1024];
multiset<int> b[1024];

void solve(int node)
{
  if (b[node].SZ) return;
  multiset<int>::IT it,i1;
  Repi(a[node].SZ)
   {
		int v=a[node][i];
		solve(v);
		for (it=b[v].begin(); it!=b[v].end(); it++)
		 {
				b[node].insert(*it+c[node][i]);
				while (b[node].SZ>K) { i1=b[node].end(); i1--; b[node].erase(i1); }
				if (b[node].SZ==K && *b[node].rbegin()<=*it+c[node][i]) 
						break;
		 }
   }
 // cout<<node<<": ";
//  for (it=b[node].begin(); it!=b[node].end(); it++)  cout<<*it<<" "; cout<<endl;
}

int main()
{
    int i,j,k,l;
    FILE *f=fopen("cowjog.in","r");
    fscanf(f,"%d%d%d",&N,&M,&K);
    Repi(M)
     {
			fscanf(f,"%d%d%d",&k,&l,&j);
			a[max(k,l)].PB(min(k,l));
			c[max(k,l)].PB(j);
	 }
    fclose(f);
    
    b[1].insert(0);
    solve(N);
    
    ofstream of("cowjog.out");
    for (multiset<int>::IT it=b[N].begin(); it!=b[N].end(); it++)
     of<<*it<<"\n";
    Repi(K-b[N].SZ)
     of<<"-1\n";
    of.close();
    
    return 0;
}
