/*
ID: pascala1
PROG: cheer
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 10100
int n,m,N,M,P,T,K;
int d[MAXN],par[MAXN];
VI adj[MAXN],cost[MAXN];
int C[MAXN];
bool used[MAXN];

void prim()
{
	PQ<PI,vector<PI>,greater<PI> > q;
	memset(d,127,sizeof(d));
	memset(used,0,sizeof(used));
	d[1]=0; par[1]=0;
	q.push(MP(0,1));
	PI t; int v;
	while (!q.empty())
	 {
			t=q.top(); q.pop();
			if (used[t.y]) continue;
			used[t.y]=1;
			Repi(adj[t.y].SZ)
			 {
					int v=adj[t.y][i];
					if (!used[v] && d[v]>cost[t.y][i])
					 {
							par[v]=t.y;
							d[v]=cost[t.y][i];
							q.push(MP(d[v],v));
					 }
			 }
	 }
}

int main()
{
	freopen("cheer.in","r",stdin);
	freopen("cheer.out","w",stdout);
    scanf("%d%d",&N,&P);
    Repi(N)
     scanf("%d",C+i+1);
     
    Repi(P)
     {
			int a,b,c;
			scanf("%d%d%d",&a,&b,&c);
			adj[a].PB(b); adj[b].PB(a);
			c+=c+C[a]+C[b];
		//	cout<<" conn "<<a<<" "<<b<<" = "<<c<<endl;
			cost[a].PB(c); cost[b].PB(c);
	 }
    
    prim();
    
    int ans=0;
    Repi(N) ans+=d[i+1];
    int minn=INF;
    Repi(N) if (C[i+1]<minn) minn=C[i+1];
    ans+=minn;
    
//    Repi(N) cout<<i+1<<" "<<par[i+1]<<" "<<d[i+1]<<endl;
    printf("%d\n",ans);
    
    return 0;
}
