/*
ID: pascala1
PROG: mixup2
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;


#define MAXN 16
int num[MAXN];
LL dp[MAXN][1<<MAXN];

LL solve(int last,int used)
{
	LL &ret=dp[last][used];
	if (ret>-1) return ret;
	if (__builtin_popcount(used)==1) return ret=1;
	
	ret=0;
	Repi(N)
	 if ((used&(1<<i)) && abs(num[last]-num[i])>K)
	  ret+=solve(i,used^(1<<last));
	
	//cout<<" "<<last<<" "<<bitset<4>(used)<<" = "<<ret<<endl;
	return ret;
}

int brute()
{
	int a[MAXN];
	Repi(N)
	 a[i]=i;
	
	int br=0;
	do
	{
		int ok=1;
		Repi(N-1)
		 if (abs(num[a[i]]-num[a[i+1]])<=K) { ok=0; break; }
		if (ok) br++;
	}while (next_permutation(a,a+N));
	
	return br;
}

int main()
{
freopen("mixup2.in","r",stdin);
freopen("mixup2.out","w",stdout);


	cin>>N>>K;
	Repi(N) cin>>num[i];
    memset(dp,-1,sizeof(dp));
    
    LL ans=0;
    Repi(N)
     ans+=solve(i,(1<<N)-1);
    
    cout<<ans<<"\n";
   // cout<<brute()<<endl;
    return 0;
}
