/*
ID: pascala1
PROG: fence
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;
#define MAXN 256

PI p[MAXN],ps[MAXN];

inline int cp(const PI &A,const PI &B,const PI &C)
{  int dx1=B.x-A.x,dx2=C.x-A.x,dy1=B.y-A.y,dy2=C.y-A.y; return dx1*dy2-dx2*dy1; }

int at=0;
bool cmp(const int a,const int b)
{  return cp(p[at],p[a],p[b])>0;  }

int around;
bool cmp2sux(const int a,const int b) //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! atan2 sucks!!!
{   return atan2(p[a].y-p[around].y,p[a].x-p[around].x)<atan2(p[b].y-p[around].y,p[b].x-p[around].x); }
bool cmp2(const int a,const int b)
{
    if (p[a].y-p[around].y<0 && p[b].y-p[around].y>=0) return 1;
    if (p[b].y-p[around].y<0 && p[a].y-p[around].y>=0) return 0;
    return cp(p[around],p[a],p[b])>0;
}

int sorted[MAXN][MAXN],srtd[MAXN];
int pos[MAXN][MAXN],opos[MAXN][MAXN];
int dp[MAXN][MAXN];

int main()
{
	freopen("fence.in","r",stdin); freopen("fence.out","w",stdout);
    scanf("%d",&N); Repi(N) scanf("%d%d",&p[i].x,&p[i].y);
    sort(p,p+N);
    
    memset(pos,-1,sizeof(pos));  memset(opos,-1,sizeof(opos));
    Repi(N)
     { Repj(N) sorted[i][j]=j; swap(sorted[i][i],sorted[i][N-1]); 
       around=i;
       sort(sorted[i],sorted[i]+N-1,cmp2); 
       Repj(N-1) pos[i][sorted[i][j]]=j; 
       for (int j=0,k=1;;)
        {
            int sec=sorted[i][j];
            while (k!=j && cp(p[sec],p[around],p[sorted[i][k]])<0) { k++; if (k>=N-1) k=0; }
            opos[i][sec]=k;
            if (++j==N-1) break;
        }
     }
    Repi(N) srtd[i]=i;

    int ans=0,in;
    for (at=0;at<N-2;at++)
     {
            int leftmost;
            for (int i=at;i<N;i++)
             if (srtd[i]==at) { leftmost=i; break; }
            swap(srtd[at],srtd[leftmost]);
            sort(srtd+at+1,srtd+N,cmp); 
            memset(dp,0,sizeof(dp));
            for (int i=at+2;i<N;i++) dp[srtd[at+1]][srtd[i]]=3,ans=max(ans,3); 

            for (int lower=at+2;lower<N-1;lower++) 
             {
                    in=srtd[lower];
                    for (int tsum=0,ui=opos[in][at],bi=pos[in][at]; ;ui++) 
                     {
                            if (ui==N-1) ui=0;
                            if (ui==pos[in][at]) break;
                            if (sorted[in][ui]<at) continue;
                            while (bi!=ui && bi!=opos[in][sorted[in][ui]])
                             {
                                    tsum=max(tsum,(sorted[in][bi]>=at)*dp[sorted[in][bi]][in]);
                                    bi++; if (bi==N-1) bi=0;
                             }
                            dp[in][sorted[in][ui]]=max(tsum+1,3);
                            ans=max(ans,tsum+1);
                     }
            }
     }
    printf("%d\n",ans);
    return 0;
}
