/*
ID: pascala1
PROG: winchk
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;
#define MAXN 412

int mv[4][2]={
	{-2,2},
	{2,-2},
	{2,2},
	{-2,-2}
	};
char board[MAXN][MAXN];
inline bool valid(int x1,int y1,int x2,int y2)
{	return x2>=0 && y2>=0 && x2<N && y2<N && board[(x1+x2)>>1][(y1+y2)>>1]=='o' && board[x2][y2]=='+';   }


bool used[MAXN][MAXN];
int ansc[MAXN][MAXN];
int cc[MAXN][MAXN][4];
int dir[MAXN][MAXN];
PI prev[MAXN][MAXN];
PI forw[MAXN][MAXN][4];
int ans[MAXN][MAXN];
int go[MAXN][MAXN];
int lev[MAXN][MAXN];

void dfs(int x,int y)
{
	cout<<"  !!!in "<<x<<" "<<y<<" at "<<lev[x][y]<<endl;
	used[x][y]=1;
    int c[4]; memset(c,0,sizeof(c));
	Repk(4)
	 {
			int nx=x+mv[k][0],ny=y+mv[k][1];
			if (!valid(x,y,nx,ny) || used[nx][ny]) continue;
			lev[nx][ny]=lev[x][y]+1;
			dir[x][y]=k;
			cout<<"       from "<<x<<" "<<y<<" to "<<nx<<" "<<ny<<endl;
		    prev[nx][ny]=MP(x,y);
			dfs(nx,ny);
			c[k]=ans[nx][ny]+1;
			ansc[x][y]+=cc[x][y][k];
	 }
	cout<<"===ansc "<<x<<" "<<y<<" = "<<ansc[x][y]<<endl;
	Repk(4)
	 {
			int nx=x+mv[k][0],ny=y+mv[k][1];
			if (!valid(x,y,nx,ny) || lev[nx][ny]!=lev[x][y]+1) continue;
			int tmp=ansc[x][y]-cc[x][y][k]+c[k];
			if (tmp>ans[x][y])
			 {
			   ans[x][y]=tmp;
			   go[x][y]=k;
			 }
			cout<<"         ans "<<x<<" "<<y<<" >?= "<<ansc[x][y]<<" - "<<cc[x][y][k]<<" + "<<c[k]<<"  ;;; "<<go[x][y]<<endl;
	 }
	if (ansc[x][y]>ans[x][y]) ans[x][y]=ansc[x][y],go[x][y]=-1;
	cout<<"---ans "<<x<<" "<<y<<" = "<<ans[x][y]<<"   ;;; go = "<<go[x][y]<<endl;

    Repk(4)
     {
			int nx=x+mv[k][0],ny=y+mv[k][1];
			if (!valid(x,y,nx,ny)) continue;
			if (lev[nx][ny]+1<lev[x][y])
			  {
			    int dd=dir[nx][ny];
			    int tmp=ansc[x][y]+lev[x][y]-lev[nx][ny]+1;
			    if (tmp>cc[nx][ny][dd])
			     {
			       cc[nx][ny][dd]=tmp;
			       forw[nx][ny][dd]=MP(x,y);
				 }
			    cout<<"    from "<<x<<" "<<y<<" : cc "<<nx<<" "<<ny<<" "<<dd<<" >?= "<<ansc[x][y]<<" + "<<lev[x][y]<<" - "<<lev[nx][ny]<<" + 1\n";
			  }
	 }
}

void travcycs(int x,int y,int banned)
{
	printf("%d - %d\n",x+1,y+1);
    Repk(4)
     if (cc[x][y][k] && k!=banned)
     {
	   PI next=forw[x][y][k];
	   cout<<"               "<<x+1<<" "<<y+1<<" "<<k<<endl;
       travcycs(next.x,next.y,-1);
       do
        {
			next=prev[next.x][next.y];
			printf("%d = %d\n",next.x+1,next.y+1);
		}
       while (next.x!=x || next.y!=y);
	 }
}

void traverse(int x,int y)
{
	cout<<"     traverse "<<x+1<<" "<<y+1<<" "<<go[x][y]<<endl;
	travcycs(x,y,go[x][y]);
	Repk(4)
	 {
			int nx=x+mv[k][0],ny=y+mv[k][1];
			if (!valid(x,y,nx,ny)) continue;
			if (k==go[x][y])
			 {
					traverse(nx,ny);
			 }
	 }
}

int main()
{
       freopen("winchk.in","r",stdin); freopen("winchk.out","w",stdout);
    scanf("%d",&N);
	Repi(N)
	 scanf("%s",board[i]),cout<<board[i]<<"\n";
	
	memset(go,-1,sizeof(go));
	PI king=MP(-1,-1); int bans=0,gott=-1;
	Repi(N)
	 Repj(N)
	  if (board[i][j]=='K')
	   {
			int anss=0,got=-1;
			Repk(4)
			 {
					int nx=i+mv[k][0],ny=j+mv[k][1];
					if (!valid(i,j,nx,ny)) continue;
					lev[nx][ny]=1;
					dfs(nx,ny);
					if (ans[nx][ny]+1>anss)
					 {
							anss=ans[nx][ny]+1; got=k;
							cout<<"+++++++++++++++++++++++++++ king "<<i<<" "<<j<<" - ans "<<anss<<" go "<<got<<endl;
					 }
			 }
			if (anss>bans)
			 {
					king=MP(i,j);
					gott=got;
					bans=anss;
			 }
	   }
	   
    if (king.x==-1)
     {
			printf("impossible\n"); return 0;
	 }
	
	printf("%d %d\n",king.x+1,king.y+1);
	int x=king.x,y=king.y;
	x+=mv[gott][0],y+=mv[gott][1];
	traverse(x,y);
    
    return 0;
}
