#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 1024
#define EPS 1e-4
int n,m,M,P,T,K;

int N;
struct line
   {  
		PD A,B;
		line(){};
		line(double a,double b,double c,double d){ A=MP(a,b); B=MP(c,d); if (A>B) swap(A,B); };
	};
line lines[MAXN];

inline double cp(const PD &A,const PD &B,const PD &C)
{
	double dx1=B.x-A.x,dx2=C.x-A.x,dy1=B.y-A.y,dy2=C.y-A.y;
	return dx1*dy2-dx2*dy1;
}

inline PD intersect(const PD &A,const PD &B,const PD &C,const PD &D)
{
	double s1=cp(A,C,D),s2=s1+cp(C,B,D);
	if (fabs(s2)<EPS) return MP(1e100,1e100);
	return MP( A.x+(B.x-A.x)*s1/s2 , A.y+(B.y-A.y)*s1/s2 );
}

inline bool isin(const PD &X,const PD &A,const PD &B)
{	return X.x>MIN(A.x,B.x)-EPS && X.x<MAX(A.x,B.x)+EPS && X.y>MIN(A.y,B.y)-EPS && X.y<MAX(A.y,B.y)+EPS; }





void bf()
{
	PD X;
	cout<<endl; int cnt=0;
	Repi(N)
	 for (int j=i+1;j<N;j++)
	  {
	   X=intersect(lines[i].A,lines[i].B,lines[j].A,lines[j].B);
	   if (isin(X,lines[i].A,lines[i].B) && isin(X,lines[j].A,lines[j].B))
	    {
	           cout<<"                     "<<X.x<<" "<<X.y<<" of "<<i<<" and "<<j<<endl;
	           cnt++;
		}
	  }
	cout<<"       total "<<cnt<<" intersections\n";
}




//type: 0 - line start; 1 - line intersection; 2 - line end

struct event
{
	PD X; int type,line1,line2;
	event(){};
	event(const PD &XX,int tip,int l1,int l2):X(XX),type(tip),line1(l1),line2(l2){};
};

bool operator<(const event &e1,const event &e2)
{	return (e1.X.x==e2.X.x)?(e1.type==e2.type)?e1.X.y>e2.X.y:e1.type>e2.type:e1.X.x>e2.X.x; }


PQ<event> q;
double atx;
set<int> active;

void bentleyottoman()
{
	Repi(N)
	 q.push(event(lines[i].A,0,i,6661313)),q.push(event(lines[i].B,2,i,6661349));
	 
	event cur;
	vector<event> q2;
	while (!q.empty())
	 {
			cur=q.top(); q.pop();
			atx=cur.X.x;
			
			if (cur.type==0 && lines[cur.line1].A.x==lines[cur.line1].B.x)
			 {
					//verticallll
			 }
			if (cur.type==0)
	 }
}

int main()
{
    freopen("bentley.in","r",stdin);
    freopen("bentley.out","w",stdout);
    
	int a,b,c,d;
	N=0;
    while (cin>>a>>b>>c>>d)
     {
			cout<<" line "<<N<<" : "<<a<<" "<<b<<" -> "<<c<<" "<<d<<endl;
			lines[N++]=line(a,b,c,d);
	 }


	bf();
	
	bentleyottoman();
	
			
    return 0;
}
