/*
PROG:tower
LANG:C++
ID:pascala1
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

const int MAXN=100100;
int w[MAXN];
int N;
int dp[MAXN];
int last[MAXN];
int sum[MAXN];

int bans;
void brute(int pos,int last,int lev)
{
	if (pos==N+1)
	 {
			bans=max(bans,lev);
			return;
	 }
	int width=0;
	for (int i=pos;i<=N;i++)
	 {
			width+=w[i];
			if (width>=last)
			 {
			   brute(i+1,width,lev+1);
			   //cout<<"         from "<<pos<<" "<<last<<" "<<lev<<" to "<<i+1<<" "<<width<<" "<<lev+1<<"\n";
			 }
	 }
}

int main()
{
//	freopen("tower.in","r",stdin); freopen("tower.out","w",stdout);
 /*	scanf("%d",&N);
	Repi(N)
	 scanf("%d",w+i+1); */
	srand(3352);

while(1)
{
	N=100;
	Repi(N) w[i+1]=rand()%2+1;
	Repi(N) cout<<w[i+1]<<" ";cout<<"\n";
	reverse(w+1,w+N+1);
	
	bans=0;
	brute(1,0,0);
	cout<<" bRUTE "<<bans<<"\n";
	
	sum[0]=0;
	for (int i=1;i<=N;i++) sum[i]=sum[i-1]+w[i];
	dp[0]=last[0]=0;
	
	PQ<PI,vector<PI>,greater<PI> > q1;
	PQ<int> q;
	q1.push(MP(0,0));
	
	for (int i=1;i<=N;i++)
	 {
			int ww=w[i];
		//	cout<<" at "<<w[i]<<"\n";
			while (!q1.empty() && q1.top().x<=sum[i]) q.push(q1.top().y),q1.pop();
			int j=q.top();
		
		//	for (int j=i-1;j>=0;j--)
			 {
					if (last[j]+sum[j]<=sum[i]) { last[i]=sum[i]-sum[j]; 
									   dp[i]=dp[j]+1;
								//	   cout<<" to "<<i<<" from "<<j<<" - new dp "<<dp[i]<<" new last "<<last[i]<<"\n";
					 			//	   break;
										 }
			 }
			 
			q1.push(MP(last[i]+sum[i],i));
			//cout<<last[i]<<" - "<<dp[i]<<"\n";
	 }
	printf("%d\n",dp[N]);
	
	system("pause");
}
	return 0;
}

