/*
PROG:ontherun
LANG:C++
ID:pascala1
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

int N,L;
int p[1024];
int curt[1024][1024];
int bestans[1024][1024];

struct state{ int st,en,time,ans;
state(){}; state(int s,int e,int t,int t1):st(s),en(e),time(t),ans(t1){};
 };
bool operator<(const state &a,const state &b)
{ return (a.time==b.time)?a.ans>b.ans:a.time>b.time; }

int main()
{
	freopen("ontherun.9.in","r",stdin); freopen("ontherun.out","w",stdout);
	scanf("%d%d",&N,&L);
	Repi(N)
	 scanf("%d",&p[i]);
	p[N++]=L;
	sort(p,p+N);
	
//	Repi(N) cout<<i<<" --- "<<p[i]<<endl;
	
	int s,e,t,a; Repi(N) if (p[i]==L) { s=e=i; break; }
	int ans=1000000000;
	PQ<state> q;
	q.push(state(s,e,0,0));
	memset(curt,-1,sizeof(curt)); memset(bestans,127,sizeof(bestans));
	while (!q.empty())
	 {
			state tmp=q.top(); q.pop(); s=tmp.st,e=tmp.en,t=tmp.time,a=tmp.ans;
		//	cout<<"  in "<<tmp.st<<" "<<tmp.en<<" : "<<tmp.time<<" "<<tmp.ans<<" ("<<curt[s][e]<<" "<<bestans[s][e]<<")"<<endl;
			if (a>=bestans[s][e]) { // cout<<"      rejected...\n"; 
				                           continue;   }
			if ((s==0 && e==N-1) || (s==N-1 && e==0)) ans=min(ans,a);
			curt[s][e]=t,bestans[s][e]=a;
			if (s<=e)
			 {
					if (s) 
					 {
					 //  cout<<"                  going left -> "<<s-1<<" "<<e<<" : "<<t+p[s]-p[s-1]<<" "<<a+t+p[s]-p[s-1]<<endl;
					   tmp=state(s-1,e,t+p[s]-p[s-1],a+t+p[s]-p[s-1]);
					   if (curt[s-1][e]>=tmp.time || bestans[s-1][e]>=tmp.ans)
					   q.push(tmp);
					 }
					if (e<N-1)
					 {
					//	cout<<"                  going right -> "<<e+1<<" "<<s<<" : "<<t+p[e+1]-p[s]<<" "<<a+t+p[e+1]-p[s]<<endl;
						tmp=state(e+1,s,t+p[e+1]-p[s],a+t+p[e+1]-p[s]);
						if (curt[e+1][s]>=tmp.time || bestans[e+1][s]>=tmp.ans)
						q.push(tmp);
					 }
			 }
			else
			 {
					if (e)
					 {
					 //  cout<<"                  going left -> "<<e-1<<" "<<s<<" : "<<t+p[s]-p[e-1]<<" "<<a+t+p[s]-p[e-1]<<endl;
					   tmp=state(e-1,s,t+p[s]-p[e-1],a+t+p[s]-p[e-1]);
					   if (curt[e-1][s]>=tmp.time || bestans[e-1][s]>=tmp.ans)
					   q.push(tmp);
					 }
					if (s<N-1)
					 {
					//	cout<<"                  going right -> "<<e+1<<" "<<s<<" : "<<t+p[s+1]-p[s]<<" "<<a+t+p[s+1]-p[s]<<endl;
						tmp=state(s+1,e,t+p[s+1]-p[s],a+t+p[s+1]-p[s]);
					    if (curt[s+1][e]>=tmp.time || bestans[s+1][e]>=tmp.ans)
						q.push(tmp);
					 }
			 }
	 }
	printf("%d\n",ans);
	return 0;
}

