/*
ID: pascala1
PROG: betsy
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,ans,u[8][8],br,N;

void dfs(char row,char col)
{
     if (row<0 || col<0 || row>n-1 || col>n-1 || u[row][col]) return;
 //    cout<<(int)row<<" "<<(int)col<<" "<<br<<endl;
 //    Repi(n) { Repj(n) cout<<u[i][j]; cout<<endl; } cout<<endl;
     if (br==N && row==n-1 && col==0)
      { ans++; return; }
     u[row][col]=1;
     br++;
     dfs(row+1,col);
     dfs(row,col+1);
     dfs(row-1,col);
     dfs(row,col-1);
     br--;
     u[row][col]=0;
}

int main()
{
    int i,j,k,l;
    ifstream f("betsy.in");
    f>>n;
    f.close();
    N=n*n-1;
    if (n<6)
     dfs(0,0);
    else ans=(n==6)*1770+(n==7)*88418; 
//    pause;
    
    ofstream of("betsy.out");
    of<<ans<<"\n";
    of.close();
    
    return 0;
}
