//N dijkstra's
/*
ID: pascala1
PROG: butter
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,N,P,C;
int cow[512];
VI a[1024];
int c[1024][810];
int d[1024][810];
int MAX;

void dijkstra(int v,int d[])
{
     d[v]=0;
     PQ<PI, vector<PI>, greater<PI> > q;
     q.push(MP(0,v));
     bool u[1024]; memset(u,0,sizeof(u));
     PI t; int w;
     while (!q.empty())
     {
          t=q.top();
          q.pop();
          if (u[t.y]) continue;
          u[t.y]=true;
          Repi(a[t.y].SZ)
           {
                         w=a[t.y][i];
                         if (d[w]>t.x+c[t.y][w] && !u[w])
                          {
                                                d[w]=t.x+c[t.y][w];
                                                q.push(MP(d[w],w));
                          }
           }
     }
}

int main()
{
    int i,j,k,l;
    FILE *f;
    f=fopen("butter.in","r");
    fscanf(f,"%d%d%d",&N,&P,&C);
    Repi(N) fscanf(f,"%d",&cow[i]);
    Repi(C) { fscanf(f,"%d%d%d",&j,&k,&l);
     a[j].PB(k); a[k].PB(j); c[j][k]=l; c[k][j]=l; 
     }
    fclose(f);

    
    memset(d,1,sizeof(d)); MAX=d[0][0];
    
    Repi(N)
     if (d[cow[i]][cow[i]])
      dijkstra(cow[i],d[cow[i]]); 
      
     long long ans=INF,tmp;
    Repi(P+1)
     {
           tmp=0; Repj(N) tmp+=(LL)d[cow[j]][i];
           ans=min(ans,tmp);
//           if (ans!=l)  cout<<i<<endl;
     }
    
    ofstream of("butter.out");
    of<<ans<<"\n";
    of.close();

     pause;  
    return 0;
}
