/*
ID: pascala1
PROG: castle
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;

int w[64][64],gr[64][64];
int br[64*64],grc;

void dfs(int r,int c)
{
     if (r<0 || r==n || c<0 || c>m) return;
     if (gr[r][c]>-1) return;
    // cout<<"in "<<r<<" "<<c<<endl;
     gr[r][c]=grc; br[grc]++;
     if (!(w[r][c]&1)) dfs(r,c-1);
     if (!(w[r][c]&2)) dfs(r-1,c);
     if (!(w[r][c]&4)) dfs(r,c+1);
     if (!(w[r][c]&8)) dfs(r+1,c);
}

int main()
{
    int i,j,k,l;
    ifstream f("castle.in");
    f>>m>>n;
    Repi(n)
     Repj(m)
      f>>w[i][j];
    f.close();
    
    memset(gr,255,sizeof(gr));
    Repi(n)
     Repj(m)
      if (gr[i][j]==-1)
      {//  cout<<"group "<<grc<<endl;
      dfs(i,j);grc++;
       }
 /*      
    cout<<grc<<endl;
    Repi(n)  {  
     Repj(m)
      cout<<setw(3)<<gr[i][j]; cout<<endl; }
      pause;
    */
    int M=0;
    Repi(grc)
     M=max(M,br[i]);
     
    int MM=0,r,c,tmp; char dir;
    Repi(n) 
     Repj(m)
      {
        if (i>0 && w[i][j]&2 && gr[i][j]!=gr[i-1][j])
         { tmp=br[gr[i][j]]+br[gr[i-1][j]];
           if (tmp>MM || (tmp==MM && (j<c || (j==c && i>r) ) ))
            {
                      MM=tmp;
                      r=i; c=j; dir='N';
            }
         }
        if (j<m-1 && w[i][j]&4 && gr[i][j]!=gr[i][j+1])
         { tmp=br[gr[i][j]]+br[gr[i][j+1]];
           if (tmp>MM || (tmp==MM && (j<c || (j==c && i>r) ) ))
            {
                      MM=tmp;
                      r=i; c=j; dir='E';
            }
         }
      }  
    
    ofstream of("castle.out");
    of<<grc<<"\n"<<M<<"\n";
    of<<MM<<"\n"<<r+1<<" "<<c+1<<" "<<dir<<"\n";
    of.close();

    return 0;
}
