//dijkstra
/*
ID: pascala1
PROG: comehome
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;

bool u[256];
int d[256];
VI a[256];
VI b[256];

int main()
{
    int i,j,k,l;
    ifstream f("comehome.in");
    f>>m; char c1,c2;
    Repi(m)
     { f>>c1>>c2>>l;
       a[(int)c1].PB((int)c2);
       a[(int)c2].PB((int)c1);
       b[(int)c1].PB(l);
       b[(int)c2].PB(l);
       cout<<(int)c1<<" "<<(int)c2<<" "<<l<<endl;
      }
    f.close();

    PQ< PI, vector<PI>, greater<PI> > q;
    memset(d,127,sizeof(d));
    q.push(MP(0,'Z')); d['Z']=0;
    PI t; int v;
    while (!q.empty())
    {
          t=q.top();
          q.pop();
          cout<<(char)t.y<<" "<<t.x<<endl;
          cout<<a[t.y].SZ<<endl;
          if (u[t.y]) continue;
          u[t.y]=true;
          Repi(a[t.y].SZ)
          { v=a[t.y][i];
            if (!u[v] && t.x+b[t.y][i]<d[v])
             {
                      d[v]=t.x+b[t.y][i];
                      q.push(MP(d[v],v));
             }
          }
    }
    
    int M=0;
    for (i='A'; i<'Z'; i++)
     if (d[M]>d[i]) M=i;
     
    
    ofstream of("comehome.out");
    of<<(char)M<<" "<<d[M]<<"\n";
    of.close();

    return 0;
}
