/*
ID: pascala1
PROG: contact
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,A,B,N;
int a[13][200002];

int br[13][1<<13];

vector<PI> cnt[200002];

string ss;

inline string out(int l,int v)
{
       int k=0;
       ss="";
       while (v>0) 
        { ss+=(char)(v%2+'0'); v/=2; k++; }
       while (ss.SZ<l) ss+="0";
       reverse(ALL(ss));
       return ss;
}

int main()
{
    int i,j,k,l;
    ifstream f("contact.in");
    
    string s,s1;
    f>>A>>B>>N;
    while (f>>s1)
     s+=s1;
    n=s.length();
    memset(a,255,sizeof(a));
    Repi(n)
     { a[1][i]=s[i]-'0'; br[1][a[1][i]]++; }
    f.close();

    for (int i=2; i<=B; i++)
    {
     Repj(n)
      if (j>0 && a[i-1][j-1]>-1)
       {
        a[i][j]=a[i-1][j-1]*2+a[1][j];
        br[i][a[i][j]]++;
       }
   /*    
     cout<<"row ";
      Repj(n) 
        cout<<setw(3)<<a[i][j];
    cout<<endl; */
   }
   pause;
   
    for (int i=A; i<=B; i++)
     Repj( (1<<B) )
      if (br[i][j]>0)
      {
       cnt[br[i][j]].PB(MP(i,j));
       m=max(m,br[i][j]);
      }
//       cout<<i<<" "<<j<<" = "<<br[i][j]<<endl;

    Repi(m+1)
     sort(ALL(cnt[i]));
      
    ofstream of("contact.out");
    int c=0;
    for (int i=m; i>=0 && c<N; i--)  
     if (cnt[i].SZ>0)
      {
                     of<<i; l=cnt[i].SZ-1;
                     Repj(l) { if (j%6==0) of<<"\n"; of<<out(cnt[i][j].x,cnt[i][j].y);
                      if ((j+1)%6!=0) of<<" ";
                      }
                     if (l%6==0) of<<"\n";
                     of<<out(cnt[i][l].x,cnt[i][l].y)<<"\n";
                     c++;
      }
      
      
    of.close();


    return 0;
}
