/*
ID: pascala1
PROG: cryptcow
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

#define MAXQ 16
//here is what makes the damn bitch work 1 sec faster ;)
#define HSZ 79999

int n,m;
char S[80],ES[]="Begin the Escape execution at the Break of Dawn\n";
char q[MAXQ][80];
char lev[MAXQ];
int cnt[256],cn1[256];
int subc;
char substrings[125000],*ss,*subs[2500];
unsigned long long hash[2500],hashv=91LL;
bool u[HSZ];

int TLE=(int)((double)0.97*(double)CLOCKS_PER_SEC);

void OUT(int a,int b)
{
    ofstream of("cryptcow.out");
    of<<a<<" "<<b<<"\n";
    of.close();
}

bool found;
char *ch;

inline bool isvalid(char s[])
{
        ch=strchr(s,'C');
        if (ch==NULL) ch=s+strlen(s);
        if (strncmp(s,ES,ch-s)) return 0;
        ch=strrchr(s,'W');
        if (ch==NULL) ch=s-1;
        if (strncmp(ch+1,ES+49-strlen(ch),strlen(ch)-1))
          return 0;
        return 1;
}

bool cmp(const char *a,const char *b)
{
     return (strcmp(a,b)<0)?1:0;
}



inline bool vsepaknestava(char s[])
{
       char **ch=lower_bound(subs,subs+subc,s,cmp);
    //   printf("%s == %s\n",s,*ch); pause;
       if (ch>=subs+subc) 
        return 1;
       if (strcmp(*ch,s)) 
        return 1;
       return 0;
}

inline void HASH(ULL &a,char s[])
{
       a=0;
       Repi(strlen(s))
        { a*=hashv; a+=(LL)(s[i]-' '+1); }
}

inline bool vsepaknestavaNEW(char s[])
{
       ULL t;
       HASH(t,s);
       ULL *it=lower_bound(hash,hash+subc,t);
       if (it>=hash+subc) 
        return 1;
       if (*it!=t) 
        return 1;
       return 0;
}

char t[16][76];
int times=0;

void dfs(int s)
{
       ULL a; HASH(a,q[s]);
       int oi=int(a%(LL)HSZ);
       if (u[oi]) return;
       u[oi]=true;
   //  if (s>=0) printf("%d : %s\n",s,q[s]); pause;
        if (!strcmp(q[s],ES)) { OUT(1,s); found=true; return; }
        if (!isvalid(q[s])) return;
        int c[10],cc=0,oc=0,wc=0,o[10],w[10];
        oi=-1;
        char t[75];
        Repi(strlen(q[s]))
        if (q[s][i]=='C' || q[s][i]=='O' || q[s][i]=='W')
        {
         if (q[s][i]=='C') c[cc++]=i;
         else if (q[s][i]=='O') o[oc++]=i;
         else if (q[s][i]=='W') w[wc++]=i;
         memset(t,'\0',sizeof(t));
         strncpy(t,q[s]+oi+1,i-oi-1);
         if (i-oi>2 && vsepaknestavaNEW(t)) return;
         oi=i;
        }
        for (int C=0; C<cc; C++)
         for (int O=0; O<oc; O++)
          if (o[O]>c[C])
           for (int W=wc-1; W>=0; W--)
            if (w[W]>o[O])
              {
                              memset(q[s+1],'\0',76);
                              memcpy(q[s+1],q[s],c[C]);
                              memcpy(q[s+1]+c[C],q[s]+o[O]+1,w[W]-o[O]-1);
                              memcpy(q[s+1]+c[C]+w[W]-o[O]-1,q[s]+c[C]+1,o[O]-c[C]-1);
                              memcpy(q[s+1]+w[W]-2,q[s]+w[W]+1,strlen(q[s])-w[W]);
                           //   printf("%s %d\n",q[s+1],s+1);  pause;
                            //  if (s==1) cout<<"yey\n";
                              dfs(s+1);
                              if (found || clock()>TLE) return;
              } else break;
}

int main()
{
    int i,j,k,l,O,W,C;
  
    FILE *f=fopen("cryptcow.in","r");
    fgets(S,80,f);
    fclose(f);

//    printf("%s\n",S);
//    pause;
    if (!strcmp(S,ES)) { OUT(1,0); return 0; }

    ss=substrings;
    for (int i=0; i<strlen(ES)-1; i++)
     for (int j=i+1; j<strlen(ES); j++)
     {
      strncpy(ss,ES+i,j-i+1);
      subs[subc++]=ss;
      ss+=strlen(ss)+1;
     }
//    sort(subs,subs+subc,cmp);  
    Repi(subc)
     HASH(hash[i],subs[i]);
    sort(hash,hash+subc);         
    
/*    char tmp1[80],tmp2[80];
    strcpy(tmp1,"fg ");
    strcpy(tmp2,"fgJ");
    cout<<strcmp(tmp1,tmp2)<<endl;
    Repi(subc)
     printf("%s\n",subs[i]);
    pause;
   char tmp[]="Begin the Esc";
   char **ch=lower_bound(subs,subs+subc,tmp,cmp);
   printf("%s\n",*ch);
   pause;
    */

    Repi(strlen(ES))
    cn1[ES[i]]++;
    Repi(strlen(S)) 
     cnt[S[i]]++;
    for (int i=32; i<=128; i++)
     if (i!='O' && i!='C' && i!='W')
      if (cn1[i]!=cnt[i])
        { OUT(0,0); return 0; }
    if (!( cnt['C']==cnt['O'] && cnt['O']==cnt['W'] ) ) 
      { OUT(0,0); return 0; }
    

    strcpy(q[0],S); lev[0]=0;
    srand(time(NULL));
    
    dfs(0);
    
/*    for (int s=0,e=1; s!=e; s++)
    {
        if (s==MAXQ) s=0;
        if (!strcmp(q[s],ES)) { OUT(1,lev[s]); return 0; }
        l=strlen(q[s]);
        for (C=0; C<l-2; C++)
         if (q[s][C]=='C')
          for (O=C+1; O<l-1; O++)
           if (q[s][O]=='O')
            for (W=O+1; W<l; W++)
             if (q[s][W]=='W')
              {
                              strncpy(q[e],q[s],C);
                              strncat(q[e],q[s]+O+1,W-O-1);
                              strncat(q[e],q[s]+C+1,O-C-1);
                              strncat(q[e],q[s]+W+1,l-W);
                              lev[e]=lev[s]+1;
                            //  printf("%s %d\n",q[e],lev[e]);  pause;
                              e++; if (e==MAXQ) e=0;
              }
    }
*/

cout<<clock()<<" "<<TLE<<endl<<endl; pause;

l=0;
Repi(strlen(q[0]))
 if (q[0][i]=='W') l++;
 
if (clock()>TLE && !found)
  OUT(1,l);
else  
if (!found)
  OUT(0,0);
  
    return 0;
}
