/*
ID: pascala1
PROG: fence6
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,ans=INF;
int v[128],nod;
int go[128][128];
VI a[128][2];
int d[128][2];

int dfs(int node,int side)
{
    if (node==nod && side==1) return 0;
    if (d[node][side]>-1) return d[node][side];
    int &r=d[node][side]=INF;
    Repi(a[node][side].SZ)
     r=min(r,dfs( a[node][side][i] , go[node][a[node][side][i]] ));
    r+=v[node];
    cout<<node<<" "<<side<<" = "<<r<<endl;
    pause;
    return r;
}

int tek=0;
bool u[128];
void brute(int node,int side)
{
    if (nod==node && side==0 && tek>0) { ans=min(ans,tek); return; }
    if (u[node] || v[node]+tek>ans) return;
    tek+=v[node]; u[node]=true;
//    Repi(n) if (u[i+1]) cout<<i+1<<" "; cout<<" = "<<tek<<endl;
    Repi(a[node][side].SZ)
     brute(a[node][side][i],go[node][a[node][side][i]]);
    tek-=v[node]; u[node]=false;
}

bool cmp(int a,int b)
{ return v[a]<v[b]; }

int main()
{
    int i,j,k,l,k1,k2,e;
    FILE *f=fopen("fence6.in","r");
    fscanf(f,"%d",&n);
    Repi(n)
     {
           fscanf(f,"%d%d%d%d",&j,&l,&k1,&k2);
           v[j]=l;
           Repi(k1)
           {
                   fscanf(f,"%d",&l);
                   a[j][0].PB(l);
                   go[l][j]=1;
           }
           Repi(k2)
           {
                   fscanf(f,"%d",&l);
                   a[j][1].PB(l);
                   go[l][j]=0;
           }
     }
    fclose(f);

   int ii[128]; Repi(n) ii[i]=i+1;
   sort(ii,ii+n,cmp);
    Repi(n)
     {
           nod=ii[i];
           memset(d,255,sizeof(d));
           cout<<"  start "<<nod<<" 0\n";
           //ans=min(ans,dfs(i+1,0));
           brute(nod,0);
        //   cout<<ans<<endl; pause;
     }
    
    ofstream of("fence6.out");
    of<<ans<<"\n";
    of.close();

    return 0;
}
