/*
ID: pascala1
PROG: fence8
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <bitset>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,R,m=INF,r,left,sumb[1024],suma[55],Tota,Totb,a[56],b[1024],ans=0,f[56],ml,Tek;

int u[1024],end[1024],v[130],c[130];


inline int sumA(int en,int st) { 
       return suma[en]-((st>0)?suma[st-1]:0); }

int TLE=(double)0.60*(double)CLOCKS_PER_SEC;

int notused[64][1024],id[64][1024],sumu[64][1024];

void rec(int board)
{
     ans=max(ans,Tek);
     if (board==n) return;
     if (Totb > sumA(n-1,board) )  return;
     int r=0,br=0,F=0,j,k,l,M,lastM; bool fl;
     Repi(R) if (!u[i]) { notused[board][r++]=i; sumu[board][r-1]=b[i]+((r>1)?sumu[board][r-2]:0); }
     for (br=0; br<r; br++) if (F+b[notused[board][br]]>a[board]) break; else F+=b[notused[board][br]];
     
     lastM=0; int X=max(0,br-2),MAX=0;
     Repi(r) if (b[notused[board][i]]<=a[board]) MAX=max(MAX,b[notused[board][i]]);
     for (;br>X;br--)
     {
         F=0; M=br-1;
         Repi(br-1) { F+=b[notused[board][i]]; id[board][i]=i; }
         for (l=br; l<r; l++)
          if (F+b[notused[board][l]]<=a[board]) M=l; else break;
         id[board][br-1]=max(lastM,br-1);
         
         fl=true; 
         F+=b[notused[board][id[board][br-1]]];
         while(1)
         {
                if (board==1) 
                {
             //    cout<<"board: "<<board<<" ("<<a[board]<<") - "<<F<<" "<<fl<<" "<<M<<" "<<br<<"   "<<ans<<endl;
             //    cout<<"left: "; Repi(r) cout<<b[notused[board][i]]<<" "; cout<<endl;
             //    cout<<"current: "; Repi(br) cout<<id[board][i]<<" ("<<b[notused[board][id[board][i]]]<<") "; cout<<endl;
             //    pause;
                }
                 
                if (fl)
                {
                       Repi(br) u[notused[board][id[board][i]]]=true; Totb-=F; Tek+=br; MAX=max(F,MAX);
                       rec(board+1);
                       if (ans==R) return;
                       if (clock()>TLE) return;
                       Repi(br) u[notused[board][id[board][i]]]=false; Totb+=F; Tek-=br;
                }
                
                if (board==0 && br==2)
                 board=0;

                fl=true;
                for(j=br-1; j>=0; j--)
                 if ((j==br-1 && id[board][j]<M) || (j<br-1 && id[board][j]+1<id[board][j+1]))
                  break;
                if (j==-1) break;
                id[board][j]++;
                if (sumu[board][id[board][0]+br-1]-((id[board][0]>0)?sumu[board][id[board][0]-1]:0)>a[board]) break;
                if (b[notused[board][id[board][j]]]==b[notused[board][id[board][j]-1]]) fl=false;
                F=F-b[notused[board][id[board][j]-1]]+b[notused[board][id[board][j]]];
                for (j++;j<br;j++) { F=F-b[notused[board][id[board][j]]]+b[notused[board][id[board][j-1]+1]]; id[board][j]=id[board][j-1]+1; }
//                if (id[board][br-1]<=lastM) fl=false;
                if (F>a[board]) fl=false;
                if (F<MAX) fl=false;
                if (fl)
                Repi(br) if (id[board][i]>0 && id[board][i]!=id[board][i-1]+1 && b[notused[board][id[board][i]-1]]==b[notused[board][id[board][i]]]) { 
                         fl=false; 
                         break; }
         }
         
         lastM=M;
     }
     rec(board+1);
}


int main()
{
    int i,j,k,l;
    ifstream f("fence8.in");
    f>>n; Repi(n) f>>a[i];
    f>>r; Repi(r) f>>b[i];
    f.close();

    sort(a,a+n);// reverse(a,a+n);
    srand(6661313);
//    random_shuffle(a,a+n);
    
    sort(b,b+r);
    
    end[r-1]=r-1;
    for (int i=r-2; i>=0; i--)
     if (b[i]==b[i+1]) end[i]=end[i+1]; else end[i]=i;
/*    v[0]=b[0]; c[0]=1; N=1;
    Repi(r-1) if (b[i+1]!=b[i]) v[N++]=b[i+1]; else c[N-1]++;
    */

    Repi(n) { Tota+=a[i]; suma[i]=Tota; }
    for (R=0; R<r; R++)
    {
        Totb+=b[R];
        sumb[R]=Totb;
        if (Totb>Tota) break;
    }
    if (R<r) Totb-=b[R];
    Repi(R) c[b[i]]++;
    
    for (R; R>0; R--)
    {
     Totb=sumb[R-1];
     cout<<endl<<R<<endl;
     rec(0);
     if (ans>=R) break;
    }

    ofstream of("fence8.out");
    of<<ans<<"\n";
    of.close();

   cout<<(double)clock()/(double)CLOCKS_PER_SEC<<endl; pause;

    return 0;
}
