/*
ID: pascala1
PROG: game1
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,a[128],s[128],d[128][128];

inline int sum(int st,int en)
{ return  s[en]-((st>0)?s[st-1]:0);   }

int go(int st,int en)
{
    if (st==en) return a[st];
    if (d[st][en]>-1) return d[st][en];
    return d[st][en]=sum(st,en)-min( go(st+1,en) , go(st,en-1) );
}

int main()
{
    int i,j,k,l;
    ifstream f("game1.in");
    f>>n;
    Repi(n) { f>>a[i]; s[i]=a[i]+((i>0)?s[i-1]:0); }
    f.close();
    
    
    memset(d,255,sizeof(d));
    ofstream of("game1.out");
    of<<go(0,n-1)<<" "<<sum(0,n-1)-go(0,n-1)<<"\n";
    of.close();

    return 0;
}
