/*
ID: pascala1
PROG: hamming
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,N,B,D;

inline int dif(int a,int b)
{ return __builtin_popcount(a^b); }

int main()
{
    int i,j,k,l;
    ifstream f("hamming.in");
    f>>N>>B>>D;
    f.close();
    
    bool fl;
    int a[1000],br=0;
    for (int i=0; i<(1<<B); i++)
    { 
      fl=false;
      Repj(br)
       if (dif(a[j],i)<D) {fl=true; break;}
      if (fl) continue;
      a[br++]=i; 
      if (br==N) break;
     }
    
    ofstream of("hamming.out");
    Repi(N)
    {
     of<<a[i];
     if ((i+1)%10==0 || i==N-1)
      of<<"\n"; else of<<" ";
    }
    of.close();

    return 0;
}
