/*
ID: pascala1
PROG: hidden
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
char s[100100];
ULL h[100100],p[100100];

inline ULL hash(int start,int end)
{
	if (start<=end)
	 return h[end+1]-h[start]*p[end-start+1];
	else
	 return h[end+1]+(h[n]-h[start]*p[n-start])*p[end+1];
}

int main()
{
    int i,j,k,l;
    FILE *f=fopen("hidden.in","r");
    fscanf(f,"%d",&n);
    Repi(n/72+1)
     fscanf(f,"%s",s+i*72);
    fclose(f);
    
    p[0]=1; for (int i=1;s[i];i++) p[i]=p[i-1]*29LL;
    h[0]=0; for (int i=0;s[i];i++) h[i+1]=h[i]*29LL+(ULL)(s[i]-'a');
    
//    cout<<s<<endl;
//    for (int i=0;s[i];i++) cout<<h[i+1]<<" "; cout<<endl;
    int ans=0,m;
    for (int i=1;i<n;i++)
     {
			int l=0,r=n-1;
//			cout<<ans<<" "<<i<<":\n";
			while (l<r)
			 {
					m=(l+r)/2;
//					cout<<l<<" "<<r<<" -> "<<m<<": "<<hash(i,(m+i)%n)<<" "<<hash(ans,(m+ans)%n)<<endl;
					if (hash(i,(m+i)%n)==hash(ans,(m+ans)%n)) l=m+1;
					else r=m;
			 }
			if (r<n-1 && ((s[(i+r)%n]<s[(ans+r)%n]) || ((s[(i+r)%n]==s[(ans+r)%n]) && s[(r+i+1)%n]<s[(r+ans+1)%n]))) ans=i;
//			cout<<l<<" "<<r<<endl;
	 }
//	cout<<ans<<endl;
    
    //pause;
    ofstream of("hidden.out");
    of<<ans<<"\n";
    of.close();
    
    return 0;
}
