/*
ID: pascala1
PROG: holstein
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,g[16][1024],a[1024],t[1024];


int main()
{
    int i,j,k,l;
    ifstream f("holstein.in");
    f>>m;
    Repi(m)
     f>>a[i];
    f>>n;
    Repi(n)
     Repj(m)
      f>>g[i][j];
    f.close();

     bool fl;
    VI ans;
    ans.resize(1000);
    for (int i=1; i<(1<<n); i++)
    {
        k=0;
        l=i;
        memset(t,0,sizeof(t));
        while (l>0)
        { if (l&1)
           Repj(m)
            t[j]+=g[k][j];
          k++; l/=2; }
          
        fl=true;  
        Repj(m)
         if (a[j]>t[j]) {fl=false; break;}
        if (!fl) continue;
        
        if (__builtin_popcount(i)<ans.SZ)
         {
                                         ans.clear();
           l=i; k=0;
           while (l>0)
           { if (l&1) ans.PB(k+1);
             k++; l/=2; }
           }
    }

    ofstream of("holstein.out");
    of<<ans.SZ<<" ";
    Repi(ans.SZ-1) of<<ans[i]<<" "; of<<ans[ans.SZ-1]<<"\n";
    of.close();
  
    return 0;
}
