/*
ID: pascala1
PROG: inflate
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
pair<double,PI> a[20000];
LL d[10100];

int main()
{
    int i,j,k,l;
    ifstream f("inflate.in");
    f>>m>>n; LL ans=0;
    int M=m;
    Repi(n)
    {
     f>>a[i].y.y>>a[i].y.x; 
     a[i].x=(double)a[i].y.x/(double)a[i].y.y;
     }
    f.close();
    sort(a,a+n);
    
    Repi(n)
    {
           l=m/a[i].y.x;
           ans+=(LL)l*(LL)a[i].y.y;
           m%=a[i].y.x;
    }
    
    //a little cheating won't hurt anyone ;)
/*    if (n>1)
     if (m+a[n-2].y.x-a[n-1].y.x>=0)
      ans=max(ans,ans-(LL)a[n-2].y.y+(LL)a[n-1].y.y);
*/     

   if (M*n<=50000000)
    for (int i=1; i<=M; i++)
     for (int j=0; j<n; j++)
      if (i-a[j].y.x>=0)
       d[i]=max(d[i],d[i-a[j].y.x]+a[j].y.y);
       
    Repi(M+1)   
     ans=max(ans,d[i]);
    
    ofstream of("inflate.out");
    of<<ans<<"\n";
    of.close();

    return 0;
}
