/*
ID: pascala1
PROG: job
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,N,m,a[32],b[32],tim[32000],tib[32000];

bool can(int T)
{
     memset(tib,0,sizeof(tib));
     int i;
     Repj(N)
     {
       for (i=0; i<m; i++)
        if (max(tib[i],tim[j])+b[i]<=T) break;
       if (i==m) return false;
       tib[i]=max(tib[i],tim[j])+b[i]; 
     }
     return true;
}

int main()
{
    int i,j,k,l;
    ifstream f("job.in");
    f>>N>>n>>m;
    Repi(n) f>>a[i];
    Repi(m) f>>b[i];
    f.close();
    
    Repi(n)
     Repj(N)
      tim[i*N+j]=a[i]*(j+1);
    sort(tim,tim+n*N);  
    
 //   Repi(N) cout<<tim[i]<<" "; cout<<endl;


    Repi(m)
     Repj(N)
      tib[i*N+j]=b[i]*(j+1);
    sort(tib,tib+m*N);  reverse(tib,tib+N);

//    Repi(N) cout<<tib[i]<<" "; cout<<endl;
//    pause;
//    sort(b,b+m); reverse(b,b+m);


/*    int L=1,R=20000,M;
    while (L+1<R)
    {
          M=(L+R)/2;
          if (can(M)) R=M; else L=M;
    }
    if (can(L)) l=L; else l=R;
    
    cout<<can(14)<<" : ";  Repi(m) cout<<tib[i]<<" "; cout<<endl; pause;
*/
    l=0;
    Repi(N)
     l=max(l,tim[i]+tib[i]);
    
    ofstream of("job.out");
    of<<tim[N-1]<<" "<<l<<"\n";
    of.close();
    
    return 0;
}
