/*
ID: pascala1
PROG: lamps
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define Repl(n) for (int l=0; l<n; l++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,C;

int t[128],mask[128];

VS ans;

int main()
{
    int i,j,k,l=0;
    ifstream f("lamps.in");
    f>>n>>C;
    memset(mask,255,sizeof(mask));
    while (1) { f>>l; 
    if (l==-1) break; mask[l-1]=1; }
    while (1) { f>>l; 
    if (l==-1) break; mask[l-1]=0; }
    f.close();
    
    
    bool fl;
    int d[2][2][2][2][2];
    
    memset(d,0,sizeof(d));
    d[0][0][0][0][0]=1; int Y=0;
    for (int c=0; c<C; c++)
     {
        memset(d[Y^1],0,sizeof(d[Y^1]));
        Repi(2) 
         Repj(2)
          Repk(2)
           for (int l=0; l<2; l++)
            if (d[Y][i][j][k][l])
             {
               d[Y^1][(i+1)%2][j][k][l]=1;
               d[Y^1][i][(j+1)%2][k][l]=1;
               d[Y^1][i][j][(k+1)%2][l]=1;
               d[Y^1][i][j][k][(l+1)%2]=1;
             }
        Y^=1;  
     }
     
    VS ans;
    string s;

    Repi(2)
     Repj(2)
      Repk(2)
       Repl(2)
        if (d[Y][i][j][k][l])
         {
                        //     cout<<i<<j<<k<<l<<endl;
                             for (int x=0; x<n; x++) t[x]=1;
                             if (i)
                              for (int x=0; x<n; x++)
                               t[x]^=1;
                             if (j)
                              for (int x=0; x<n; x+=2)
                               t[x]^=1;
                             if (k)
                              for (int x=1; x<n; x+=2)
                               t[x]^=1;
                             if (l)
                              for (int x=0; x<n; x+=3)
                               t[x]^=1;
                        //     for (int x=0; x<n; x++) cout<<t[x]<<" "; cout<<endl;  pause;
                             bool fl=true;  
                             for (int x=0; x<n; x++)
                              if ((mask[x]==0 && t[x]==1) || (mask[x]==1 && t[x]==0)) 
                               { fl=false; break; }
                             if (!fl) continue;
                             
                             s="";
                             for (int x=0; x<n; x++)
                              s+=(char)(t[x]+'0');
                            //  cout<<s<<endl; pause;
                             ans.PB(s); 
         }
         
     ofstream of("lamps.out");
    sort(ALL(ans));    
    VS::IT it=unique(ALL(ans));
    ans.resize(it-ans.begin());
     Repi(ans.SZ)
     {
         //cout<<ans[i]<<endl; pause;
      of<<ans[i]<<"\n"; }
     if (ans.SZ==0)
      of<<"IMPOSSIBLE\n"; 

    of.close();

    return 0;
}
