/*
ID: pascala1
PROG: maze1
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,MAX;
string S[256];
int d[2][256][256];
PI q[200000];
PI a[2];
int mo[][2]={
    {1,0},
    {-1,0},
    {0,1},
    {0,-1}
    };

void bfs(int di)
{
     q[0]=a[di]; PI v;
                 //    cout<<"in "<<q[0].x<<" "<<q[0].y<<endl;
     for (int s=0,e=1; s<e; s++)
              Repi(4)
               {
                  v=MP(q[s].x+mo[i][0],q[s].y+mo[i][1]);
                  if (v.x<0 || v.x>=n || v.y<0 || v.y>=m) continue;
                  if (S[ q[s].x*2+1+mo[i][0] ][ q[s].y*2+1+mo[i][1] ]==' ' && 
                  d[di][v.x][v.y]==MAX)
                   {
             //        cout<<"in "<<v.x<<" "<<v.y<<endl;
                                                               d[di][v.x][v.y]=d[di][q[s].x][q[s].y]+1;
                                                               cout<<d[di][v.x][v.y]<<endl;
                                                               q[e++]=v;
                   }
               }
}

int main()
{
    int i,j,k,l;
    ifstream f("maze1.in");
    f>>m>>n;
    getline(f,S[0]);
    Repi(n*2+1)
    {
     getline(f,S[i]);
     cout<<S[i]<<";\n";
    }
    f.close();
    
     l=0;
    memset(d,127,sizeof(d));
    MAX=d[0][0][0];
    Repi(n)
    {
      if (S[i*2+1][0]==' ')
       a[l++]=MP(i,0);
      if (S[i*2+1][m*2]==' ') 
       a[l++]=MP(i,m-1);
    }
    Repi(m)
    {
      if (S[0][i*2+1]==' ')
       a[l++]=MP(0,i);
      if (S[n*2][i*2+1]==' ')
       a[l++]=MP(n-1,i);
    }
//    cout<<a[0].x<<" "<<a[0].y<<" "<<a[1].x<<" "<<a[1].y<<endl;
    d[0][a[0].x][a[0].y]=1;
    d[1][a[1].x][a[1].y]=1;
    
    bfs(0);
  //  pause;
    bfs(1);
   // pause;
    
    int ans=0;
    Repi(n)
    Repj(m)
    ans=max(min(d[0][i][j],d[1][i][j]),ans);
    
    
    ofstream of("maze1.out");
    of<<ans<<"\n";
    of.close();


    return 0;
}
