/*
ID: pascala1
PROG: milk4
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,p[128],P,Q,brR,tek;
//int come[20100],len[20100],val[20100],u[20100];

struct yey{char br,come;
yey() {};
yey(char _br,char _come): br(_br),come(_come) {};
};
bool operator<(yey a,yey b)
{ return (a.br==b.br)?a.come<b.come:a.br<b.br; }

int d[20100],par[20100];
bitset<128> u[20100];

int rec(int pos)
{
    if (pos<0) return 128;
    if (pos==0) return 0;
    if (d[pos]>-1) return d[pos];
    d[pos]=128;
    for (int i=0; i<P; i++)
     if (pos-p[i]>=0)
      {
       if ((u[pos-p[i]][i]^1)+rec(pos-p[i])<d[pos])
        {
          d[pos]=(u[pos-p[i]][i]^1)+rec(pos-p[i]);
          u[pos]=u[pos-p[i]]; u[pos][i]=1;
        }
      } 
     else break; 
     return d[pos];
}

bool operator<(bitset<128> &a,bitset<128> &b)
{
     Repi(P) if (a[i]<b[i]) return 1; else if (a[i]>b[i]) return 0;
     return 0;
}

    vector<bool> ok(20100);
    vector<int> last(20100,120),br(20100,120);

int A[20100],B[20100];

bool areascending(int a,int b)
{
     int ca=0,cb=0,l=-1;
     while (a!=0) { if (l!=last[a]) {l=last[a]; A[ca++]=last[a]; } a-=last[a]; }
     while (b!=0) { if (l!=last[b]) {l=last[b]; B[cb++]=last[b]; } b-=last[b]; }
     Repi(ca) cout<<A[i]<<" "; cout<<" ?  "; Repi(cb) cout<<B[i]<<" "; cout<<endl;
     for (int i=ca-1; i>=0; i--) 
      if (A[i]<B[i]) return 1; else if (A[i]>B[i]) return 0;
     return 0;
}

int main()
{
    int i,j,k,l;
    ifstream f("milk4.in");
    f>>Q>>P;
    Repi(P) f>>p[i];
    f.close();
    sort(p,p+P);
    int *pp=unique(p,p+P);
    P=pp-p;

/*
    VI ans;
    memset(d,255,sizeof(d));
    ofstream of("milk4.out");
    of<<rec(Q)<<"\n";
    Repi(Q) cout<<setw(3)<<d[i];cout<<endl;
    Repi(Q) cout<<setw(3)<<i;cout<<endl;
    Repi(P) if (u[Q][i]) ans.PB(p[i]);
    Repi(ans.SZ-1) of<<ans[i]<<" ";
    of<<ans[ans.SZ-1]<<"\n";
    of.close();
    pause;
*/
 /*   ok[0]=1; br[0]=0;
    for (int i=P-1; i>=0; i--)
     Repj(Q-p[i]+1)
      if (ok[j] && br[j]+(last[j]!=p[i])<=br[j+p[i]])
       { br[j+p[i]]=br[j]+(last[j]!=p[i]); last[j+p[i]]=p[i]; ok[j+p[i]]=1;
   //      cout<<j+p[i]<<" = "<<j<<" + "<<p[i]<<"    "<<br[j]<<" "<<last[j]<<endl;
       }
  //   pause;  
   */    
//    Repi(Q+1) cout<<" "<<ok[i]; cout<<endl;
//    Repi(Q+1) cout<<" "<<br[i]; cout<<endl;
//    cout<<br[Q]<<endl;

    SI up; bool U[20100];
    memset(d,127,sizeof(d)); bitset<128> t;
    Repi(Q+1) Repj(P) u[i][j]=1; 
    Repi(P) { Repj(P) u[p[i]][j]=0; u[p[i]][i]=1; U[p[i]]=1; up.insert(p[i]); }
    SI::reverse_iterator i1;
    int MA=150;
    for (int pos=1; pos<=Q; pos++)
//     for (int i=1; i<=pos/2; i++)
     for (i1=up.rbegin(),k=0; i1!=up.rend() && k<MA; i1++,k++)
      if (pos-*i1>0 && U[pos-*i1])
      {
//        if (*i1<pos/2) break;
        t=u[*i1]|u[pos-*i1];
//        cout<<pos<<" = "<<up[k]<<" + "<<pos-up[k]<<" - "<<t.count()<<" <?= "<<u[pos].count()<<"      ";
    //    if (t.count()>br[Q]) continue;
        if (t.count()<u[pos].count()
            || (u[pos].count()==t.count()) && u[pos]<t) u[pos]=t;
        if (!U[pos]) { U[pos]=1; up.insert(pos); }
 //      { Repj(P) cout<<u[pos][j]; cout<<endl;}
      }
 //  pause;
    VI ans,ans1;
    Repi(P)
     if (u[Q][i]) ans.PB(p[i]);
/*    l=Q; k=-1;
    while (l>0)
     {
          if (k!=last[l]) { k=last[l]; ans1.PB(last[l]); }
          l-=last[l];
     }
    sort(ALL(ans1));
    VI::IT it=unique(ALL(ans1)); ans1.resize(it-ans1.begin());
    if (ans1.SZ==br[Q] && ans1<ans) ans=ans1;*/
    ofstream of("milk4.out");
//    of<<br[Q]<<" ";
    of<<ans.SZ<<" ";
    Repi(ans.SZ-1) of<<ans[i]<<" "; of<<ans[ans.SZ-1]<<"\n";
    of.close();
    
       
    return 0;
}
