/*
ID: pascala1
PROG: milk6
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,U=0;
int M[34][34];
vector<PI> E;
vector<int> C;
VI adj[34];

inline void edge(int a,int b,int c)
{
       E.PB(MP(a,b)); C.PB(c);
       if (!M[a][b]) { adj[a].PB(b); adj[b].PB(a); }
       M[a][b]+=c; U=max(U,M[a][b]);
}

long long comb(int a,int b)
{
     b=max(b,a-b); long long x=1;
     for (int l=b+1; l<=a; l++)
      x=x*(long long)l/(long long)(l-b);
     return x;
}

int TLE=(double)0.97*(double)CLOCKS_PER_SEC;

int main()
{
    int i,j,k,l;
    ifstream f("milk6.in");
    f>>n>>m;
    Repi(m)
     {
           f>>j>>k>>l;
           edge(j,k,l);
     }
    f.close();
    int UU=U;
    int q[34];
    bool u[34],ou[34],found;
    memset(ou,0,sizeof(ou));
    ou[1]=1; q[0]=1;
    for (int s=0,e=1; s<e; s++)
     Repi(adj[q[s]].SZ)
      {
                     int v=adj[q[s]][i];
                     if (!ou[v] && M[q[s]][v])
                      {
                               q[e++]=v;
                               ou[v]=1;
                      }
      }


    int p[34],d[34],flow=0;
    memset(d,0,sizeof(d));
    p[1]=-1;
    while(1)
    {
        memset(u,0,sizeof(u));
        u[1]=1; q[0]=1;
        found=0;
        for (int s=0,e=1; s<e; s++)
        {
            int v=q[s];
            Repi(adj[v].SZ)
             if (!u[adj[v][i]] && M[v][adj[v][i]]>=U)
              {
                             q[e++]=adj[v][i];
                             u[adj[v][i]]=1;
                             p[adj[v][i]]=v;
                             if (adj[v][i]==n) {found=1; break;}
              }
            if (found) break;
        }
        if (!found)
         { U/=2; if (U==0) break; continue; }
         
        l=n; k=0;
        while (l!=-1) 
        { q[k++]=l; l=p[l]; }
        reverse(q,q+k);
        
        l=INF;
        Repi(k-1) l<?=M[q[i]][q[i+1]];
        flow+=l;
        
        Repi(k-1)
        {
                 M[q[i]][q[i+1]]-=l;
                 M[q[i+1]][q[i]]+=l;
        }
    }
    int flow1=flow;
 VI oans;

    Repi(E.SZ)
     if (u[E[i].x]!=u[E[i].y] && ou[E[i].x]==ou[E[i].y] && !M[ E[i].x ][ E[i].y ])
      oans.PB(i+1);








    memset(M,0,sizeof(M));
    Repi(E.SZ)
     M[E[i].x][E[i].y]++;
     flow=0;
    U=1;
    while(1)
    {
        memset(u,0,sizeof(u));
        u[1]=1; q[0]=1;
        found=0;
        for (int s=0,e=1; s<e; s++)
        {
            int v=q[s];
            Repi(adj[v].SZ)
             if (!u[adj[v][i]] && M[v][adj[v][i]]>=U)
              {
                             q[e++]=adj[v][i];
                             u[adj[v][i]]=1;
                             p[adj[v][i]]=v;
                             if (adj[v][i]==n) {found=1; break;}
              }
            if (found) break;
        }
        if (!found)
         { U/=2; if (U==0) break; continue; }
         
        l=n; k=0;
        while (l!=-1) 
        { q[k++]=l; l=p[l]; }
        reverse(q,q+k);
        
        l=INF;
        Repi(k-1) l<?=M[q[i]][q[i+1]];
        flow+=l;
        
        Repi(k-1)
        {
                 M[q[i]][q[i+1]]-=l;
                 M[q[i+1]][q[i]]+=l;
        }
    }
    
    
    
    int Flow=flow;
    
    
    
    VI ans,bans(Flow+1,n*n+1);
    

/* while(1) 
 { */
    memset(u,0,sizeof(u));
    u[1]=1; q[0]=1;
    for (int s=0,e=1; s<e; s++)
     Repi(adj[q[s]].SZ)
      {
                     int v=adj[q[s]][i];
                     if (!u[v] && M[q[s]][v])
                      {
                               q[e++]=v;
                               u[v]=1;
                      }
      }
    
    Repi(E.SZ)
     if (/*u[E[i].x]!=u[E[i].y] && ou[E[i].x]==ou[E[i].y] &&*/ !M[ E[i].x ][ E[i].y ])
      ans.PB(i+1);
      
    VI tek(Flow); int sum=0;
    Repi(Flow) { tek[i]=i; sum+=C[ans[tek[i]]-1]; }
    Repi(ans.SZ) cout<<ans[i]<<" "; cout<<endl;
    while (1)
    {
        //  Repi(tek.SZ) cout<<tek[i]<<" "; cout<<"= "<<sum<<endl;
          if (sum==flow1)
          {
          found=false;
            if (n<25)
            {
          memset(u,0,sizeof(u));
          q[0]=1; u[1]=1;
          memset(M,0,sizeof(M));
           Repi(E.SZ) M[E[i].x][E[i].y]=1;
          Repi(tek.SZ) M[ E[ans[tek[i]]-1].x ][ E[ans[tek[i]]-1].y ]=0;
          for (int s=0,e=1; s<e; s++)
          {
            Repi(adj[q[s]].SZ)
             {
                              int v=adj[q[s]][i];
                              if (!u[v] && M[q[s]][v])
                               {
                                        u[v]=1;
                                        q[e++]=v;
                                        if (v==n) {found=1; break;}
                               }
             }
            if (found) break;
          }
          cout<<found<<endl;
          }
           if (!found)
            {
                      bans.clear();
                      Repi(tek.SZ)
                       bans.PB(ans[tek[i]]);
                      break;
            }
          }
          
          int i=Flow-1;
          while (i>=0 && (i==Flow-1 && tek[i]==ans.SZ-1) || (i!=Flow-1 && tek[i]==tek[i+1]-1))
           i--;
          if (i<0) break;
          sum-=C[ans[tek[i]]-1];
          tek[i]++;
          sum+=C[ans[tek[i]]-1];
          for (i++;i<tek.SZ;i++)
          {
            sum-=C[ans[tek[i]]-1];
            tek[i]=tek[i-1]+1;
            sum+=C[ans[tek[i]]-1];
          }
          if (clock()>TLE) {bans=oans; break;}
    }  
    pause;
/*  
  
   bool uu[34]; memcpy(uu,u,sizeof(u));
   Repj(ans.SZ)  
    {
    memset(M,0,sizeof(M));
    Repi(E.SZ)
     M[E[i].x][E[i].y]++;
     flow=0;
    U=1;
    while(1)
    {
        memset(u,0,sizeof(u));
        u[E[ans[j]-1].y]=1; q[0]=E[ans[j]-1].y;
        p[E[ans[j]-1].y]=-1;
        found=0;
        for (int s=0,e=1; s<e; s++)
        {
            int v=q[s];
            Repi(adj[v].SZ)
             if (!u[adj[v][i]] && M[v][adj[v][i]]>=U && !uu[adj[v][i]])
              {
                             q[e++]=adj[v][i];
                             u[adj[v][i]]=1;
                             p[adj[v][i]]=v;
                             if (adj[v][i]==n) {found=1; break;}
              }
            if (found) break;
        }
        if (!found)
         { U/=2; if (U==0) break; continue; }
         
        l=n; k=0;
        while (l!=-1) 
        { q[k++]=l; l=p[l]; }
        reverse(q,q+k);
        
        l=INF;
        Repi(k-1) l<?=M[q[i]][q[i+1]];
        flow+=l;
        
        Repi(k-1)
        {
                 M[q[i]][q[i+1]]-=l;
                 M[q[i+1]][q[i]]+=l;
        }
    }
     
     cout<<flow<<endl;
                 
    }
    cout<<endl;
      
/*    cout<<ans.SZ<<endl;
    if (ans.SZ==0) break;
    Repi(n) cout<<ou[i+1]; cout<<endl;
    Repi(n) cout<<u[i+1]; cout<<endl;
    if (ans.SZ<bans.SZ || (ans.SZ==bans.SZ && ans<bans)) bans=ans;
    
    Repi(ans.SZ)
    {
//     cout<<E[ans[i]-1].x<<" "<<E[ans[i]-1].y<<endl; pause;
     M[ E[ans[i]-1].x ][ E[ans[i]-1].y ]=1;
     }
    ans.clear();
 }*/
 
 
    ofstream of("milk6.out");
    if (bans.SZ==4000) bans.resize(0);
    of<<flow1<<" "<<Flow<<"\n";
    Repi(Flow) of<<bans[i]<<"\n";
    Repi(Flow)
     cout<<E[bans[i]-1].x<<" "<<E[bans[i]-1].y<<endl;
    of.close();
    
    return 0;
}
