/*
ID: pascala1
PROG: nocows
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,MOD=9901;

int d1[256][256],d[256][256];

int rec(int n,int m);
int rec1(int n,int m);
    
int rec1(int n,int m)
{
    if (m<=0) return 0;
    if (d1[n][m]>-1) return d1[n][m];
    int &r=d1[n][m]=rec(n,m)+rec1(n,m-1);
    r%=MOD;
  //  cout<<"                                            d1 ["<<n<<"]["<<m<<"] = "<<r<<endl; 
    return r;
}    

int rec(int n,int m)
{
    if (m<=0) return 0;
 //   if ( n/2+1 < m ) return 0;
//    if ( n > (1<<m)-1 ) return 0;
    if (n%2==0) return 0;
    if (n==1 && m==1) return 1;
    if (d[n][m]>-1) return d[n][m];
    int &r=d[n][m]=0;
    for (int i=0; i<n; i++)
     r+=rec(i,m-1)*rec1(n-i-1,m-2)%MOD+rec(n-i-1,m-1)*rec1(i,m-2)%MOD+rec(i,m-1)*rec(n-i-1,m-1)%MOD;
    r%=MOD;
  //  cout<<"d ["<<n<<"]["<<m<<"] = "<<r<<endl;
    return r;
}


int main()
{
    int i,j,k,l;
    ifstream f("nocows.in");
    f>>n>>m;
    f.close();
    
    memset(d,255,sizeof(d));
    memset(d1,255,sizeof(d1));
    ofstream of("nocows.out");
    of<<rec(n,m)<<"\n";
    pause;
    of.close();

    return 0;
}
