/*
ID: pascala1
PROG: nuggets
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,a[24];

bool u[100000];
bool cap[100000];

int can(int v)
{
    if (u[v]) return cap[v];
    u[v]=1;
    Repi(n)
     if (v-a[i]>=0)
      if (can(v-a[i])) return cap[v]=true;
    return cap[v]=false;  
}

int main()
{
    int i,j,k,l;
    ifstream f("nuggets.in");
    f>>n;
    Repi(n)
     f>>a[i];
    f.close();
    
    u[0]=1;
    cap[0]=1;
    
    int A=1000000,found=0;
    Repi(n)
     Repj(n)
      if (__gcd(a[i],a[j])==1 && a[i]*a[j]<A) { A=a[i]*a[j]; found=true; }
      
    ofstream of("nuggets.out");
    if (!found) { of<<"0\n"; of.close(); return 0; }
    
    for (i=A; i>=1; i--)
     if (!can(i)) break;
    of<<i<<"\n";
    
    of.close();

    return 0;
}
