/*
ID: pascala1
PROG: preface
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;

string roman(int n)
{
       int M,C,X,I;
       string s;
       M=n/1000; n%=1000;
       Repi(M) s+='M';
       C=n/100; n%=100;
       if (C==4) s+="CD";
       else if (C==9) s+="CM";
       else {
         if (C>4) { s+='D'; C-=5; }
         if (C<4) Repi(C) s+='C'; }
       X=n/10; n%=10;
       if (X==4) s+="XL";
       else if (X==9) s+="XC";
       else {
         if (X>4) { s+='L'; X-=5; }
         if (X<4) Repi(X) s+='X'; }
       I=n;  
       if (I==4) s+="IV";
       else if (I==9) s+="IX";
       else {
         if (I>4) { s+='V'; I-=5; }
         if (I<4) Repi(I) s+='I'; }
       return s;  
}

int a[256];
int cnt[10];
char let[]={'I','V','X','L','C','D','M'};

int main()
{
    int i,j,k,l;

   ifstream f("preface.in");
   f>>n;
   f.close();

   string s;
   a['I']=0;
   a['V']=1;
   a['X']=2;
   a['L']=3;
   a['C']=4;
   a['D']=5;
   a['M']=6;
   for (int i=1; i<=n; i++)
    {
            s=roman(i);
            Repi(s.SZ)
             cnt[a[s[i]]]++;
    }
    
   ofstream of("preface.out");
   Repi(7)
    if (cnt[i]>0)
     of<<let[i]<<" "<<cnt[i]<<"\n";
   of.close();
  
    return 0;
}
