/*
ID: pascala1
PROG: schlnet
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,Comp,cur,ans1,ans2;
int u[128],comp[128],leaves[128];
VI a[128],p[128];
VI A,L;

void dfs(int v)
{
     u[v]=1;
     if (a[v].SZ==0) 
      leaves[cur]++;
     else
      Repi(a[v].SZ)
       if (!u[a[v][i]])
        dfs(a[v][i]);
}

void dfs1(int v)
{
  u[v]=1;
  Repi(a[v].SZ)
   if (!u[a[v][i]])
    dfs1(a[v][i]);
  L.PB(v);
}
 
void dfs2(int v)
{
  comp[v]=Comp;
  u[v]=1;
  Repi(p[v].SZ)
   if (!u[p[v][i]]) dfs2(p[v][i]);
}

bool M[128][128];

int main()
{
    int i,j,k,l;
    FILE *f=fopen("schlnet.in","r");
    fscanf(f,"%d",&n);
    Repi(n)
     while (fscanf(f,"%d",&l))
      if (l==0) break; else { a[i].PB(l-1); p[l-1].PB(i); }
    fclose(f);
    
    //remove connected componets
    Repi(n)
     if (!u[i])
      dfs1(i);
    reverse(ALL(L));
    
    memset(u,0,sizeof(u));
    Repi(n)
     if (!u[L[i]])
      {
        dfs2(L[i]);
        Comp++;
      }
      
//    Repi(n)cout<<comp[i]<<" "; cout<<endl;
       
    Repi(n)
     Repj(a[i].SZ)
       M[comp[i]][comp[a[i][j]]]=1;
      
    Repi(n) {a[i].clear(); p[i].clear();}
    
    n=Comp;
    Repi(n)
     Repj(n)
      if (M[i][j] && i!=j)
       { a[i].PB(j); p[j].PB(i); }
    
 //   Repi(n) { Repj(a[i].SZ) cout<<a[i][j]<<" "; cout<<endl; } cout<<endl; pause;
   
//subtask A
    memset(u,0,sizeof(u));
    Repi(n)
     if (p[i].SZ==0)
      {
        cur=i; ans1++;
        dfs(i);
      }
//    Repi(n) cout<<leaves[i]<<" "; cout<<endl; pause;

//subtask B
    k=0; l=0;
    Repi(n)
     if (a[i].SZ==0) { k++; if (p[i].SZ==0) l++; }
      
    ans2=ans1-1+k-(l>0); //ot vsi4ki leaves kum 1n par i ot nego kum vs drugi par's
    ans2<?=ans1+k-l; //cikal za leaves i ot nego po 1no za vs parents
    cout<<ans1<<" "<<k<<" "<<l<<endl; pause;

    ans2=max(ans1,k); if (n==1) ans2=0;
    ofstream of("schlnet.out");
    of<<ans1<<"\n"<<ans2<<"\n";
    of.close();
    
    return 0;
}
