/*
ID: pascala1
PROG: snail
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
vector<pair<char,char> > b;
bool a[128][128],B[128][128];

char go[4][2]={
     {-1,0},
     {0,1},
     {1,0},
     {0,-1}
     };

int MAX;
int dfs(char r,char c,char dir)
{
  //   int br=0; Repi(n) Repj(n) br+=a[i][j]; MAX=max(br,MAX);
  //   if (r==0 && c==2)  { cout<<endl; Repi(n) { Repj(n) cout<<a[i][j]; cout<<endl; } pause;}
     if (r>=n || c>=n || r<0 || c<0 || B[r][c] || a[r][c]) return 0;
     a[r][c]=1;
     
//     cout<<(int)r<<" "<<(int)c<<" "<<(int)dir<<" "<<B[r][c]<<endl;
     
     int ans1;
     char r1=r+go[dir][0],c1=c+go[dir][1];
     if (r1>=n || c1>=n || r1<0 || c1<0 || B[r1][c1])
      {
//         if (r==0 && c==2) cout<<(int)dir<<" "<<(int)r1<<" "<<(int)c1<<" SFSDF\n";
               //  cout<<(int)r<<" "<<(int)c<<" D-----------------\n";
                 int ans2=dfs(r+go[(dir+3)%4][0],c+go[(dir+3)%4][1],(dir+3)%4);
                 ans1=dfs(r+go[(dir+1)%4][0],c+go[(dir+1)%4][1],(dir+1)%4);
               //  cout<<(int)r<<" "<<(int)c<<" D-----------------\n";
                 a[r][c]=0;
     //            cout<<"return from "<<(int)r<<" "<<(int)c<<endl;
                 return max(ans1,ans2)+1;
      }
     if (a[r1][c1]) { a[r][c]=0; return 1; }
     ans1=1+dfs(r+go[dir][0],c+go[dir][1],dir); 
//     if (r==4 && c==0) cout<<"SDAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\n";
//     if (r==4 && c==0) cout<<"SDAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\n";
//     if (r==4 && c==0) cout<<"SDAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\n";
 //    if (r==4 && c==0) cout<<"SDAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\n";
//     if (r==4 && c==0) cout<<"SDAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\n";
 //    if (r==4 && c==0) cout<<"SDAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\n";
     a[r][c]=0;
  //   cout<<"return from "<<(int)r<<" "<<(int)c<<endl;
     return ans1;
}


int dfs1(char r,char c,char dir)
{
     cout<<(int)r<<" "<<(int)c<<" "<<(int)dir<<endl;
     Repi(n) { Repj(n) cout<<a[i][j]; cout<<endl; } pause;
     if (a[r][c]) return 0;
     int ans1;
     if (B[r][c] || r>=n || c>=n || r<0 || c<0)
      {
                 r-=go[dir][0]; c-=go[dir][1];
                 a[r][c]=0;
                 ans1=dfs(r,c,(dir+1)%4)-1;
                 a[r][c]=0;
                 return max( ans1 , dfs(r,c,(dir+3)%4)-1 );
      }
     a[r][c]=1;
     ans1=1+dfs(r+go[dir][0],c+go[dir][1],dir); 
     a[r][c]=0;
     return ans1;
}

int main()
{
    int i,j,k,l;
    FILE *f=fopen("snail.in","r");
    fscanf(f,"%d%d\n",&n,&m);
    char c[23];
    Repi(m)
    {
      fscanf(f,"%s",c);
      sscanf(c+1,"%d",&l);
      b.PB(MP(l-1,c[0]-'A'));
    }
    fclose(f);
    
    Repi(b.SZ) B[b[i].x][b[i].y]=1;

   int ans=max(dfs(0,0,1),dfs(0,0,2));
    
    cout<<MAX<<endl<<ans<<endl; pause;
    
    ofstream of("snail.out");
    of<<ans<<"\n";
    of.close();
    
    return 0;
}
