/*
ID: pascala1
PROG: starry
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,L;
char t[128][128];
char let[10000];
char LET;
int cl[128][128];
vector<PI> co[10000];
PI mi[10000],ma[10000];

void markirai(int r,int c)
{
     if (r<0 || r>=n || c<0 || c>=m) return;
     if (t[r][c]=='0') return;
     if (cl[r][c]>0) return;
     cl[r][c]=L;
     markirai(r-1,c-1);
     markirai(r+1,c-1);
     markirai(r-1,c+1);
     markirai(r+1,c+1);
     markirai(r-1,c);
     markirai(r,c-1);
     markirai(r+1,c);
     markirai(r,c+1);
}

int main()
{
    int k,l;
    FILE *F=fopen("starry.in","r");
    fscanf(F,"%d%d",&m,&n);
    Repi(n)
     fscanf(F,"%s",t[i]);
   
    Repi(n)
     Repj(m)
      if (!cl[i][j] && t[i][j]=='1')
       {
         L++;
         markirai(i,j);
       }
       
//    Repi(n) { Repj(m) cout<<setw(3)<<cl[i][j]; cout<<endl; }    pause;
    memset(mi,127,sizeof(mi));
    Repi(n) Repj(m) 
    {
            co[cl[i][j]].PB(MP(i,j));
            mi[cl[i][j]].x<?=i;
            mi[cl[i][j]].y<?=j;
            ma[cl[i][j]].x>?=i;
            ma[cl[i][j]].y>?=j;
    }
    for (int i=1; i<L+1; i++)
     Repj(co[i].SZ) { co[i][j].x-=mi[i].x; co[i][j].y-=mi[i].y; }
    Repi(L+1) { ma[i].x-=mi[i].x; ma[i].y-=mi[i].y; sort(ALL(co[i])); }
 
    
    vector<PI> a,b,c,d,e,f,g,h;
    LET='a'-1;
    for (int ii=1; ii<L+1; ii++)
    if (!let[ii])
     {
       let[ii]=++LET;
       a=b=c=d=e=f=g=h=co[ii];
       Repi(b.SZ) b[i]=MP(a[i].y,ma[ii].x-a[i].x); sort(ALL(b));
       Repi(c.SZ) c[i]=MP(b[i].y,ma[ii].y-b[i].x); sort(ALL(c));
       Repi(d.SZ) d[i]=MP(c[i].y,ma[ii].x-c[i].x); sort(ALL(d));
       Repi(e.SZ) e[i]=MP(ma[ii].x-a[i].x,a[i].y); sort(ALL(e));
       Repi(f.SZ) f[i]=MP(e[i].y,ma[ii].x-e[i].x); sort(ALL(f));
       Repi(g.SZ) g[i]=MP(f[i].y,ma[ii].y-f[i].x); sort(ALL(g));
       Repi(h.SZ) h[i]=MP(g[i].y,ma[ii].x-g[i].x); sort(ALL(h));
/*       cout<<LET<<endl;
       Repi(a.SZ) cout<<a[i].x<<" "<<a[i].y<<" ; "; cout<<endl;
       Repi(b.SZ) cout<<b[i].x<<" "<<b[i].y<<" ; "; cout<<endl;
       Repi(c.SZ) cout<<c[i].x<<" "<<c[i].y<<" ; "; cout<<endl;
       Repi(d.SZ) cout<<d[i].x<<" "<<d[i].y<<" ; "; cout<<endl;
       Repi(e.SZ) cout<<e[i].x<<" "<<e[i].y<<" ; "; cout<<endl;
       Repi(f.SZ) cout<<f[i].x<<" "<<f[i].y<<" ; "; cout<<endl;
       Repi(g.SZ) cout<<g[i].x<<" "<<g[i].y<<" ; "; cout<<endl;
       Repi(h.SZ) cout<<h[i].x<<" "<<h[i].y<<" ; "; cout<<endl; 
       pause;*/
       for (int j=ii+1; j<L+1; j++)
        if (co[j]==a || co[j]==b || co[j]==c || co[j]==d ||
            co[j]==e || co[j]==f || co[j]==g || co[j]==h)
             let[j]=let[ii];
     }
    
    ofstream of("starry.out"); 
    Repi(n) {     Repj(m)      of<<((let[cl[i][j]]==0)?('0'):let[cl[i][j]]); of<<"\n"; }
    of.close();
     
    return 0;
}

