/*
ID: pascala1
PROG: theme
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,a[5010],d[5010];
ULL h[5010],pw[5010]; int base=179;

void prehash()
{
     h[0]=0LL; pw[0]=1LL;
     Repi(n-1) { h[i+1]=h[i]*(LL)base+(LL)d[i]; pw[i+1]=pw[i]*(LL)base; }
}

inline ULL hash(int p1,int len)
{    return h[p1+len]-h[p1]*pw[len]; }

set<ULL> used;
bool stava(int len)
{
     used.clear();
     Repi(n-len)
      {
                if (i-len-1>-1)
                 used.insert(hash(i-len-1,len));
                if (used.find(hash(i,len))!=used.end()) return 1;
      }
     return 0;
}

int main()
{
    int i,j,k,l;
    ifstream f("theme.in");
    f>>n;
    Repi(n) f>>a[i];
    Repi(n-1) d[i]=a[i+1]-a[i]+88;
    f.close();
    
    prehash();
    
    l=4; int r=n/2;
    while (l<r-1)
     {
          m=(l+r)/2;
          if (stava(m)) l=m; else r=m;
     }
    int ans;
    if (stava(l)) ans=l+1; else if (stava(r)) ans=r+1; else ans=0;
    
    ofstream of("theme.out");
    of<<ans<<"\n";
    of.close();
    
    return 0;
}
