/*
ID: pascala1
PROG: vans
LANG: C++
*/
//see solution below...
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;
#define MAXN 1024
#define MAXDIG 1024

char dp[MAXN][8][MAXDIG]; int dpc[MAXN][8];

/*
0 - |  |
1 - |||| separated
2 - |||| united
3 -   ||
4 -  ||
5 - ||

-- these are the only possible vertical "cuts" (rotated 90) of the avenues and we can dp over them
note - need big ints
*/

const int base=10;
inline void add(char a[],int &ac,char b[],int bc)
{
	ac=MAX(ac,bc);
	int o=0;
	Repi(ac)
	 o+=a[i]+b[i],a[i]=o%base,o/=base;
	if (o) a[ac++]=o;
}

char res[MAXDIG],r1[MAXDIG]; int resc,rc;

void solve(int N)
{
	memset(dp,0,sizeof(dp));
	memset(dpc,0,sizeof(dpc));
	dp[0][0][0]=dp[0][1][0]=dpc[0][0]=dpc[0][1]=1;
	N--;
	if (!N) { res[0]=0; resc=1; return; }
	for (int i=0;i<N;i++)
	 {
			add(dp[i+1][2],dpc[i+1][2],dp[i][0],dpc[i][0]);
			add(dp[i+1][3],dpc[i+1][3],dp[i][0],dpc[i][0]);
			add(dp[i+1][4],dpc[i+1][4],dp[i][0],dpc[i][0]);
			add(dp[i+1][5],dpc[i+1][5],dp[i][0],dpc[i][0]);

            add(dp[i+1][0],dpc[i+1][0],dp[i][1],dpc[i][1]);
            add(dp[i+1][1],dpc[i+1][1],dp[i][1],dpc[i][1]);
            
            add(dp[i+1][2],dpc[i+1][2],dp[i][2],dpc[i][2]);
            add(dp[i+1][3],dpc[i+1][3],dp[i][2],dpc[i][2]);
            add(dp[i+1][5],dpc[i+1][5],dp[i][2],dpc[i][2]);
            
            add(dp[i+1][0],dpc[i+1][0],dp[i][3],dpc[i][3]);
            add(dp[i+1][1],dpc[i+1][1],dp[i][3],dpc[i][3]);

            add(dp[i+1][0],dpc[i+1][0],dp[i][4],dpc[i][4]);
      
            add(dp[i+1][0],dpc[i+1][0],dp[i][5],dpc[i][5]);
            add(dp[i+1][1],dpc[i+1][1],dp[i][5],dpc[i][5]);
	 }
	memset(res,0,sizeof(res)); resc=0;
	memset(r1,0,sizeof(r1)); rc=0;
	add(r1,rc,dp[N-1][0],dpc[N-1][0]);
	add(r1,rc,dp[N-1][2],dpc[N-1][2]);
	add(res,resc,r1,rc); add(res,resc,r1,rc);
}

int main()
{
	freopen("vans.in","r",stdin);
	freopen("vans.out","w",stdout);
	
	scanf("%d",&N);
	solve(N);
	Repi(resc) printf("%d",res[resc-i-1]); printf("\n");
    return 0;
}
