//sort cows po x; res += sum of all higher volumes of passed cows * distance to beginning - sum( volume of cow[i] * distance from cow[i] to beginning ) for all passed cows i
//reverse and repeat, only this time consider cows with equal volumes as well
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 30000
int n,m,N,M,P,T,K;
PI cow[MAXN];
LL vols[MAXN*2],volsd[MAXN*2];
map<int,int> vid;

inline void push(LL tree[],int pos,LL val)
{
       for(;pos<=M;pos+=pos&(-pos))
        tree[pos]+=val;
}

inline LL qry(LL tree[],int pos)
{
       LL res=0;
       for(;pos;pos-=pos&(-pos))
        res+=tree[pos];
       return res;
}

inline LL query(LL tree[],int st,int en)
{ return qry(tree,en)-qry(tree,st-1);   }


LL solve(bool second)
{
        //  for (int i=1;i<=N;i++) cout<<cow[i].x<<" "<<cow[i].y<<" ; "; cout<<endl;
          memset(vols,0,sizeof(vols));
          memset(volsd,0,sizeof(volsd));
          int st=cow[1].x;
          LL ret=0,sumvols,sumvolsd,vi,dist;
          for (int i=1;i<=N;i++)
           {
                   vi=vid[cow[i].y]; dist=cow[i].x-st;
                   sumvols=query(vols,vi+second,N);
                   sumvolsd=query(volsd,vi+second,N);
          //         cout<<i<<": "<<cow[i].x<<" "<<cow[i].y<<" - "<<vi<<" "<<dist<<" , "<<sumvols<<" "<<sumvolsd<<" -> ";
                   ret+=sumvols*dist-sumvolsd;
                   push(vols,vi,cow[i].y);
                   push(volsd,vi,cow[i].y*dist);
            //       cout<<ret<<endl;
           }
          return ret;
}

int main()
{
    scanf("%d",&N);
    Repi(N)
     {
       scanf("%d%d",&cow[i+1].y,&cow[i+1].x);
       vid[cow[i+1].y]=666;
     }
    map<int,int>::IT it; int i;
    for (it=vid.begin(),i=1;it!=vid.end();it++,i++)
     it->y=i;
    M=1; while (M<N) M*=2;
    
    sort(cow+1,cow+N+1);
    LL ans=solve(0);
    reverse(cow+1,cow+N+1);
    Repi(N+1) cow[i].x*=-1;
    ans+=solve(1);
    cout<<ans<<"\n";
    
    return 0;
}
