#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 100100
int n,m,N,M,P,T,K;
PD p[MAXN],segm[MAXN],np[MAXN]; double len[MAXN];

inline double dist1(const PD &A,const PD &B)
{  return sqr(A.x-B.x)+sqr(A.y-B.y);  }
inline double dist(const PD &A,const PD &B) //inline!
{ return sqrt(dist1(A,B)); }

inline double cp(const PD &A,const PD &B,const PD &C)
{  double dx1=B.x-A.x,dy1=B.y-A.y,dx2=C.x-A.x,dy2=C.y-A.y; return dx1*dy2-dx2*dy1; }

bool cmp(const PD &A,const PD &B)
{
	double CP=cp(p[0],A,B);
	return (CP==0)?dist(p[0],A)<dist(p[0],B):CP>0;
}

int graham()
{
	int m=2,one=0;
	Repi(N) if (p[i]<p[one]) one=i;
	swap(p[0],p[one]);
	sort(p+1,p+N,cmp);
	p[N]=p[0];
	for (int i=3;i<=N;i++)
	 {
			while (cp(p[m-1],p[m],p[i])<0) m--;
			swap(p[++m],p[i]);
	 }
//	cout<<m<<endl;Repi(N) printf("%d - %.2lf %.2lf\n",i,p[i].x,p[i].y);
	return m;
}

inline PD intersect(const PD &A,const PD &B,const PD &C,const PD &D)
{   
	double num=cp(A,C,D),den=cp(A,C,B)+cp(A,B,D);
	if (fabs(den)<1e-7) return MP(1e100,1e100);
	return MP(A.x+(B.x-A.x)*num/den,A.y+(B.y-A.y)*num/den);
}

double area(PD p[],int N)
{
	double ret=0;
	Repi(N-1) ret+=(p[i].x-p[i+1].x)*(p[i].y+p[i+1].y);
	ret+=(p[N-1].x-p[0].x)*(p[N-1].y+p[0].y);
	return ret;
}

int main()
{
    scanf("%d",&N);
    Repi(N)
     scanf("%lf%lf",&p[i].x,&p[i].y);
     
    m=graham();  double l;
    p[m+1]=p[1];
    Repi(m+1) segm[i]=MP(p[i].y-p[i+1].y,p[i+1].x-p[i].x);
    Repi(m+1) l=dist(p[i],p[i+1]),segm[i].x/=l,segm[i].y/=l;
    
    Repi(m+1)
     {
			cout<<i<<" - "<<p[i].x<<","<<p[i].y<<" -> "<<p[i+1].x<<","<<p[i+1].y<<" ; "<<segm[i].x<<" "<<segm[i].y<<endl;
	 }
    
    
    
/*    PD last,A,B,C,D;
    double L=0,R=5,mid;
//   while(L+1e-3<R)
   for (mid=0;mid<10;mid+=.2) 
     {
		//	mid=(L+R)/2.;
			cout<<L<<" "<<R<<" ; testing "<<mid<<"\n";
			C=MP(p[0].x+segm[0].x*mid,p[0].y+segm[0].y*mid);
			D=MP(p[1].x+segm[0].x*mid,p[1].y+segm[0].y*mid);
			n=m;
			for (int i=1;i<=m;i++)
			 {
					A=C,B=D;
					C=MP(p[i].x+segm[i].x*mid,p[i].y+segm[i].y*mid);
					D=MP(p[i+1].x+segm[i].x*mid,p[i+1].y+segm[i].y*mid);
				//	cout<<"        "<<i<<" - "<<A.x<<","<<A.y<<" "<<B.x<<","<<B.y<<" - "<<C.x<<","<<C.y<<" "<<D.x<<","<<D.y<<endl;
					np[i]=intersect(A,B,C,D);
			 }
			np[0]=np[m];
			
		//	Repi(m+1) cout<<"    pts "<<i<<" : "<<np[i].x<<" "<<np[i].y<<endl;
			cout<<"                                "<<area(np,m)<<endl;
			
			if (area(np,m)<0) R=mid; else L=mid;
	 }*/
    
    return 0;
}
