#include <cstdio>
#include <set>
using namespace std;

#define a							first
#define b							second
#define min(a, b)					((a) < (b) ? (a) : (b))

const int MAX_N = 35000;

typedef long long LL;
typedef pair<LL, LL> PLL;

LL N, T, money[MAX_N], dp[MAX_N], ans;
set<PLL> envelope;

void Read()
{
	scanf("%I64d %I64d", & N, & T);
	
	for(int i = 1; i <= N; i ++)
	{
		scanf("%I64d", & money[i]);
	}
}

void Solve()
{
	for(int i = N - 1; 1 <= i; i --)
	{
		money[i] += money[i + 1];
	}
	
//	dp[1] = money[1] - money[2] - T;
//	envelope.insert(PLL(money[1], dp[1]));
	envelope.insert(PLL(money[1], dp[0]));
	
	for(LL i = 1; i <= N; i ++)
	{
		set<PLL>::iterator it1 = envelope.begin(), it;
		
		for(it = it1 ++; it1 != envelope.end(); it = it1 ++)
		{
//			printf("%I64d %I64d,    %I64d %I64d\n", it -> a, it -> b, it1 -> a, it1 -> b);
			
			if(i * it -> a + it -> b <= i * it1 -> a + it1 -> b)
			{
				envelope.erase(it);
			}
		}
		
		dp[i] = envelope.begin() -> b + (envelope.begin() -> a - money[i + 1]) * i - T;
		
		envelope.insert(PLL(money[i + 1], dp[i]));
	}
	
	ans = dp[N];
}

void Write()
{
	printf("%I64d\n", ans);
	
	fprintf(stderr, "RUN TIME: %.5lf\n", clock() / double(CLOCKS_PER_SEC));
	getchar(); getchar();
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}

/*
TEST 0:
7 1
-10 3 -2 4 -6 2 3

17


*/
