// map heights to 1..N, for dp[i] add values in range -H,H (precalc with linesweep) + 1 and in the end substract N (all possibilities with one box)
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K,H;

#define MAXN 200000
int dp[MAXN*2];
int val[MAXN],a[MAXN];
map<int,int> ind;
int prev[MAXN],next[MAXN];
const int MOD=9901;

inline void push(int v,int val)
{
    for(;v<=M;v+=v&(-v))
     dp[v]=(dp[v]+val)%MOD;
}

inline int qry(int v)
{
       int ret=0;
       for (;v;v-=v&(-v))
        ret=(ret+dp[v])%MOD;
       return ret;
}

inline int query(int v1,int v2)
{   return (qry(v2)-qry(v1-1)+MOD)%MOD;  }

int main()
{
    scanf("%d%d",&N,&H);
    Repi(N) scanf("%d",val+i+1);
    memcpy(a,val,sizeof(val));
    sort(val+1,val+N+1);
    M=1; while (M<=N) M*=2; 
    
    int tail=1,head=1;
//    Repi(N+1) cout<<setw(3)<<val[i]; cout<<endl;
//    Repi(N+1) cout<<setw(3)<<i; cout<<endl;
    
    for (int i=1;i<=N;i++)
     {
           ind[val[i]]=i;
           while (val[i]-val[tail]>H) tail++;
           while (val[head+1]-val[i]<=H && head<N) head++;
           prev[i]=tail,next[i]=head;
           
         //  cout<<tail<<" "<<i<<" "<<head<<endl;
     }
    
    for (int i=1;i<=N;i++)
     {
       int v=ind[a[i]];
       //cout<<" push "<<v<<" "<<query(prev[v],next[v])<<endl;
       push( v , query(prev[v],next[v])+1 );
       //for (int j=1;j<=N;j++) cout<<qry(j)-qry(j-1)<<" "; cout<<endl;
     }
     
    printf("%d\n",(query(1,N)-N%MOD+MOD)%MOD);
    
    return 0;
}
