/* 
nice greedy: 
   for each subset V of colors
   L: **__**_***_*_*___***    (in terms of colors; count doens't matter) take all * => take at least K _
   R: **__**_***_*_*___***    take at least one * OR take at least count(_)-K+1 _
   swap(L,R) and repeat procedure once again
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,R[32],L[32];

int main()
{
    int i,j,k,l;
    cin>>n;
    Repi(n) cin>>L[i];
    Repi(n) cin>>R[i];
    int SL=0,SR=0;
    Repi(n) { SL+=L[i]; SR+=R[i]; }
    
    int ans=INF,bestl,bestr,tl,tr,tl2,tr2;
    VI Lu,Ru;
    for (int mask=1;mask<(1<<n);mask++)
     {
			int sl=0,mil=INF,mir=INF,sr=0,ok=1,szl=0,szr=0;
			Lu.clear(); Ru.clear();
			
			Repi(n)
			 if (mask&(1<<i) && (!L[i] || !R[i])) {ok=0; break;}
			if (!ok) continue;
			Repi(n)
			 if (mask&(1<<i))
			 {
					sl+=L[i]; sr+=R[i];
					mil=min(mil,L[i]); mir=min(R[i],mir);
			 }
			 else
			  {
			    if (!L[i]) szr+=R[i]; else Lu.PB(i);
			    if (!R[i]) szl+=L[i]; else Ru.PB(i);
			  }
			sort(ALL(Lu)); sort(ALL(Ru));
			
			//at least one from left and all from right
			tl=SL-sl+1,tr=SR-mir+1;
			int ri=tr-sr-szr; //what leaves for the unmarked colors in worst case (for them)
			if (ri>0)
			 {
			   k=0;
			   for (int i=Ru.SZ-1;i>=0 && ri>0;i--) { k++; ri-=Ru[i]; } //at least k unmarked colors from R will be taken - find k
			   tl2=SL-sl;
			   for (int i=0;i<Lu.SZ && k>1;i++) tl2-=Lu[i]; // make sure no more than (k-1) unmarked colors are left untouched in L
			   tl<?=tl2; //get best of two
			 }
			if (tl+tr<ans) { ans=tl+tr; bestl=tl; bestr=tr; }
			
			//and vice versa
			tl=SL-mil+1,tr=SR-sr+1;
			int li=tl-sl-szl;
			if (li>0)
			 {
			   k=0;
			   for (int i=Lu.SZ-1;i>=0 && li>0;i--) { k++; li-=Lu[i]; }
			   tr2=SR-sr;
			   for (int i=0;i<Ru.SZ && k>1;i++) tr2-=Ru[i];
			   tr<?=tr2;
			 }
			if (tl+tr<ans) { ans=tl+tr; bestl=tl; bestr=tr; }
	 }
	
	cout<<bestl<<"\n"<<bestr<<"\n";
    
    return 0;
}
