//fix meridians, then dp (or bsearch for ans + greedy) over rows
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N,M,a[32][32];
int row[32],sums[32][32],Max[32][32];
int dp[32][32],ans=INF;

int getcols()
{
	memset(sums,0,sizeof(sums));
	for (int i=1;i<=M;i++)
	{
	 sums[0][i]=sums[0][i-1];
     for (int j=1,k=0;j<=N;j++)
	  {
			if (j==row[k+1]) { k++; sums[k][i]=sums[k][i-1]; }
			sums[k][i]+=a[j][i];
	  }
	}
	
	for (int i=1;i<=M;i++)
	 for (int j=i;j<=M;j++)
	  {
	   Max[i][j]=0;
	   for (int k=0;k<=n;k++)
	    Max[i][j]>?=sums[k][j]-sums[k][i-1];
	  }
	
	memset(dp,127,sizeof(dp));
	for (int i=1;i<=M;i++)
	 dp[1][i]=Max[1][i];
	
	for (int i=2;i<=m+1;i++)
	 for (int j=1;j<=M;j++)
	  for (int k=1;k<j;k++)
	   dp[i][j]<?=max(Max[k+1][j],dp[i-1][k]);
	
	ans<?=dp[m+1][M];
	
	/*
	Repi(n+1) cout<<row[i]<<" "; cout<<endl;
	Repi(n+1)
	 {
			cout<<" ";
			Repj(M) cout<<sums[i][j+1]<<" "; cout<<endl;
	 }
	cout<<":\n";
	for (int i=1;i<=m;i++)
	 {
	  for (int j=1;j<=M;j++)
	   cout<<setw(3)<<dp[i][j];
	  cout<<endl;
	 }
	cout<<endl;*/
}

void getrows(int pos)
{
	if (pos==n+1)
	 {
			getcols();
			return;
	 }
	if (row[pos-1]==N) return;
	for (row[pos]=row[pos-1]+1;row[pos]<=N;row[pos]++)
	 {
	  getrows(pos+1);
	 // assert(0);
	 }
}

int main()
{
    scanf("%d%d%d%d",&N,&M,&n,&m);
    Repi(N)
     Repj(M)
      scanf("%d",&a[i+1][j+1]);
      
    row[0]=1;
    getrows(1);
    
    cout<<ans<<"\n";
    return 0;
}
