// keep next and prev for each num ; generate intervals [st,en] with numbers in it, keep only last number if the numbers are ordered correctly
// binary search for requests
// dbg: didn't choose correctly the starts of intervals (omitted if (.. && prev.find(at)==prev.end()))
#include <iostream> 
#include <fstream> 
#include <sstream> 
#include <iomanip> 
#include <cstdio> 
#include <cstdlib> 
#include <ctime> 
#include <cmath> 
#include <cstring> 
#include <vector> 
#include <set> 
#include <bitset> 
#include <map> 
#include <queue> 
#include <numeric> 
#include <functional> 
#include <utility> 
#include <algorithm> 

using namespace std;

#define F(i,n) for (int i=0;i<n;i++)
#define Repi(n) F(i,n)
#define Repj(n) F(j,n)
#define Repk(n) F(k,n)
#define SZ size()
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define y second
#define LL long long
#define PD pair<double,double>
#define PI pair<int,int>
#define sqr(a) ((a)*(a))
#define ABS(a) (((a)<0)?(-(a)):(a))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define IT iterator
#define sign(x) (((x)>0)-((x)<0))
#define INF 2000000000
 
 
int N;
map<int,int> prev,next;

void fix(int a,bool pr,bool ne)
{
	 if (pr)
	 	if (prev.find(a)==prev.end())
	 	 	prev[a]=a-1,next[a-1]=a;//,cout<<"    prev "<<a<<" = "<<a-1<<" ; next "<<a-1<<" = "<<a<<"\n";
	 if (ne)
	 	if (next.find(a)==next.end())
	 		next[a]=a+1,prev[a+1]=a;//,cout<<"    	next "<<a<<" = "<<a+1<<" ; prev "<<a+1<<" = "<<a<<"\n";
}

struct interval{
  int st,en; VI id;
};

const int MAXN=100100;
map<int,int> pos;
interval I[MAXN]; int ic;

int getposof(int who)
{
	int l=0,r=ic-1;
	while (l+1<r)
	 {
	 	int m=(l+r)/2;
	 	int last=I[m].id.SZ; last=I[m].id[last-1];
		//cout<<" look for "<<who<<" in ["<<l<<","<<r<<"] : "<<m<<" "<<last<<"\n";
	 	if (last>=who) r=m;//,cout<<"   go left\n";
	 	else l=m+1;//,cout<<"    go right\n";
	 }
	int last=I[l].id.SZ; last=I[l].id[last-1];
	if (last>=who) return I[l].en-(last-who);
	last=I[r].id.SZ; last=I[r].id[last-1];
	return I[r].en-(last-who);
}

int getatpos(int pos)
{
	int l=0,r=ic-1;
	while (l<=r)
	 {
	 	int m=(l+r)/2;
//	 	cout<<" at "<<m<<" : \n";
	 	if (I[m].st<=pos && I[m].en>=pos)
	 	 if (I[m].id.SZ>1)
	 	  return I[m].id[pos-I[m].st];
	 	 else return I[m].id[0]-(I[m].en-pos);
	 	else
	 	 if (I[m].st>pos)
	 	  r=m-1;
	 	 else l=m+1;
	 }
}

int main()
{
	scanf("%d",&N);
	Repi(N)
	 {
	 	int a,b;
	 	scanf("%d%d",&a,&b);
	 	//cout<<"move "<<a<<" before "<<b<<"\n";
	 	fix(a,1,1); fix(b,1,0);
	 	int pa=prev[a],na=next[a],pb=prev[b];
	 	if (pb==a) continue;
	 	next[pa]=na; prev[na]=pa;  //cout<<"   next "<<pa<<" = "<<na<<" ; prev "<<na<<" = "<<pa<<"\n";
	 	next[pb]=a; prev[a]=pb;    //cout<<"   next "<<pb<<" = "<<a<<" ; prev "<<a<<" = "<<pb<<"\n";
	 	next[a]=b; prev[b]=a;      //cout<<"   next "<<a<<" = "<<b<<" ; prev "<<b<<" = "<<a<<"\n";
	 }
	
	ic=1; I[0].st=-1; I[0].en=-1; I[0].id.PB(-1);
	for (map<int,int>::IT it=next.begin(); it!=next.end(); it++)
	 {
	 	int at=it->x;
	 	if (pos.find(at)==pos.end() && prev.find(at)==prev.end())
	 	 {
	 	 	int last=I[ic-1].id.SZ; last=I[ic-1].id[last-1];
	 	 	//cout<<" new interval start "<<I[ic].st<<"\n";
	 	 	bool putinprev=0;
	 	 	int start=I[ic-1].en+at-last;
	 	 	if (at-last==1) putinprev=1;
	 	 	else I[ic].st=I[ic-1].en+1,I[ic].en=start-1,I[ic].id.PB(at-1),ic++;
	 	 	I[ic].st=start;
	 	 	for (int p=0;;p++,at=next[at])
	 	 	 {
	 	 	 //	cout<<"             add "<<at<<" at pos "<<I[ic].st+p<<"\n";
	 	 	 	pos[at]=I[ic].st+p;
	 	 	 	I[ic-putinprev].id.PB(at);
	 	 	 	if (next.find(at)==next.end()) break;
	 	 	 }
	 	 	I[ic-putinprev].en=I[ic-putinprev].st+(int)I[ic-putinprev].id.SZ-1;
	 	 	//cout<<"    end "<<I[ic].en<<"\n";
	 	 	if (!putinprev) ic++;
	 	 }
	 }
	I[ic].st=I[ic-1].en+1; I[ic].en=INF; I[ic].id.PB(INF);
	ic++;
//	Repi(ic){	 	cout<<" interval "<<i<<" : ["<<I[i].st<<","<<I[i].en<<"] -> "; Repj(I[i].id.SZ) cout<<I[i].id[j]<<" ";cout<<"\n"; 	 }
	
	int M;
	scanf("%d",&M);
	char comm[4];
	Repi(M)
	 {
	 	int a;
	 	scanf("%s %d\n",comm,&a);
	 	//cout<<comm[0]<<" "<<a<<" : ";
	 	if (comm[0]=='P')
	 	 {
	 	 	if (pos.find(a)!=pos.end())
	 	 	 printf("%d\n",pos[a]);
	 	 	else
	 	 	 printf("%d\n",getposof(a));
	 	 }
	 	else 
	 	 {
	 	 	printf("%d\n",getatpos(a));
	 	 }
	 }
	fprintf(stderr,"%.5lf\n",(double)clock()/CLOCKS_PER_SEC);
	return 0;
}
