//try each vertex with each time - pfs by time
//optim1: O(1) function telling min time when a road is traversible a.k.a. 2 lights are the same color
//optim2: don't enter vertex with a time > the earliest time it has been entered + the maximal time it would ever have to wait to go somewhere
//optim3: don't be an idiot and don't enter the same vertex TWICE with the same time... (like i did)
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <ctime>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <string>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <numeric>
#include <functional>
#include <cstdlib>
#include <cstdio>
#include <queue>

using namespace std;

#define Repi(n) for (int i=0;i<(n);i++)
#define Repj(n) for (int j=0;j<(n);j++)
#define Repk(n) for (int k=0;k<(n);k++)
#define MIN(a,b) ((a>b)?b:a)
#define VI vector<int>
#define PB push_back
#define MP make_pair
#define x first
#define y second
#define SZ size()
#define ALL(v) (v).begin(),(v).end()
#define sqr(x) ((x)*(x))
#define Time (double)clock()/CLOCKS_PER_SEC
#define PI pair<int,int>

#define MAXN 301
int A,B,N,M;
char C[MAXN]; int init[MAXN],r[MAXN],t[2][MAXN];
int tim[MAXN][MAXN];
VI adj[MAXN];
int earliest[MAXN],maxwait[MAXN];
bitset<MAXN*300> used[MAXN];

inline bool getcolat(int a,int tt)
{
	if (tt<r[a]) return init[a];
	tt-=r[a];
	tt%=t[0][a]+t[1][a];
	if (tt<t[init[a]^1][a]) return init[a]^1;
	return init[a];
}

inline int getchangedelay(int a,int tt)
{
	if (tt<r[a]) return r[a]-tt;
	tt-=r[a];
	tt%=t[0][a]+t[1][a];
	if (tt<t[init[a]^1][a]) return t[init[a]^1][a]-tt;
	return t[0][a]+t[1][a]-tt;
}

inline int getmeetdelay(int a,int b,int tt)
{
	int ya,yb,ret=0;
	if (getcolat(a,tt)==getcolat(b,tt)) return 0;
	Repi(3)
	 {
		  ya=getchangedelay(a,tt),yb=getchangedelay(b,tt);
		  if (ya!=yb)
		     return ret+MIN(ya,yb);
		  ret+=ya; tt+=ya;
	 }
	return -1;
}

int main()
{
	scanf("%d%d%d%d",&A,&B,&N,&M);
	for (int i=1;i<=N;i++)
	 {
			scanf("\n%c %d %d %d\n",C+i,r+i,t[0]+i,t[1]+i);
			if (C[i]=='P') init[i]=1;
		//	cout<<init[i]<<" "<<r[i]<<" "<<t[0][i]<<" "<<t[1][i]<<endl;	
	     //   Repj(200)		     cout<<"     "<<j<<" - "<<getcolat(i,j)<<" "<<getchangedelay(i,j)<<endl;
	 }
	
/*	for (int i=1;i<=N;i++)
	 for (int j=i+1;j<=N;j++)
	  {
			cout<<"MEET "<<i<<" and "<<j<<" : \n";
			Repk(200)
			 cout<<k<<" : "<<getcolat(i,k)<<" "<<getcolat(j,k)<<" == "<<getmeetdelay(i,j,k)<<endl;
	  }*/
	for (int i=1;i<=N;i++)
	{
	 maxwait[i]=t[0][i]+t[1][i];
	 Repj(adj[i].SZ)
	  {
			int k=adj[i][j];
			maxwait[i]=max(maxwait[i],t[0][k]+t[1][k]);
	  }
	}

    int a,b,l;	
	Repi(M)
	 {
			scanf("%d%d%d",&a,&b,&l);
			adj[a].PB(b); adj[b].PB(a);
			tim[a][b]=tim[b][a]=l;
		//	cout<<" con "<<a<<" "<<b<<" "<<l<<endl;
	 }
	 
	priority_queue<PI,vector<PI>,greater<PI> > q;
	PI tmp;
	q.push(MP(0,A));
	int ans=0,next,wait,newtime;
	memset(earliest,127,sizeof(earliest));
	used[A][0]=1;
	while (!q.empty())
	 {
			tmp=q.top(); q.pop();
		//	cout<<" in "<<tmp.y<<" with "<<tmp.x<<endl;
			if (tmp.y==B) { ans=tmp.x; break; }
			earliest[tmp.y]=MIN(earliest[tmp.y],tmp.x);
			if (tmp.x>earliest[tmp.y]+maxwait[tmp.y]) continue;
			Repi(adj[tmp.y].SZ)
			 { next=adj[tmp.y][i];
			   wait=getmeetdelay(tmp.y,next,tmp.x);
			   newtime=tmp.x+wait+tim[tmp.y][next];
			   if (newtime>earliest[next]+maxwait[next] || wait==-1 || used[next][newtime]) continue;
			   q.push(MP(newtime,next));
			   used[next][newtime]=1;
			 }
	 }
	
    printf("%d\n",ans);
   // cout<<Time<<endl;
	return 0;
}
