// this apparently wrong greedy fails on tests 7,8 and 15
// 1. start grouping consequtive numbers (a[i] with a[i]-1 and a[i]+1)
// 2. for each group keep its smallest number, its largest number and its number that was first encountered in the input
// 3. if after adding a[i] to (a[i]-1)'s group, the difference between a[i] and the group's smallest number equals the difference between i and the smallest position of a number in the group
//    then it's an empodio
// 4. when declaring an empodio, delete all numbers from it but the last one, since only it can be part of another empodio (or otherwise it wouldn't be an empodio but a framed interval with 2 empodia)
//note: disjoint sets (a.k.a. union find) used
//---now this is WRONG because a group may contain an empodio without it being one - for example:
//       number: 198 199 200 201 202 203
// pos in input:   6  71  74  73  72  75
//---we will add 198, then 199 then the others and finally 203 and we won't see the empodio 199..203 because of 198 which was added to the group as the earliest and smallest number, but the difference between the positions is too big
#include <vector>
#include <list>
#include <map>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;
#define MAXN 1100100

int n,m,N,M,P,T,K;
int a[MAXN],pos[MAXN];
bool used[MAXN];

struct set{ 
	int par,rank,leftmost,small,large;
    bool empodio;
    set(){};
	set(int x){leftmost=pos[x]; par=small=large=x; rank=0; empodio=0; };
          };
set sets[MAXN];

int findroot(int x)
{
	if (x==sets[x].par) return sets[x].par;
	sets[x].par=findroot(sets[x].par);
	return sets[x].par;
}

void unite(int x,int y)
{
    int sm=MIN(sets[x].small,sets[y].small),lr=MAX(sets[x].large,sets[y].large),lf=MIN(sets[x].leftmost,sets[y].leftmost);
	cout<<"             ...uniting ["<<sets[x].small<<","<<sets[x].large<<"]"<<sets[x].leftmost<<" with ["<<sets[y].small<<","<<sets[y].large<<"]"<<sets[y].leftmost<<"\n";
	cout<<"                    into ["<<sm<<","<<lr<<"] "<<lf<<endl;
	x=findroot(x);
	y=findroot(y);
	if (sets[x].rank>sets[y].rank)
	 { sets[y].par=x; sets[x].small=sm; sets[x].large=lr; sets[x].leftmost=lf; }
	else if (sets[y].rank>sets[x].rank)
	 { sets[x].par=y; sets[y].small=sm; sets[y].large=lr; sets[y].leftmost=lf; }
	else
	 {
			sets[x].rank++;
			sets[y].par=x;
		    sets[x].small=sm; sets[x].large=lr; sets[x].leftmost=lf;
	 }
}

vector<PI> ans;

int main()
{
    scanf("%d",&M);
    int prev,next;
    Repi(M)
     {
			scanf("%d",a+i);
			pos[a[i]]=i;
			sets[a[i]]=set(a[i]);
			cout<<"\n\n"<<i<<" : "<<a[i]<<endl;
			used[a[i]]=1;
			if (i && used[a[i]-1])
			 {
					prev=findroot(a[i]-1);
					cout<<"        prev used - ["<<sets[prev].small<<","<<sets[prev].large<<"] "<<sets[prev].leftmost<<endl;
					if (sets[prev].empodio) {cout<<"  prev is empodia..\n"; 
					                         goto sux; }
					unite(a[i],prev);
					prev=findroot(prev);
					if (a[sets[prev].leftmost]==sets[prev].small && i-sets[prev].leftmost==sets[prev].large-sets[prev].small)
					 {
					   cout<<"          declare as empodio\n";
					   ans.PB(MP(sets[prev].leftmost+1,i+1));
					   sets[prev].empodio=1;
					   sets[prev].large--; sets[a[i]]=set(a[i]); //only the last element can be a part of another empodio and with no other element from that empodio (or otherwise it wouldn't be an empodio but a framed interval with 2 empodia)
					 }
					sux:;
			 }
			if (used[a[i]+1])
			 {
					prev=findroot(a[i]);
					next=findroot(a[i]+1);
					cout<<"     2   prev used - ["<<sets[prev].small<<","<<sets[prev].large<<"] "<<sets[prev].leftmost<<endl;
					cout<<"     2   next used - ["<<sets[next].small<<","<<sets[next].large<<"] "<<sets[next].leftmost<<"\n";
					if (sets[next].empodio || sets[prev].empodio) { cout<<"    next or a[i] is empodia.. \n"; 
					                                                 goto sux2; }
					unite(prev,next);
					sux2:;
			 }
	 }
	
	printf("%d\n",ans.SZ);
	Repi(ans.SZ)
	 printf("%d %d\n",ans[i].x,ans[i].y);
	fprintf(stderr,"time: %lf\n",Time);
    return 0;
}
