// take as many olive trees from whole fields as possible (find all sums of fields and take largest one)
// if there are any fields left, take all trees from any one of them (each of the left ones will be able to provide us with enough trees, otherwise we would have added it to the sum)
// if not, take trees from the stripes, starting from the largest one and continuing to the smallest one
// note that it's a subcase of the knapsack problem
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 2048
int n,m,N,M,P,T,K,Q;
int f[MAXN],s[MAXN];
int sums[MAXN*160];
int q[MAXN*160],qsz;

int main()
{
    scanf("%d%d%d",&Q,&N,&M);
    Repi(N)
       scanf("%d",f+i);
    Repi(M)
     scanf("%d",s+i);
    
 
    memset(sums,-1,sizeof(sums));
    sums[0]=0; q[0]=0; qsz=1;
    Repi(N)
     {
		    int nqsz=qsz;
			Repj(qsz)
			 if (q[j]+f[i]<=Q && sums[q[j]+f[i]]==-1)
			  {
					sums[q[j]+f[i]]=sums[q[j]]+1;
					q[nqsz++]=q[j]+f[i];
			  }
			qsz=nqsz;
	 }
	 
	int ans=0;
	bool anyfieldsleft;
	for (int i=Q;i>=0;i--)
	 {
			if (sums[i]>-1) { Q-=i; ans+=i;
			                  anyfieldsleft=sums[i]<N;
			                  break; }
	 }
	 
	if (anyfieldsleft || Q==0)
	 {
	   printf("%d\n",ans+Q-(Q>0));
	   return 0;
	 }
	sort(s,s+M); reverse(s,s+M);
	Repi(M)
	 {
			ans+=min(s[i],Q)-1;
			Q-=min(s[i],Q);
			if (!Q) break;
	 }
	
	printf("%d\n",ans);
	
    return 0;
}
