//dp[height][width] - seki vuzmojen horizontalen i vertikalen razrez i gleda6 min ot sbora na decata
//optimization - precompute-va6 si4ki sumi po height i po width i cepi6 samo na tqh
//optimization 2 - ako minimalniq width s koito moje da se naprai dadena height-suma e > ot teku6tiq, ne praim razrez tam (i obratnoto za height i width-sumite)
//optimization 3 - za vseki width za vsqka width suma pazi6 koq e sledva6tata suma s <= min width ot toq (demek ot stoinostite ot gorniq optimization ; prai6 i analogi4no za seki height i sqka width-suma)
//optimization 3.1 - maha6 optimization 4 6toto ne e nikakuv optimization a BAVI!! ( k=jump[w][h_sum] e 324234234 puti po-bavno ot k++, vupreki mnogoto izli6ni proverki, koito vsa6tnost hi4 ne sa tolkova mnogo)
//optimization 4 - ako dp[i][j] <= minimalnoto dp[i][x]*2 ili minimalnoto dp[x][j]*2 break-va6 teku6toto cepene (6tot nqma kak da stane po-dobro)
//...............ba i pak bavi na poslednite testove...pone na moqta boza, ako tqhnata e 1.6x faster moje i da fana 100
#include <iostream> 
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <list>
#include <algorithm>
#include <utility>
#include <numeric>
#include <functional>
#include <cmath>
#include <ctime>

using namespace std;

#define Repi(n) for (int i=0;i<(n);i++)
#define Repj(n)	for (int j=0;j<(n);j++)
#define Repk(n) for (int k=0;k<(n);k++)
#define VI vector<int>
#define PB push_back
#define MP make_pair
#define x first
#define y second
#define SZ size()
#define ALL(v) v.begin(),v.end()
#define LL long long
#define UI unsigned int
#define sqr(a) ((a)*(a))
#define PI pair<int,int>
#define Time (double)clock()/CLOCKS_PER_SEC

#define MAXN 256
#define INF 10000000
#define MAXH 666
#define MIN(a,b) ((a>b)?b:a)

int N,H,W;
PI p[MAXN];

bool ispiece[MAXH][MAXH];
int sumh[MAXH],sumw[MAXH];
vector<PI> sh,sw;
vector<int> jh[MAXH],jw[MAXH];

int minh[MAXH],minw[MAXH];
int dp[MAXH][MAXH];

bool cmp(const PI &a,const PI &b)
{ return a.y<b.y; }

int main()
{
   scanf("%d%d%d",&W,&H,&N);
   Repi(N)
    scanf("%d%d",&p[i].y,&p[i].x);
    
   memset(ispiece,0,sizeof(ispiece));
   Repi(N)
       ispiece[p[i].x][p[i].y]=1;
    
    
   memset(sumw,-1,sizeof(sumw));
   sort(p,p+N);
   sumw[0]=INF;
   Repi(N)
    Repj(W)
     if (sumw[j]>-1 && j+p[i].y<=W && sumw[j+p[i].y]==-1)
        sumw[j+p[i].y]=min(p[i].x,sumw[j]);
   for (int i=1;i<=W;i++)
    if (sumw[i]>-1) sw.PB(MP(i,sumw[i]));
    
   /*
   int last;
   Repj(H+1)
    { last=-1;
      jw[j].resize(sw.SZ);
      for (int i=sw.SZ-1;i>=0;i--)
       { jw[j][i]=last;
        // cout<<"   jw "<<j<<" "<<i<<" = "<<last<<endl;
         if (sw[i].y<=j) last=i; 
       }
    }
    */  
   
   memset(sumh,-1,sizeof(sumh));
   sort(p,p+N,cmp);
   sumh[0]=INF;
   Repi(N)
    Repj(H)
     if (sumh[j]>-1 && j+p[i].x<=H && sumh[j+p[i].x]==-1)
      {
        sumh[j+p[i].x]=min(p[i].y,sumh[j]);
      //  cout<<j+p[i].x<<" = "<<sumh[j+p[i].x]<<" from "<<i<<endl; //verify for correctness
      }
   for (int i=1;i<=H;i++)
    if (sumh[i]>-1) sh.PB(MP(i,sumh[i]));
    
   /*
   Repj(W+1)
    { last=-1;
      jh[j].resize(sh.SZ);
      for (int i=sh.SZ-1;i>=0;i--)
       { jh[j][i]=last; 
     //    cout<<"                                   jh "<<j<<" "<<i<<" = "<<last<<endl;
         if (sh[i].y<=j) last=i; 
       }
    }
   */   
      
   int tmp;
   memset(minh,127,sizeof(minh));
   memset(minw,127,sizeof(minw));
   for (int i=1;i<=H;i++)
    for (int j=1;j<=W;j++)
     {
          if (ispiece[i][j]) { 
                                dp[i][j]=0;
                                minh[i]=minw[j]=0;
                                continue;
                             }
                            
          dp[i][j]=i*j;
          
          //for (int k=0;k!=-1;k=jh[j][k])
          Repk(sh.SZ)
           {
                     if (sh[k].x>=i)
                          break;
                     if (sh[k].y>j)
                          continue;
                     tmp=dp[sh[k].x][j]+dp[i-sh[k].x][j];
                     dp[i][j]=MIN(dp[i][j],tmp);
                     if (dp[i][j]<=(minw[j]<<1)) break;
           }
     
          //for (int k=0;k!=-1;k=jw[i][k])
          Repk(sw.SZ)
           {
                     if (sw[k].x>=j)
                          break;
                     if (sw[k].y>i)
                          continue;
                     tmp=dp[i][sw[k].x]+dp[i][j-sw[k].x];
                     dp[i][j]=MIN(dp[i][j],tmp);
                     if (dp[i][j]<=(minh[i]<<1)) break;
           }
          minh[i]=MIN(minh[i],dp[i][j]);
          minw[j]=MIN(minw[j],dp[i][j]);
     }
   printf("%d\n",dp[H][W]);
   return 0;
}
