//y = (x+1)*2^a-1  are all losing positions for x>=1 && a>=0
//for each pos find all losing positions in same row & column in O(a)
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;

#define MAXN1 1024
#define MAXN 200000000
bool u[MAXN1][MAXN1];
PI go[MAXN1][MAXN1];

PI solve(int h,int w)
{
	if (u[h][w]) return go[h][w];
	u[h][w]=1;
	for (int i=h/2+h%2;i<=h;i++)
	 if (solve(i,w).x==-1)
	  { //if (h==43 && w==89) cout<<"fr "<<h<<" "<<w<<" to "<<i<<" "<<w<<endl; 
	    go[h][w]=MP(i,w); return go[h][w];
	  }
	for (int i=w/2+w%2;i<=w;i++)
     if (solve(h,i).x==-1)
	  { //if (h==43 && w==89)cout<<"fr "<<h<<" "<<w<<" to "<<h<<" "<<i<<endl; 
        go[h][w]=MP(h,i); return go[h][w];
	  }
	go[h][w]=MP(-1,0);
	return go[h][w];
}

bool hah[MAXN1][MAXN1];

int movex(int x,int y)
{
	int a2=1,x1;
	if (y==1)
	 {
	   int at=1;
	   while (at<x)
	    { a2*=2; at+=a2; }
	   return at-a2;
	 }
	else
	while(a2<MAXN)
	 {
			x1=y*a2+a2-1;
			if (x1>=x/2 && x1<=x) return x1;
			a2*=2;
	 }
	return -1;
}

int main()
{
    int i,j,k,l;
    
    go[1][1].x=-1; u[1][1]=1;
    k=l=100;
    
    //variant 1
	for (int i=1;i<=k;i++) for (int j=1;j<=l;j++) solve(i,j);
	
	//variant 2
	for (int x=1;x<=k;x++)
	 for (int a=0;a<5;a++)
	  {
	    int y=(int)((x+1)*pow(2.,(double)a)-1);
	    hah[x][y]=hah[y][x]=1;
	  }


/*	for (int i=1;i<=k;i++)
	{
	 cout<<i<<": ";
	 for (int j=1;j<=50;j++)
	  if (go[i][j].x==-1)
	   cout<<"1";
	  else
	   cout<<"-";
	 // if (u[i][j])
	//  cout<<i<<" "<<j<<" to "<<go[i][j].x<<" "<<go[i][j].y<<endl;
	 cout<<endl;
	}
	
/*	cout<<endl<<endl;
	
	for (int x=1;x<=k;x++)
	 for (int a=0;a<5;a++)
	  {
	    int y=(int)((x+1)*pow(2.,(double)a)-1);
	    hah[x][y]=hah[y][x]=1;
	  }
	 
	Repi(k+1)
	 {
	  Repj(l+1)  
	   if (hah[i][j]) cout<<" 1";
	   else cout<<" -";
	  cout<<endl;
	 }*/
	 
	while(1)  
	{
	  cin>>k>>l; cout<<go[k][l].x<<" "<<go[k][l].y<<endl;
	  j=movex(k,l);
	  if (j>-1) { cout<<j<<" "<<l<<" -> "; cout<<go[j][l].x<<" "<<go[j][l].y<<endl; }
	  else
	   {
			j=movex(l,k);
			cout<<k<<" "<<j<<" -> "; cout<<go[k][j].x<<" "<<go[k][j].y<<endl;
	   }
	}
    
    return 0;
}
