#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;

inline LL cp(PI A,PI B,PI C)
{
	int dx1=B.x-A.x;
	int dy1=B.y-A.y;
	int dx2=C.x-A.x;
	int dy2=C.y-A.y;
	return (LL)dx1*dy2-(LL)dx2*dy1;
}

bool intersect(PI A,PI B,PI C,PI D)
{
	LL d1=cp(A,C,D),d2=cp(A,C,B)+cp(A,B,D);
	double t=(double)d1/d2;
	if (t<1e-7 || t>1-1e-7) return 0;
	swap(A,C); swap(B,D);
	d1=cp(A,C,D),d2=cp(A,C,B)+cp(A,B,D);
	t=(double)d1/d2;
	if (t<1e-7 || t>1-1e-7) return 0;
	return 1;
}

PI R[100000],G[100000];
bool ug[100000],ur[100000];
PI g[100000],r[100000];
int gc,rc;

int main(int argc, char* argv[])
{
    int i,j,k,l;
    FILE *f=fopen(argv[1],"r");
    fscanf(f,"%d",&n);
    Repi(n)
     {
			fscanf(f,"%d%d",&G[i+1].x,&G[i+1].y);
	 }
	fscanf(f,"%d",&m);
	Repi(m)
     {
			fscanf(f,"%d%d",&R[i+1].x,&R[i+1].y);
	 }
    fclose(f);
    
    
    f=fopen(argv[2],"r");
    char c;
    Repi(n+m-2)
     {
			fscanf(f,"%d %d %c\n",&j,&k,&c);
		//	cout<<j<<" "<<k<<" "<<c<<endl;
			if (c=='g')
			 {
					ug[j]=ug[k]=1;
					g[gc++]=MP(j,k);
					for (int l=0;l<rc;l++)
					 {
							if (intersect(R[r[l].x],R[r[l].y],G[j],G[k]))
							 cout<<"BAAAA!!!! "<<j<<" "<<k<<" g   se nasra s  "<<r[l].x<<" "<<r[l].y<<" r \n";
					 }
			 }
			else
			 {
					ur[j]=ur[k]=1;
					r[rc++]=MP(j,k);
					for (int l=0;l<gc;l++)
					 {
							if (intersect(G[g[l].x],G[g[l].y],R[j],R[k]))
							 cout<<"BAAAA!!!! "<<j<<" "<<k<<" r   se nasra s  "<<g[l].x<<" "<<g[l].y<<" g \n";
					 }
			 }
	 }
    fclose(f);
    
    return 0;
}
