#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define pause system("pause")

using namespace std;

int n,m;

char f[100100];
char m1[23],m2[23]; int c1,c2;
int br[256],pos[128][128];

inline int count(char m[],int c)
{
       br['M']=0; br['F']=0; br['B']=0;
       int cnt=0;
       Repi(c)
        {
              br[m[i]]++;
              if (i>2) br[m[i-3]]--;
              cnt+=(br['M']>0)+(br['F']>0)+(br['B']>0);
        }
       return cnt; 
}



int ga[3][10]={
{2,2,3,3,2,2,2,1,2,1},
{3,3,2,2,2,2,2,2,1,1},
{2,2,2,2,3,3,1,2,2,1},
};

int sa[3][10]={
{7,0,0,5,5,7,0,7,5,7},
{4,3,3,8,8,4,3,4,8,8},
{1,6,6,2,2,1,6,1,2,6},
};


inline int gain(int state,char c)
{   if (c=='B') return ga[0][state];
   if (c=='F') return ga[1][state];
   if (c=='M') return ga[2][state];
}

inline int newstate(int state,char c)
{   if (c=='B') return sa[0][state];
   if (c=='F') return sa[1][state];
   if (c=='M') return sa[2][state];
}

//old DP
/*
int d[100100][10][10];


int MM;
int rec(int pos,int state0,int state1)
{
    if (pos>MM) {MM=pos; cout<<MM<<" ";}
    if (pos==n) return 0;
    if (d[pos][state0][state1]>-1) return d[pos][state0][state1];
    d[pos][state0][state1]>?=rec(pos+1 , newstate(state0,f[pos]) , state1) + gain(state0,f[pos]);
    d[pos][state0][state1]>?=rec(pos+1 , state0 , newstate(state1,f[pos])) + gain(state1,f[pos]);
    return d[pos][state0][state1];
}
*/

//new DP

int d[2][16][16];

int main()
{
    int i,j,k,l; char c;
    scanf("%d",&n);
    scanf("%s",f);
    
    memset(d,255,sizeof(d));
    
    //brute
    if (n<=0)
     {
       int ans=0;
       Repi((1<<n))
        {
                   l=i; c1=0; c2=0;
                   Repj(n)
                   {
                          if (l&1) m2[c2++]=f[j];
                          else m1[c1++]=f[j];
                          l/=2;
                   }
                   ans=max(ans,count(m1,c1)+count(m2,c2));
        }
       printf("%d\n",ans); 
    cout<<(double)clock()/(double)CLOCKS_PER_SEC<<endl;
       return 0;
     }
    
    //dp
    pos['M']['B']=0;
    pos['B']['M']=1;
    pos['F']['M']=2;
    pos['M']['F']=3;
    pos['B']['F']=4;
    pos['F']['B']=5;
    pos['M']['M']=6;
    pos['B']['B']=7;
    pos['F']['F']=8;
//    memset(d,255,sizeof(d));
//    printf("%d\n",rec(0,9,9));

    int Y=0;
    for (int pos=n-1; pos>=0; pos--)
    {
        memset(d[Y^1],0,sizeof(d[Y^1]));
        Repi(10)
         Repj(10)
         {
          d[Y^1][i][j]>?=d[Y][newstate(i,f[pos])][j]+gain(i,f[pos]);
          d[Y^1][i][j]>?=d[Y][i][newstate(j,f[pos])]+gain(j,f[pos]);
         }
        Y^=1;
    }
   printf("%d\n",d[Y][9][9]+1);
    cout<<(double)clock()/(double)CLOCKS_PER_SEC<<endl;
    
    return 0;
}
