#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>

#define MP make_pair
#define PI pair<int,int>
#define VI vector<int>
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define LL long long
#define pause system("pause");

using namespace std;

typedef struct point{int x,y,z;};

bool operator<(point a,point b)
{
     return(a.z<b.z)?1:( (b.z<a.z)?0:( (a.y<b.y)?1:( (b.y<a.y)?0:(a.x<b.x) ) ) );
 }

int N,B,M,D,n;
point a[100100];
int d[100100];
int t[300000];
int T[610][610];

inline void push(int pos)
{
     pos+=n;
     while (pos>0) { t[pos]++; pos/=2; }
}

inline void dec(int pos)
{
     pos+=n;
     while (pos>0) { t[pos]--; pos/=2; }
}

inline int sum1(int pos)
{
     if (pos==-1) return 0;
     pos+=n;
     int ans=t[pos];
     while (pos>1)
     {
           if (pos/2*2!=pos) ans+=t[pos/2*2];
           pos/=2;
     }
     return ans;
}

inline int sum(int st,int en)
{    return sum1(en)-sum1(st-1);}


int dd[800][800];

inline void push2D(int X,int Y)
{
  dd[X][Y]++;
  for (;X<=n;X+=X&(-X))
   for (int y=Y;y<=n;y+=y&(-y))
    T[X][y]++;
}
       
inline void dec2D(int X,int Y)
{
  dd[X][Y]--;
   for (;X<=n;X+=X&(-X))
   for (int y=Y;y<=n;y+=y&(-y))
    T[X][y]--;
}

inline int sum12D(int X,int Y)
{
 int ans=0;
 for (;X>0;X-=X&(-X))
  for (int y=Y;y>0;y-=y&(-y))
   ans+=T[X][y];
 return ans;
}

inline int sum2D(int X1,int Y1,int X2,int Y2)
{ return sum12D(X2,Y2)-sum12D(X2,Y1-1)-sum12D(X1-1,Y2)+sum12D(X1-1,Y1-1); }

point ta[100100];

int main()
{
    int i,j,k,l;
    
    scanf("%d%d%d%d",&B,&N,&D,&M);

    LL ans=0;    
    if (B==1)
    {
      Repi(N)
       scanf("%d",&a[i].x);
      sort(a,a+N); 
      j=0;
      for (int i=1; i<N; i++)
       {
             while (a[i].x-a[j].x>D) j++;
             ans+=(LL)(i-j);
       }
    }
    
    if (B==2)
    {
      Repi(N)
       scanf("%d%d",&a[i].x,&a[i].y);
      Repi(N)
      { 
             j=a[i].x; k=a[i].y; 
             a[i].x=M-(j+k)+2*j; a[i].y=j+k;
      }
      sort(a,a+N);

      n=1; while (n<M*2+1) n*=2;
      j=0; push(a[0].x);
      for (int i=1; i<N; i++)
       {
               while (a[i].y-a[j].y>D) { dec(a[j].x); j++; }
//               cout<<j<<endl;
//               for (int j=n; j<=n+M*2; j++) cout<<t[j]<<" "; cout<<endl;
//               cout<<a[i].x-D+1<<" "<<a[i].x+D-1<<" = "<<sum(a[i].x-D,a[i].x+D)<<endl;
//               cout<<endl;
               ans+=(LL)sum(max(0,a[i].x-D),min(n-1,a[i].x+D));
               push(a[i].x);
       }
    }
    
    if (B==3)
    {
      Repi(N)
       scanf("%d%d%d",&a[i].x,&a[i].y,&a[i].z);
      Repi(N)
       {
             j=a[i].x; k=a[i].y; l=a[i].z;
//             ta[i].x=j; ta[i].y=k; ta[i].z=l;
//             a[i].x=2*M-(j+k+l)+2*j; a[i].y=2*M-(j+k+l)+2*k; a[i].z=j+k+l;
             a[i].x=2*M+(j-k)*2+(j+k+l)%2; a[i].y=2*M-(j+k+l)+(j+k)*2; a[i].z=j+k+l;
       }
      sort(a,a+N);
       

      n=M*4+1;
      j=0; push2D(a[0].x,a[0].y);
      for (int i=1; i<N; i++)
       {
               cout<<a[i].x<<" "<<a[i].y<<" "<<a[i].z<<" -> ";
               while (a[i].z-a[j].z>D) { dec2D(a[j].x,a[j].y); j++; }
//               cout<<j<<endl;
//               for (int j=n; j<=n+M*2; j++) cout<<t[j]<<" "; cout<<endl;
//               cout<<a[i].x-D+1<<" "<<a[i].x+D-1<<" = "<<sum(a[i].x-D,a[i].x+D)<<endl;
//               cout<<endl;
//               l=sum2D(max(1,a[i].x-D),max(1,a[i].y-D),min(a[i].x+D,n),min(a[i].y+D,n));
//               k=0;
//               for (int o=0; o<i; o++)
//                if (abs(a[i].x-a[o].x)<=D && abs(a[i].y-a[o].y)<=D && abs(a[i].z-a[o].z)<=D) k++;
//               printf("%d %d %d -> %d %d",a[i].x,a[i].y,a[i].z,l,k); if (k!=l) printf("   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"); printf("\n");
               l=ans;
               ans+=(LL)sum2D(max(1,a[i].x-D),max(1,a[i].y-D),min(a[i].x+D,n),min(a[i].y+D,n));
               cout<<ans-l<<endl;
               push2D(a[i].x,a[i].y);
          //     cout<<a[i].x<<" "<<a[i].y<<" "<<a[i].z<<endl;
              // Repj(n){  Repk(n-5)  cout<<" "<<dd[j][k]; cout<<endl; } pause;
       }
    }
    cout<<B<<endl;
    cout<<ans<<"\n";

//pause;    
    return 0;
}
