#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
#define MAXN 310
int x[MAXN],v[MAXN];
int d[MAXN][MAXN][2];
int t[MAXN][MAXN][2];
int come[MAXN][MAXN][2];

int solve1(int st,int en,bool pos) //LL ?????
{
	int &ret=d[st][en][pos];
	if (ret>-1) return ret;
	ret=INF; int tmp1=solve1(st+1,en,0),tmp2=solve1(st+1,en,1),tmp3=solve1(st,en-1,0),tmp4=solve1(st,en-1,1);
	int &cc=come[st][en][pos],&tt=t[st][en][pos];
	int addtime=x[en]-x[st];

         if (!pos)
          {
				
			if (tmp1+v[st]*(t[st+1][en][0]+x[st+1]-x[st])<ret)
			 {
			  tt=t[st+1][en][0]+x[st+1]-x[st];
			  ret=tmp1+v[st]*tt; cc=0;
//			  cout<<cc<<": "<<st<<" "<<en<<" "<<pos<<" = "<<st+1<<" "<<en<<" 0 ("<<ret<<") = "<<tmp1<<" + "<<v[st]<<" * "<<tt<<endl;
			 }

			if (tmp2+v[st]*(t[st+1][en][1]+addtime)<ret)
			 {
			  tt=t[st+1][en][1]+addtime;
			  ret=tmp2+v[st]*tt; cc=1;
//			  cout<<cc<<": "<<st<<" "<<en<<" "<<pos<<" = "<<st+1<<" "<<en<<" 1 ("<<ret<<") = "<<tmp2<<" + "<<v[st]<<" * "<<tt<<endl;
			 }
			 
		  }
		 else
		  {

			if (tmp3+v[en]*(t[st][en-1][0]+addtime)<ret)
			 {
			  tt=t[st][en-1][0]+addtime;
			  ret=tmp3+v[en]*tt; cc=2;
//			  cout<<cc<<": "<<st<<" "<<en<<" "<<pos<<" = "<<st<<" "<<en-1<<" 0 ("<<ret<<") = "<<tmp3<<" + "<<v[en]<<" * "<<tt<<endl;
			 }

			if (tmp4+v[en]*(t[st][en-1][1]+x[en]-x[en-1])<ret)
			 {
			   tt=t[st][en-1][1]+x[en]-x[en-1];
			   ret=tmp4+v[en]*tt; cc=3;
//			   cout<<cc<<": "<<st<<" "<<en<<" "<<pos<<" = "<<st<<" "<<en-1<<" 1 ("<<ret<<") = "<<tmp4<<" + "<<v[en]<<" * "<<tt<<endl;
			 }
			 
		  }

//    cout<<"        ====     "<<st<<" "<<en<<" "<<pos<<" = "<<ret<<" ; "<<tt<<" "<<cc<<endl;
    return ret;
}


int solve(int st,int en,int pos)
{
	int &ret=d[st][en][pos];
	if (ret>-1) return ret;
	ret=INF;
	int &cc=come[st][en][pos],&tt=t[st][en][pos];
	
	if (!pos)
	 {
			int totlost=0,sum=0,tottime=0;
			for (int i=st+1;i<=en;i++)
			 {
			        int oret=ret;
					sum+=v[i-1];
					if ( solve(i,en,0)+totlost+sum*(x[i]-x[i-1]+t[i][en][0]) < ret )
					 {
							tt=x[i]-x[i-1]+t[i][en][0];
							ret=solve(i,en,0)+totlost+sum*tt;
							tt+=tottime;
							cc=come[i][en][0];
					 }
					if ( solve(i,en,1)+totlost+sum*(x[en]-x[i-1]+t[i][en][1]) < ret )
					 {
							tt=x[en]-x[i-1]+t[i][en][1];
							ret=solve(i,en,1)+totlost+sum*tt;
							tt+=tottime;
							cc=come[i][en][1];
					 }
					if (ret==oret) break;
					tottime+=x[i]-x[i-1];
					totlost+=sum*(x[i]-x[i-1]);
			 }
	 }
	else
	 {
			int totlost=0,sum=0,tottime=0;
			for (int i=en-1;i>=st;i--)
			 {
					int oret=ret;
					sum+=v[i+1];
					if ( solve(st,i,1)+totlost+sum*(x[i+1]-x[i]+t[st][i][1]) < ret )
					 {
							tt=x[i+1]-x[i]+t[st][i][1];
							ret=solve(st,i,1)+totlost+sum*tt;
							tt+=tottime;
							cc=come[st][i][1];
					 }
					if ( solve(st,i,0)+totlost+sum*(x[i+1]-x[st]+t[st][i][0]) < ret )
					 {
							tt=x[i+1]-x[st]+t[st][i][0];
							ret=solve(st,i,0)+totlost+sum*tt;
							tt+=tottime;
							cc=come[st][i][0];
					 }
					if (oret==ret) break;
					tottime+=x[i+1]-x[i];
					totlost+=sum*(x[i+1]-x[i]);
			 }
	 }

//   cout<<"        ====     "<<st<<" "<<en<<" "<<pos<<" = "<<ret<<" ; "<<tt<<" "<<cc<<endl;
   return ret;
}

int brute()
{
	VI a(n);
	Repi(n) a[i]=i;
	int ans=INF;
	do
	{
		int tmp=0,time=0,in=a[0];
		for (int i=1;i<a.SZ;i++)
		 {
				time+=abs(x[a[i]]-x[in]);
				tmp+=v[a[i]]*time;
				in=a[i];
	 	 }
	 	ans<?=tmp;
	} while (next_permutation(ALL(a)));
	return ans;
}

int main()
{
    int i,j,k,l;
    scanf("%d",&n);
    memset(d,255,sizeof(d));
    Repi(n)
     {
       scanf("%d%d",x+i,v+i);
       t[i][i][0]=t[i][i][1]=0;
       d[i][i][0]=d[i][i][1]=0;
       come[i][i][0]=come[i][i][1]=i;
	 }
	
	int st=0,en=n-1,pos=0;
	if (solve(st,en,0)>solve(st,en,1)) pos=1;
	cout<<solve(st,en,pos)<<endl;
	
/*
	while (cc>-1)
	 {
			cc=come[st][en][pos];
//			cout<<st<<" "<<en<<" "<<pos<<" - "<<cc<<endl;
//			if (!pos) cout<<st+1<<"\n"; else cout<<en+1<<"\n";
            if (!pos) ans=st+1; else ans=en+1;
			if (cc==0) st++;
			if (cc==1) { st++; pos=1; }
			if (cc==2) { en--; pos=0; }
			if (cc==3) en--;
	 }
	cout<<ans<<endl;
*/
    cout<<come[st][en][pos]+1<<endl;
//    cout<<brute()<<endl;
    
    return 0;
}
