#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;

inline int comb(int N,int K)
{
    if (N-K>K) K=N-K; int ret=1;
    for (int i=K+1,j=1;i<=N;i++,j++)
     ret=ret*i/j;
    return ret;
}



int binom[50][50];

void calcbinom()
{
    binom[0][0]=1;
    for (int i=1;i<50;i++)
     Repj(i+1)
      binom[i][j]=binom[i-1][j]+(j>0)*binom[i-1][j-1];
}

inline int encode(int p[])
{
    sort(p,p+6);
    int res=0;
    Repi(6)
     {
       int tmp=0;
       for (int j=(i)?(p[i-1]+1):1;j<p[i];j++)
         tmp+=binom[49-j][6-i-1];
       res+=tmp;
     }
    return res+1;
}

inline void decode(int code,int p[])
{
    Repi(6)
       for (int j=(i)?p[i-1]+1:1,tmp=0;j<50;j++)
        {
          tmp+=binom[49-j][6-i-1];
          if (tmp>=code) { tmp-=binom[49-j][6-i-1]; p[i]=j; code-=tmp; break; }
        }
}


int main()
{
    calcbinom();
    int p[7],p1[7],code;
    while (1)
     {
        cout<<" enter toto 6/49 combination:    ";
        Repi(6) cin>>p[i];
        code=encode(p);
        cout<<" code =                                           "<<code<<endl;
        cout<<" decoded:                        ";
        decode(code,p1);
        Repi(6) cout<<p1[i]<<" "; cout<<"\n\n";
     }
    return 0;
}
