// bfs
//note: test renaming in-file to chess.in
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#include "module.h"

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int N;
char wkz[4],wcz[4],bkz[4];
PI dir[8];
PI wk,wc,bk,ww,cc,bb;
PI cm[64];

inline int encode(bool turn,PI wk,PI wc,PI bk)
{
    int pos=turn; 
    pos<<=3; pos|=wk.x; pos<<=3; pos|=wk.y;
    pos<<=3; pos|=wc.x; pos<<=3; pos|=wc.y; 
    pos<<=3; pos|=bk.x; pos<<=3; pos|=bk.y;
    return pos;
}

inline void decode(int pos,bool &turn,PI &wk,PI &wc,PI &bk)
{
    bk.y=pos&7; pos>>=3; bk.x=pos&7; pos>>=3;
    wc.y=pos&7; pos>>=3; wc.x=pos&7; pos>>=3;
    wk.y=pos&7; pos>>=3; wk.x=pos&7; pos>>=3;
    turn=pos;
}

const int MAXPOS=1<<19;
int go[MAXPOS];
bool used[MAXPOS],win[MAXPOS];
int out[MAXPOS],startpos,curpos;

void printpos(int pos)
{PI wk,wc,bk; bool turn; decode(pos,turn,wk,wc,bk);
 cout<<turn<<" "<<wk.x<<","<<wk.y<<" "<<wc.x<<","<<wc.y<<" "<<bk.x<<","<<bk.y;   }
void coolprintpos(int pos)
{
  PI wk,wc,bk; bool turn; decode(pos,turn,wk,wc,bk);
  Repi(8)
   {
      cout<<"                            ";
      Repj(8)
       if (MP(j,7-i)==wk)
        cout<<"W";
       else if (MP(j,7-i)==bk)
        cout<<"B";
       else if (MP(j,7-i)==wc)
        cout<<"C";
       else cout<<".";
      cout<<endl;
   }
  if (turn) cout<<"                                        It's HIS turn\n";
  else cout<<"                                        It's YOUR turn\n";
}

inline int getparpos(bool turn,PI wk,PI wc,PI bk,int p[])
{
    PI nk,nc; int br=0;
    if (turn) //bilo e na6 red 6tot sq e negov
     {
            Repi(8)
              {
                    nk.x=wk.x+dir[i].x,nk.y=wk.y+dir[i].y;
                    if (nk.x<0 || nk.y<0 || nk.x>7 || nk.y>7 || nk==wc || nk==bk) continue;
                    if (wc==wk) //ako polokovnika e vzet trq i predi tvoq hod da e bil zet
                     p[br++]=encode(0,nk,nk,bk);
                    else
                     p[br++]=encode(0,nk,wc,bk);
              }
            if (wc!=wk) //ako vmomenta ti e zet polokovnika nqma kak predi da ne e bil
             Repi(N)
              {
                    nc.x=wc.x-cm[i].x,nc.y=wc.y-cm[i].y;
                    if (nc.x<0 || nc.y<0 || nc.x>7 || nc.y>7 || nc==wk || nc==bk) continue;
                    p[br++]=encode(0,wk,nc,bk);
              }
     }
    else //bilo e negov red
     {
            Repi(8)
              {
                    nk.x=bk.x+dir[i].x,nk.y=bk.y+dir[i].y;
                    if (nk.x<0 || nk.y<0 || nk.x>7 || nk.y>7 || nk==wk || nk==wc) continue;
                    p[br++]=encode(1,wk,wc,nk);
                    if (wk==wc)  //vmomenta e zet polokivnika - na4i gore si e ostanal zet
                     p[br++]=encode(1,wk,bk,nk); //no moje i sega da sme go vzeli
              }
     }
    return br;
}



//bool cmp(const int &aa,const int &bb)
//{  return ABS(mvs[aa])<ABS(mvs[bb]);  }
/*
template<typename T>class cmp
{
    public:
        bool operator()(const T &aa, const T &bb) const
        {  return ABS(mvs[aa])<ABS(mvs[bb]); }
};
PQ<int,vector<int>,cmp<int> > q;
*/
int q[MAXPOS],en;

void getterminal()
{
    PI wk,wc,bk; bool turn;
    int pp[1024],pc; en=0;
    for (int pos=0;pos<(MAXPOS);pos++)
     {
            decode(pos,turn,wk,wc,bk);
            if (wk==bk || (turn && wc==bk))
             {
                    used[pos]=1;
                    win[pos]=0;
                    q[en++]=pos;
             }
            pc=getparpos(turn,wk,wc,bk,pp);
            Repi(pc) out[pp[i]]++;
     }
}

inline void addmove(int pos,int parpos)
{
    if (used[pos]) return;
    if (win[parpos]) //going to a winning position -> pos could be losing
     {
            out[pos]--;
            if (!out[pos])
             {
                    go[pos]=parpos; //we are sure this is the farthest winning position we can go to (lose as slowly as possible)
                    used[pos]=1;
                    win[pos]=0;
                    q[en++]=pos;
             }
     }
    else //going to a losing position -> pos is winning (and with a least number of moves because of PQ)
     {
           used[pos]=1;
           win[pos]=1;
           go[pos]=parpos; //we are sure that's the closest losing one we can go to
           q[en++]=pos;
     }
}

PI fromchar(char c,int x)
{    return MP(c-'a',x-1); }

int pp[1024],br;
int main()
{
    dir[0]=MP(0,1);
    dir[1]=MP(1,1);
    dir[2]=MP(1,0);
    dir[3]=MP(1,-1);
    dir[4]=MP(0,-1);
    dir[5]=MP(-1,-1);
    dir[6]=MP(-1,0);
    dir[7]=MP(-1,1);
    scanf("%s %s %s",wkz,wcz,bkz);
    scanf("%d",&N);
    Repi(N)
      scanf("%d%d",&cm[i].x,&cm[i].y);
    wk.x=wkz[0]-'a',wk.y=wkz[1]-'1';
    wc.x=wcz[0]-'a',wc.y=wcz[1]-'1';
    bk.x=bkz[0]-'a',bk.y=bkz[1]-'1';
    startpos=encode(0,wk,wc,bk);
    
    getterminal();
    
    bool turn,t1;
    int pc;
    for (int st=0;st<en;st++)
     {
            curpos=q[st];
            decode(curpos,turn,wk,wc,bk);
            //cout<<" IN "<<curpos<<": "<<turn<<" "<<wk.x<<","<<wk.y<<" "<<wc.x<<","<<wc.y<<" "<<bk.x<<","<<bk.y<<" with "<<mvs[curpos]<<" moves\n";
            pc=getparpos(turn,wk,wc,bk,pp);
            Repi(pc)
              addmove(pp[i],curpos); 
     }
    cout<<Time<<endl;
     
    int pos=startpos;
    char BKx; long BKy;
    int allmoves=0; PI k1,c1;
    while (1)
     {
            decode(pos,turn,wk,wc,bk);
            if (wk==bk) break;
            cout<<"                                  "; printpos(pos); cout<<" ; mvs  "<<allmoves<<"\n";
            coolprintpos(pos);
            if (turn)
             {
                    getKing(&BKx,&BKy);
                    bk=fromchar(BKx,BKy);
                   // decode(go[pos],turn,wk,wc,bk);
                    cout<<" his move: "<<bk.x<<" "<<bk.y<<endl;
                    pos=encode(0,wk,wc,bk);
                  //  pos=go[pos];
             }
            else
             {
                    allmoves++;
                    decode(go[pos],turn,k1,c1,bk);
                    if (k1!=wk)
                     {
                            cout<<" your move: king to "<<k1.x<<" "<<k1.y<<endl;
                            moveKing(k1.x+'a',k1.y+1);
                     }
                    else
                     {
                            cout<<" your move: colonel to "<<c1.x<<" "<<c1.y<<endl;
                            moveColonel(c1.x+'a',c1.y+1);
                     }
                    pos=go[pos];
             }
     }
    cout<<"       TOTAL "<<allmoves<<" moves\n";
     
    return 0;
}
