#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;

#define VI vector<int>
#define PB push_back
#define PI pair<int,int>
#define PD pair<double,double>
#define x first
#define y second
#define Repi(n) 	for (int i=0;i<n;i++)
#define Repj(n) 	for (int j=0;j<n;j++)

#define MAXN 1510

int N;
PD p[MAXN];
double d[MAXN],W;
bool u[MAXN][MAXN];
double d1[MAXN][MAXN];

//tva moje i lineino da stane...
double solve(int st,int en)
{
	if (u[st][en]) return d1[st][en];
	u[st][en]=1;
	double &m=d1[st][en];
	if (d1[st][en-1]>1000.+1e-7 || d1[st+1][en]>1000.+1e-7) return m=1001;
	double l=0,r=1001,w;
	Repi(40)
	 {
			m=(l+r)*.5;
			w=0;
			bool yes=1;
			for (int j=st;j<=en;j++)
			{
			  if (p[j].x<=m) w+=p[j].y;
			  else if (p[j].y<=m) w+=p[j].x; else {yes=0; break;}
			  if (w>W+1e-7) {yes=0; break;}
			}
	//		cout<<p[st].x<<" "<<p[st].y<<"   -   "<<l<<" "<<r<<": "<<m<<" - "<<w<<" "<<yes<<endl;
			if (yes) r=m; else l=m;
	 }
//	cout<<st<<" "<<en<<" = "<<m<<endl;
	return m;
}

int main()
{
	scanf("%d%lf",&N,&W);
	Repi(N)
	 {
	  scanf("%lf%lf",&p[i].x,&p[i].y);
	  if (p[i].x<p[i].y) swap(p[i].x,p[i].y);
	 }
	 
	
	d[0]=0; double tmp;
	for (int i=1;i<=N;i++)
	 {
	  d[i]=1e100;
	  for (int j=i-1;j>=0;j--)
	   if ((tmp=solve(j,i-1))<=1000.+1e-7)
	    d[i]=min(d[i],d[j]+tmp);
	   else break;
//	  cout<<i<<" ------- "<<d[i]<<endl;
	 }
	
	printf("%.6lf\n",d[N]); 
	
	return 0;
}
