//bsearch + mestene i se4ene na stranite; iska se absolute to4nost!!! nikvi EPS pri isin() ili pri cp() !!!!
//test case 10 e gre6en (swetko's e vqrno i izkarva kato moeto)
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N;
vector<PD> a,b;

inline double cp(PD A,PD B,PD C)
{
	double dx1=B.x-A.x;
	double dy1=B.y-A.y;
	double dx2=C.x-A.x;
	double dy2=C.y-A.y;
	return dx1*dy2-dx2*dy1;
}


inline PD intersect(PD A,PD B,PD C,PD D)
{
	double num=cp(A,D,C),den=cp(A,D,B)+cp(A,B,C);
	if (fabs(den)<1e-7) return MP(1e100,1e100);
	return MP( A.x+(B.x-A.x)*num/den , A.y+(B.y-A.y)*num/den );
}

inline bool isin(PD A,PD B,PD X)
{
	return X.x>=min(A.x,B.x) && X.x<=max(A.x,B.x)
	    && X.y>=min(A.y,B.y) && X.y<=max(A.y,B.y);
}


bool cut(PD A,PD B)
{
	PD sX=MP(1e100,1e100),eX=MP(1e100,1e100),X;
	vector<PD> nb;
	Repi(b.SZ)
	 {
	   if (cp(A,B,b[i])<=0) nb.PB(b[i]);
	   int j=(i+1)%b.SZ;
	   X=intersect(b[i],b[j],A,B);
	   if (isin(b[i],b[j],X))
	    nb.PB(X);
	 }
	if (!nb.SZ) return 0;

	b=nb;
	return 1;
}

bool calc(double dist1)
{
	b=a;
	Repi(N)
	 {
			PD A=a[i],B=a[(i+1)%N];
			PD vec=MP(B.y-A.y,B.x-A.x);
//			double cotg=(double)vec.x/vec.y,tg=(double)vec.y/vec.x;
            double xx=sqr(vec.x),yy=sqr(vec.y);
            double den=xx+yy;
			vec.x=sqrt(dist1*xx/den);
			vec.y=sqrt(dist1*yy/den);
			vec.x*=sign(B.y-A.y);
			vec.y*=sign(A.x-B.x);
			A.x+=vec.x; B.x+=vec.x; A.y+=vec.y; B.y+=vec.y;
			if (!cut(A,B)) return 0;
	 }
	return 1;
}

int main()
{
    int i,j,k;
    
    scanf("%d",&N); a.resize(N);
    Repi(N)
     scanf("%lf%lf",&a[i].x,&a[i].y);
    
    double l=0.,r=1e3,m;
    while (r-l>1e-6)
     {
			m=(l+r)*.5;
			if (calc(sqr(m))) l=m; else r=m;
	 }
	 
    cout<<setprecision(5)<<fixed<<m<<"\n";
    
    return 0;
}
