/*
ID: pascala1
PROG: 
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m;
char s[4][5][5]; //digit, row, col

int coord[7][2]={
	{0,1},
	{1,0},
	{1,2},
	{2,1},
	{3,0},
	{3,2},
	{4,1}
	};

void getdig(char s[][5],int &ok,int &on)
{
	ok=0; on=0;
	Repi(7)
	 {
			char c=s[coord[i][0]][coord[i][1]];
			if (c=='#' || c=='=') on|=1<<i;
			if (c=='|' || c=='-') ok|=1<<i;
	 }
	ok|=on;
}

int dig[11]={ //!!!!!! check!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	1+2+4+16+32+64,
	4+32,
	1+4+8+16+64,
	1+4+8+32+64,
	2+4+8+32,
	1+2+8+32+64,
	1+2+8+16+32+64,
	1+4+32,
	127,
	127-16,
	0
	};

int h[1440];
int hour(int n)
{
	VI ret(4);
	int h=n/60,m=n%60;
	ret[0]=(h/10)?(h/10):10;
	ret[1]=h%10;
	ret[2]=m/10;
	ret[3]=m%10;
	return (dig[ret[0]]<<21)+(dig[ret[1]]<<14)+(dig[ret[2]]<<7)+dig[ret[3]];
}

int main()
{
    int i,j,k,l;
    Repi(5)
     Repj(4)
      scanf("%s",s[j][i]);
    /*
    Repi(4)
    {
     Repj(5)
      cout<<s[i][j]<<endl;
      cout<<endl;
	}*/
	
	int cur=0,ok=0;
	Repi(4)
	 {
			getdig(s[i],j,k);
			ok<<=7; ok|=j;
			cur<<=7; cur|=k;
	 }
	 
	VI tmp;
	map<int,VI> M;
	set<VI> S,S1;
	set<VI>::IT it;
	map<int,VI>::IT i1;
	
	Repi(1440) h[i]=hour(i);
    
    Repi(1440)
     if ((h[i]&ok)==cur)
      tmp.PB(i);
    S.insert(tmp);
    
    int ans=-10;
    Repi(1445)
     {
			S1.clear();
			for (it=S.begin(); it!=S.end(); it++)
			 {
				if (it->SZ==1) continue;
			    M.clear();
			    Repj(it->SZ)
			     {
						int H=h[(i+(*it)[j])%1440];
					//	cout<<(*it)[j]<<" "<<H<<" - "<<bitset<28>(H&ok)<<endl;
						M[H&ok].PB((*it)[j]);
				 }
				for (i1=M.begin(); i1!=M.end(); i1++)
				 S1.insert(i1->y);
			 }
			S=S1;
			if (!S.SZ) { ans=i-1; break; }
			/*
			for (it=S.begin(); it!=S.end(); it++)
			 {
					cout<<" -> ";
					Repj(it->SZ)
					 cout<<(*it)[j]<<" ";
					cout<<endl;
			 }
			cout<<endl;*/
	 }
	if (ans==-1) ans=0;
	if (ans==-10) ans=-1;
	cout<<ans<<endl;
    
    return 0;
}
