#include <cstdio>
#include <utility>
#include <algorithm>
using namespace std;

#define f(i, n)						for(int i = 0; i < n; i ++)
#define min(a, b)					((a) < (b) ? (a) : (b))
#define number						first
#define position					second
#define left						first
#define right						second
#define INF							(1 << 25)
#define MAX_N						(1 << 20)

typedef pair<int, int> PII;

int N;
PII a[MAX_N];
PII pos[MAX_N];
PII dp[MAX_N];
int ans;

void Read()
{
int k;
	
	scanf("%d", &N);
	
	f(i, N)
	{
		scanf("%d", &k);
		
		a[i] = PII(k, i);
	}
}

void Solve()
{
int n, k;
	
	sort(a, a + N);
	
	n = 0;
	k = a[0].number;
	pos[n].left = a[0].position;
	
	f(i, N)
	{
		if(k != a[i].number)
		{
			pos[n ++].right = a[i - 1].position;
			
			pos[n].left = a[i].position;
			
			k = a[i].number;
		}
	}
	
	pos[n ++].right = a[N - 1].position;
	
	dp[0].left = dp[0].right = 0;
	
	f(i, n - 1)
	{
		dp[i + 1] = PII(INF, INF);
		
		if(pos[i + 1].left < pos[i].left && pos[i].left < pos[i + 1].right)
		{
			dp[i + 1].left = min(dp[i + 1].left, dp[i].left + 2);
			dp[i + 1].right = min(dp[i + 1].right, dp[i].left + 1);
		}
		
		if(pos[i + 1].left < pos[i].right && pos[i].right < pos[i + 1].right)
		{
			dp[i + 1].left = min(dp[i + 1].left, dp[i].right + 1);
			dp[i + 1].right = min(dp[i + 1].right, dp[i].right + 2);
		}
		
		if(pos[i + 1].right < pos[i].left)
		{
			dp[i + 1].left = min(dp[i + 1].left, dp[i].left);
			dp[i + 1].right = min(dp[i + 1].right, dp[i].left + 1);
		}
		
		if(pos[i + 1].right < pos[i].right)
		{
			dp[i + 1].left = min(dp[i + 1].left, dp[i].right + 1);
			dp[i + 1].right = min(dp[i + 1].right, dp[i].right + 2);
		}
		
		if(pos[i].left < pos[i + 1].left)
		{
			dp[i + 1].left = min(dp[i + 1].left, dp[i].left + 2);
			dp[i + 1].right = min(dp[i + 1].right, dp[i].left + 1);
		}
		
		if(pos[i].right < pos[i + 1].left)
		{
			dp[i + 1].left = min(dp[i + 1].left, dp[i].right + 1);
			dp[i + 1].right = min(dp[i + 1].right, dp[i].right);
		}
	}
	
	ans = min(dp[n - 1].left, dp[n - 1].right);
}

void Write()
{
	printf("%d\n", ans);
	printf("%.5lf\n", (double)clock()/CLOCKS_PER_SEC);
	
//	system("pause");
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	
	return 0;
}
