#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int N,m;

LL d[666][2000],trivial[4]={2,3,0,1};

inline int prevstage0(int stage)
{ return (stage-1)/4*4+(stage-1)%2*2; }

LL znak[]={-1,1};

LL solve1(int N,int stage,LL pos)
{
	if (N==2) return trivial[stage];
	if (!stage) return 1LL<<N-1;
	bool right=!((stage-1)/2%2);
	int pr=prevstage0(stage);
	if (d[N-1][pr]<pos) { pos-=d[N-1][pr]; pr++; }
	LL ret=(1LL<<N-1)+znak[right]*solve1(N-1,pr,pos);
	return ret;
}

LL solve(LL pos)
{
	int stage; LL tot,newpos=0;
	for (stage=0,tot=0;tot<pos;stage++)
	 tot+=d[N][stage];
	stage--; tot-=d[N][stage];
	return solve1(N,stage,pos-tot);
}



int main()
{
    int Q;
    cin>>N>>Q;
     
    d[2][0]=d[2][1]=d[2][3]=1;
    for (int i=3;i<=N;i++)
     {
	   d[i][0]=1;
       for (int j=1;j<=i*2;j++)
        {
		 int index=prevstage0(j);
         d[i][j]=d[i-1][index]+d[i-1][index+1];
		}
	 }
    
    /*
    for (int i=2;i<=N;i++)  
	{  
     for (int j=0;j<=i*2;j++)
      cout<<setw(2)<<d[i][j];
     cout<<endl;
	}
	for (int i=1;i<1<<N;i++)
	 cout<<solve(i)<<endl;
	*/ 
	 
	Repi(Q) 
	 {
		LL k;
		cin>>k;
		
		cout<<solve(k)<<endl;
	 }
	 
	
//    system("pause");
    return 0;
}
