/*
ID: pascala1
PROG: 
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define Repl(n) for (int l=0; l<n; l++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int N,M,P;
PI key[15],A,B,X;
bool s[16][16],os[16][16];
VI kk[16][16];
int swi[16][16],sc=0; //switches
PI swp[12]; //switches pos
#define MAXQ 4000000
int q[MAXQ],start,lev[MAXQ],end;
int adj[10][10][10][10][1<<10];
bitset<67108865> u,win;

inline int code(int x1,int y1,int x2,int y2,int mask)
{
	return x1+(y1<<4)+(x2<<8)+(y2<<12)+(mask<<16);
}

inline void decode(int state,int &x1,int &y1,int &x2,int &y2,int &mask)
{
	x1=state&15; state>>=4;
	y1=state&15; state>>=4;
	x2=state&15; state>>=4;
	y2=state&15; state>>=4;
	mask=state&1023; state>>=10;
}

int mv[4][2]={{1,0},{0,1},{-1,0},{0,-1}};

inline void qadd(bool wind,int x1,int y1,int x2,int y2,int mask)
{
	int tt=code(x1,y1,x2,y2,mask);


/*
	int dest=q[start],dx1,dy1,dx2,dy2,dmask; decode(dest,dx1,dy1,dx2,dy2,dmask);
	if (
	 //    (  MP(x1,y1)==MP(2,0) && MP(x2,y2)==MP(4,2) ) ||
//	     (  MP(x1,y1)==MP(4,2) && MP(x2,y2)==MP(1,0) && mask   ) ||
//       (  MP(dx1,dy1)==MP(2,0) && MP(dx2,dy2)==MP(4,2) && dmask   ) ||
       (  MP(dx2,dy2)==MP(3,5)  && dmask==2 )
	   )
	 {
	  cout<<"  from  "<<x1<<" "<<y1<<" , "<<x2<<" "<<y2<<" , "<<bitset<2>(mask)<<" - "<<win[tt]<<" ("<<adj[x1][y1][x2][y2][mask]<<") ";
	  cout<<"    to   "<<dx1<<" "<<dy1<<" , "<<dx2<<" "<<dy2<<" , "<<bitset<2>(dmask)<<" - "<<win[dest]<<"    lev "<<lev[start]<<endl;
	 }
*/

	if (!wind) { win[tt]=1; adj[x1][y1][x2][y2][mask]=1; }
//	cout<<adj[3][0][2][0][0]<<" ";
	if (--adj[x1][y1][x2][y2][mask]) return;
	
    if (u[tt]) return;
	u[tt]=1;
	q[end]=tt;
  //  prev[tt]=q[start];


  //  lev[end]=lev[start]+1;
    end++; if (end==MAXQ) { end=0; cout<<"overflow queue\n"; }
}

void path(int x1,int y1,int x2,int y2,int mask)
{
	int tt=code(x1,y1,x2,y2,mask);
	cout<<"path: ";
	while (tt!=-1)
	 { 
	   decode(tt,x1,y1,x2,y2,mask);
	   cout<<x1<<""<<y1<<","<<x2<<""<<y2<<","<<mask<<"("<<win[tt]<<") -> "; 
//	   tt=prev[tt];
	 }
	cout<<endl;
}

int main()
{
    int i,j,k,l;
	cin>>N>>M;
	Repi(N) Repj(M) {  cin>>s[i][j]; os[i][j]=s[i][j]; }
	cin>>P;
	memset(swi,255,sizeof(swi)); int tx,ty;
	Repi(P)
	 {
	  cin>>key[i].x>>key[i].y>>tx>>ty;
	  key[i].x--; key[i].y--; tx--; ty--;
	  if (swi[tx][ty]==-1) { swp[sc]=MP(tx,ty); swi[tx][ty]=sc++; }
	  kk[key[i].x][key[i].y].PB(swi[tx][ty]);
	 }
	cin>>A.x>>A.y>>B.x>>B.y>>X.x>>X.y;
	A.x--; A.y--; B.x--; B.y--; X.x--; X.y--;
	start=0,end=0; int tt;
	for (int mask=0;mask<1<<sc;mask++)
	 {
			Repi(sc) if ((1<<i)&mask) s[swp[i].x][swp[i].y]^=1;
			Repi(N)
			 Repj(M)
			  if (!s[i][j])
			   Repk(N)
			    Repl(M)
			     if (!s[k][l])
			      {
						tt=code(i,j,k,l,mask);
						if (i==X.x && j==X.y) { u[tt]=1; continue; } //careful ako 1viq ot na4aloto e na X
						if (k==X.x && l==X.y) { u[tt]=1; win[tt]=0; q[end++]=tt; u[tt]=1; continue; }
						for (int ii=0;ii<4;ii++)
						 {
								tx=i+mv[ii][0],ty=j+mv[ii][1];
								if (tx<0 || ty<0 || tx>=N || ty>=M || s[tx][ty]) continue;
								adj[i][j][k][l][mask]++;
						 }
						adj[i][j][k][l][mask]++;
						for (int ii=0;ii<kk[i][j].SZ;ii++)
						 if ( (MP(i,j)!=swp[kk[i][j][ii]] && MP(k,l)!=swp[kk[i][j][ii]]) )
						   adj[i][j][k][l][mask]++;
				  }
		    memcpy(s,os,sizeof(s));
     }
     
    int state,x1,y1,x2,y2,mask,winstate;
    for (start=0;start!=end;start++)
     {
			if (start==MAXQ) start=1;
			state=q[start];
			decode(state,x1,y1,x2,y2,mask);
			Repi(sc) if ((1<<i)&mask) s[swp[i].x][swp[i].y]^=1; //tva moi se pita direktno kato stupva6 ma pa4a!
			
		//	if (MP(x1,y1)==MP(1,0) && MP(x2,y2)==MP(4,2))
		//	cout<<"in "<<x1<<" "<<y1<<" , "<<x2<<" "<<y2<<" , "<<bitset<2>(mask)<<" - "<<win[state]<<endl;
			winstate=win[state];
			
			qadd(winstate,x2,y2,x1,y1,mask);
			Repi(4)
			 {
					tx=x2+mv[i][0],ty=y2+mv[i][1];
					if (tx>=0 && ty>=0 && tx<N && ty<M && !s[tx][ty])
					 qadd(winstate,tx,ty,x1,y1,mask);
			 }
			Repi(kk[x2][y2].SZ)
			 {
					tx=swp[kk[x2][y2][i]].x; ty=swp[kk[x2][y2][i]].y;
					if ((tx!=x1 || ty!=y1) && (tx!=x2 || ty!=y2))
					 qadd(winstate,x2,y2,x1,y1,mask^(1<<kk[x2][y2][i]));
			 }
			
			memcpy(s,os,sizeof(s));
	 }

	int state0=code(A.x,A.y,B.x,B.y,0);
//	path(4,2,1,0,1);
    if (u[state0]) cout<<!win[state0]+1<<endl;
    else cout<<"0\n";
    
    return 0;
}
