//bellman ford
#include <cstdio>
#include <numeric>

#define f(i, n) for(int i = 0; i < n; i ++)

#define MAX_N (15)


struct person
{
	int hight;
	int weight;
};


int N, T;
person a[MAX_N];
int price[1 << MAX_N];
int dp[1 << MAX_N];
int ans;


void Read()
{
	scanf("%d %d", &N, &T);
	
	f(i, N) scanf("%d %d", &a[i].hight, &a[i].weight);
}

void Find_Price()
{
register int _cost, _weight;
	
	
	memset(price, -1, sizeof(price));
	
	f(i, 1 << N)
	{
		_cost = 0;
		_weight = 0;
		
		f(j, N) if(i & (1 << j))
		{
			if(_cost < a[j].hight) _cost = a[j].hight;
			
			_weight += a[j].weight;
		}
		
		if(_weight <= T) price[i] = _cost;
	}
}

void Solve()
{
register int all = (1 << N) - 1;
register int mask, s, left, right;
bool done = false;
	
	
	Find_Price();
	
	
	ans = INT_MAX;
	
	f(i, 1 << N) dp[i] = INT_MAX;
	
	dp[all] = 0;
	
	while(done == false)
	{
		done = true;
		
		for(mask = all; mask > 0; mask --) if(dp[mask] != INT_MAX)
		{
			left = mask;
			
			if((price[left] != -1) && (dp[left] + price[left] < ans))
			{
				ans = dp[left] + price[left];
			}
			
			//	GO RIGHT
			for(s = (left - 1) & left; s > 0; s = (s - 1) & left) if(price[s] != -1)
			{
				right = (~left & all) | s;
				
				//	GO LEFT
				f(i, N) if((right & (1 << i)) && (price[1 << i] != -1))
				{
					//	CHECK
					if(dp[left] + price[s] + price[1 << i] < dp[left ^ s | (1 << i)])
					{
						done = false;
						
						dp[left ^ s | (1 << i)] = dp[left] + price[s] + price[1 << i];
					}
				}
			}
		}
	}
	
	if(ans == INT_MAX) ans = 0;
}

void Write()
{
	printf("%d\n", ans);
	
//	system("pause");
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	
	return 0;
}
