/*
TASK:bw
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>
#include <iomanip>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <functional>
#include <utility>
#include <numeric>
#include <sstream>
#include <string>

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define SZ size()
#define MP make_pair
#define PB push_back
#define x first
#define y second
#define IT iterator
#define VI vector<int>
#define PD pair<double,double>
#define sign(a) (((a)>0)-((a)<0))

using namespace std;

int N,M;
PD w[128],b[128];

inline double cp(PD &A,PD &B,PD &C)
{
       double dx1=B.x-A.x;
       double dy1=B.y-A.y;
       double dx2=C.x-A.x;
       double dy2=C.y-A.y;
       return dx1*dy2-dx2*dy1;
}

int check(PD &A,PD &Z) //0 - ok, -1 - pove4e sa s + , 1 - pove4e
{
    bool pres=0;
    int wh=0,bl=0,xx;
    Repi(N)
    {
     xx=sign(cp(A,Z,w[i]));
     if (!xx) pres=1; else wh+=xx;
    }
    Repi(M)
    {
     xx=sign(cp(A,Z,b[i]));
     if (!xx) pres=1; else bl+=xx;
    }
   // cout<<A.x<<" "<<A.y<<" - "<<Z.x<<" "<<Z.y<<"   =   "<<wh<<" "<<bl<<"    "<<pres<<endl; 
    if (bl==wh && bl==0)
     return pres*(-2);
    if (sign(wh)!=sign(bl)) return -2;
    return sign(wh);
}

PD P,v;

bool solve()
{
    PD X,Y,b0,b1; int res,xaxax;
    double Tmaax=10000;
    double Tmax=min((int)Tmaax,10000000/(M*N*(N+M))),m,dbx,dby,dwx,dwy;
    for (int W=1;W<N;W++)
     for (int B=1;B<M;B++)
     {
      xaxax=check(w[0],b[0]);
      if (xaxax==check(w[0],b[B]) && xaxax==check(w[W],b[0]) && xaxax==check(w[W],b[B])) continue;
      b0=b[0],b1=b[B];
      dwx=w[W].x-w[0].x,dwy=w[W].y-w[0].y;
      Tmax=max(fabs(w[W].x-w[0].x),fabs(w[W].y-w[0].y))*101;
      for (double T=0;T<=Tmax;T++)   //trivial check if even necessary to do loop
       {
               X.x=dwx*T/Tmax+w[0].x; X.y=dwy*T/Tmax+w[0].y;
               if (cp(X,b0,b1)<=0) swap(b0,b1);
               dbx=b1.x-b0.x; dby=b1.y-b0.y;
               double l=0,r=1;
               while (r-l>1e-6)
                {
                     m=(l+r)*.5;
                     Y=MP(dbx*m+b0.x,dby*m+b0.y);
                    // cout<<l<<" "<<r<<endl;
                     res=check(X,Y);
                     if (res==-2) break;
                     if (res==1) l=m; else if (res==-1) r=m;
                     else
                      { //cout<<"found it! "<<W<<" "<<B<<"  ; "<<T/Tmax<<" "<<m<<endl; 
                        P=X; v=MP(Y.x-X.x,Y.y-X.y);
                        if (fabs(v.x)>1-1e-6 || fabs(v.y)>1-1e-6)
                         {
                            double wow=fabs(v.x)>fabs(v.y)?v.x:v.y;
                            v.x/=wow,v.y/=wow;
                         }
                        return 1; }
                }
       }
     }
     return 0;
}

int main()
{
    int i,j,k;
    cin>>N;
    Repi(N)
     cin>>w[i].x>>w[i].y;
    cin>>M;
    Repi(M)
     cin>>b[i].x>>b[i].y;
    
    if (solve()) printf("%.5lf %.5lf %.5lf %.5lf\n",P.x,P.y,v.x,v.y);
    else printf("0 0 0 0\n");
    
    return 0;
}
