// LCA s RMQ - O(1) ; solution:  sortirane po red na obhojdane v dfs-to , namirane na LCA na vseki 2 susedni
#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <numeric>
#include <utility>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <string>

using namespace std;

#define Repi(n) for (int i=0;i<(n);i++)
#define Repj(n) for (int j=0;j<(n);j++)
#define Repk(n) for (int k=0;k<(n);k++)
#define sign(x) (((x)>0)-((x)<0))
#define PI pair<int,int>
#define PD pair<double,double>
#define MP make_pair
#define LL long long
#define ULL unsigned long long
#define UI unsigned int
#define x first
#define y second
#define ALL(v) (v).begin(),(v).end()
#define IT iterator
#define VI vector<int>
#define VD vector<double>
#define PB push_back
#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define pause system("pause")
#define PQ priority_queue
#define INF 2000000000
#define LINF 2000000000000000000LL
#define SZ size()
#define Time ((double)clock()/CLOCKS_PER_SEC)

#define MAXN 500100
int N,M,n,m,K;
int par[MAXN],cost[MAXN],used[MAXN];
VI chi[MAXN],chic[MAXN];
int ord[MAXN],at[MAXN],from[MAXN];
int dest[MAXN],rmq[19][3*MAXN];
int p[MAXN];

int br=0;
void dfs(int v)
{
	ord[v]=br; from[br++]=v;
	at[v]=n;
    rmq[0][n++]=ord[v];
	Repi(chi[v].SZ)
	 {
	  dfs(chi[v][i]);
	  rmq[0][n++]=ord[v];
	 }
}

int paths(int v)
{
	if (p[v]>-1) return p[v];
	if (v==1) return p[v]=0;
	return p[v]=cost[v]+paths(par[v]);
}

void initrmq()
{
	for (int i=1,step=1;step<=n;i++,step<<=1)
	 {
		    for (int j=0;j+step<n;j++)
					rmq[i][j]=MIN(rmq[i-1][j],rmq[i-1][j+step]);
     }
}

inline int qry(int st,int en)
{
	int pow=31-__builtin_clz(en-st+1),step=1<<pow;
	return MIN(rmq[pow][st],rmq[pow][en-step+1]);
}

inline int lca(int v1,int v2)
{
//	if (at[v1]>at[v2]) swap(v1,v2); - tva se opravq ot sort-a
	return from[qry(at[v1],at[v2])];
}

bool cmp(int a,int b)
{ return at[a]<at[b]; }

int L[64];
inline LL solve()
{
	sort(dest,dest+m,cmp);
    int A; LL ans=0;
    Repi(m)
     {
			A=(i==0)?1:L[i-1];
			if (i<m-1) 
			 {
					L[i]=lca(dest[i],dest[i+1]);
					if (at[A]<at[L[i]]) A=L[i];
			 }
//			cout<<dest[i]<<" - "<<A<<" ("<<L[i]<<")"<<"      ";
//			cout<<dest[i]<<" - "<<p[dest[i]]<<" "<<A<<" "<<p[A]<<endl;
		    ans+=p[dest[i]]-(p[A]>>1);
	 }
	return ans;
	//cout<<endl;
}

int main()
{
	int j,k,l;
    scanf("%d%d%d",&N,&M,&K);
    Repi(M)
       {
			scanf("%d%d%d",&j,&k,&l);
			par[k]=j;
			cost[k]=l;
			chi[j].PB(k);
			chic[j].PB(l);
		}
	
	dfs(1);	
	initrmq();
	memset(p,-1,sizeof(p));
	Repi(N) paths(i+1);
	
//	Repi(N) cout<<p[i+1]<<" "; cout<<endl;
	
/*	Repi(10)
	{
	 Repj(n)
	  cout<<setw(3)<<rmq[i][j];
	 cout<<endl;
	} */
	
	Repi(K)
	 {
			scanf("%d",&m);
			Repj(m)
			 scanf("%d",dest+j);
			printf("%I64d\n",solve());
	 }
	
	cout<<Time<<endl;
    return 0;
}
