#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <numeric>
#include <utility>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <string>

using namespace std;

#define Repi(n) for (int i=0;i<(n);i++)
#define Repj(n) for (int j=0;j<(n);j++)
#define Repk(n) for (int k=0;k<(n);k++)
#define sign(x) (((x)>0)-((x)<0))
#define PI pair<int,int>
#define PD pair<double,double>
#define MP make_pair
#define LL long long
#define ULL unsigned long long
#define x first
#define y second
#define ALL(v) (v).begin(),(v).end()
#define IT iterator
#define VI vector<int>
#define VD vector<double>
#define PB push_back
#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define pause system("pause")
#define PQ priority_queue
#define INF 2000000000
#define SZ size()

#define MAXN 100100
int N,M,n,m,K,a[MAXN];

int tmp[MAXN];
inline int median(int M)
{
	int br=0;
	Repi(N)
	 if (a[i]!=M || br!=i)
	  tmp[br++]=ABS(a[i]-M);
	sort(tmp,tmp+br);
//	cout<<"                           "; Repj(br) cout<<tmp[j]<<" "; cout<<endl;
	return tmp[N/2-1];
}


int *L,*R,lc,rc,ldif,rdif,N2,*groupl0,*groupl1,*groupr0,*groupr1;

bool cmp(int a,int b)
{   
//	cout<<"compare "<<a<<" < "<<b<<" <=> "<<a+(a==curcheck)*rdif<<" > "<<b+rdif<<endl;
	return a+rdif>b+rdif; }

inline int countb4(int mm,int &after)
{
	after=lower_bound(R,R+rc,mm-rdif,cmp)-R;
    int upperbound= (after==rc) ? after : ( (mm<=R[after]+rdif)?groupr1[after]+1:after );
/*	if (upper_bound(R,R+rc,mm-rdif,cmp)-R!=upperbound)
	 {
		Repi(rc) cout<<R[i]+rdif<<" "; cout<<endl;
		Repi(rc) cout<<groupr1[i]<<" "; cout<<endl;
	    cout<<" adasdasdasda  "<<mm<<" "<<R[after]+rdif<<" - "<<upperbound<<" "<<upper_bound(R,R+rc,mm-rdif,cmp)-R<<endl;
	    cout<<endl;
     }*/
	return rc-upperbound; //(upper_bound(R,R+rc,mm-rdif,cmp)-R);;
}

inline int stava(int pogolemi,int mm)
{
	int after,before=countb4(mm,after)+(lc-groupl1[pogolemi]-1); after+=pogolemi;
    //cout<<"     ("<<mm<<") "<<pogolemi<<" "<<(lc-group1[pogolemi]-1)<<"   - "<<before<<" "<<after<<"\n";
    if (after<=N2 && before<=N2) return 0; //tva e medianata
    if (after>before) return 1; //medianata e vdqsno
    return -1; //vlqvo e
}

inline int coolmed()
{
        int l=0,r=lc-1,res,m;

/*        Repi(lc)
         {
		   cout<<"          "<<stava(group0[i],L[i]+ldif)<<endl;
	     }
	    cout<<endl;*/
	    while (l<r)
	     {
				m=(l+r)>>1;
				res=stava(groupl0[m],L[m]+ldif);
				if (!res) return L[m]+ldif;
				if (res>0) r=groupl0[m]-1;
				else l=groupl1[m]+1;
			//	cout<<"   b "<<L[m]+ldif<<" - "<<res<<"      "<<l<<" "<<r<<endl;
		 }
		if (!stava(groupl0[l],L[l]+ldif)) return L[l]+ldif;
		return -1;
}

inline int madafaka()
{
     //   cout<<" grl0 "; Repi(lc) cout<<groupl0[i]<<" "; cout<<endl;
     //   cout<<" grl1 "; Repi(lc) cout<<groupl1[i]<<" "; cout<<endl;
     //   cout<<" grr0 "; Repi(rc) cout<<groupr0[i]<<" "; cout<<endl;
     //   cout<<" grr1 "; Repi(rc) cout<<groupr1[i]<<" "; cout<<endl;

	int med=coolmed();
	if (med==-1)
	 {
			swap(lc,rc); swap(L,R); swap(ldif,rdif); swap(groupl1,groupr1);   swap(groupl0,groupr0); 
			med=coolmed();
			swap(lc,rc); swap(L,R); swap(ldif,rdif);  swap(groupl1,groupr1);  swap(groupl0,groupr0); 
	 }
	return med;
}

int solve()
{
	int M=a[0],Mmed=median(a[0]),yeha;
	reverse(tmp,tmp+N-1);
	memcpy(R,tmp,sizeof(int)*N);
	rc=N-1,lc=0;
	ldif=rdif=0;
	N2=N/2-1;
	
        groupr1[rc-1]=rc-1;
        for (int i=rc-2;i>=0;i--) if (R[i]==R[i+1]) groupr1[i]=groupr1[i+1]; else groupr1[i]=i;
        groupr0[0]=0;
        for (int i=1;i<rc;i++) if (R[i]==R[i-1]) groupr0[i]=groupr0[i-1]; else groupr0[i]=i;
        groupl0[0]=groupl1[0]=0;

	//cout<<M<<" -> "<<Mmed<<endl;
	int i; int last=-INF;
	for (int j=1;j<N;j++)
	 {
			rdif+=a[j-1]-a[j];
			rc--;
			for (i=rc-1;i>=0 && R[i]==R[rc];i--) groupr1[i]--;
			
			L[lc++]=-ldif;
			ldif+=a[j]-a[j-1];
			if (lc>1)
			 {
			   if (L[lc-1]==L[lc-2]) groupl0[lc-1]=groupl0[lc-2]; else groupl0[lc-1]=lc-1;
			   groupl1[lc-1]=lc-1;
			   for (i=lc-2;i>=0 && L[i]==L[i+1];i--) groupl1[i]++;
			 }
			
			if (a[j]==last) continue;
			last=a[j];
		//	cout<<a[j]<<" -> ("<<ldif<<") "; Repi(lc) cout<<L[i]+ldif<<" "; cout<<"  |  "; cout<<"("<<rdif<<") "; Repi(rc) cout<<R[i]+rdif<<" "; cout<<endl;
			//multiset<int> s; cout<<"     set - "; Repi(lc) s.insert(L[i]+ldif); Repi(rc) s.insert(R[i]+rdif); for (multiset<int>::IT it=s.begin(); it!=s.end(); it++) cout<<*it<<" "; cout<<endl;
			//cout<<lower_bound(L,L+lc,-14,greater<int>())-L<<" "<<upper_bound(L,L+lc,-14,greater<int>())-L<<endl;
		//	cout<<madafaka()<<endl<<endl;
			yeha=madafaka();
			//if (yeha!=median(a[j]))
			// cout<<"                        ERROR "<<j<<" "<<a[j]<<" -> "<<yeha<<" "<<median(a[j])<<endl;
			if (yeha<=Mmed) { Mmed=yeha; M=a[j]; }
			//if (j%1000==0)     cout<<j<<" "<<(double)clock()/CLOCKS_PER_SEC<<endl;
	 }
	return M;
}


int brute()
{
	int M=a[0],Mv=median(a[0]),tmp;
	Repi(N)
	 { tmp=median(a[i]);
	   if (tmp<=Mv)
	    { M=a[i]; Mv=tmp; }
	 }
	return M;
}

int main()
{
    scanf("%d",&N);
    Repi(N) scanf("%d",a+i);
    sort(a,a+N);
    
    groupl1=new int[N+3];
    groupl0=new int[N+3];
    groupr1=new int[N+3];
    groupr0=new int[N+3];
    L=new int[N+3]; R=new int[N+3];
    printf("%d\n",solve());
    
   // cout<<(double)clock()/CLOCKS_PER_SEC<<endl;
   // cout<<brute()<<endl;
    return 0;
}
