/*
TASK: groups
LANG: C++
*/
#include <cstdio>
#include <cstring>

#define LL long long

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

#define MAXN 1024

int N,K;
LL buf[2][MAXN*2];
LL *dp[2];

int bans;
int bruteforce(int pos,int left,int last)
{
     if (pos==K) return (left>=last);
     
     int ret=0;
     for (int i=last;i<=left;i++)
      {
        ret+=bruteforce(pos+1,left-i,i);
      //  printf(" %d %d %d += %d %d %d = %d\n",pos,left,last,pos+1,left-i,i,ret);
      }
     return ret;
}

int main()
{
    scanf("%d%d",&N,&K);
    
    bans=0;
  //  printf("%d\n",bruteforce(1,N,1));
    
    dp[0]=buf[0]+MAXN; dp[1]=buf[1]+MAXN;
    N-=K;
    
    memset(buf,0,sizeof(buf));
    dp[0][0]=1;
    int at=0;
    for (int k=1;k<=K;k++)
     {
           memset(buf[at^1],0,sizeof(buf[at^1]));
         //  printf(" ----- %d groups \n",k);
           for (int i=0;i<=N;i++)
            {
                    dp[at^1][i]=dp[at][i]+dp[at^1][i-k];
              //      printf("   %d = %d\n",i,dp[at^1][i]);
            }
           
           at^=1;
     }
    
    printf("%d\n",dp[at][N]);
    return 0;
}
