/*
TASK:strpath
LANG:C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define F(i,n) for (int i=0;i<n;i++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 128
int N,M;
VI adj[MAXN];
char label[MAXN];
char path[MAXN]; int plen;

int dp[MAXN][MAXN];
int solve(int at,int p)
{
    int &ret=dp[at][p];
    if (ret>-1) return ret;
    if (path[p]!=label[at]) return ret=0;
    if (p==plen-1) return ret=1;
    
    ret=0;
    Repi(adj[at].SZ)
     {
       ret+=solve(adj[at][i],p+1);
    //   cout<<"   from "<<at<<" "<<p<<" to "<<adj[at][i]<<" "<<p+1<<" ;;; ret = "<<ret<<"\n";
     }
    
   // cout<<" "<<at<<" "<<p<<" = "<<ret<<"\n";
    return ret;
}

int main()
{
    scanf("%d%d",&N,&M);
    scanf("%s",label+1);
    Repi(M)
     {
           int a,b;
           scanf("%d%d",&a,&b);
           adj[a].PB(b);
           if (a!=b)
            adj[b].PB(a);
     }
    scanf("%s",path); plen=strlen(path);
    
    int ans=0;
    memset(dp,-1,sizeof(dp));
    Repi(N)
     ans+=solve(i+1,0);
    
    printf("%d\n",ans);
    return 0;
}
