//same as lab101, noi2006:
//find terminal positions, then lose/win bfs backwards, counting outgoing edges to determine losing positions
//infinite cycles consist of unused positions only (for each state there will be at least one unused outgoing edge, and none of the others will be winning a.k.a. leading to losing states)
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

#define MAXN 1000100
int n,m,V[32],K[32],N,M;
int A[MAXN],B[MAXN],C[MAXN],D[MAXN];

inline int encode(int a[])
{
	int ret=0;
	Repi(N)
	 ret=ret*(V[i]+1)+a[i];
	return ret;
}

inline void decode(int pos,int a[])
{
	for (int i=N-1;i>=0;i--)
	 { a[i]=pos%(V[i]+1); pos/=V[i]+1; }
}

int q[MAXN],st,en,a[32],b[32],szoin;
bool used[MAXN],win[MAXN]; int go[MAXN];
VI come[MAXN],godeal[MAXN],gocomb[MAXN];

inline void add(int pos,bool winner)
{
	q[en++]=pos;
	used[pos]=1;
	win[pos]=winner;
//	cout<<"                                 adding "<<pos<<" "<<winner<<endl;
}

void getterminal(int at)
{
	if (at==N)
	 {
			int code=encode(a),code2;
			Repi(M)
			 if (a[A[i]]>=B[i] && a[C[i]]+D[i]<=V[C[i]])
			  {
			    memcpy(b,a,szoin);
			    b[A[i]]-=B[i]; b[C[i]]+=D[i];
			    code2=encode(b);
			    go[code]++;
				come[code2].PB(code);
				gocomb[code].PB(code2);
				godeal[code].PB(i);
			  }
			if (go[code]) return;
			q[en++]=code;
			win[code]=0; used[code]=1;
			return;
		}
    for (a[at]=0;a[at]<=V[at];a[at]++)
     getterminal(at+1);
}

int main()
{
    int i,j,k,l;
    scanf("%d",&N);
    Repi(N)
     scanf("%d%d",V+i,K+i);
    scanf("%d",&M);
    Repi(M)
     {
      scanf("%d%d%d%d",A+i,B+i,C+i,D+i);
      A[i]--; C[i]--;
	 }
     
    szoin=sizeof(int)*N;
    en=0;
    getterminal(0);
    
   /* Repi(en)
     {
			decode(q[i],a);
			cout<<q[i]<<" ("<<come[q[i]]<<") -> ";
			Repi(N) cout<<a[i]<<" "; cout<<endl;
		}*/
		
	int cur,to;
	for (st=0;st<en;st++)
	 {
			cur=q[st];
			decode(cur,a);
		//	cout<<"in "; Repi(N) cout<<a[i]<<" "; cout<<" ("<<win[cur]<<"):\n";
			Repi(come[cur].SZ)
			 {
					to=come[cur][i];
					decode(to,b);
				//	cout<<"   to "; Repj(N) cout<<b[j]<<" "; cout<<endl;
					if (used[to]) continue;
					if (!win[cur])
					 add(to,1);
					else 
					 {
							go[to]--;
							if (!go[to])
							 add(to,0);
					 }
			 }
	 }
    
    
    int deal;
    bool firstmove=1;
    while(1)
     {
       cur=encode(K);
       deal=-1;
       if (used[cur]) //imame pe4eliv6a/gube6ta poziciq
        {
			if (!win[cur])
			 if (firstmove)
			  printf("2\n");
			 else
			  {
					if (!gocomb[cur].SZ) deal=-1; //aide da ne se slu4va toq slu4ai izob6to...
					else deal=godeal[cur][0];
			  }
			else
			 {
					Repi(gocomb[cur].SZ)
					 if (!win[gocomb[cur][i]] && used[gocomb[cur][i]])
					  {
							deal=godeal[cur][i];
							break;
					  }
			 }
   	    }
 	   else //imame bezkraen cikal
	    {
			Repi(gocomb[cur].SZ)
			 if (!used[gocomb[cur][i]])
			  {
					deal=godeal[cur][i];
					break;
			  }
	    }
	   
	   if (deal>-1)
	    {
			if (firstmove) printf("1\n");
			printf("%d\n",deal+1);
			K[A[deal]]-=B[deal]; K[C[deal]]+=D[deal];
	    }
	   firstmove=0;
	  // cout<<"    "; Repi(N) cout<<K[i]<<" "; cout<<endl;
	   
	   scanf("%d",&deal);
	   if (!deal) break;
	   deal--;
	   K[A[deal]]-=B[deal]; K[C[deal]]+=D[deal];
	  // cout<<"    "; Repi(N) cout<<K[i]<<" "; cout<<endl;
	  // cout<<endl;
	 }
    
    return 0;
}
