//3 dijkstri i posle izbira6 to4ka na cepene na puti6tata
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

#define MAXN 4096
int n,m,N,A,B,C;
VI adj[MAXN],badj[MAXN],cost[MAXN],bcost[MAXN];
int d[MAXN],come[MAXN],comecost[MAXN],dC[MAXN],comeC[MAXN],comecostC[MAXN],dB[MAXN],comeB[MAXN],comecostB[MAXN];
bool used[MAXN];

void bdijkstra(int v,int d[],int come[],int comecost[])
{
    PQ<PI,vector<PI>,greater<PI> > q;
    memset(used,0,sizeof(used));
    q.push(MP(0,v)); PI t;
    memset(d,127,sizeof(int)*(N+1)); d[v]=0;
    while (!q.empty())
     {
			t=q.top();
			q.pop();
			if (used[t.y]) continue;
			used[t.y]=1;
			Repi(badj[t.y].SZ)
			 {
					v=badj[t.y][i];
				//	cout<<"from "<<t.y<<" to "<<v<<" - "<<used[v]<<" "<<d[v]<<" > "<<d[t.y]<<" + "<<bcost[t.y][i]<<endl;
					if (!used[v] && bcost[t.y][i]+d[t.y]<d[v])
					 {
							come[v]=t.y;
							comecost[v]=bcost[t.y][i];
							d[v]=bcost[t.y][i]+d[t.y];
							q.push(MP(d[v],v));
					 }
			 }
	 }
}

int main()
{
    int i,j,k,l;
    scanf("%d%d%d%d",&N,&A,&B,&C);
    Repi(N)
     {
			scanf("%d",&l);
			adj[i+1].resize(l); cost[i+1].resize(l);
			Repj(l)
			 {
					scanf("%d%d",&adj[i+1][j],&cost[i+1][j]);
					badj[adj[i+1][j]].PB(i+1); bcost[adj[i+1][j]].PB(cost[i+1][j]);
			 }
	 }
	 
/*	Repi(N+1)
	 {
			cout<<"::: "<<i<<" -> ";
			Repj(adj[i].SZ) cout<<adj[i][j]<<" "; cout<<endl;
	 }*/
	 
    PQ<PI,vector<PI>,greater<PI> > q;
    memset(used,0,sizeof(used));
    q.push(MP(0,A)); PI t;
    memset(d,127,sizeof(d)); d[A]=0;
    while (!q.empty())
     {
			t=q.top();
			q.pop();
			if (used[t.y]) continue;
			used[t.y]=1;
			Repj(adj[t.y].SZ)
			 {
					int v=adj[t.y][j];
					if (!used[v] && cost[t.y][j]+d[t.y]<d[v])
					 {
							come[v]=t.y;
							comecost[v]=cost[t.y][j];
							d[v]=cost[t.y][j]+d[t.y];
							q.push(MP(d[v],v));
					 }
			 }
	 }
	bdijkstra(B,dB,comeB,comecostB);
	bdijkstra(C,dC,comeC,comecostC);

//	Repi(N) cout<<dC[i+1]<<" "; cout<<endl;
//	Repi(N) cout<<comeC[i+1]<<" "; cout<<endl;
//	Repi(N) cout<<comecostC[i+1]<<" "; cout<<endl;
//	cout<<endl;
	 
    int best=INF,bmed=0;
    for (int med=1;med<=N;med++)
     {
			int tek=0;
			l=med;
			while (l!=A)
			 {
					tek+=comecost[l];
					l=come[l];
					if (!l) {tek=-1; break;}
			 }
			if (tek==-1) continue;
		//	cout<<med<<" - "<<tek<<endl;
			
			l=med;
			while (l!=B)
			 {
					tek+=comecostB[l];
					l=comeB[l];
					if (!l) {tek=-1; break;}
			 }
			if (tek==-1) continue;
		//	cout<<med<<" - "<<tek<<endl;
			
			l=med;
			while (l!=C)
			 {
					tek+=comecostC[l];
					l=comeC[l];
					if (!l) {tek=-1; break;}
			 }
			if (tek==-1) continue;
	//		cout<<med<<" - "<<tek<<endl;
	//		cout<<endl;
	        tek-=min(comecostB[med],comecostC[med]);
			
			if (tek<best)
			 {					best=tek; bmed=med; 				}
	 }
	 //cout<<best<<" "<<bmed<<endl;
	 
	vector<PI> ans;
	l=bmed;
	while (l!=A)
	 {
			ans.PB(MP(come[l],comecost[l]));
			l=come[l];
	 }
	reverse(ALL(ans));
	
	l=bmed;
	ans.PB(MP(l,max(comecostC[l],comecostB[l])));
	
	l=comeB[bmed];
	while (l && l!=B)
	 {
			ans.PB(MP(l,comecostB[l]));
			l=comeB[l];
	 }
	l=comeC[bmed];
	while (l && l!=C)
	 {
			ans.PB(MP(l,comecostC[l]));
			l=comeC[l];
	 }
	 
	
	printf("%d %d\n",ans.SZ,best);
	Repi(ans.SZ)
	 {
			printf("%d %d\n",ans[i].x,ans[i].y);
	 }

    return 0;
}
