#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <numeric>
#include <utility>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <string>

using namespace std;

#define Repi(n) for (int i=0;i<(n);i++)
#define Repj(n) for (int j=0;j<(n);j++)
#define Repk(n) for (int k=0;k<(n);k++)
#define sign(x) (((x)>0)-((x)<0))
#define PI pair<int,int>
#define PD pair<double,double>
#define MP make_pair
#define LL long long
#define ULL unsigned long long
#define x first
#define y second
#define ALL(v) (v).begin(),(v).end()
#define IT iterator
#define VI vector<int>
#define VD vector<double>
#define PB push_back
#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define pause system("pause")
#define PQ priority_queue
#define INF 2000000000
#define SZ size()

#define MAXN 512
int N,M,n,m,K,C;
multiset<PI> s;
PI p[MAXN];

bool can(int dist)
{
	int br=1;
	multiset<PI>::IT it=s.begin(),i1=s.begin();
	while (it!=s.end() && it->x-i1->x+1<=dist) { br++; it++; } br--;
	if (br>=C) return 1;
	
//	cout<<s.SZ<<endl;
//	cout<<"  can "<<dist<<" -> "<<" ; "<<i1->y<<","<<i1->x<<" "<<it->y<<","<<it->x<<" = "<<br<<" :\n";
	for (;it!=s.end(); it++)
	 {
			br++;
			while (i1!=it && it->x-i1->x+1>dist) { br--; i1++; }
	//		cout<<"                                                 "<<i1->y<<","<<i1->x<<" "<<it->y<<","<<it->x<<" = "<<br<<endl;
			if (br>=C) return 1;
	 }
	return 0;
}

int ans=INF;

void solve()
{
	sort(p,p+N);
	
//	Repi(N) cout<<p[i].x<<" "<<p[i].y<<" ; "; cout<<endl;
	s.clear();
	int head,tail;
	for (head=0,tail=0;head<N;head++)
	 {
			s.insert(MP(p[head].y,p[head].x));
		//	cout<<p[tail].x<<" "<<p[head].x<<endl;
			while (can(p[head].x-p[tail].x+1) && tail<head) 
			 { ans<?=p[head].x-p[tail].x+1; 
			   //cout<<"  moje "<<p[tail].x<<","<<p[tail].y<<" "<<p[head].x<<","<<p[head].y<<" \n";
			   s.erase(s.find(MP(p[tail].y,p[tail].x))); 
			   tail++;
			 }
	 }
}

int main()
{
	scanf("%d%d",&C,&N);
	Repi(N) scanf("%d%d",&p[i].x,&p[i].y);
	
	solve();
	Repi(N) swap(p[i].x,p[i].y);
	solve();
	
	printf("%d\n",ans);
	
    return 0;
}
