/*
TASK:skate
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <stdio.h>

using namespace std;

int n,m,a[200][100],x[200][100],y[200][100],xx[20000],yy[20000];
long p[200][100];

void dfs(int i,int j,int ci,int cj)
{
    x[i][j]=ci; y[i][j]=cj; p[i][j]=p[ci][cj]+1;
    if ((i-1>0)&&(p[i-1][j]>p[i][j]+1)&&(a[i-1][j]==0)) dfs(i-1,j,i,j);
    if ((i+1<=n)&&(p[i+1][j]>p[i][j]+1)&&(a[i+1][j]==0)) dfs(i+1,j,i,j);
    if ((j-1>0)&&(p[i][j-1]>p[i][j]+1)&&(a[i][j-1]==0)) dfs(i,j-1,i,j);
    if ((j+1<=m)&&(p[i][j+1]>p[i][j]+1)&&(a[i][j+1]==0)) dfs(i,j+1,i,j);
}

int main()
{
    char c;
    long i,j,k,l;

    ifstream f("skate.in");  
    f>>n>>m;
    for (i=1; i<=n; i++)
     for (j=1; j<=m; j++)
      {
               f>>c;
               if (c=='*') a[i][j]=1;
               p[i][j]=1000000;
      }
    f.close();

    x[1][1]=0;
    y[1][1]=0;
    p[1][1]=0;
    dfs(1,1,1,1);
    
    ofstream f1("skate.out");
    
    xx[1]=n; yy[1]=m;
    for (l=2; l<=p[n][m]; l++)
     {
              xx[l]=x[xx[l-1]][yy[l-1]];
              yy[l]=y[xx[l-1]][yy[l-1]];
     }
    for (l=p[n][m]; l>=1; l--) 
     f1<<xx[l]<<" "<<yy[l]<<"\n";
    f1.close();   
    
    return 0;
}
