/*
TASK:fliptile
LANG:C++
ID:pascala1
*/
#include <strings.h>
#include <fstream>
#include <iostream>

using namespace std;

int m,n;
bool a[16][16];

inline void flip(bool b[][16],int r,int c)
{
       b[r][c]=!b[r][c];
       if (r>1) b[r-1][c]=!b[r-1][c];
       if (c>1) b[r][c-1]=!b[r][c-1];
       if (r<m) b[r+1][c]=!b[r+1][c];
       if (c<n) b[r][c+1]=!b[r][c+1];
}

inline bool clean(bool b[][16],bool c[][16],int &br)
{
       int i,j; br=0;
       for (i=1; i<m; i++)
        for (j=1; j<=n; j++)
         if (b[i][j])
         {
          flip(b,i+1,j);
          c[i+1][j]=1;
          br++;
         }
       for (i=1; i<=n; i++)
        if (b[m][i]) return false;
       return true; 
}

inline int ffs(int x)
{
       int l=1;
       if (x==0) return 0;
       while ((x&1)==0) { x>>=1; l++; }
       return l;
}

int main()
{
    ifstream f("fliptile.in");
    f>>m>>n;
    int i,j,k,l,tek,ans=1000000000;
    for (i=1; i<=m; i++)
     for (j=1; j<=n; j++)
      f>>a[i][j];
    f.close();
    
    bool b[16][16],c[16][16],cs[16][16];
    for (i=0; i<=(1<<n); i++)
    {
        memcpy(b,a,sizeof(b));
        memset(c,0,sizeof(c));
        j=i;
        while (j>0)
        {
          l=ffs(j);
          flip(b,1,l);
          c[1][l]=1;
          j&=j-1;
          tek++;
        }
        if (!clean(b,c,k)) continue;
        tek+=k;
        if (tek<ans)
        {
                    ans=tek;
                    memcpy(cs,c,sizeof(cs));
        }
    }
    
    ofstream of("fliptile.out");
    if (ans==1000000000) of<<"IMPOSSIBLE\n";
    else
    {
        for (i=1; i<=m; i++)
        {
            for (j=1; j<n; j++) of<<cs[i][j]<<" ";
            of<<cs[i][n]<<"\n";
        }
    }
    of.close();
    
    return 0;
}
