/*
ID: pascala1
PROG: paint2
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
int a[128][128];
int t[128][128];

inline void col(int r,int c,int plus)
{
       if (r<0 || c<0 || r>=n || c>=n) return;
       t[r][c]+=plus;
}

int main()
{
    int i,j,k,l;
    FILE * f;
    f=fopen("paint2.in","r");
    fscanf(f,"%d%d",&n,&m);
    Repi(m)
     { fscanf(f,"%d%d",&j,&k);
       a[j-1][k-1]++;
       t[j-1][k-1]++;
     }
    fclose(f);
    
    Repi(n)
     Repj(n)
      if (a[i][j]>0)
       for (int k=1; k<n; k++)
        {
              col(i-k,j,a[i][j]);
              col(i+k,j,a[i][j]);
              col(i,j-k,a[i][j]);
              col(i,j+k,a[i][j]);
              col(i-k,j-k,a[i][j]);
              col(i-k,j+k,a[i][j]);
              col(i+k,j-k,a[i][j]);
              col(i+k,j+k,a[i][j]);
        }
        
   /* Repi(n) {   
     Repj(n)
      cout<<t[i][j]<<" "; cout<<endl; } pause; */
        
    int ans=0;
    Repi(n)    
     Repj(n)
      if (t[i][j]==m) ans++;
    
    ofstream of("paint2.out");
    of<<ans<<"\n";
    of.close();

    return 0;
}
