/*
ID: pascala1
PROG: tanning
LANG: C++
*/
#include <vector>
#include <iostream>
#include <fstream>

#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second
#define PI pair<int,int>
#define VI vector<int>
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define INF 2000000000
#define pause system("pause")

using namespace std;

#define MAXN 5010

int n,m,N,C,source,sink;
PI cow[2510];
VI a[MAXN];
VI t[MAXN];
VI c[MAXN];

    int d[MAXN],q[MAXN],q1[MAXN],p[MAXN],p1[MAXN];
    bool u[MAXN];

int flow()
{
    int flow=0,x,y,m,r,r1;
    
    memset(d,127,sizeof(d));
    memset(u,0,sizeof(u));
    d[sink]=0; q[0]=sink; u[sink]=true;
    for (int s=0,e=1; s<e; s++)
     Repi(a[q[s]].SZ)
     { int v=q[s];
       if (c[v][i]==0 && !u[a[v][i]])
       {
                         u[a[v][i]]=true;
                         q[e++]=a[v][i];
                         d[a[v][i]]=d[v]+1;
       }
     }
    
    int i=source; p[source]=-1;
    while (d[source]<N)
    {
      r=-1;
   //   cout<<"in "<<i<<endl;
      Repj(a[i].SZ)
       if (c[i][j]>0 && d[a[i][j]]==d[i]-1) { r=a[i][j]; r1=j; break; }
      if (r==-1) //retreat
       {
                 r=2000000000;
                 Repj(a[i].SZ) if (c[i][j]) r=min(r,d[a[i][j]]);
                 d[i]=r+1;
       //          cout<<"retreat from "<<i<<" to "<<p[i]<<endl;
                 if (i!=source) i=p[i];
                 continue;
       }
      //advance  
      p[r]=i;
      p1[r]=r1;
   //   cout<<"go to "<<r<<endl;
      i=r;
      //augment
      if (i==sink)
       {
                  x=i; y=0;
                  while (x!=-1) { q[y++]=x; q1[y]=p1[x]; x=p[x]; }
                  reverse(q,q+y); reverse(q1,q1+y);
                  m=2000000000;
                  for (int j=0; j<y-1; j++) m=min(m,c[q[j]][q1[j]]);
//                  cout<<"path "; Repj(y) cout<<q[j]<<" "; cout<<" flow "<<m<<endl;
                  for (int j=0; j<y-1; j++) 
                  {
                    c[q[j]][q1[j]]-=m;
                    c[q[j+1]][ t[q[j]][q1[j]] ]+=m;
//                    cout<<q[j+1]<<" <- "<<a[ q[j+1] ] [ t[q[j]][q1[j]] ]<<endl;
                  }
                  flow+=m;
                  i=source;
       }
    }
    return flow;
}


inline void edge(int X,int Y,int C)
{
  //    cout<<"edge "<<X<<" "<<Y<<" = "<<C<<endl;
           a[X].PB(Y);
           a[Y].PB(X);
           t[X].PB(a[Y].SZ-1);
           t[Y].PB(a[X].SZ-1);
           c[X].PB(C);
           c[Y].PB(0);
}

int main()
{
    int i,j,k,l;
    FILE *f;
    f=fopen("tanning.in","r");
    fscanf(f,"%d%d",&C,&n);
    source=0; sink=C+n+1; N=sink+1;
    Repi(C)
    {
           fscanf(f,"%d%d",&j,&k);
           cow[i]=MP(j,k);
           edge(i+n+1,sink,1);
    }
    Repi(n)
    {
           fscanf(f,"%d%d",&j,&k);
           edge(source,i+1,k);
           for (l=0; l<C; l++)
            if (j>=cow[l].x && j<=cow[l].y) 
             edge(i+1,l+n+1,1);
    }
    fclose(f);
    
    ofstream of("tanning.out");
    of<<flow()<<"\n";
    of.close();
 //pause;
    return 0;
}
