/*
ID: pascala1
PROG: tower
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
VI a[10100];
int par[10100];
int chi[10100];
set<int> leaves,lpars,lpars1;
bool u[10100],e[10100];

void tree(int v)
{
     u[v]=1;
     Repi(a[v].SZ)
      if (!u[a[v][i]])
       {
                      par[a[v][i]]=v;
                      tree(a[v][i]);
       }
}
int main()
{
    int i,j,k,l;
    FILE *f=fopen("tower.in","r");
    fscanf(f,"%d",&n);
    Repi(n-1)
    {
     fscanf(f,"%d%d",&k,&l);
     a[k].PB(l);
     a[l].PB(k);
    }
    fclose(f);
    
    par[1]=0;
    tree(1);
    Repi(n) chi[par[i+1]]++;
    Repi(n) if (!chi[i+1]) { leaves.insert(i+1);  }
    
  //  Repi(n) cout<<par[i+1]<<" "; cout<<endl;
  //  cout<<endl;
    
    set<int>::IT it;
    int ans=0;
    while (leaves.SZ)
    {
          lpars.clear(); lpars1.clear();
       //   cout<<"leaves: ";
          for (it=leaves.begin(); it!=leaves.end(); it++)
          {
       //    cout<<*it<<" ";
           if (par[*it])
           {
            lpars1.insert(par[*it]);
            lpars.insert(par[par[*it]]);
           }
           e[*it]=1; e[par[*it]]=1;
          }
      //    cout<<endl;
          ans+=lpars1.SZ;
          if (lpars1.SZ==0) ans+=leaves.SZ;

          for (it=lpars1.begin(); it!=lpars1.end(); it++)
           Repi(a[*it].SZ) e[a[*it][i]]=1;
           
      //    cout<<"parents: "; for (it=lpars1.begin(); it!=lpars1.end(); it++)  cout<<*it<<" "; cout<<endl;
      //    cout<<"parents of parents: "; for (it=lpars.begin(); it!=lpars.end(); it++)  cout<<*it<<" "; cout<<endl;
           
          memset(u,0,sizeof(u)); 
          leaves.clear();
          for (it=lpars.begin(); it!=lpars.end(); it++) 
            {
                                 l=par[*it];
                                 chi[l]--;
                                 if (!chi[l] && !e[l] && l) leaves.insert(l);
                        //         cout<<"ppp "<<l<<" -> "<<chi[l]<<endl;
            }
    //      Repi(n) cout<<e[i+1]<<" "; cout<<endl;  
   //       cout<<endl;
    }

   ofstream of("tower.out");
   of<<ans<<"\n";
   of.close();
 //   pause;
    return 0;
}
