/*
TASK: grading
LANG: C++
ID: ambigs1

USACO GOLD - Feb08, TASK 1

SOL: DP
N*N
*/
#include <cstdio>
#include <set>
#include <algorithm>
using namespace std;

#define LB(x) (x)&(-x)

FILE *fin = fopen ("grading.in","r");
FILE *fout = fopen ("grading.out","w");

const int MAXN = 2048;
const int MAXA = 1000000005;
const int INF = 2147483647;

int n;
int a[MAXN];
int dp[2][MAXN];

void read() {
 fscanf (fin,"%d",&n);
 int i;

 for (i=1;i<=n;i++)
  fscanf (fin,"%d",&a[i]);
}

int solve() {
 set < int > compress;
 static int b[MAXN];
 int i , j;
 int m = 0;
 int mn;
 int ans = INF;

 for (i=1;i<=n;i++) 
  compress.insert ( a[i] );

 for (set<int>::iterator it=compress.begin();it!=compress.end();it++)
  b[++m] = (*it);

 for (i=0;i<MAXN;i++) {
  dp[0][i] = 0;
  dp[1][i] = INF;
 }

 for (i=1;i<=n;i++) {
  mn = (1<<30);
  for (j=1;j<=m;j++) {
   mn = min ( mn , dp[0][j] );
   dp[1][j] = mn + abs( b[j] - a[i] );
  }

  for (j=0;j<MAXN;j++)  {
   dp[0][j] = dp[1][j];
   dp[1][j] = (1<<30);
  }
 }

 for (i=1;i<=m;i++)
  ans = min ( ans , dp[0][i] );

 return ans;
}

int main() {
 read();

 int ans , i;
 ans = solve();

 for (i=1;i<=n;i++)
  a[i] = MAXA - a[i];
 ans = min ( ans , solve() );

 fprintf (fout,"%d\n",ans);

 return 0;
}
