//range query; maintain-vane na intervali
/*
ID: pascala1
PROG: hotel
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

int n,m,N;

set<int> pos[60000];
set<int> ints;
int len[60000],bt[300000];

inline void push(int p,int v)
{
	p+=N-1;
	bt[p]=v;
    while (p>1)
	 {
			p/=2;
			bt[p]=min(bt[p*2],bt[p*2+1]);
	 }
}

inline int query(int p)
{
	p+=N-1;
	int ret=bt[p];
	while (1)
	{
		p=(p+1)/2;
		ret<?=bt[p];
		if (!(p&(p+1))) break;
	}
	return ret;
}

inline void add_interval(int p,int v) //length, position
{
	len[v]=p;
	ints.insert(v);
	pos[p].insert(v);
	if (*pos[p].begin()==v)
	  push(p,v);
}

inline void erase_interval(int v)
{
	pos[len[v]].erase(v);
	push(len[v], (pos[len[v]].SZ==0)?bt[0]:*pos[len[v]].begin() );
	len[v]=0;
	ints.erase(v);
}

void print()
{
	cout<<"tree -> ";
   for (int i=1; i<2*N; i++) { cout<<bt[i]<<" ";
               if ((i&(i+1))==0) cout<<"\n -> ";
         }
         
   cout<<"ints -> ";
   for (set<int>::IT it=ints.begin(); it!=ints.end(); it++)
    cout<<"("<<*it<<","<<len[*it]<<") ";
   cout<<endl; 
   cout<<endl; 
   
   pause;
}

int main()
{
    int i,j,k,l,r,st,EN,ST;
    FILE *f=fopen("hotel.in","r"),*f1=fopen("hotel.out","w");
    
    fscanf(f,"%d%d",&n,&m);
    N=1;
    while (N<n) N*=2;
    len[1]=n;
    memset(bt,127,sizeof(bt));
    
    add_interval(n,1);    
    set<int>::IT it;
    for (int X=0; X<m; X++)
     {
			fscanf(f,"%d",&l);
			if (l==1)
			 {
					fscanf(f,"%d",&r);
					k=query(r);
					if (k>n) {fprintf(f1,"0\n"); continue;}
					fprintf(f1,"%d\n",k);
					l=len[k];
					erase_interval(k);
					if (l-r>0) add_interval(l-r,k+r);
					
			//		cout<<"ADD "<<r<<endl;
				//	print();
			 }
			else
			 {
					fscanf(f,"%d%d",&st,&r); 
					it=ints.lower_bound(st);
					ST=st; EN=st+r-1;
					if (it!=ints.begin())
					 {
							it--;
							if (*it+len[*it]-1<st-1) it++; else ST<?=*it;
					 }
					if (it!=ints.end())
					{
					for (;it!=ints.end() && *it<=st+r;)
					 {
							k=*it;
							EN>?=k+len[k]-1;
							it++;
							erase_interval(k);
							if (!ints.SZ) break;
					 }
					}
					add_interval(EN-ST+1,ST);
					 
			//		cout<<"CLEAR "<<st<<" "<<r<<" ("<<ST<<" "<<EN<<")"<<endl;
			//		if (X>12) print();
			 } 
     }
    
    fclose(f);
    fclose(f1);
    
    return 0;
}
