/*
ID: pascala1
PROG: lites
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

int n,m,N,M,P,T,K;
#define MAXN (1<<17)

struct node
{
	int xo,on,left,right,cnt;
	node(){};
	node(int a,int b,int c,int d,int e){xo=a,on=b,left=c,right=d,cnt=e;};
	};
	
node tr[MAXN*2];

void init()
{
	for (int i=T;i<T*2;i++)
	 tr[i]=node(0,0,i-T+1,i-T+1,1);
	for (int i=T-1;i;i--)
	 tr[i]=node(0,0,tr[i*2].left,tr[i*2+1].right,tr[i*2].cnt+tr[i*2+1].cnt);
}

void printree(int lev,int i)
{
	if (i>=2*T) return;
	printree(lev+1,i*2+1);
	Repj(lev) cout<<"          ";
	cout<<tr[i].xo<<" "<<tr[i].on<<" ("<<tr[i].left<<" "<<tr[i].right<<") "<<i<<"\n";
	printree(lev+1,i*2);
}

int le,ri;

void toggle(int at)
{
	 if (at>=2*T || tr[at].left>ri || tr[at].right<le) return;
	 
	 if (tr[at].right<=ri && tr[at].left>=le)
	  {
			tr[at].xo^=1;
			tr[at].on=tr[at].cnt-tr[at].on;
			//cout<<"            completely xor "<<at<<endl;
	  }
	 else
	  if (at<T)
	   {
			toggle(at*2); toggle(at*2+1);
			//cout<<"    partially xor "<<at<<endl;
			tr[at].on=tr[at*2].on+tr[at*2+1].on;
			if (tr[at].xo) tr[at].on=tr[at].cnt-tr[at].on;
	   }
}

int query(int at)
{
	 if (at>=2*T || tr[at].left>ri || tr[at].right<le) return 0;
	 if (tr[at].right<=ri && tr[at].left>=le) return tr[at].on;
	 int cnt=min(tr[at].right,ri)-max(tr[at].left,le)+1;
	 if (tr[at].xo) return cnt-(query(at*2)+query(at*2+1));
	 else return query(at*2)+query(at*2+1);
}


int yey[MAXN];

void brtoggle()
{
	for (int i=le;i<=ri;i++)
	 yey[i]^=1;
}

int brquery()
{
	int ans=0;
	for (int i=le;i<=ri;i++)
	 ans+=yey[i];
	return ans;
}


int main()
{
    freopen("lites.in","r",stdin);
    freopen("lites.out","w",stdout);
    
    scanf("%d%d",&N,&M);
    T=1; while (T<N) T*=2;
    init();
    
    Repi(M)
     {
			int a;
       scanf("%d%d%d",&a,&le,&ri);
       if (!a)
        {
		//	cout<<"---------toggling "<<le<<" "<<ri<<endl;
			toggle(1);
		//	brtoggle();
		//	printree(0,1); cout<<endl;
		}
	   else
	    {
		//	cout<<"=======querying "<<le<<" "<<ri<<endl;
		// if (query(1)!=brquery())
			printf("%d\n",query(1));
		}
	 }
    
    return 0;
}
