/*
ID: pascala1
PROG: toy
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 100100
int n,m,D,N,M,P,K;
int N1,C1,N2,C2,Tc;
int T[MAXN],sumT[MAXN];
int addclean[MAXN];

int sum(int st,int en)
{
	if (st>en) return 0;
	int ans=sumT[en]-sumT[st-1];
	for (int i=st;i<=en;i++)
	 ans-=addclean[i];
	return ans;
}

int main()
{
    freopen("toy.in","r",stdin);
    freopen("toy.out","w",stdout);
    
    scanf("%d%d%d%d%d%d",&D,&N1,&N2,&C1,&C2,&Tc);
    if (N2<N1) swap(N1,N2);

    int all=0;
    sumT[0]=0;
    Repi(D)
     {
      scanf("%d",T+i+1);
      all+=T[i+1];
      sumT[i+1]=sumT[i]+T[i+1];
	 }    
	
	if (Tc<=C1 && Tc<=C2) 
	 {
			printf("%d\n",all*Tc);
			return 0;
	 }
	
	int ans=0;
	
	int clean=0,dirty=0;
	for (int i=1;i<=D;i++)
	 {
			clean+=addclean[i];
			cout<<" day "<<i<<" ("<<T[i]<<") :\n";
			cout<<"  "<<clean<<" clean & "<<dirty<<" dirty\n";
			
			if (clean<T[i])
			 {
					ans+=(T[i]-clean)*Tc;
					cout<<"  buy "<<(T[i]-clean)<<" toys ; ans "<<ans<<endl;
					clean=T[i];
			 }
			
			clean-=T[i]; dirty+=T[i];
			cout<<"  left "<<clean<<" clean & "<<dirty<<" dirty\n";


			int income=-sum(i+1,min(i+N2-1,D));
			int demand=sum(i+N2,D);
			int req=demand-(clean+income);
			cout<<"       cheap slow dem "<<demand<<" inc "<<income<<" req "<<req<<endl;
			if (req>0 && C2<C1)
			 {
					ans+=req*C2;
					addclean[i+N2]+=req;
					cout<<"      slow clean "<<req<<" toys ; ans "<<ans<<"\n";
			 }


			income=-sum(i+1,min(i+N1-1,D));
			demand=sum(i+N1,D);
			req=demand-(clean+income);
			cout<<"       expensive fast dem "<<demand<<" inc "<<income<<" req "<<req<<endl;
			if (req>0 && Tc>C1)
			 {
					ans+=req*C1;
					addclean[i+N1]+=req;
					cout<<"       expensive fast clean "<<req<<" toys ; ans "<<ans<<"\n";
			 }			 
			

/*
			
			int demand2=sum(i+N2,D);
			cout<<"   demands : "<<demand1<<" "<<demand2<<endl;
			
			int income2=sum(i+1,min(D-1,i+N2-1))-(sumT[min(D-1,i+N2-1)]-sumT[i]);
			cout<<"   incomes : "<<income1<<" "<<income2<<endl;
			
			int req2=demand2-(clean+income2);
			
			cout<<"       req : "<<req1<<" "<<req2<<endl;
*/			
	 }
/*    for (int buy=T[0];buy<=all;buy++)
     {
			d
	 }
*/
    
    return 0;
}
