/*
ID: pascala1
PROG: sec
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 50100
int n,m,N,M,P,T,K;

struct node{
	int ending;
	int pass;
	node *next[2];
	node(){ending=pass=0; next[0]=next[1]=NULL;};
	};

void printree(node *at,int lev)
{
	if (!at) return;
	bool first=1;
	Repi(2)
	 if (at->next[i])
	  {
			if (!first)
			 Repj(lev) cout<<"       ";
			cout<<i<<"("<<at->next[i]->ending<<","<<at->next[i]->pass<<") "; 
			printree(at->next[i],lev+1);
			first=0;
	  }
	if (first) cout<<endl;
}

int main()
{
       node *root; root=new node; int cnt;
       freopen("sec.in","r",stdin); freopen("sec.out","w",stdout);
       scanf("%d%d",&M,&N);
       Repi(M)
        {
          scanf("%d",&cnt);
          int x; node *tmp=root;
          Repj(cnt)
           {
             scanf("%d",&x);
             if (!tmp->next[x]) tmp->next[x]=new node;
             tmp=tmp->next[x]; tmp->pass++;
		   }
		  tmp->ending++;
		}

    //printree(root,0);

	   Repi(N)
	    {
			scanf("%d",&cnt);
            int x,ans=0; node *tmp=root;
            bool counting=1;
            Repj(cnt)
             {
					scanf("%d",&x);
					if (!tmp->next[x]) counting=0;
					if (!counting) continue;
					tmp=tmp->next[x];
					ans+=tmp->ending;
			 }
			if (counting) ans+=tmp->pass-tmp->ending;
			printf("%d\n",ans);
		}
       
    
    
    return 0;
}
