/*
ID: pascala1
PROG: treat
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 100100
int n,m,N,M,P,T,K;
int next[MAXN]; VI prev[MAXN];
int ans[MAXN];
int len[MAXN];

void solve(int v)
{
	if (ans[v]>0) return;
	ans[v]=ans[next[v]]+1;
//	cout<<" ans "<<v<<" = "<<ans[v]<<endl;
	Repi(prev[v].SZ)
	 solve(prev[v][i]);
}

int main()
{
    freopen("treat.in","r",stdin); freopen("treat.out","w",stdout);
    scanf("%d",&N);
    Repi(N)
     scanf("%d",next+i+1),prev[next[i+1]].PB(i+1);
    
	for (int i=1;i<=N;i++) 
	 if (!ans[i])
	  {
			int at=i,cnt=0;
			while (!ans[at])
			 {
					ans[at]=-1;
					at=next[at];
			 }
			if (ans[at]==-1)
			 {
			      //  cout<<" found cycle at "<<at<<endl;
			        int cnt=0;
					while (ans[at]!=6661313)
					 {
					//		cout<<"      cycle : "<<at<<endl;
							ans[at]=6661313;
							cnt++;
							at=next[at];
					 }
				//	cout<<"  len = "<<cnt<<endl;
					while (ans[at]==6661313)
					 {
							ans[at]=cnt;
							Repj(prev[at].SZ)
							 solve(prev[at][j]);
							at=next[at];
					 }
			 }
	  }
	
	for (int i=1;i<=N;i++)
	 printf("%d\n",ans[i]);

    return 0;
}

