/*
ID: pascala1
PROG: baric
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)
#define F(i,n) for (int i=0;i<n;i++)

#define INF 2000000000
#define EPS 1e-6

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

using namespace std;

#define MAXN 103
#define MAXM 800000
int bt[MAXM*2];
int bt2[MAXM*2];

int n,m,N,M,P,T,K,E;
int a[MAXN],maxval;
int dp[MAXN][MAXN];
int lastadd[MAXN];
   

struct bintree
{
	int *bt;
	int size;
	
    void clear()
    {memset(bt,0,sizeof(int)*size);}
    
	bintree(){};
	bintree(int *bb,int sz){ bt=bb; size=sz; clear(); };
	
	int sum1old(int pos)
	{
		int ret=0;
		Repi(pos+1)
		 ret+=bt[i];
		return ret;
	};
	void pushold(int pos,int val)
	{ bt[pos]+=val; };
	
	
	void push(int pos,int val)
	{
		for (;pos<=maxval;pos+=pos&(-pos))
		 bt[pos]+=val;
	}
	
	int sum1(int pos)
	{
		int ret=0;
		for (;pos;pos-=pos&(-pos))
		 ret+=bt[pos];
		return ret;
	}
	
	int sum(int x1,int x2)
	{
		return sum1(x2)-sum1(x1-1);
	};
};

bintree vals(bt,MAXM*2-2);
bintree cnts(bt2,MAXM*2-2);


int ans(int cur)
{
	return 2*( cnts.sum(1,cur)*cur - vals.sum(1,cur)  +  vals.sum(cur+1,maxval) - cnts.sum(cur+1,maxval)*cur );
}

int ans2(int cur)
{
	int c2=cur/2;
	return cnts.sum(1,c2)*cur - 2*vals.sum(1,c2)  +  2*vals.sum(c2,maxval) - cnts.sum(c2,maxval)*cur;
}



int bf[MAXN][MAXN];
void bruteforce()
{
	int cnt=INF,out2;
	memset(bf,127,sizeof(bf));
	for (int mask=1;mask<(1<<N);mask++)
	 {
			int first=INF,last=-1;
			Repi(N)
			 if (mask&(1<<i)) first=min(first,i),last=max(last,i);
			int cans=0;
			Repi(first)
			 cans+=2*abs(a[first]-a[i]);
			for (int i=N-1;i>last;i--)
			 cans+=2*abs(a[last]-a[i]);
			for (int i=first;i<last;i++)
			 if (mask&(1<<i))
			  {
					int j;
					for (j=i+1;(mask&(1<<j))==0;j++);
					for (int k=i+1;k<j;k++)
					 cans+=abs(2*a[k]-a[i]-a[j]);
			  }
			bf[__builtin_popcount(mask)][last]<?=cans;
	 }
}


int main()
{
	freopen("baric.in","r",stdin); freopen("baric.out","w",stdout);
    scanf("%d%d",&N,&E);
    maxval=0;
    Repi(N)
     scanf("%d",a+i),maxval=max(maxval,a[i]); 
     
   // bruteforce();
    
    memset(dp,127,sizeof(dp));
    Repi(N)
     {
			dp[1][i]=ans(a[i]); 
		//	cout<<"  dp 1 "<<i<<" = "<<ans(a[i])<<endl;
			vals.push(a[i],a[i]); cnts.push(a[i],1);
	 }
	vals.clear(); cnts.clear();
	
    for (int i=N-1;i>=0;i--)
	 {
			lastadd[i]=ans(a[i]);
			//cout<<"  last add "<<i<<" ("<<a[i]<<") = "<<ans(a[i])<<endl;
			vals.push(a[i],a[i]); cnts.push(a[i],1);
	 }
	vals.clear(); cnts.clear();
    
    for (int cnt=1;cnt<N;cnt++)
     {
			for (int last=cnt-1;last<N;last++)
			 {
					if (dp[cnt][last]>E) continue;
					//cout<<" in "<<cnt<<" "<<last<<" = "<<dp[cnt][last]<<endl;
					for (int next=last+1;next<N;next++)
					 {
					//	 cout<<"     dp "<<cnt+1<<" "<<next<<" = min "<<dp[cnt+1][next]<<" , "<<dp[cnt][last]<<" + "<<ans2(a[last]+a[next])<<" = ";
						 dp[cnt+1][next]=min( dp[cnt+1][next] , dp[cnt][last] + ans2(a[last]+a[next]) );
					//	 cout<<dp[cnt+1][next]<<endl;
						 vals.push(a[next],a[next]); cnts.push(a[next],1);
					 }
					for (int next=last+1;next<N;next++)
					 vals.push(a[next],-a[next]),cnts.push(a[next],-1);
			 }
	 }
	 
	int out1=-1,out2=E+1;
	for (int cnt=1;cnt<=N;cnt++)
	 {
			for (int last=cnt-1;last<N;last++)
			 {
					int cans=dp[cnt][last]+lastadd[last];
				//	cout<<"--answer for "<<cnt<<" "<<last<<" = "<<dp[cnt][last]<<" + "<<lastadd[last]<<" = "<<cans<<" ("<<bf[cnt][last]<<")"<<endl;
				//	if (cans!=bf[cnt][last]) cout<<" jhsdfklgjhdsfjklghsdfjklghsdfklghsdfjklghsdfjklgafldghjklsdhgjksdflghklsdfg\n";
					if (cans<out2) { out1=cnt; out2=cans; }
			 }
			if (out1>-1)
			 {
					printf("%d %d\n",out1,out2); return 0;
			 } 
	 }
    
    return 0;
}
