/*
PROG:revamp
LANG:C++
ID:pascala1
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

#define MAXN 10003
VI adj[MAXN],cost[MAXN];

struct my
{
	int v,k; LL d;
 	my(){};
	my(LL a,int b,int c):d(a),v(b),k(c){};
};
bool operator<(const my &a,const my &b)
{
	return a.d>b.d;
}
int N,M,K;
bool used[MAXN][22];
LL dist[MAXN][22];
priority_queue<my> q;

inline void advance(int nv,int nk,LL nd)
{
	if (used[nv][nk] || nd>=dist[nv][nk]) return;
	dist[nv][nk]==nd;
	//cout<<"                     to "<<nv<<" "<<nk<<" with "<<nd<<endl;
	q.push(my(nd,nv,nk));
}

int main()
{
	freopen("revamp.in","r",stdin); freopen("revamp.out","w",stdout);
	scanf("%d%d%d",&N,&M,&K);
	Repi(M)
	 {
			int a,b,t;
			scanf("%d%d%d",&a,&b,&t);
			adj[a].PB(b); cost[a].PB(t);
			adj[b].PB(a); cost[b].PB(t);
		}
	
	
	q.push(my(0,1,0));
	memset(dist,127,sizeof(dist));
	dist[1][0]=0;
	my tmp;
	
	LL ans=1000000000000000LL;
	while (!q.empty())
	 {
			tmp=q.top(); q.pop();
			if (used[tmp.v][tmp.k]) continue;
			used[tmp.v][tmp.k]=1;                            /////////////////// TVA GO NQMA6E WEEEEEEEEEEEEEEEEEEEEEEEEEEEE TAPAKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
		//	cout<<"   in "<<tmp.v<<" "<<tmp.k<<" with "<<tmp.d<<endl;
			if (tmp.v==N) { ans=tmp.d; break; }
			Repi(adj[tmp.v].SZ)
			 {
					int w=adj[tmp.v][i]; LL c=cost[tmp.v][i];
					advance(w,tmp.k,tmp.d+c);
					if (tmp.k<K)
					 advance(w,tmp.k+1,tmp.d);
			 }
	 }
	
	cout<<ans<<"\n";
	return 0;
}

