/*
PROG:stock
LANG:C++
ID:pascala1
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))
int S,D,M;

int pr[64][64];

int ans;
int stock[64];

void conbf(int money,int day);
void bruteforce(int money,int day);

void getallcombs(int money,int st,int day)
{
	if (st==S)
	 { conbf(money,day); return; }
	
    getallcombs(money,st+1,day);
	if (stock[st])
	 {
	   int cc=stock[st];
	   stock[st]-=cc;
	   getallcombs(money+cc*pr[st][day],st+1,day);
	   stock[st]+=cc;
	 }
}

void getallcombs2(int money,int st,int day)
{
	if (st==S)
	 { conbf(money,day); return; }
	
    getallcombs2(money,st+1,day);
	if (stock[st])
	 {
	   int cc=stock[st];
	   stock[st]+=cc;
	   getallcombs2(money+cc*pr[st][day],st+1,day);
	   stock[st]-=cc;
	 }
}


void conbf(int money,int day)
{
	//cout<<"        conbf day "<<day<<" $ "<<money<<" stock: "; Repi(S) cout<<stock[i]<<" "; cout<<endl;
	bruteforce(money,day+1);
	
	getallcombs2(money,0,day)
	Repi(S)
	 {
			int can=money/pr[i][day];
			stock[i]+=can;
			bruteforce(money-can*pr[i][day],day+1);
			stock[i]-=can;		
	 }
}

void bruteforce(int money,int day)
{
//	cout<<"          bf day "<<day<<" $ "<<money<<" stock: "; Repi(S) cout<<stock[i]<<" "; cout<<endl;
	
	if (day==D)
	 { ans=max(ans,money); return; }
	getallcombs(money,0,day);
}


int main()
{
	freopen("stock.in","r",stdin); freopen("stock.out","w",stdout);
	
	scanf("%d%d%d",&S,&D,&M);
	Repi(S)
	 Repj(D)
	  scanf("%d",&pr[i][j]);
	  
	ans=0;
    bruteforce(M,0);
	printf("%d\n",ans);
	return 0;
}

