/*
PROG:cleanup
LANG:C++
ID:pascala1
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))
#define MIN(a,b) ((a>b)?b:a)

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define MAXN 40100
#define INF 200000000000000000LL;
int N,M;
int f[MAXN];
int dp[MAXN];
bitset<MAXN> used;
int prev[MAXN];

int solve()
{
	dp[0]=0; prev[0]=-1;
	int val,tmp;
	for (int i=1;i<=N;i++)
	 {
			prev[i]=(f[i]==f[i-1])?prev[i-1]:i-1;
			dp[i]=i;
			int types=1; used.reset(); used[f[i]]=1;
	//		cout<<"   in "<<i<<"\n";
			for (int j=prev[i];j>=0;j=prev[j])
			 {
					while (used[f[j]] && j) j=prev[j];
					tmp=types*types;
					if (tmp>=dp[i]) break;
					int val=dp[j]+tmp;
				//	cout<<"           from "<<j<<" = "<<dp[j]<<" + "<<types*types<<"  ================= "<<val<<"\n";
					dp[i]=MIN(val,dp[i]);
					if (!used[f[j]]) used[f[j]]=1,types++;
			 }
//			cout<<dp[i]<<"\n";
	 }
	return dp[N];
}

int main()
{
	freopen("cleanup.in","r",stdin); freopen("cleanup.out","w",stdout);
	scanf("%d%d",&N,&M);
	Repi(N)
	 scanf("%d",f+i+1);
	f[0]=0;
	
    cout<<solve()<<"\n";
	
//	cout<<Time<<"\n";
	return 0;
}

