## Contest: MAR09
## Program: damage2.c
## Competitor: dkisman1
 1: OK [0.01 sec]
 2: OK [0.00 sec]
 3: OK [0.01 sec]
 4: OK [0.01 sec]
 5: OK [0.05 sec]
 6: OK [0.03 sec]
 7: OK [0.04 sec]
 8: OK [0.41 sec]
 9: OK [0.34 sec]
10: OK [0.55 sec]
11: OK [0.00 sec]
12: OK [0.01 sec]
13: OK [0.01 sec]
14: OK [0.02 sec]
15: OK [0.04 sec]
------------------------------------------------------------------------
/*
ID: dkisman1
LANG: C++
PROG: damage2
 */
#include <algorithm>
#include <cstdio>
#include <iostream>
#include <vector>
using namespace std;

typedef vector<int> VI;

VI e[6001];
int goal[6001], P, C, N;
bool seen[6001];

bool doit(int x) {
  if (seen[x]) return false;
  seen[x] = true;
  if (goal[x]) return true;
  for (int i = 0; i < e[x].size(); i++)
    if (doit(e[x][i])) {
      int y = e[x][i];
      swap(e[x][i], e[x].back());
      e[x].pop_back();
      e[y].push_back(x);
      return true;
    }
  return false;
}

main() {
  freopen("damage2.in", "r", stdin);
  freopen("damage2.out", "w", stdout);
  int i, j, k, x, y, z, ret = 0;
  scanf("%d %d %d", &P, &C, &N);
  for (i = 0; i < C; i++) {
    scanf("%d %d", &x, &y);
    if (x == y) continue;
    e[x].push_back(y+P);
    e[y].push_back(x+P);
  }
  for (i = 1; i <= P; i++) e[i+P].push_back(i);
  for (i = 0; i < N; i++) {
    scanf("%d", &x);
    goal[x+P] = true;
  }
  for(;;) {
    memset(seen, 0, sizeof(seen));
    if (!doit(1)) break;
    ret++;
  }
  printf("%d\n", ret);
}
