/*
PROG:job
LANG:C++
ID:pascala1
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))

const int MAXN=100100;
int N;
PI job[MAXN];

int main()
{
	FILE *f=fopen("job.in","r");
	FILE *ff=fopen("job.out","w");
	fscanf(f,"%d",&N);
	LL ans=0;
	Repi(N)
	 fscanf(f,"%d%d",&job[i].x,&job[i].y);
	sort(job,job+N);
	
	int cnt=0;
	PQ<int,VI,greater<int> > q;
	Repi(N)
	 {
			if (cnt<job[i].x)
			 {
					cnt++;
					q.push(job[i].y);
			 }
			else
			 {
					int prof=q.top(); q.pop();
					prof=max(prof,job[i].y);
					q.push(prof);
			 } 
	 }
	while (!q.empty())
	 { ans+=(LL)q.top(); q.pop(); }
	fprintf(ff,"%lld\n",ans);
	fclose(f); fclose(ff);
	return 0;
}

