/*
Problem milking: Milking Orders [Hal Burch and Russ Cox, 2004]

Now that dairy products have been mooved to the bottom of the USDA
food pyramid, milk is in higher demand than ever. Farmer John has
put his recent profits back into the farm, increasing the size of
his herd to C (1 <= C <= 1,000) cows. Unfortunately, he didn't leave
any money to hire anyone to milk the new cows, so he must milk them
all himself.

Each cow wakes up at a particular time W (1 <= W <= 10,000) minutes
after dawn each day (in the hot sun on the farm, the days can seem
very long). Farmer John must wait for a cow to wake up on her own
before the cow can be milked. As you must have noticed, FJ is a
laid-back, play-it-by-ear kind of guy. In the old days, he would
have just gone out each day, walked around in no particular pattern,
and milked cows as they woke up. But now he has so many cows that
he needs to plan the order in which he milks them exactly, so that
he can finish in time to visit the farmhouse and watch his favorite
evening game show, Cheese Wheel of Fortune.

The cow fields are located all over the farm, but are all reachable
via a single winding path of length P (1 <= P <= 1,000) yards that
starts at the barn. FJ ambles down the path at a speed of one yard
per minute.  The farmhouse is at location H (0 <= H <= P) along the
path.

Given the waking time of each cow along with the distance of its
field from the barn, determine how quickly FJ can milk all the cows
and get to the farmhouse.  FJ starts at the barn and can milk a cow
in no time at all.

PROBLEM NAME: milking

INPUT FORMAT:

* Line 1: Three integers: C, P, and H.

* Lines 2..C+1: Each line contains two space-separated integers
        describing a cow. The first integer (0..P) is the location of
        the cow's field along the path. The second integer (0..10,000)
        is the number of minutes after dawn that the cow wakes up.

SAMPLE INPUT (file milking.in):

4 10 3
8 9
4 21
3 16
8 12

INPUT DETAILS:

FJ has four cows: Anna, Bessie, Charlotte, and Denise.

OUTPUT FORMAT:

* Line 1: A single integer: the earliest time (in minutes since dawn)
        that FJ can  get to the farmhouse having milked all the cows.

SAMPLE OUTPUT (file milking.out):

22

OUTPUT DETAILS:

Time  Action
  0   FJ walks to the field 8 yards down the path.
  8   FJ rests for one minute, waiting for Anna to wake up, and then milks
Anna.
  9   FJ rests for three more minutes, waiting for Denise to wake up, and
then milks Denise.
 12   FJ walks to the field 4 yards from the barn.
 16   FJ waits five minutes for Bessie to wake up, and then milks Bessie.
 21   FJ walks to the field 3 yards from the barn (one yard from his
current location).
 22   FJ milks Charlotte, who has been awake for six minutes already. 
 22   FJ enters the farmhouse, which is right next to this field.

Thus, FJ can finish his rounds and make it to the farmhouse 22 minutes
after dawn.  No better schedule exists.
*/




//1:1 copy-paste ot turnin
