/*
PROG:weight
LANG:C++
ID:pascala1
Problem weight: Weight Reconstruction [Coaches, 2004]

Farmer John has forgotten how old his N (1 <= N <= 1,000) cows are.
Obviously, some cows might be the same age as others.  Also, some ages
might not be represented in FJ's herd.

FJ keeps the cows on a precise feed schedule, so he knows that
every cow that is the same age weighs the same. FJ decided to weigh
the cows to determine their ages.

FJ took the cows to have them weighed, but the weigh station had a
new method for weighing cows. To weigh the cows, the cows are put
into a long line.  The station then weighs the first cow, the first
two cows together, the first three cows together, and so on for the
whole line.  Subsequenty, the station weighs the last cow, the last
two cows together, the last three cows together, and so on for the
whole line.

Given either of these weighing sequences, FJ could subtract adjacent
weighings and determine the weight of each cow.  Unfortunately, the
weigh station forgot to tell him which weighings are which and, to
make matters worse, mixed them up.

For example, suppose FJ took 5 cows of weight 1, 1, 5, 2, and 5,
in that order.  The weigh station would have recorded the following
weights:

 1 = 1                      5 = 5
 2 = 1+1                    7 = 2+5
 7 = 1+1+5                 12 = 5+2+5
 9 = 1+1+5+2               13 = 1+5+2+5
14 = 1+1+5+2+5             14 = 1+1+5+2+5

FJ has the list of possible weights (range: 1..10,000) and the set of
weights from the weigh station (range: 1...10,000,000), in no particular
order.  Help FJ determine the possible weights of his cows that would
result in the measured weights.  If there are multiple possible weights,
find the one that puts lighter cows first.

PROBLEM NAME: weight

INPUT FORMAT:

* Line 1: Two space-separated integers, N and K, the number of
        possible cow weights (1 <= K <= 1,000)

* Lines 2..K+1: The possible cow weights, one per line

* Lines K+2..K+2N+1: An integer which is either the sum of the weights
        of the first k cows or the last k cows for some k <= N.

SAMPLE INPUT (file weight.in):

5 4
1
2
5
4
1
2
5
7
14
7
9
12
13
14

INPUT DETAILS:

There are 5 cows, whose weights can be 1, 2, 4, or 5.  The weights of all
the non-empty prefixes and suffixes of the original line are 1, 2, 5, 7, 7,
9, 12, 13, 14, and 14, as in the example described above.

OUTPUT FORMAT:

* Line N lines: An ordering of the weights of N cows that would give
        rise to the prefix and suffix weights in the input.  If there
        is more than one ordering, print the lexicographically least
        one: favor orderings that put lighter cows first.  If there is
        no ordering, output "0".

SAMPLE OUTPUT (file weight.out):

1
1
5
2
5

OUTPUT DETAILS:

There are other possible weights, but 1, 1, 5, 2, 5 is the one that puts
lighter cows first.  (e.g., 1, 4, 2, 5, 2 is another possible weights, but
1, 1, 5, 2, 5 is better because it puts a lighter cow first (second in
line, 1 instead of 4).
*/
// dp[last_prefix_num][last_suffix_num] - praim 1-2 obervations i tva e qsno
// shita stava s lexicographically least puthkata... cool 6te zemame seki pat nai-malkoto rebro, prez koeto moe da stignem do kraq, ama tam kudeto sme add
//-vali suffix-i kvo praim bace??? tam nema ceni... see fucked up implementation below... zada4kata e zlobni4ka, na 30-tiq submit q ucelih:
// 10 opita da naglasq nqkoe greedy da namira min path-a dokato ne osaznah 4e 6te e the HARD way i o6te 20 dokato naglasq 6IBANIQ MEMORY LIMIT!!!!! see the EVEN MORE FUCKED UP variables...
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<short int,short int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))
#define INF 1000000000

#define MAXN 1003
#define SHFT 14

int N,K;
int a[MAXN*2];
bool can[MAXN][MAXN];
short int from[MAXN][MAXN];
map< short int, map<short int,vector<short int> > > fr;   // kvo da naprava kato nema pamet :)))
set<int> wsw;
 
void getfrom(int i,int j,int f,int &x,int &y)    // tva laino e 4e da paza short int vmesto PI
{   x=i,y=j;
    if ((1<<SHFT)&f) y=f^(1<<SHFT);
    else x=f;
}
int added(int i,int j,int x,int y)
{  return (i==x)?a[j]-a[y]:a[i]-a[x]; }


void path(int i,int j,VI &ans)   // tva namira NQKUV otgovor kato vari nazad po dp-to
{
	VI pref,suff;
	while (i>1 || j>1)
	 {
            int x,y;
			getfrom(i,j,from[i][j],x,y);
			if (a[i]-a[x]) pref.PB(a[i]-a[x]);
			else suff.PB(a[j]-a[y]);
			i=x,j=y;
	 }
	reverse(pref.begin(),pref.end());
	ans=pref; Repi(suff.SZ) ans.PB(suff[i]);
}


void advance(int i,int j)   //////...
{
	  if (i<N+1 && j<N+1 && can[i][j])
	   {
			int pos=max(i,j);
			int oppos=2*N+1-pos;
			int addi=a[pos+1]-a[i],addj=a[pos+1]-a[j],oi=2*N+1-i,oj=2*N+1-j;
			if (wsw.find(addi)!=wsw.end() && a[oi]-a[oppos-1]==addi)
			 {
                    fr[pos+1][j].PB(i);
                    if (can[pos+1][j]) goto notthistime;
					from[pos+1][j]=i;
					can[pos+1][j]=1;
			 }
            notthistime:
			if (wsw.find(addj)!=wsw.end() && a[oj]-a[oppos-1]==addj)
			 {
                    fr[i][pos+1].PB(j+(1<<SHFT));
                    if (can[i][pos+1]) return;
					from[i][pos+1]=j+(1<<SHFT);
					can[i][pos+1]=1;
			 }
	   }
}

short int cost[MAXN][MAXN];

bool path2(VI &ans)                     // tva namira samiq otgovor - iame graf i iskame lexico min path ot A do B => zemame nai-malkite rebra, koito vodqt do vurhove, ot koito moe se stigne do B
//  6tom e DAG stava lesno, samo 4e kofti e 4e tam kudeto sme advance-nali sus suffix ne moje da slojim cena - tam cenata = nai-malkata cena na prefix value, koito 6te addnem v daden moment sled kato minem po tova rebro
// za tva e parvoto laino
{
    memset(cost,127,sizeof(cost));
    memset(from,0,sizeof(from));
    for (int i=N+1;i;i--)
     for (int j=N+1;j;j--)
      if ((can[i][j] && i<N+1 && j<N+1  && from[i][j]) || ((i==N && j==N+1) || (j==N && i==N+1)))              //baaa usloviqta we!!!! (i==N || j==N) dali obob6tava si4ki nenaredeni dvoiki N,N+1 ?!?!?!?!?!
       Repk(fr[i][j].SZ)
      {
       int x,y; getfrom(i,j,fr[i][j][k],x,y);
       int z=added(i,j,x,y);
       if (!can[x][y]) continue;
       if (i==N+1 || j==N+1)
         {
           if (z>=cost[x][y]) continue;
           cost[x][y]=z;
           from[x][y]=((i==x)?j+(1<<SHFT):i);
         }
       else
        if (j==y)
         {
            if (z>=cost[x][y]) continue;
            cost[x][y]=z;
            from[x][y]=((i==x)?j+(1<<SHFT):i);
         }
        else
         {
                if (cost[i][j]>=cost[x][y]) continue;
                cost[x][y]=cost[i][j];
                from[x][y]=((i==x)?j+(1<<SHFT):i);
         }
      }

    int i=0,j=1;
    VI pref,suff;
    while (i<N+1 && j<N+1)
     {
            int x,y; getfrom(i,j,from[i][j],x,y);
            if (x==i) suff.PB(a[y]-a[j]);
            else pref.PB(a[x]-a[i]);
            i=x,j=y;
     }
    reverse(suff.begin(),suff.end());
    ans=pref; Repi(suff.SZ) ans.PB(suff[i]);
    return 1;
}

int main()
{
	freopen("weight.in","r",stdin); freopen("weight.out","w",stdout);
	scanf("%d%d",&N,&K); int w;
	Repi(K) scanf("%d",&w),wsw.insert(w);
	Repi(2*N) scanf("%d",a+i); sort(a,a+2*N+2);
	
	
	//dp - where can we go
	memset(can,0,sizeof(can));
	can[0][1]=1;
	for (int i=0;i<N+1;i++)
     for (int j=1;j<N+1;j++)
      advance(i,j);

	//check if sol exists
	VI cans1,cans2,ans;
	if (can[N][N+1])
	 path(N,N+1,cans1);
	if (can[N+1][N])
	 path(N+1,N,cans2);

	if (!cans1.SZ && !cans2.SZ)
	  { printf("0\n"); return 0; }
	
	
	//generate real lexicographically min path
	path2(ans);
	Repi(ans.SZ)
	 printf("%d\n",ans[i]);
	 
	return 0;
}

