/*
PROG:groc
LANG:C++
ID:pascala1
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cmath>
#include <vector>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <utility>
#include <algorithm>
#include <functional>
#include <numeric>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)

#define PI pair<int,int>
#define PB push_back
#define VI vector<int>
#define MP make_pair
#define x first
#define F(i,n) for (int i=0;i<n;i++)
#define y second
#define PD pair<double,double>
#define LL long long
#define SZ size()
#define PQ priority_queue
#define sign(x) (((x)>0)-((x)<0)))
#define INF 1000000000
#define MAXN 512

int P,N,A,B;
PI g[MAXN];

vector<VI> anss;
int bruteforce()
{
	int ans=INF;
	VI id(P); Repi(P) id[i]=i;
	do
	{
		int tmp=(g[id[0]].x-1)*B+g[id[0]].y;
		for (int i=1;i<P;i++)
		 {
				if (g[id[i]].x==g[id[i-1]].x)
				 tmp+=abs(g[id[i]].y-g[id[i-1]].y);
				else
				 {
				  int dd=g[id[i]].y+g[id[i-1]].y;
				  tmp+=abs(g[id[i]].x-g[id[i-1]].x)*B + min(dd,2*(A+1)-dd);
				 }
		 }		
		tmp+=g[id[P-1]].y+(N-g[id[P-1]].x)*B;
		
		if (tmp<ans)
		 {
				ans=tmp;
				anss.clear();
		 }
		if (tmp==ans)
		 anss.PB(id);
		 
	//	cout<<" for "<<tmp<<" : "; Repi(P) cout<<id[i]<<" "; cout<<endl;
		
	}while (next_permutation(id.begin(),id.end()));
	return ans;
}

int upperd[MAXN],lowerd[MAXN],bothd[MAXN],*upper=upperd+1,*lower=lowerd+1,*both=bothd+1;
VI aisle[MAXN];
int dp[MAXN][2];

int main()
{
	freopen("groc.in","r",stdin); freopen("groc.out","w",stdout);
	scanf("%d%d%d%d",&P,&N,&A,&B);
	Repi(P)
	 scanf("%d%d",&g[i].x,&g[i].y),aisle[g[i].x].PB(g[i].y);
	sort(g,g+P);
	
//	Repi(P) cout<<i<<" -> "<<g[i].x<<" "<<g[i].y<<"\n";
/*	ofstream bf("groc1.out");
	bf<<bruteforce()<<"\n";
	bf.close(); */
/*	Repi(anss.SZ)
	 {
			cout<<"        ";
			Repj(anss[i].SZ)
			 cout<<anss[i][j]<<" ";
			cout<<endl;
	 }
*/	 
	 
	for (int i=1;i<=N+1;i++)
	 {
			if (!aisle[i].SZ) goto xaxa;
			sort(aisle[i].begin(),aisle[i].end());
			
			upper[i]=A+1-aisle[i][0];
			lower[i]=aisle[i][aisle[i].SZ-1];
			both[i]=min(upper[i],lower[i]);
			Repj(aisle[i].SZ-1)
			 both[i]<?=aisle[i][j]+A+1-aisle[i][j+1];
			 
			xaxa:;
			both[i]+=both[i-1],upper[i]+=upper[i-1],lower[i]+=lower[i-1];
	 }
	 
	memset(dp,127,sizeof(dp));
	int cornercase=0;
	dp[0][0]=-B;
	for (int b=1;b<=N+1;b++)
	 {
			dp[b][1]=cornercase+A+1;
			cornercase+=(lower[b]-lower[b-1])*2;
  	        for (int a=b-1;a>=0;a--)
  	         {
					int addd=(b-a)*B+A+1,tmp0=INF,tmp1=INF;
					for (int i=a;i<b && !((i>0)&&(a==0));i++)
					 for (int j=(b==N+1)?b:i+1;j<=b;j++)
					  {
							int add=(both[i]-both[a]+both[b-1]-both[j-1])*2 + (b-j+i-a)*2*B;
							int add0=(upper[j-1]-upper[i])*2;
							int add1=(lower[j-1]-lower[i])*2;
							tmp0<?=addd+add+add0;
							tmp1<?=addd+add+add1;
					  }
					dp[b][0]<?=dp[a][1]+tmp0,dp[b][1]<?=dp[a][0]+tmp1;
			 }
			cornercase+=B;
	 }

	int ans=cornercase-2*B;
	ans<?=dp[N][0];
	ans<?=dp[N+1][1]-A-1-B;
	printf("%d\n",ans);
	
	return 0;
}

