/*
TASK:training
LANG:C++
ID:pascala1
*/
//author's solution
//...omg TL on 10c and 11b, others worked 1st time, well done!
#include <iostream>
#include <bitset>
#include <fstream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define PI pair<int,int>
#define VI vector<int>
#define MP make_pair
#define PB push_back
#define x first
#define y second
#define SZ size()
#define ALL(v) v.begin(),v.end()

#define MAXN 1024
#define MAXM 5010

int N,M;
VI adj[MAXN];
int posinadj[MAXN][MAXN];

struct edge
{
	int a,b,w;
	edge(){};
    edge(int aa,int bb,int ww):a(aa),b(bb),w(ww){};	
};
vector<edge> E;

int dist[MAXN],par[MAXN];
int root;

void hangtree(int v)
{
	Repi(adj[v].SZ)
	 if (adj[v][i]!=par[v])
	 {
			par[adj[v][i]]=v;
			dist[adj[v][i]]=dist[v]+1;
			hangtree(adj[v][i]);
	 }
}


bitset<1024> used;
inline int lca(int a,int b)
{
	used.reset();
	while (a)
	 used[a]=1,a=par[a];
	while (!used[b])
	 b=par[b];
	return b;
}

vector<edge> out[MAXN];
int dp[MAXN][1<<11];
int solve(int v,int mask)
{
	int &ret=dp[v][mask];
	if (ret>-1) return ret;
	ret=0;

	//don't add (another) edge with v
	Repi(adj[v].SZ)
	 if (adj[v][i]!=par[v] && !((1<<i)&mask))
	  ret+=solve(adj[v][i],0);
	
	//add edge with v
	int a,b,tmp,nmask;
	Repi(out[v].SZ)
	 if ( (out[v][i].a<0 || !((1<<out[v][i].a)&mask)) && (out[v][i].b<0 || !((1<<out[v][i].b)&mask)) )
	  {
 			a=E[out[v][i].w].a,b=E[out[v][i].w].b;
 			tmp=E[out[v][i].w].w;
 		    if (a!=v) {
					       tmp+=solve(a,0);
					  }
 		    if (b!=v) { 
					       tmp+=solve(b,0);
					  }
 		    while (a!=v && par[a]!=v)
 		     {
					tmp+=solve(par[a],1<<posinadj[par[a]][a]);
					a=par[a];
			 }
 		    while (b!=v && par[b]!=v)
 		     {
					tmp+=solve(par[b],1<<posinadj[par[b]][b]);
					b=par[b];
			 }
			 
			nmask=mask;
			if (out[v][i].a>-1)
			 nmask|=1<<out[v][i].a;
			if (out[v][i].b>-1)
			 nmask|=1<<out[v][i].b;
			tmp+=solve(v,nmask);
			ret=max(ret,tmp);
	  }
	return ret;
}

int main()
{
	freopen("training.in","r",stdin); freopen("training.out","w",stdout);
	int a,b,c,sumw=0;
	scanf("%d%d",&N,&M);
	memset(posinadj,-1,sizeof(posinadj));
	Repi(M)
	 {
			scanf("%d%d%d",&a,&b,&c);
			if (c)
			 E.PB(edge(a,b,c)),sumw+=c;
			else
			 {
			   posinadj[a][b]=adj[a].SZ; //pos of b in adj[a]
			   posinadj[b][a]=adj[b].SZ;
			   adj[a].PB(b),adj[b].PB(a);
			 }
	 }
	
	srand(6661349);
	root=rand()%N+1;
	dist[root]=par[root]=0;
	hangtree(root);
	
	int v;
	Repi(E.SZ)
	 {
			a=E[i].a,b=E[i].b;
			v=lca(a,b);
			if ((dist[a]+dist[b]-(dist[v]<<1))&1) 
					continue;

			while (a!=v && par[a]!=v) a=par[a];
			a=posinadj[v][a];
			while (b!=v && par[b]!=v) b=par[b];
			b=posinadj[v][b];

			out[v].PB(edge(a,b,i)); //a's branch, b's branch, edge ab's index
	 }
	
	memset(dp,-1,sizeof(dp));
	printf("%d\n",sumw-solve(root,0));
	
	return 0;
}

