/*
ID: pascala1
PROG: beads
LANG:C++
*/#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;

int main()
{
    int i,j,k,l;
    ifstream f("beads.in");
    ofstream of("beads.out");
    string s;
    f>>n;
    f>>s;
    
 //   s="rwrwrwrwrwrwrwrwrwrwrwrwbwrwbwrwrwrwrwrwrwrwrwrwrwrwrwrwrwrwrwrwrwrwrwrwrwrwr"; 
    
  //  n=s.SZ;
//    cout<<n<<endl;

    int ans=0,st,ne; char c1,c2;


    Repi(n)
    {
           st=i; ne=i+1; if (ne==n) ne=0;
           c1=0; c2=0;
           if (s[st]!=s[ne])
            {
                            l=0;
//                            cout<<st<<" "<<ne<<" to ";
                            while (st!=ne && (c1==0 || (s[st]==c1 || s[st]=='w')))
                             {  if (s[st]!='w' && c1==0) c1=s[st]; l++; st--; if (st<0) st=n-1; }
                            st++; if (st==n) st=0;
                            while (ne!=st && (c2==0 || (s[ne]==c2 || s[ne]=='w')))
                             {  if (s[ne]!='w' && c2==0) c2=s[ne]; l++; ne++; if (ne==n) ne=0; }
 //                           cout<<st<<" "<<ne<<"   len "<<l<<endl; 
                            ans=max(l,ans);
            }
    }
    if (ans==0) ans=n;
    of<<ans<<"\n";
  //  pause;
    f.close(); of.close();
    return 0;
}
