//longest increasing subsequence - lowerbound / binary index tree
/*
ID: pascala1
PROG: buylow
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

UI n,m,a[5010],b[5010],d[5010],dd[5010];

inline UI push(UI d[],UI pos,UI val)
{
    d[pos]=val;
    for(;pos<=n;pos+=pos&(-pos))
     d[pos]>?=val;
}

inline UI qry(UI d[],UI pos)
{
    UI ans=0;
    for(;pos>0;pos-=pos&(-pos))
     ans>?=d[pos];
    return ans; 
}

int osn=1000000000,osnc=9;
typedef VI bigint;

bigint sub(bigint a,bigint b)
{
       a.resize(max(b.SZ,a.SZ));
       b.resize(max(b.SZ,a.SZ));
       bigint c;
       int o=0;
       Repi(a.SZ)
       {
                 c.PB((a[i]+b[i]+o)%osn);
                 o=(a[i]+b[i]+o)/osn;
       }
       if (o>0) c.PB(o);
       return c;
}

string biginttostr(bigint a)
{
       char t[10000];
       memset(t,0,sizeof(t));
       reverse(ALL(a));
       sprintf(t,"%d",a[0]);
       for (int i=1; i<a.SZ; i++)
        sprintf(t+strlen(t),"%09d",a[i]);
       string s=t;
       return s;
}

int main()
{
    UI i,j,k,l;
    UI *p;
    FILE *f=fopen("buylow.in","r");
    fscanf(f,"%d",&n);
    memset(b,127,sizeof(b));
    Repi(n)
     fscanf(f,"%d",&a[i]);
    reverse(a,a+n); 
    UI len[5010];
    Repi(n)
    {
     p=lower_bound(b,b+m,a[i]);
     if (p==b+m) m++;
     *p=a[i];
//     Repj(m) cout<<b[j]<<" "; cout<<endl;
     len[i]=m;// cout<<i<<" -> "<<m<<endl;
    }
    int AnZ=m;
    fclose(f);
//    pause;
    UI t[5010];
    Repi(n) t[i]=a[i];
    sort(t,t+n);
    p=unique(t,t+n);
    m=p-t;
    map<UI,UI> M;
    Repi(m) M[t[i]]=i;
    Repi(n) t[i]=M[a[i]]+1;
//    Repi(n) cout<<setw(3)<<t[i]; cout<<endl; 
//    Repi(n) cout<<setw(3)<<len[i]; cout<<endl;
    
    Repi(n)
     {
           l=qry(d,t[i]-1);
           dd[i]=l+1;
           push(d,t[i],l+1);
     }
//    Repi(n) cout<<setw(3)<<dd[i]; cout<<endl; 
    
    memset(d,0,sizeof(d));
    bigint B[5010];
    B[0].PB(1);
    Repi(n)
    {
           B[t[i]].clear();
           Repj(t[i])
            if (d[j]==dd[i]-1)
             B[t[i]]=sub(B[t[i]],B[j]);
//             b[t[i]]+=b[j];
           d[t[i]]=dd[i];
//           cout<<setw(3)<<B[t[i]][0];
    }// cout<<endl; pause;
//    B[n+1].PB(1);
//    B[n+1].PB(2);
//    cout<<biginttostr(B[n+1])<<endl; pause;
    
    bigint anZ;
    Repi(n+1) if (d[i]==AnZ) anZ=sub(anZ,B[i]);
    ofstream of("buylow.out");
    of<<AnZ<<" "<<biginttostr(anZ)<<"\n";
    of.close();
    
    
    return 0;
}
