/*
ID: pascala1
PROG: calfflac
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,c;

char s[20100];
char *a[20100],*t;
char p[20100];
PI pos[20100];


int main()
{
    int i,j,k,l;
    
    FILE * f; f=fopen("calfflac.in","r");
    t=s;
    while (fgets(t,1000,f)!=NULL) 
     { a[m++]=t; t+=strlen(a[m-1])+1; }
//    cout<<m<<endl;

    Repi(m)
     Repj(strlen(a[i]))
      if ((a[i][j]>='a' && a[i][j]<='z') || (a[i][j]>='A' && a[i][j]<='Z'))
      { p[n++]=a[i][j]; pos[n-1]=MP(i,j);
        if ( p[n-1]>='A' && p[n-1]<='Z' ) p[n-1]+='a'-'A'; }
      
    int maxi=0,maxl=1;  
    bool f1,f2;
    Repi(n)
    {
           f1=true; f2=true;
           for (int j=1; i+j<n && i-j>=0; j++)
            if (p[i+j]==p[i-j]) 
             { if (maxl<j*2+1) { maxl=j*2+1; maxi=i; } } else break;
           for (int j=1; i+j<n && i-j+1>=0; j++)
            if (p[i+j]==p[i-j+1]) 
             { if (maxl<j*2) { maxl=j*2; maxi=i; } } else break;
    }
//    Repi(n)     cout<<p[i]; cout<<endl;
    
//    for (int j=maxi-maxl/2+(maxl%2==0); j<=maxi+maxl/2; j++)
//     cout<<p[j]; cout<<endl;
    
    fclose(f);

   ofstream of("calfflac.out");
   of<<maxl<<"\n";
   PI st=pos[maxi-maxl/2+(maxl%2==0)],en=pos[maxi+maxl/2];
   
   if (st.x!=en.x)
   {
   for (int j=st.y; j<strlen(a[st.x]); j++) of<<a[st.x][j];
   for (int i=st.x+1; i<en.x; i++) of<<a[i];
   for (int j=0; j<=en.y; j++) of<<a[en.x][j];
   of<<"\n";
   }
   else
   {
   for (int j=st.y; j<=en.y; j++) of<<a[st.x][j];
   of<<"\n";
   }
   
   of.close();

//    pause;
    return 0;
}
