/*
ID: pascala1
PROG: camelot
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int R,C; PI K[1100],king;
int p[32][64][32][41];
PI q[10000];
int n,m,s,e,vi,vj,lev[10000],le;

inline void move(int i,int j)
{
       if (i<0 || i>=C || j<0 || j>=R || p[vi][vj][i][j]>-1) return;
       p[vi][vj][i][j]=le;
       q[e++]=MP(i,j);
       lev[e-1]=le;
}

void bfs()
{
     q[0]=MP(vi,vj); lev[0]=0;
     p[vi][vj][vi][vj]=0;
     for (s=0,e=1; s<e; s++)
      {
              le=lev[s]+1;
              move(q[s].x-2,q[s].y-1);
              move(q[s].x-2,q[s].y+1);
              move(q[s].x-1,q[s].y-2);
              move(q[s].x-1,q[s].y+2);
              move(q[s].x+2,q[s].y-1);
              move(q[s].x+2,q[s].y+1);
              move(q[s].x+1,q[s].y-2);
              move(q[s].x+1,q[s].y+2);
      }
}

int main()
{
    int i,j,k,l;
  ifstream f("camelot.in");
  f>>R>>C; char c;
  while (f>>c>>l)
   {
        K[n++]=MP(c-'A',l-1);
    }
  f.close();
  
  memset(p,255,sizeof(p));
  Repi(C)
  Repj(R)
  {
    vi=i; vj=j;
    bfs();
  }
   
  // Repi(C) { Repj(R) cout<<setw(3)<<p[K[1].x][K[1].y][i][j]; cout<<endl;}  pause;

int mo[9][2]={
    {0,0},{-1,0},{1,0},{0,-1},{0,1},{-1,-1},{1,1},{-1,1},{1,-1}
    };

int i1,j1; bool fl;
int tmp,ans=INF,ttmp;
  Repi(C)
   Repj(R)
    {
          l=max(abs(K[0].x-i),abs(K[0].y-j));
          tmp=l;
          fl=true;
          Repk(n-1)
          { tmp+=p[K[k+1].x][K[k+1].y][i][j];
            if (p[K[k+1].x][K[k+1].y][i][j]<0) {fl=false; break;}
          }
          if (!fl) continue;
          ttmp=tmp;
          Repk(n-1)
         /*  ttmp=min(ttmp,tmp-l-
           p[K[k+1].x][K[k+1].y][i][j]+
           p[K[k+1].x][K[k+1].y][K[0].x][K[0].y]+
           p[K[0].x][K[0].y][i][j]);
        */  
           for (int o=0; o<9; o++)
           {
            i1=K[0].x+mo[o][0]; j1=K[0].y+mo[o][1];
            if (i1<0 || j1<0 || i1>=C || j1>=R) continue;
            if (p[i1][j1][i][j]<0 || p[K[k+1].x][K[k+1].y][i1][j1]<0) continue;
            ttmp=min(ttmp,tmp-
            l-p[K[k+1].x][K[k+1].y][i][j]
            +max(abs(mo[o][0]),abs(mo[o][1]))+
            +p[i1][j1][i][j]+p[K[k+1].x][K[k+1].y][i1][j1]);
           }
          tmp=min(tmp,ttmp); 
          ans=min(ans,tmp);
    }
  //  pause;
  
  ofstream of("camelot.out");
  of<<ans<<"\n";
  of.close();

    return 0;
}
