/*
ID: pascala1
PROG: charrec
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,br,cost,best;
char ans[256],cur[256],s[256];
int a[2000],f[28][32];
bool u[2000]; int q[2000];
int mem[1300][3],memc[1300][3],d[1300];

void OCR(int row)
{
     if (n-row==0)
      if (cost<best) 
       {
                     best=cost;
                     cur[br]=0;
                     memcpy(ans,cur,sizeof(ans));
               //      printf("%d %s\n",best,ans);
       }
     if (cost>=best || cost>=d[row] || !u[n-row])
       return;
     d[row]=cost;  
      
     int l=INF,l1=0,c;
     
     
     //no omitted nor duplicated
     if (n-row>=20)
     {
       if (mem[row][0]==-1)
       {
        Repi(m)
         {
          l1=0;
          Repj(20)
          {
           l1+=__builtin_popcount(f[i][j]^a[row+j]);
           if (l1>=l) break;
          }
          if (l1<l)
           {
                  l=l1;
                  c=i;
           }
         }
        mem[row][0]=l;
        memc[row][0]=c;
       }
       else { l=mem[row][0]; c=memc[row][0]; }
       cost+=l;
       if (c) cur[br++]='a'+c-1; else cur[br++]=' ';
       OCR(row+20);
       br--;
       cost-=l;
     }
        
        
     //omitted
     l=INF;
     if (mem[row][1]==-1)
     {
     Repi(m)
      Repk(20) //omitted row
       {
         l1=0;
         Repj(20) //current row
          if (j!=k) 
           {
            l1+=__builtin_popcount(f[i][j]^a[row+j-(j>k)]);
            if (l1>=l) break;
           }
         if (l1<l)
          {
                  l=l1;
                  c=i;
          }
       }
      mem[row][1]=l;
      memc[row][1]=c;
     }
     else { l=mem[row][1]; c=memc[row][1]; }
     cost+=l;
     if (c) cur[br++]='a'+c-1; else cur[br++]=' ';
     OCR(row+19);
     br--;
     cost-=l;
     
     
     //duplicated
     if (n-row>=21)
     {
      l=INF;
      if (mem[row][2]==-1)
      {
      Repi(m)
       Repk(20) //dupe row
        {
          l1=0;
          Repj(20) //cur row
           if (j!=k) 
            {
              l1+=__builtin_popcount(f[i][j]^a[row+j+(j>k)]);
              if (l1>=l) break;
            }
          l1+=min(__builtin_popcount(f[i][k]^a[row+k]),__builtin_popcount(f[i][k]^a[row+k+1]));
          if (l1<l)
           {
                   l=l1;
                   c=i;
           }
        }
       mem[row][2]=l;
       memc[row][2]=c;
      }
      else { l=mem[row][2]; c=memc[row][2]; }
      cost+=l;
      if (c) cur[br++]='a'+c-1; else cur[br++]=' ';
      OCR(row+21);
      br--;
      cost-=l;
     } 
}

int main()
{
    int i,j,k,l;
    FILE *fi=fopen("charrec.in","r");
    fscanf(fi,"%d",&n);
    Repi(n)
     {
           fscanf(fi,"%s",s);
           Repj(20)
            a[i]|=(1<<j)*(s[j]=='1');
     }
    fclose(fi);
    
    q[0]=0;
    for (int s=0,e=1; s<e; s++)
     {
   //          cout<<"in "<<s<<" "<<q[s]<<endl;
             if (q[s]+19<n+10 && !u[q[s]+19]) q[e++]=q[s]+19;
             u[q[s]+19]=1;
             if (q[s]+20<n+10 && !u[q[s]+20]) q[e++]=q[s]+20;
             u[q[s]+20]=1;
             if (q[s]+21<n+10 && !u[q[s]+21]) q[e++]=q[s]+21;
             u[q[s]+21]=1;
     }
  //  Repi(n+1) cout<<u[i]<<" "; cout<<endl; pause;
    
    memset(f,0,sizeof(f));
    fi=fopen("font.in","r");
    fscanf(fi,"%d",&m);
    m/=20;
    Repi(m)
     Repj(20)
      {
             fscanf(fi,"%s",s);
             Repk(20)
              f[i][j]|=(1<<k)*(s[k]=='1');
      }
    fclose(fi);
    
    best=INF;
    memset(mem,255,sizeof(mem));
    memset(d,127,sizeof(d));
    OCR(0);
//    Repi(n) cout<<a[i]<<" "; cout<<endl;
//    Repi(m) { Repj(20) cout<<f[i][j]<<" "; cout<<endl; }
//    pause;
    fi=fopen("charrec.out","w");
    fprintf(fi,"%s\n",ans);
    fclose(fi);
    
    cout<<(double)clock()/(double)CLOCKS_PER_SEC<<endl; pause;
    return 0;
}
