/*
ID: pascala1
PROG: cowcycle
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,F,R,F1,R1,F2,R2,maxF,maxR;
double mean,var,Bvar=INF;
double dif[10000];
int fg[100],rg[100],Brg[100],Bfg[100];

long long comb(int a,int b)
{
     b=max(b,a-b); long long x=1;
     for (int l=b+1; l<=a; l++)
      x=x*(long long)l/(long long)(l-b);
     return x;
}

inline bool nestava(int a,int b,int c,int d)
{ return ((double)a/(double)b + EPS <= 3.*(double)c/(double)d); }

bool fl;

int TLE=(double)1.97*CLOCKS_PER_SEC;

double debamaikativnasranataputka,temp;
int id[6],I,i; double dv;

void calc()
{
     if ( nestava(fg[F],rg[1],fg[1],rg[R]) ) return;
//     Repi(F)
//      Repj(R)
//       dif[i*R+j]=(double)fg[i+1]/rg[j+1];
       
       
     Repi(F) id[i+1]=R; int i,l;
     Repj(n)
      {
            dv=INF;
            for (i=1; i<=F; i++)
             if (id[i]>0 && dv>(double)fg[i]/rg[id[i]]) { dv=(double)fg[i]/rg[id[i]]; l=i; }
            dif[j]=dv;
//            cout<<dif[j]<<endl;
            id[l]--;
      }
   //   pause;
       
/*     fl=false;
     while(!fl) 
     {
                 fl=true;
                 Repi(n-1) if (dif[i]>dif[i+1]) { swap(dif[i],dif[i+1]); fl=false; }
     } */
//      sort(dif,dif+n);
//     Repi(n) cout<<dif[i]<<"\n"; pause;
/*     mean=0.;
     Repi(n-1) mean+=dif[i]; mean/=(double)(n-1);
*/
     mean=(dif[n-1]-dif[0])*debamaikativnasranataputka;
//     Repi(n-1) dif[i]=dif[i+1]-dif[i];
     var=0.;
     Repi(n-1) var+=sqr(dif[i+1]-dif[i]-mean);
     if (Bvar>var+EPS)
      {
               //    cout<<Bvar<<" > "<<var<<endl;
               //    Repi(F) cout<<fg[i+1]<<" "; cout<<endl; Repi(R) cout<<rg[i+1]<<" "; cout<<endl<<endl; pause;
                   Bvar=var;
                   Repi(F)
                    Bfg[i]=fg[i+1];
                   Repi(R)
                    Brg[i]=rg[i+1]; 
      }
//     cout<<var<<endl; pause;
//     Repi(n) mean+=dif
}

void rear(int gear)
{
     if (gear==R) { calc(); return; }
     if (gear>1 && nestava(fg[F],rg[1],fg[1],rg[R])) return;
     if (clock()>TLE) return; 
     for (rg[gear]=rg[gear-1]+1; rg[gear]<=rg[R]-(R-gear); rg[gear]++)
      rear(gear+1);
}

void front(int gear)
{
     if (gear==F)
      { 
        for (rg[R]=R+R1-1; rg[R]<=R2; rg[R]++)
         rear(1);
        return; }
     if (gear>1 && nestava(fg[F],R1,fg[1],R2)) return;
     if (clock()>TLE) return; 
     for (fg[gear]=fg[gear-1]+1; fg[gear]<=fg[F]-(F-gear); fg[gear]++)
        front(gear+1);
}



void rear1(int gear)
{
     if (gear==1) { calc(); return; }
     if (gear<R && nestava(fg[F],rg[1],fg[1],rg[R])) return;
     if (clock()>TLE) return; 
     for (rg[gear]=rg[gear+1]-1; rg[gear]>=rg[1]+gear-1; rg[gear]--)
      rear1(gear-1);
}

void front1(int gear)
{
     if (gear==1)
      { 
        for (rg[1]=R2-R+1; rg[1]>=R1; rg[1]--)
         rear1(R);
        return; }
     if (gear<F && nestava(fg[F],R1,fg[1],R2)) return;
     if (clock()>TLE) return; 
     for (fg[gear]=fg[gear+1]-1; fg[gear]>=fg[1]+gear-1; fg[gear]--)
        front1(gear-1);
}


void Rear()
{
     if ( nestava(fg[F],R1,fg[1],R2) ) return;
     Repi(R) rg[i+1]=R1+i;
     int i;
     while (1)
     {
           calc();
           i=R;
           while (rg[i]+1>=rg[i+1] && i>0) i--;
           if (i==0) break;
           rg[i]++;
           for (i++;i<=R;i++) rg[i]=rg[i-1]+1;
     }
}

void Front()
{
     Repi(F) fg[i+1]=F1+i;
     int i;
     while(1)
     {
             Rear();
             i=F;
             while (fg[i]+1>=fg[i+1] && i>0) i--;
             if (i==0) break;
             fg[i]++;
             for (i++;i<=F;i++) fg[i]=fg[i-1]+1;
     }
}

int main()
{
    int i,j,k,l;
    ifstream f("cowcycle.in");
    f>>F>>R>>F1>>F2>>R1>>R2;
    f.close();
    
//    cout<<comb(36,10)<<endl;
//    cout<<comb(56,5)<<endl;
  //  pause;
   n=F*R;
   debamaikativnasranataputka=1./(double)(n-1);
    fg[0]=F1-1;
    rg[0]=R1-1;
    fg[F+1]=F2+1;
    rg[R+1]=R2+1;
//    maxF=(F2-F1+1)/F+2; if (F<=4) maxF+=10;
//    maxR=(R2-R1+1)/R+2; if (R<=5) maxR+=10;
//    cout<<maxF<<" "<<maxR<<endl;
   // pause;
    for (fg[F]=F+F1-1; fg[F]<=F2; fg[F]++)
     front(1);
//   for (fg[1]=F2-F+1; fg[1]>=F1; fg[1]--)
//    front1(F);
//    Front();
    
    ofstream of("cowcycle.out");
    Repi(F-1) of<<Bfg[i]<<" "; of<<Bfg[F-1]<<"\n";
    Repi(R-1) of<<Brg[i]<<" "; of<<Brg[R-1]<<"\n";
    of.close();
    
    cout<<clock()<<endl; pause;
    
    
    return 0;
}
