//N dijkstra's
/*
ID: pascala1
PROG: cowtour
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <queue>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n;
VI adj[256];
string m[256];
PD a[160];
double d[256][256],md[256];
bool u[169];

inline double dist(int b,int m)
{      return sqrt(sqr(a[b].x-a[m].x)+sqr(a[b].y-a[m].y));  }

void dijkstra(int di)
{
     memset(u,0,sizeof(u));
     PQ< pair<double,int> , vector<pair<double,int> >, greater<pair<double,int> > > q;
     q.push(MP(0,di));
     d[di][di]=0;
     int v,k;
     pair<double,int> tmp;
     while (q.SZ>0)
     {
           tmp=q.top(); v=tmp.y;
           q.pop();
           if (u[v]) continue;
           u[v]=true;
           Repi(adj[v].SZ)
            {
              k=adj[v][i];
              if ( d[di][v]+dist(v,k) < d[di][k] )
               {
                   d[di][k]=d[di][v]+dist(v,k);
                   q.push(MP(d[di][k],k));
               }
            }
     }
}

int main()
{
    int i,j,k,l;
    ifstream f("cowtour.in");
    f>>n;
    Repi(n)
     f>>a[i].x>>a[i].y;
    Repi(n) 
     f>>m[i];
    f.close();
    Repi(n)
     Repj(n)
      if (m[i][j]=='1') { adj[i].PB(j); adj[j].PB(i); }
    
    
    Repi(n)
     Repj(n) 
      d[i][j]=INF;
      
    Repi(n)
     dijkstra(i);
     
  //  Repi(n)  {     Repj(n)      cout<<setw(11)<<d[i][j]; cout<<endl; }
  //  pause;
  
     double da=INF;
    Repi(n)
     Repj(n)
      if (i!=j && fabs(d[i][j]-INF)>=EPS)
       md[i]=max(md[i],d[i][j]);
       
   double MAx=0;
    Repi(n)
      MAx=max(MAx,md[i]);

    Repi(n)   
     Repj(n)
      if (i!=j && fabs(d[i][j]-INF)<EPS)
       da=min( da, max( md[i]+md[j]+dist(i,j) , MAx ) );
    
    
    FILE * of; of=fopen("cowtour.out","w");
    fprintf(of,"%.6lf\n",da);
    fclose(of);

    return 0;
}
