/*
ID: pascala1
PROG: fc
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
PD p[12000];

inline double cp(PD A,PD B,PD C)
{
       double dx1=B.x-A.x;
       double dy1=B.y-A.y;
       double dx2=C.x-A.x;
       double dy2=C.y-A.y;
       return dx1*dy2-dx2*dy1;
}

double dist1(PD A,PD B)
{ return sqr(A.x-B.x)+sqr(A.y-B.y); }

bool cmp(PD A,PD B)
{
     double CP=cp(p[0],A,B);
     return (fabs(CP)<EPS)?(dist1(p[0],A)<dist1(p[0],B)):CP>0.;
 }

int main()
{
    int i,j,k,l; double ans;
     ifstream f("fc.in");
     f>>n;
     Repi(n)
      f>>p[i].x>>p[i].y;
     f.close();
     
     l=0;
     Repi(n) if (p[i].y<p[l].y || (p[i].y==p[l].y && p[i].x<p[l].x)) l=i;
     swap(p[0],p[l]);
     p[n]=p[0];
     sort(p+1,p+n,cmp);
     
  //   Repi(n)
  //    cout<<p[i].x<<" "<<p[i].y<<endl;
     
     int m=2;
     for (int i=3; i<=n; i++)
      {
              while (cp(p[m-1],p[m],p[i])<0.) m--;
              m++; swap(p[i],p[m]);
      }
  //   cout<<endl<<m<<endl;
  //   Repi(m) 
  //    cout<<p[i].x<<" "<<p[i].y<<endl;
  //   pause;
     
     ans=0.;
     Repi(m) ans+=sqrt(dist1(p[i],p[i+1]));
      
     ofstream of("fc.out");
     of<<setprecision(2)<<fixed<<ans<<endl;
     of.close();

    return 0;
}
