//Eulerian Cycle Undirected
/*
ID: pascala1
PROG: fence
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
VI a[512];
VI t[512];
int sta[10000],cir[10000],id[512],sc,cc,cur;
PI li[10000];

int main()
{
    int i,j,k,l;
    ifstream f("fence.in");
    f>>m;
    int st=20000;
    Repi(m)
           { f>>li[i].x>>li[i].y; if (li[i].x>li[i].y) swap(li[i].x,li[i].y); }
    sort(li,li+m);       
    Repi(m)
    {
           j=li[i].x; k=li[i].y;
           a[j].PB(k); a[k].PB(j);
           cout<<"put "<<j<<" "<<k<<" - "<<a[k].SZ-1<<" "<<a[j].SZ-1<<endl;
           t[j].PB(a[k].SZ-1); t[k].PB(a[j].SZ-1);
           n=max(n,k+1); n=max(n,j+1);
           st=min(st,j); st=min(st,k);
    }
    f.close();

    Repi(n)     sort(ALL(a[i]));
    Repi(n)
     if (a[i].SZ%2==1) { st=i; break; }
    /*
    Repi(n)
     if (a[i].SZ>0)
      { cout<<i<<" -> ";Repj(a[i].SZ) cout<<a[i][j]<<" "; cout<<endl; }
    cout<<endl;
    Repi(n)
     if (t[i].SZ>0)
      { cout<<i<<" -> ";Repj(t[i].SZ) cout<<t[i][j]<<" "; cout<<endl; }
    cout<<endl;  
    */
    cur=st;
    while (1)
    {
      /*    cout<<"stack: ";Repi(sc) cout<<sta[i]<<" "; cout<<endl;
          cout<<"current: "<<cur<<endl;
          cout<<"circuit: "; Repi(cc) cout<<cir[i]<<" "; cout<<endl;
          cout<<endl;*/

          while (id[cur]<a[cur].SZ && a[cur][id[cur]]==0) id[cur]++;
          if (id[cur]==a[cur].SZ) 
           { cir[cc++]=cur; sc--; if (sc>-1) cur=sta[sc]; else break;  }
          else { sta[sc++]=cur; l=a[cur][id[cur]]; 
          a[ a[cur][id[cur]] ][ t[cur][id[cur]] ]=0; a[cur][id[cur]]=0;
           cur=l;
          } 
    }
  //  pause;
    
    
    ofstream of("fence.out");
    reverse(cir,cir+cc);
    Repi(cc)
    of<<cir[i]<<"\n";
    of.close();

    return 0;
}
