/*
ID: pascala1
PROG: fence3
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,mx=INF,my=INF,Mx=0,My=0; double tans=INF; int tx,ty;

pair<PI,PI> s[170];
int a[170],b[170],c[170],L[170];

inline int dist1(int x1,int y1,int x2,int y2)
{ return (sqr(x1-x2)+sqr(y1-y2)); }

inline int perpen(int a,int b,int c,int xx,int yy)
{
       return ((a*a+b*b)!=0)?(a*xx+b*yy+c)/(int)sqrt(a*a+b*b):0;
}

inline int sp(PI &a,PI &b,PI c)
{
       int dx1=a.x-b.x;
       int dy1=a.y-b.y;
       int dx2=a.x-c.x;
       int dy2=a.y-c.y;
       return dx1*dx2+dy1*dy2;
}

void check(int x,int y)
{
//     cout<<x<<" "<<y<<endl;
    if (x<mx || x>Mx || y<my || y>My) return;
     double T=0.,X,Y;
     Repi(n)
      {
            if (sp( s[i].x,s[i].y,MP(x,y) )>=L[i] || sp( s[i].y,s[i].x,MP(x,y) )>=L[i]) 
             T+=min(sqrt(dist1(s[i].x.x,s[i].x.y,x,y)),sqrt(dist1(s[i].y.x,s[i].y.y,x,y)));
            else T+=fabs(perpen(a[i],b[i],c[i],x,y));
            if (T>tans) return;
            //cout<<T<<endl;
      }
     tans=T; tx=x; ty=y;
}

int TLE=0.96*(double)CLOCKS_PER_SEC;

int main()
{
    int i,j,k,l;
    int gx=0,gy=0;
    ifstream f("fence3.in");
    f>>n;
    Repi(n)
    {
     f>>s[i].x.x>>s[i].x.y>>s[i].y.x>>s[i].y.y;
     s[i].x.x*=10; s[i].x.y*=10; s[i].y.x*=10; s[i].y.y*=10;
     mx=min(mx,s[i].x.x);
     mx=min(mx,s[i].y.x);
     Mx=max(Mx,s[i].x.x);
     Mx=max(Mx,s[i].y.x);
     my=min(my,s[i].x.y);
     my=min(my,s[i].y.y);
     My=max(My,s[i].x.y);
     My=max(My,s[i].y.y);
     a[i]=s[i].x.y-s[i].y.y;
     b[i]=s[i].y.x-s[i].x.x;
     c[i]=s[i].y.y*s[i].x.x-s[i].y.x*s[i].x.y;
     L[i]=dist1(s[i].x.x,s[i].x.y,s[i].y.x,s[i].y.y);
     gx+=s[i].x.x+s[i].y.x;
     gy+=s[i].x.y+s[i].y.y;
    }
    f.close();
    
    gx/=n*2; gy/=n*2;
    //gx=(Mx+mx)/2,gy=(My+my)/2;
    for (int k=0; gx+k<=Mx || gx-k>=mx || gy+k<=My || gy-k>=my; k++)
    {
     for (int l=0; l<=k*2; l++)
      {
              //optim - check if to4ka e izvun obseg; used na to4kite
              check(gx-k+l,gy-k);
              check(gx-k,gy-k+l);
              check(gx+k,gy-k+l);
              check(gx-k+l,gy+k);
//              pause;
      }
      if (clock()>TLE) break;
   }
    FILE *of=fopen("fence3.out","w");
    fprintf(of,"%.1lf %.1lf %.1lf\n",(double)tx/10.,(double)ty/10.,tans/10.);
    fclose(of);
    
    return 0;
}
