/*
ID: pascala1
PROG: frameup
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,H,W;
string a[32];
pair<PI,pair<int,int> > r[32];
int big[32];
bool M[32][32];
VI ans,come[32];
VI adj[32];
bool u[32];
VS res;

void dfs(int v)
{
     u[v]=1;
     Repi(adj[v].SZ)
      if (!u[adj[v][i]])
       dfs(adj[v][i]);
     ans.PB(v);  
}

int TLE=(double)0.97*(double)CLOCKS_PER_SEC;

inline bool stava(string &s)
{
     int used=0,j;
     for (int i=s.SZ-1; i>=0; i--)
     {
      j=s[i]-'A';
      if ((big[j]|used)!=used) return 0;
      used|=1<<j;
     }
     return 1;
}

int Big(int v)
{
    if (big[v]>-1) return big[v];
    big[v]=0;
    Repi(adj[v].SZ)
     big[v]|=(1<<adj[v][i])|Big(adj[v][i]);
    return big[v]; 
}

int used,Let[32];
string let,s;
void doitbaby(int pos)
{
     if (pos==n)
      {
                res.PB(s);
                return;
      }
     Repi(n) 
      if (!(used&(1<<Let[i])) && (big[Let[i]]|used)==used)
       {
                         s[pos]=let[i];
                         used^=1<<Let[i];
                         doitbaby(pos+1);
                         used^=1<<Let[i];
       }
}

int main()
{
    int i,j,k,l;
    ifstream f("frameup.in");
    f>>H>>W;
    Repi(H) f>>a[i];
    f.close();
    
    Repi(30) { r[i]=MP(MP(1000,1000),MP(-1,-1)); M[i][i]=1; }
    Repi(H)
     Repj(W)
      if (a[i][j]!='.')
       {
                       r[a[i][j]-'A'].x.x<?=i;
                       r[a[i][j]-'A'].x.y<?=j;
                       r[a[i][j]-'A'].y.x>?=i;
                       r[a[i][j]-'A'].y.y>?=j;
       }
       
    Repi(27)
     if (r[i].x.x<1000)
      {
                       adj[27].PB(i);
                 //      cout<<(char)(i+'A')<<" <- \n";
                       int X,Y;
                       for (int j=r[i].x.x; j<=r[i].y.x; j++)
                        {
                                X=j; Y=r[i].x.y; 
                                if (!M[a[X][Y]-'A'][i]) { M[a[X][Y]-'A'][i]=1; adj[a[X][Y]-'A'].PB(i);  come[i].PB(a[X][Y]-'A');
                    //               cout<<" "<<a[X][Y]<<endl;
                                 } 
                                Y=r[i].y.y; 
                                if (!M[a[X][Y]-'A'][i]) { M[a[X][Y]-'A'][i]=1; adj[a[X][Y]-'A'].PB(i); come[i].PB(a[X][Y]-'A'); 
                    //               cout<<" "<<a[X][Y]<<endl;
                                 } 
                        }
                       for (int j=r[i].x.y; j<=r[i].y.y; j++)
                        {
                                Y=j; X=r[i].x.x; 
                                if (!M[a[X][Y]-'A'][i]) { M[a[X][Y]-'A'][i]=1; adj[a[X][Y]-'A'].PB(i); come[i].PB(a[X][Y]-'A');
                      //             cout<<" "<<a[X][Y]<<endl;
                                 } 
                                X=r[i].y.x; 
                                if (!M[a[X][Y]-'A'][i]) { M[a[X][Y]-'A'][i]=1; adj[a[X][Y]-'A'].PB(i); come[i].PB(a[X][Y]-'A');
                      //             cout<<" "<<a[X][Y]<<endl;
                                 } 
                        }
      }
      
//    pause;
/*
    Repi(27)
     sort(ALL(adj[i]));
    dfs(27);*/
    memset(big,255,sizeof(big));
    Repi(27) Big(i);
/*    
    string ANS;
    Repi(ans.SZ-1) ANS+=(char)(ans[i]+'A');
//    Repi(ANS.SZ) cout<<big[ANS[i]-'A']<<endl;
    
/*    string perm;
    Repi(26) if (r[i].x.x<1000) perm+=(char)(i+'A');
    do
     if (stava(perm)) res.PB(perm);
    while (next_permutation(ALL(perm)) && clock()<=TLE);
*/

     n=0;
     Repi(26) if (r[i].x.x<1000) { n++; let+=(char)(i+'A'); Let[n-1]=i; s+=' '; }
    doitbaby(0);
    
    ofstream of("frameup.out");
 /*   if (clock()>TLE)
     of<<ANS<<"\n";
    else*/
     {
       Repi(res.SZ)
        of<<res[i]<<"\n";
     }
    of.close();
    
 //   pause;
    
    return 0;
}
