/*
ID: pascala1
PROG: kimbits
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
unsigned int d[32][32];

int rec(int N,int L)
{
    if (N==1) if (L==0) return 1; else return 2;
    if (L==0) return 1;
    if (L<0) return 0;
    unsigned int &r=d[N][L];
    if (r!=(unsigned int)(-1)) return r;
    r=rec(N-1,L)+rec(N-1,L-1);
    return r;
}

int main()
{
    unsigned int i,j,k,l,N,L,I;
   ifstream f("kimbits.in");
   f>>N>>L>>I;
   f.close();
   string s;
   memset(d,255,sizeof(d));
//   cin>>I;
   for (int i=N-1; i>=1; i--)
   {
  //  cout<<i<<" "<<I<<" "<<L<<" "<<rec(i,L)<<endl;
    if (rec(i,L)<I) { s+="1"; I-=rec(i,L); L--;  } else s+="0";
   }
 //  cout<<i<<" "<<I<<" "<<L<<" "<<rec(i,L)<<endl;
   if (I==2) s+="1"; else s+="0";
  // cout<<s<<endl;  pause;
   
   ofstream of("kimbits.out");
   of<<s<<"\n";
   of.close();

    return 0;
}
