/*
ID: pascala1
PROG: latin
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m; long long ans;
bool ur[8][8],uc[8][8];
char a[8][8];

void gen(char row,char col)
{
//     cout<<(int)row<<" "<<(int)col<<endl;
     if (row==n)
      {
                ans++;
           //     Repi(n) {
           //      Repj(n) cout<<(int)a[i][j]<<" "; cout<<endl;}
           //     cout<<endl;
                return;
      }
     if (col==n) { 
                  gen(row+1,0); 
                  return; }
     Repi(n)
      if (!uc[col][i] && !ur[row][i])
      {
       uc[col][i]=1; ur[row][i]=1;
       a[row][col]=i+1;
       gen(row,col+1);
       uc[col][i]=0; ur[row][i]=0;
      }
}

int main()
{
    int i,j,k,l;
    ifstream f("latin.in");
    f>>n;
    f.close();
    
    Repi(n)
     { a[0][i]=i+1; ur[0][i]=1; uc[i][i]=1; }
     
    if (n<6)
     gen(1,0); 
    else
     ans=(1128960LL)*(n==6)+(12198297600LL)*(n==7);
    
    ofstream of("latin.out");
    of<<ans<<"\n";
    of.close();
    
    return 0;
}
