/*
ID: pascala1
PROG: milk4
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,Q,P,p[128],u[20100],added[20100],br[20100],prev[20100];
int A[20100],B[20100],ca,cb;

bool better(int a,int b)
{
     ca=0; cb=0;
     while (a!=0) { A[ca++]=added[a]; a=prev[a]; }
     while (b!=0) { B[cb++]=added[b]; b=prev[b]; }
     Repi(ca) if (A[i]<B[i]) return 1; else if (A[i]>B[i]) return 0;
     return 0;
}

int main()
{
    int i,j,k,l,cur;
    ifstream f("milk4.in");
    f>>Q>>P;
    Repi(P) f>>p[i];
    f.close();
    sort(p,p+P);
    int *pp=unique(p,p+P);
    P=pp-p;

    memset(br,127,sizeof(br));
    u[0]=1; br[0]=0;
    for (int k=P-1; k>=0; k--)
     for (int j=0; j<Q; j++)
      if (u[j])
       for (int d=1;;d++)
        {
               cur=j+d*p[k];
               if (cur>Q) break;
               if (
                   br[cur]>br[j]+1 || 
                   (br[cur]==br[j]+1 && (k<added[cur] || (k==added[cur] && better(j,prev[cur])))) 
                  )
                {
                                 //    cout<<cur<<"="<<j<<"+"<<p[k]<<"*"<<d<<endl;
                                     prev[cur]=j;
                                     added[cur]=k;
                                     br[cur]=br[j]+1;
                                     u[cur]=1;
                }
        }
    //pause;
        
    better(Q,Q);
    VI ans;
    Repi(ca) ans.PB(p[A[i]]);
    ofstream of("milk4.out");
    of<<ans.SZ<<" ";
    Repi(ans.SZ-1) of<<ans[i]<<" "; of<<ans[ans.SZ-1]<<"\n";
    of.close();
    
       
    return 0;
}
