//permutations; bfs with hash indices
/*
ID: pascala1
PROG: msquare
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,a[8],t[8],r[8],tt,tt1,end,start;

bool u[50000];
int q[50000],come[50000],lev[50000]; char trans[50000];

vector<int> perm;

inline int yey(int t[])
{
                int v=0;
                Repi(8) { v*=10; v+=t[i]; }
                return v;
       }

inline int id(int t[])
{ return (lower_bound(ALL(perm),yey(t))-perm.begin()); }

inline void yeey(int v,int t[])
{
       v=perm[v];
       Repi(8) { t[8-i-1]=v%10; v/=10; }
       }

void rec(int pos)
{
     if (pos==8)
     {
                perm.PB(yey(a));
                return;
     }
     Repi(8)
      if (!u[i+1])
       {
                  u[i+1]=true;
                  a[pos]=i+1;
                  rec(pos+1);
                  u[i+1]=false;
                 }
 }

const int X[4][8]={
      {7,6,5,4,3,2,1,0},
      {3,0,1,2,5,6,7,4},
      {0,6,1,3,4,2,5,7}
};

string history(int v)
{
       string s; int v1,tt,t[8];
    while (v!=start)
    {
          s+=trans[v];
          v1=come[v];
          tt=0;  Repi(7) { t[6-i]=v&7; tt+=v&7; v>>=3; } t[7]=28-tt;
//          Repi(4) cout<<t[i]; cout<<endl; Repi(4) cout<<t[i+4]; cout<<endl;  cout<<endl;
          v=v1;
    }
    return s;

}

int main()
{
    int i,j,k,l;
    rec(0);
    
    ifstream f("msquare.in");
    Repi(8) f>>a[i];
    Repi(8) t[i]=i+1;
    start=id(t);
    end=id(a);
    f.close();
    
    memset(u,0,sizeof(u));
    u[start]=true;
    come[start]=-1;
    q[0]=start;
    int v; bool found=false;
    for (int s=0,e=1; s<e; s++)
    {
        yeey(q[s],t);
       // Repi(8) cout<<t[i]; cout<<endl; pause;
        
        Repi(3)
        {
          Repj(8) r[j]=t[X[i][j]];
          v=id(r);
          if (!u[v])
           {
                    lev[v]=lev[q[s]]+1;
                    come[v]=q[s];
                    trans[v]=i+'A';
                    u[v]=true;
                    if (v==end) {found=true; break;}
                    q[e++]=v;
           }
        }
        if (found) break;
    }
    
//    cout<<lev[end]<<endl; 
//    cout<<history(end)<<endl; pause;

    ofstream of("msquare.out");
    of<<lev[end]<<"\n";
    string s=history(end);
    reverse(ALL(s));
    if (s.SZ==0) of<<"\n";
    Repi(s.SZ)
     {
              of<<s[i];
              if ((i+1)%60==0 || i==s.SZ-1) of<<"\n";
              }
    of.close();

    return 0;
}
