/*
ID: pascala1
PROG: msquare
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,a[8],end,start;

    char trans[(1<<21)];
    int come[(1<<21)];
    int q[(1<<21)],lev[(1<<21)],alev=INF;
    
string history(int v)
{
       string s; int v1,tt,t[8];
    while (v!=start)
    {
          s+=trans[v];
          v1=come[v];
          tt=0;  Repi(7) { t[6-i]=v&7; tt+=v&7; v>>=3; } t[7]=28-tt;
//          Repi(4) cout<<t[i]; cout<<endl; Repi(4) cout<<t[i+4]; cout<<endl;  cout<<endl;
          v=v1;
    }
    return s;

}

int main()
{
    int i,j,k,l;
    ifstream f("msquare.in");
    Repi(8)
     { f>>a[i]; a[i]--; }
    reverse(a+4,a+8);
    Repi(7)
     { end<<=3; end+=a[i]; }
    f.close();
    

    memset(trans,255,sizeof(trans)); int v1,v2,v3,t[8],r[8],v,tt,tt2;
    q[0]=5+(6<<3)+(7<<6)+(3<<9)+(2<<12)+(1<<15);  start=q[0];
//q[0]=end;
 //   swap(end,q[0]);
    trans[q[0]]='M'; come[q[0]]=-1; lev[q[0]]=0;
    for (int s=0,e=1; s<e; s++)
    {
        tt=0; v=q[s]; Repi(7) { t[6-i]=v&7; tt+=v&7; v>>=3; } t[7]=28-tt;
        memcpy(r,t,sizeof(r));      Repi(4) swap(r[i],r[i+4]);
        v1=0; Repi(7) { v1<<=3; v1+=r[i]; }
        memcpy(r,t,sizeof(r));   tt=r[3]; tt2=r[7];   for (int i=3; i>0; i--) { r[i]=r[i-1]; r[i+4]=r[i+3]; } r[0]=tt; r[4]=tt2;
        v2=0; Repi(7) { v2<<=3; v2+=r[i]; }
        memcpy(r,t,sizeof(r));   tt=r[5]; r[5]=r[6]; r[6]=r[2]; r[2]=r[1]; r[1]=tt;
        v3=0; Repi(7) { v3<<=3; v3+=r[i]; }
        if (trans[v1]==(char)255) { q[e++]=v1; lev[v1]=lev[q[s]]+1; come[v1]=q[s]; trans[v1]='A'; 
       // if (v1==end) break;
        }
        if (trans[v2]==(char)255) { q[e++]=v2; lev[v2]=lev[q[s]]+1; come[v2]=q[s]; trans[v2]='B';
      //  if (v2==end) break;
        }
        if (trans[v3]==(char)255) { q[e++]=v3; lev[v3]=lev[q[s]]+1; come[v3]=q[s]; trans[v3]='C';
      //  if (v3==end) break;
        }
  //      Repi(8) cout<<r[i]; cout<<endl;
    }
    string s=history(end);
    reverse(ALL(s));    

    cout<<lev[end]<<endl;
    cout<<s<<endl;
     pause;

    ofstream of("msquare.out");
    of<<lev[end]<<"\n";
    Repi(s.SZ)
    { of<<s[i]; if ((i+1)%60==0 || i==s.SZ-1) of<<"\n"; }
    of.close();
    

    return 0;
}
