/*
ID: pascala1
PROG: msquare
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,a[8],end,start,r[8],t[8],tt,tt2,v1,v2,v3;

string s;
bool found;

bool u[(1<<21)];

void dfs(int lev,int v)
{
        if (lev==n)
         {
                   if (v==end)
                    found=true;
                   return;
         }
        int V=v; 
        u[V]=true;
        tt=0; Repi(7) { t[6-i]=v&7; tt+=v&7; v>>=3; } t[7]=28-tt;
        
//if (n==8 && s.substr(0,7)=="BCABCCB") {cout<<" "<<lev<<" ";        Repi(8)         cout<<t[i]; cout<<endl; pause;}
//if (u[791870]) { cout<<lev<<" "<<n<<" "<<V<<endl;  Repi(8)         cout<<t[i]; cout<<endl; found=true; return;}

        memcpy(r,t,sizeof(r));      Repi(4) swap(r[i],r[i+4]);
        int v1=0; Repi(7) { v1<<=3; v1+=r[i]; }
        memcpy(r,t,sizeof(r));   tt=r[3]; tt2=r[7];   for (int i=3; i>0; i--) { r[i]=r[i-1]; r[i+4]=r[i+3]; } r[0]=tt; r[4]=tt2;
        int v2=0; Repi(7) { v2<<=3; v2+=r[i]; }
        memcpy(r,t,sizeof(r));   tt=r[5]; r[5]=r[6]; r[6]=r[2]; r[2]=r[1]; r[1]=tt;
        int v3=0; Repi(7) { v3<<=3; v3+=r[i]; }

        if (!u[v1])
        {
                   s[lev]='A';
                   dfs(lev+1,v1);
                   if (found) return;
        }
        if (!u[v2])
        {
                   s[lev]='B';
                   dfs(lev+1,v2);
                   if (found) return;
        }
        if (!u[v3])
        {
                   s[lev]='C';
                   dfs(lev+1,v3);
                   if (found) return;
        }
        u[V]=false;
}

int main()
{
    int i,j,k,l;
    ifstream f("msquare.in");
    Repi(8)
     { f>>a[i]; a[i]--; }
    reverse(a+4,a+8);
    Repi(7)
     { end<<=3; end+=a[i]; }
    f.close();
    

    start=5+(6<<3)+(7<<6)+(3<<9)+(2<<12)+(1<<15);
    s.resize(10000);
    for (n=0; !found;n++)
    { memset(u,0,sizeof(u));
     dfs(0,start); }
    // pause;

    ofstream of("msquare.out");
    of<<n-1<<"\n";
    Repi(n-1)
    { of<<s[i]; if ((i+1)%60==0 || i==n-2) of<<"\n"; }
    if (n<=1) of<<"\n";
    of.close();
    

    return 0;
}
