/*
ID: pascala1
PROG: packrec
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;

PI r[6];
PI A[6],B[6];
bool u[6];
PI tek;
int ans=INF;
vector<PI> Ans;
int tmp1,tmp2;

inline bool isok(int v)
{
       Repi(v)
       {
        tmp1=max(abs(A[v].x-B[i].x),abs(A[i].x-B[v].x));
        tmp2=max(abs(A[v].y-B[i].y),abs(A[i].y-B[v].y));
        if (tmp1<B[v].x-A[v].x+B[i].x-A[i].x && tmp2<B[v].y-A[v].y+B[i].y-A[i].y) return false;
       }
       return true;
}

void put(int v)
{
if (v==4)
{
tmp1=INF; tmp2=0;
Repi(v) tmp1=min(tmp1,A[i].x);
Repi(v) tmp2=max(tmp2,B[i].x);
tek.x=tmp2-tmp1;
tmp1=INF; tmp2=0;
Repi(v) tmp1=min(tmp1,A[i].y);
Repi(v) tmp2=max(tmp2,B[i].y);
tek.y=tmp2-tmp1;
if (tek.x>tek.y) swap(tek.x,tek.y);
if (tek.x*tek.y>ans) return;
if (tek.x*tek.y==ans) Ans.PB(tek);
else { ans=tek.x*tek.y; Ans.clear(); Ans.PB(tek); }
/*
cout<<" rectangles: \n";
Repi(v) cout<<A[i].x<<" "<<A[i].y<<" ; "<<B[i].x<<" "<<B[i].y<<endl;
cout<<endl;
return;
*/
         }
/*     
cout<<" rectangles: \n";
Repi(v) cout<<A[i].x<<" "<<A[i].y<<" ; "<<B[i].x<<" "<<B[i].y<<endl;
cout<<endl;
*/
     
Repj(4)
if (!u[j])
{
     u[j]=true;
     Repk(2)
     {
            if (v==0)
             {
                     A[0]=MP(0,0);
                     B[0]=MP(r[j].x,r[j].y);
                     put(v+1);
             }
            else
               Repi(v)
                {
                      A[v]=MP(B[i].x,A[i].y);
                      B[v]=MP(B[i].x+r[j].x,A[i].y+r[j].y);
                      if (isok(v)) put(v+1);
                      A[v]=MP(A[i].x,B[i].y);
                      B[v]=MP(A[i].x+r[j].x,B[i].y+r[j].y);
                      if (isok(v)) put(v+1);
                      A[v]=MP(B[i].x,B[i].y);
                      B[v]=MP(B[i].x+r[j].x,B[i].y+r[j].y);
                      if (isok(v)) put(v+1);
                      A[v]=MP(B[i].x-r[j].x,B[i].y);
                      B[v]=MP(B[i].x,B[i].y+r[j].y);
                      if (isok(v)) put(v+1);
                      A[v]=MP(B[i].x,B[i].y-r[j].y);
                      B[v]=MP(B[i].x+r[j].x,B[i].y);
                      if (isok(v)) put(v+1);
                }
            swap(r[j].x,r[j].y);
     }
     u[j]=false;
}
}

int main()
{
    int i,j,k,l;
    ifstream f("packrec.in");
    Repi(4) f>>r[i].x>>r[i].y;
    f.close();

    put(0);
    
    ofstream of("packrec.out");
    of<<ans<<"\n";
    sort(ALL(Ans));
    vector<PI>::IT it=unique(ALL(Ans));
    Ans.resize(it-Ans.begin());
    Repi(Ans.SZ) of<<Ans[i].x<<" "<<Ans[i].y<<"\n";
    of.close();
//    pause;
    return 0;
}
