/*
ID: pascala1
PROG: picture
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;
#define sint short int
int n,m;
struct rect{sint x1,y1,x2,y2; bool up; 
inline rect(){};
inline rect(sint xx1,sint yy1,sint xx2,sint yy2,bool uup){x1=min(xx1,xx2);y1=min(yy1,yy2);x2=max(xx1,xx2);y2=max(yy1,yy2);up=uup;}
};
typedef rect line;

rect a[5100];
line hor[800100],ver[800100];
int hc,vc;

bool operator<(rect a,rect b)
{
	if (a.x1==b.x1)
	 if (a.y1==b.y1)
	  if (a.x2==b.x2)
	   return a.y2<b.y2;
	  else return a.x2<b.x2;
	 else return a.y1<b.y1;
	else return a.x1<b.x1;
}

bool cmp(rect a,rect b)
{
	if (a.y1==b.y1)
	 if (a.x1==b.x1)
	  if (a.y2==b.y2)
	   return a.x2<b.x2;
	  else return a.y2<b.y2;
	 else return a.x1<b.x1;
	else return a.y1<b.y1;
}

int main()
{
    int i,j,k,l;
    ifstream f("picture.in");
    f>>n;
    Repi(n)
     {
       f>>a[i].x1>>a[i].y1>>a[i].x2>>a[i].y2;
       hor[hc++]=line(a[i].x1,a[i].y1,a[i].x2,a[i].y1,0);
       hor[hc++]=line(a[i].x1,a[i].y2,a[i].x2,a[i].y2,1);
       ver[vc++]=line(a[i].x1,a[i].y1,a[i].x1,a[i].y2,0);
       ver[vc++]=line(a[i].x2,a[i].y1,a[i].x2,a[i].y2,1);
	 }
    f.close();
    
	cout<<(double)clock()/(double)CLOCKS_PER_SEC<<" "<<vc<<" "<<hc<<" "<<endl;
    sort(a,a+n);
    Repi(hc)
     Repj(n)
      {
			if (a[j].x1>=hor[i].x2) break;
			if (a[j].y1>=hor[i].y2 || a[j].y2<=hor[i].y1 || a[j].x2<=hor[i].x1) continue;
			int l1=a[j].x1-hor[i].x1,l2=hor[i].x2-a[j].x2;
			int x2=hor[i].x2;
			int nw=-1;
			if (l1>0)
			 { hor[i].x2=hor[i].x1+l1; nw=hc; }
			else nw=i;
			if (nw>-1)
			 if (l2>0 && l2<x2-hor[i].x1)
			  { hor[nw]=line(x2-l2,hor[i].y1,x2,hor[i].y2,hor[i].up);
			    hc+=(nw==hc);
			    i-=(nw==i);
			  }
			 else hor[nw]=line(-1,-1,-1,-1,0); 
	  }
	cout<<(double)clock()/(double)CLOCKS_PER_SEC<<" "<<vc<<" "<<hc<<" "<<endl;
	sort(hor,hor+hc);
	int br=0;
//	Repi(hc) cout<<hor[i].x1<<" "<<hor[i].y1<<" "<<hor[i].x2<<" "<<hor[i].y2<<" - "<<hor[i].up<<endl; cout<<endl;
	Repi(hc)
	 for (int j=i+1;j<hc;j++)
	  if (hor[j].x1<=hor[i].x2 && (hor[i].x1!=hor[i].x2 || hor[i].y1!=hor[i].y2))
	   {
			if (hor[j].y1==hor[i].y1 && hor[j].x1>=hor[i].x1 && (hor[j].x1!=hor[j].x2 || hor[j].y1!=hor[j].y2))
			 if (hor[i].up==hor[j].up)
			  {
			   hor[i].x2>?=hor[j].x2;
			   hor[j].x2=hor[j].x1;
			  }
			 else
			  {
			   sint ix2=hor[i].x2;
			   hor[i].x2=hor[j].x1;
			   hor[j].x1=min(ix2,hor[j].x2);
			   hor[j].x2=max(ix2,hor[j].x2);
			  }
	   }
	  else break;
	  
//	Repi(hc) cout<<hor[i].x1<<" "<<hor[i].y1<<" "<<hor[i].x2<<" "<<hor[i].y2<<endl; cout<<endl;
	cout<<(double)clock()/(double)CLOCKS_PER_SEC<<" "<<vc<<" "<<hc<<" "<<endl;

    sort(a,a+n,cmp);
    Repi(vc)
     Repj(n)
      {
			if (a[j].y1>=ver[i].y2) break;
			if (a[j].x1>=ver[i].x2 || a[j].x2<=ver[i].x1 || a[j].y2<=ver[i].y1) continue;
			int l1=a[j].y1-ver[i].y1,l2=ver[i].y2-a[j].y2;
			int y2=ver[i].y2;
			int nw=-1;
			if (l1>0)
			 { ver[i].y2=ver[i].y1+l1; nw=vc; }
			else nw=i;
			if (nw>-1)
			 if (l2>0 && l2<y2-ver[i].y1)
			  { ver[nw]=line(ver[i].x1,y2-l2,ver[i].x2,y2,ver[i].up);
			    vc+=(nw==vc);
			    i-=(nw==i);
			  }
			 else ver[nw]=line(-1,-1,-1,-1,0); 
	  }
	cout<<(double)clock()/(double)CLOCKS_PER_SEC<<" "<<vc<<" "<<hc<<" "<<endl;
	sort(ver,ver+vc,cmp);
//	Repi(vc) cout<<ver[i].x1<<" "<<ver[i].y1<<" "<<ver[i].x2<<" "<<ver[i].y2<<endl; cout<<endl;
	Repi(vc)
	 for (int j=i+1;j<vc;j++)
	  if (ver[j].y1<=ver[i].y2 && (ver[i].x1!=ver[i].x2 || ver[i].y1!=ver[i].y2))
	   {
			if (ver[j].x1==ver[i].x1 && ver[j].y1>=ver[i].y1 && (ver[j].x1!=ver[j].x2 || ver[j].y1!=ver[j].y2))
			 if (ver[i].up==ver[j].up)
			  {
			   ver[i].y2>?=ver[j].y2;
			   ver[j].y2=ver[j].y1;
			  }
			 else
			  {
			   sint iy2=ver[i].y2;
			   ver[i].y2=ver[j].y1;
			   ver[j].y1=min(iy2,ver[j].y2);
			   ver[j].y2=max(iy2,ver[j].y2);
			  }
	   }
	  else break;
        
//	Repi(vc) cout<<ver[i].x1<<" "<<ver[i].y1<<" "<<ver[i].x2<<" "<<ver[i].y2<<endl; cout<<endl;
	cout<<(double)clock()/(double)CLOCKS_PER_SEC<<" "<<vc<<" "<<hc<<" "<<endl;
	
	int ans=0;
	Repi(hc) ans+=hor[i].x2-hor[i].x1;
	Repi(vc) ans+=ver[i].y2-ver[i].y1;
	
	cout<<ans<<endl;
	pause;
	
	ofstream of("picture.out");
	of<<ans<<"\n";
	of.close();
    return 0;
}
