/*
ID: pascala1
PROG: runround
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,a[16],t[16];

bool found,u[16],u1[16];

inline bool check()
{
       memset(u1,0,sizeof(u1));
       int i=0;
       Repk(n)
       {
               u1[i]=true;
               i=(i+t[i])%n;
       }
       if (i!=0) return false;
       Repi(n) if (!u1[i]) return false;
       return true;
}

void rec(int pos)
{
     if (pos==n)
      {
                if (check()) found=true;
                return; 
      }
     for (int i=a[pos]; i<10; i++)
      if (!u[i])
       {
                u[i]=true;
                t[pos]=i;
                rec(pos+1);
                if (found) return;
                u[i]=false;
       }
     
     a[pos]=1;
}

int main()
{
    int i,j,k,l;
    ifstream f("runround.in");
    f>>m;
    m++;
    while (m>0)
    {
          a[n++]=m%10;
          m/=10;
    }
    reverse(a,a+n);
    f.close();
    
    rec(0);
    if (!found)
    {
     n++;
     Repi(n) a[i]=i+1;
     rec(0);
    }
    
    ofstream of("runround.out");
    Repi(n)
     of<<t[i]; of<<"\n";
    of.close();

    return 0;
}
