/*
ID: pascala1
PROG: shuttle
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;

map<int,int> come,pr;

inline int code(char t[])
{
    int hole,ans=0;
    Repi(2*n+1)
    {
      ans<<=1;
      if (t[i]=='B') ans|=1;
      if (t[i]==' ') hole=i;
    }
    ans|=hole<<(2*n+1);
    return ans;
}

inline int decode(int state,char t[])
{
     int hole=state>>(2*n+1);
     Repi(2*n+1)
      if (state&(1<<i))
       t[2*n-i]='B';
      else t[2*n-i]='W';
     t[hole]=' '; 
     return hole;
}

#define MAXQ 1000000
int q[MAXQ];

void lineino(VI &ans,int dir)
{
    int l=0; int ml=0; int m=n;
    Repi(n*(n+2))
    {
                 if (l==ml)
                  {
                    m+=dir;
                    dir*=-1;
                    ml++;
                    if (ml>n) break;
                    l=0;
                    ans.PB(m+1);
                  }
                 else
                  {
                    m+=2*dir;
                    l++;
                    ans.PB(m+1);
                  } 
    }
}

int main()
{
    int i,j,k,l,en;
    ifstream f("shuttle.in");
    f>>n;
    f.close();
/*
    char t[100];
    memset(t,0,sizeof(t));
    t[n]=' ';
    Repi(n) t[i]='B'; Repi(n) t[i+n+1]='W';
    en=code(t);
    Repi(n) t[i]='W'; Repi(n) t[i+n+1]='B';
    q[0]=code(t);
    
    map<int,int>::IT it;
    int s,e;
    pr[q[0]]=-1;
    come[q[0]]=-1;
    for (s=0,e=1; s!=e; s++)
    {
        if (s==MAXQ) s=0;
     //   l=decode(pr[q[s]],t);
    //    cout<<pr[q[s]]<<": ";
    //    Repi(n*2+1) cout<<t[i]; cout<<" -> ";
        l=decode(q[s],t);
    //    Repi(n*2+1) cout<<t[i]; cout<<endl; pause;
        if (l>0)
         {
                swap(t[l],t[l-1]);
                k=code(t);
                if ((it=come.find(k))==come.end()) { come.insert(MP(k,l-1)); pr.insert(MP(k,q[s])); q[e++]=k; }
                if (q[e-1]==en) break;
                if (e>=MAXQ) e=0;
                swap(t[l],t[l-1]);
         }
        if (l>1 && t[l-1]!=t[l-2]) 
         {
                swap(t[l],t[l-2]);
                k=code(t);
                if ((it=come.find(k))==come.end()) { come.insert(MP(k,l-2)); pr.insert(MP(k,q[s])); q[e++]=k; }
                if (q[e-1]==en) break;
                if (e>=MAXQ) e=0;
                swap(t[l],t[l-2]);
         }
        if (l<2*n)
         {
                swap(t[l],t[l+1]);
                k=code(t);
                if ((it=come.find(k))==come.end()) { come.insert(MP(k,l+1)); pr.insert(MP(k,q[s])); q[e++]=k; }
                if (q[e-1]==en) break;
                if (e>=MAXQ) e=0;
                swap(t[l],t[l+1]);
         }
        if (l<2*n-1 && t[l+1]!=t[l+2]) 
         {
                swap(t[l],t[l+2]);
                k=code(t);
                if ((it=come.find(k))==come.end()) { come.insert(MP(k,l+2)); pr.insert(MP(k,q[s])); q[e++]=k; }
                if (q[e-1]==en) break;
                if (e>=MAXQ) e=0;
                swap(t[l],t[l+2]);
         }
    }
    
    l=en;
    VI ans;
    while (l!=-1)
    {
          decode(l,t);
      //    Repi(2*n+1) cout<<t[i]; cout<<endl;
          ans.PB(come[l]+1);
          l=pr[l];
    }
    reverse(ALL(ans));
    Repi(ans.SZ-1) cout<<ans[i+1]<<" "; cout<<endl;
*/    
    
    VI ans1,ans2;
    lineino(ans1,-1);
    lineino(ans2,1);
    l=ans1.SZ; i=0;
    while (ans1.SZ<n*(n+2)-1) ans1.PB(ans2[i++]);
    reverse(ans1.begin()+l,ans1.end());
    ans1.PB(n+1);
//    Repi(ans1.SZ) cout<<ans1[i]<<" "; cout<<endl;
//    pause;
    
    ofstream of("shuttle.out");
    Repi(ans1.SZ)
     {
                 of<<ans1[i];
                 if (i%20==19 || i==ans1.SZ-1) of<<"\n";
                 else of<<" ";
     }
    of.close();
    
    return 0;
}
