/*
ID: pascala1
PROG: spin
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;

int V[6],c[6],st[6][6],ex[6][6];

inline void cut(int &s,int &e,int s1,int e1)
{ s1%=360; e1%=360;
  if (s1<=e1 && s<=e) { s=max(s,s1); e=min(e,e1); if (e<s) {s=-1; e=-1;} return; }
  if (s1>e1 && s>e) { s=max(s,s1); e=min(e,e1); return; }
  if (s1<=e1 && s>e) { swap(s1,s); swap(e1,e); }
  if (s1>e1 && s<=e)
  {
            if (s1>=s && s1<=e) { s=s1; return;  }
            if (e1>=s && e1<=e) { e=e1; return; }
            if (s>e1 && e<s1) { s=-1; e=-1; return; }
            e=e1; s=s1;
  }
  s=-1; e=-1; 
}

int I[6];

inline bool check()
{
       int s=0,e=360;
       for (I[0]=0; I[0]<c[0]; I[0]++)
        for (I[1]=0; I[1]<c[1]; I[1]++)
         for (I[2]=0; I[2]<c[2]; I[2]++)
          for (I[3]=0; I[3]<c[3]; I[3]++)
           for (I[4]=0; I[4]<c[4]; I[4]++)
            {
                    s=st[0][I[0]]; e=(st[0][I[0]]+ex[0][I[0]])%360;
                    for (int n=1; n<5; n++) 
                    {
                     cut(s,e,st[n][I[n]],(st[n][I[n]]+ex[n][I[n]])%360);
            //         cout<<s<<" "<<e<<endl;
                      if (s==-1) break;
                                          } 
           //                               cout<<endl; 
                    if (s!=-1) return true;
            }
       return false;     
} 

int main()
{
    int k,l;
    ifstream f("spin.in");
    Repi(5)
    {
           f>>V[i]; f>>c[i];
           Repj(c[i]) f>>st[i][j]>>ex[i][j];
           }
    f.close();
    
    int ans=0,big=100000;
    for (;ans<big; ans++)
    {
        //cout<<ans<<endl;
        if (check()) break;
        Repi(5)
         Repj(c[i])
          { st[i][j]+=V[i];
          st[i][j]%=360; }
    }
  //  pause;
    
    ofstream of("spin.out");
    if (ans==big) of<<"none\n";
    else of<<ans<<"\n";
    of.close();


    return 0;
}
