/*
ID: pascala1
PROG: sprime
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,a;

inline bool isprime(int v)
{
       if (v<2) return false;
       if (v%2==0 && v!=2) return false;
       for (int i=3; i*i<=v; i+=2)
        if (v%i==0) return false;
       return true; 
}

ofstream of;

void gen(int pos)
{
     if (pos==n)
      { of<<a<<"\n"; return; }
     a*=10; 
     Repi(10)
      if (isprime(a+i))
       {
                        a+=i;
                        gen(pos+1);
                        a-=i;
       }
     a/=10; 
}

int main()
{
    int i,j,k,l;
    ifstream f("sprime.in");
    f>>n;
    f.close();
    
    of.open("sprime.out");
    gen(0);
    of.close();

    return 0;
}
