/*
ID: pascala1
PROG: telecow
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,c1,c2,source,sink;
VI a[256];
int M[256][256];

int flow()
{
    int d[256],p[256],q[256],i,j,k,l,v,w,Flow=0;
    bool u[256];
    
    memset(d,INF,sizeof(d));
    memset(u,0,sizeof(u));
    q[0]=sink; d[sink]=0; u[sink]=1;
    for (int s=0,e=1; s<e; s++)
     {
             v=q[s];
             Repi(a[v].SZ)
              if (!M[v][a[v][i]] && !u[a[v][i]])
               {
                              q[e++]=a[v][i];
                              d[a[v][i]]=d[v]+1;
                              u[a[v][i]]=1;
               }
     }
//    Repi(n*2+1) cout<<d[i+1]<<" "; cout<<endl;
    v=source; p[v]=v;
    while(d[source]<n*2+3)
    {
            if (v==sink)
             {
                        k=0;
                        while (v!=source) { q[k++]=v; v=p[v]; }
                        q[k++]=v;
                        reverse(q,q+k);
              //          cout<<"path: "; Repi(k) cout<<q[i]/2<<" "; cout<<endl;
              //          cout<<"path: "; Repi(k-1) cout<<M[q[i]][q[i+1]]<<" "; cout<<endl;
                        l=INF;
                        Repi(k-1) l<?=M[q[i]][q[i+1]];
              //          cout<<"flow+= "<<l<<endl;
                        Repi(k-1) 
                         { M[q[i]][q[i+1]]-=l;
                           M[q[i+1]][q[i]]+=l;
                         }
                        Flow+=l;
                        v=source;
                        continue;
             }
            l=-1;
            Repi(a[v].SZ)
             if (M[v][a[v][i]] && d[a[v][i]]==d[v]-1) { l=a[v][i]; break; }
            if (l==-1)
             {
                      l=INF;
                      Repi(a[v].SZ)
                       if (M[v][a[v][i]]) l<?=d[a[v][i]];
                      d[v]=l+1;
                      v=p[v];
             }
            else
             {
                      p[l]=v;
                      v=l;
             } 
    }
    return Flow;
}

int main()
{
    int i,j,k,l;
    ifstream f("telecow.in");
    f>>n>>m>>c1>>c2;
    Repi(m)
     {
           f>>j>>k;
           a[j*2+1].PB(k*2);
           a[k*2].PB(j*2+1);
           M[j*2+1][k*2]=INF;
           
           a[k*2+1].PB(j*2);
           a[j*2].PB(k*2+1);
           M[k*2+1][j*2]=INF;
     }
    for (int j=1; j<=n; j++)
     {
           M[j*2][j*2+1]=n*n+j;
           a[j*2].PB(j*2+1);
           a[j*2+1].PB(j*2);
     }
    Repi(2*n+3) 
     sort(ALL(a[i]));
    source=c1*2+1;
    sink=c2*2;
    f.close();
    
    int res=flow();
//    pause;
    
    int q[256],u[256]; VI ans;
    memset(u,0,sizeof(u));
    q[0]=source; u[source]=1;
    for (int s=0,e=1; s<e; s++)
     Repi(a[q[s]].SZ)
      {
                     int v=a[q[s]][i];
                     if (M[q[s]][v] && !u[v])
                      { u[v]=1; q[e++]=v; }
      }
  //  pause;
    for (int i=1; i<=n; i++)
     if (!M[i*2][i*2+1] && u[i*2] && !u[i*2+1])
      ans.PB(i);
    
    ofstream of("telecow.out");
    of<<res/(n*n)<<"\n";
    sort(ALL(ans));
    Repi(ans.SZ-1)
     of<<ans[i]<<" ";
    of<<ans[ans.SZ-1]<<"\n";
    of.close();
    
  //  pause;
    
    return 0;
}
