/*
ID: pascala1
PROG: tour
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,ans,cur,w,ans1,source,sink,cut,curcut,broi1,broi2;
bool u[128];
string s,s1;
map<string,int> id;
VI a[128],b[128],adj[256];
bool M[128][128];
int be[128],be1[128],N[256][256];

int lp[128];
int TLE=(int)(.98*(double)CLOCKS_PER_SEC);

int pre(int v)
{
    if (lp[v]>-1) return lp[v];
    lp[v]=0;
    Repi(b[v].SZ)
     lp[v]>?=pre(b[v][i])+1;
    return lp[v];
}

bool found;
void second(char v)
{
broi2++;
     //if (clock()>TLE) return;
     if (v==0)
      {
              ans>?=cur;
              return;
      }
     be[v]=cur;
     cur++;
  //   cout<<"IN "<<(int)v+1<<" "<<cur<<endl;
     Repi(b[v].SZ)
     if (!u[b[v][i]] && lp[b[v][i]]+cur-1>ans && be[b[v][i]]<cur+2)
      second(b[v][i]);
   //  cout<<"FROM "<<(int)v+1<<" "<<cur<<endl;
     cur--;
}

void first(char v)
{
     //if (clock()>TLE) return;
broi1++;
     if (v==n-1)
      {
                second(v);
                return;
      }
     if (!N[v*2][v*2+1]) curcut++;
 //    cout<<"in "<<(int)v+1<<" "<<cur<<endl;
     if (curcut>cut) { //curcut--; 
                       return; }
     if (v>0) u[v]=1;
     cur++;
     Repi(a[v].SZ)
      if (2*lp[n-1]-lp[a[v][i]]+cur>ans+2)
       first(a[v][i]);
 //    cout<<"from "<<(int)v+1<<" "<<cur<<endl;
     cur--;
     if (!N[v*2][v*2+1]) curcut--;
     u[v]=0;
}




int flow()
{
    int d[256],p[256],q[256],i,j,k,l,v,w,Flow=0;
    bool u[256];
    
    memset(d,INF,sizeof(d));
    memset(u,0,sizeof(u));
    q[0]=sink; d[sink]=0; u[sink]=1;
    for (int s=0,e=1; s<e; s++)
     {
             v=q[s];
             Repi(adj[v].SZ)
              if (!M[v][adj[v][i]] && !u[adj[v][i]])
               {
                              q[e++]=adj[v][i];
                              d[adj[v][i]]=d[v]+1;
                              u[adj[v][i]]=1;
               }
     }
//    Repi(n*2+1) cout<<d[i+1]<<" "; cout<<endl;
    v=source; p[v]=v;
    while(d[source]<n*2+3)
    {
            if (v==sink)
             {
                        k=0;
                        while (v!=source) { q[k++]=v; v=p[v]; }
                        q[k++]=v;
                        reverse(q,q+k);
              //          cout<<"path: "; Repi(k) cout<<q[i]/2<<" "; cout<<endl;
              //          cout<<"path: "; Repi(k-1) cout<<M[q[i]][q[i+1]]<<" "; cout<<endl;
                        l=INF;
                        Repi(k-1) l<?=N[q[i]][q[i+1]];
              //          cout<<"flow+= "<<l<<endl;
                        Repi(k-1) 
                         { N[q[i]][q[i+1]]-=l;
                           N[q[i+1]][q[i]]+=l;
                         }
                        Flow+=l;
                        v=source;
                        continue;
             }
            l=-1;
            Repi(adj[v].SZ)
             if (N[v][adj[v][i]] && d[adj[v][i]]==d[v]-1) { l=adj[v][i]; break; }
            if (l==-1)
             {
                      l=INF;
                      Repi(adj[v].SZ)
                       if (N[v][adj[v][i]]) l<?=d[adj[v][i]];
                      d[v]=l+1;
                      v=p[v];
             }
            else
             {
                      p[l]=v;
                      v=l;
             } 
    }
    return Flow;
}

bool cmp(int x1,int x2)
{
     return lp[x1]<lp[x2];
 }
bool cmp1(int x1,int x2)
{
     return lp[x1]>lp[x2];
 }

int main()
{
    int i,j,k,l;
    ifstream f("tour.in");
    f>>n>>m;
    Repi(n)
     {
           f>>s;
           id[s]=i;
           adj[i*2].PB(i*2+1);
           adj[i*2+1].PB(i*2);
           N[i*2][i*2+1]=1;
     } 
    Repi(m) 
     {
            f>>s>>s1;
            k=id[s]; l=id[s1];
            if (k>l) swap(k,l);
            if (M[k][l]) continue;
            M[k][l]=1;
            a[k].PB(l);
            b[l].PB(k);
            N[k*2+1][l*2]=INF;
            adj[k*2+1].PB(l*2);
            adj[l*2].PB(k*2+1);
     }
    source=1; sink=(n-1)*2;
    f.close();
//    Repi(n) sort(ALL(b[i]),cmp);
    cut=flow();
    
    memset(lp,255,sizeof(lp));
    Repi(n)
     pre(i);
     
    /*
    Repi(n)
     {
           cout<<i+1<<" -> "<<lp[i]<<" ";
           Repj(n) cout<<reach[i][j];
           cout<<endl;
     }
    pause;
    */
  
    first(0);  
/*    int r=n; l=0;
    while (l+1<r)
     {
       ans=(l+r)/2;
       found=0; curcut=0;
       first(0);
       if (found) l=ans; else r=ans;
     }
    if (found) ans=r; else ans=l; 
*/

/*
    for (ans=n;ans>0;ans--)
    {
      found=0;
      memset(be,0,sizeof(be)); curcut=0;
      first(0);
      if (found) break;
    //  cout<<found<<" "<<ans<<" "<<cur<<" "<<curcut<<endl;
    //  Repi(n) cout<<u[i]; cout<<endl;
    //  pause;
    }
*/
    
    ofstream of("tour.out");
    if (!ans) ans=1;
    of<<ans<<endl;
    of.close();
    
    cout<<broi1<<" "<<broi2<<" "<<broi1+broi2<<endl;
    cout<<ans<<" "<<(double)clock()/(double)CLOCKS_PER_SEC<<endl; pause;
    
    return 0;
}
