/*
ID: pascala1
PROG: transform
LANG:C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;

int main()
{
    int i,j,k,l;
    ifstream f("transform.in");
    ofstream of("transform.out");
    
    VVI a,b;
    VVI v,w;
    
    f>>n; char c;
    a.resize(n); Repi(n) a[i].resize(n);
    b=a; v=a; w=a;
    Repi(n)
     Repj(n)
     {
      f>>c;
      a[i][j]=((c=='@')?1:0);
     }
    Repi(n)
     Repj(n)
     {
      f>>c;
      b[i][j]=((c=='@')?1:0);
     }
     
     int ans=0;
     
    Repi(n) Repj(n) { v[i][j]=a[n-j-1][i]; if (b==v && ans==0) ans=1;   }   Repj(n) { Repk(n) cout<<v[j][k]; cout<<endl; } cout<<endl; 
    Repi(n) Repj(n) {v[i][j]=a[n-i-1][n-j-1]; if (b==v && ans==0) ans=2;}       Repj(n) { Repk(n) cout<<v[j][k]; cout<<endl; } cout<<endl; 
    Repi(n) Repj(n) {v[i][j]=a[j][n-i-1]; if (b==v && ans==0) ans=3;   }     Repj(n) { Repk(n) cout<<v[j][k]; cout<<endl; } cout<<endl; 
    Repi(n) Repj(n) {v[i][j]=a[i][n-j-1]; if (b==v && ans==0) ans=4;  }        Repj(n) { Repk(n) cout<<v[j][k]; cout<<endl; } cout<<endl; 
    Repi(n) Repj(n) { w[i][j]=v[n-j-1][i]; if (b==w && ans==0) ans=5;  }        Repj(n) { Repk(n) cout<<w[j][k]; cout<<endl; } cout<<endl;
    Repi(n) Repj(n) {w[i][j]=v[n-i-1][n-j-1]; if (b==w && ans==0) ans=5; }       Repj(n) { Repk(n) cout<<w[j][k]; cout<<endl; } cout<<endl; 
    Repi(n) Repj(n) {w[i][j]=v[j][n-i-1]; if (b==w && ans==0) ans=5;    }     Repj(n) { Repk(n) cout<<w[j][k]; cout<<endl; } cout<<endl;
    
    if (ans==0 && a==b)  ans=6;
    if (ans==0) ans=7;
    

    of<<ans<<"\n";
    f.close();
    of.close();
//    pause;
    return 0;
}
