/*
ID: pascala1
PROG: window
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m;
char s[32],c,c1;
pair<PI,PI> A[100000],win[1000],tmp;
int pos[128],lev[1000];
int ca,can;

inline void add(pair<PI,PI> &w1)
{             if (w1.x.x<w1.y.x && w1.x.y<w1.y.y) A[ca+(can++)]=w1;  }

void intersect(pair<PI,PI> w)
{
     pair<PI,PI> W,w1;
     can=0; int k,l;
     Repi(ca)
      {
             W=A[i];
             k=min(w.x.x,W.x.x); l=max(w.y.x,W.y.x);
             if (l-k>=W.y.x-W.x.x+w.y.x-w.x.x) continue;
             k=min(w.x.y,W.x.y); l=max(w.y.y,W.y.y);
             if (l-k>=W.y.y-W.x.y+w.y.y-w.x.y) continue;

             A[i]=MP(MP(0,0),MP(0,0));

             w1=MP(MP(W.x.x,W.x.y),MP(w.x.x,w.x.y)); add(w1);
             w1=MP(MP(max(W.x.x,w.x.x),W.x.y),MP(min(W.y.x,w.y.x),w.x.y)); add(w1);
             w1=MP(MP(w.y.x,W.x.y),MP(W.y.x,w.x.y)); add(w1);
             
             w1=MP(MP(W.x.x,max(W.x.y,w.x.y)),MP(w.x.x,min(W.y.y,w.y.y))); add(w1);
             w1=MP(MP(w.y.x,max(W.x.y,w.x.y)),MP(W.y.x,min(W.y.y,w.y.y))); add(w1);
            
             w1=MP(MP(W.x.x,w.y.y),MP(w.x.x,W.y.y)); add(w1);
             w1=MP(MP(max(W.x.x,w.x.x),w.y.y),MP(min(W.y.x,w.y.x),W.y.y)); add(w1);
             w1=MP(MP(w.y.x,w.y.y),MP(W.y.x,W.y.y)); add(w1);
      }
     ca+=can;
     Repi(ca) cout<<A[i].x.x<<" "<<A[i].x.y<<" "<<A[i].y.x<<" "<<A[i].y.y<<" --- ";
     cout<<endl; 
}


int main()
{
    int i,j,k,l;
    for (c='a',i=0; c<='z'; i++,c++) pos[c]=i;
    for (c='A'; c<='Z'; i++,c++) pos[c]=i;
    for (c='0'; c<='9'; i++,c++) pos[c]=i;
    set<PI> t; int top=0,bottom=0;
    set<PI>::IT it;
    
    FILE *f=fopen("window.in","r");
    ofstream of("window.out");
    while (fscanf(f,"%s",s)!=EOF)
    {
          Repi(strlen(s)) if (s[i]==',' || s[i]=='(' || s[i]==')') s[i]=' ';
          sscanf(s,"%c",&c);
          if (c=='w')
           {
                     sscanf(s,"%c %c %d %d %d %d",&c1,&c,&tmp.x.x,&tmp.x.y,&tmp.y.x,&tmp.y.y);
                     if (tmp.x.x>tmp.y.x) swap(tmp.x.x,tmp.y.x);
                     if (tmp.x.y>tmp.y.y) swap(tmp.x.y,tmp.y.y);
                     win[pos[c]]=tmp;
                     t.insert(MP(++top,pos[c]));
                     lev[pos[c]]=top;
           }
          else
          if (c=='t')
           {
                     sscanf(s,"%c %c",&c1,&c);
                     t.erase(MP(lev[pos[c]],pos[c]));
                     t.insert(MP(lev[pos[c]]=++top,pos[c]));
           }
          else
          if (c=='b')
           {
                     sscanf(s,"%c %c",&c1,&c);
                     t.erase(MP(lev[pos[c]],pos[c]));
                     t.insert(MP(lev[pos[c]]=--bottom,pos[c]));
           }
          else
          if (c=='d')
           {
                     sscanf(s,"%c %c",&c1,&c);
                     t.erase(MP(lev[pos[c]],pos[c]));
           }
          else
          if (c=='s')
           {
                     sscanf(s,"%c %c",&c1,&c);
                     it=t.find(MP(lev[pos[c]],pos[c]));
                     A[0]=win[pos[c]]; double area=(double)(A[0].y.x-A[0].x.x)*(double)(A[0].y.y-A[0].x.y),newarea=0.;
                     ca=1;
                     cout<<"area of "<<pos[c]<<endl;
                     for (it++;it!=t.end();it++)
                      intersect(win[it->y]);
                     Repi(ca)
                      newarea+=(double)(A[i].y.x-A[i].x.x)*(double)(A[i].y.y-A[i].x.y);
                     of<<setprecision(3)<<fixed<<newarea*100./area<<"\n";
                     cout<<area<<" "<<newarea<<endl;
           }
           
          for (it=t.begin(); it!=t.end(); it++)
           cout<<it->x<<" "<<it->y<<" ; "; cout<<endl; 
          memset(s,0,sizeof(s));
    }
    fclose(f);
    of.close();
    pause;
    
    return 0;
}
