/*
ID: pascala1
PROG: wissqu
LANG: C++
*/
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <fstream>
#include <queue>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>


#define SZ size()
#define PB push_back
#define ALL(v) v.begin(),v.end()
#define MP make_pair
#define x first
#define y second

#define LL long long
#define UI unsigned int
#define ULL unsigned long long
#define PI pair<int,int>
#define PD pair<double,double>
#define PLL pair<LL,LL>
#define PULL pair<ULL,ULL>
#define VI vector<int>
#define VD vector<double>
#define VS vector<string>
#define SI set<int>
#define PQ priority_queue
#define VVI vector<vector<int> >
#define IT iterator

#define sign(a) ((a)>0)-((a)<0)
#define sqr(a) ((a)*(a))
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define Pi 3.1415926535897932384626433832795028841971693993751
#define INF 2000000000
#define EPS 1e-6

#define pause system("pause")

using namespace std;

inline int strtoint(const string &s) {stringstream ss;ss<<s;int ret;ss>>ret;return ret;}
inline string inttostr(const int &a) {stringstream ss;ss<<a;string ret;ss>>ret;return ret;}

int n,m,br,found;
char a[8][8];
struct ANS{char c; int x,y;
 ANS() {};
 ANS(char _c,int _x,int _y):c(_c),x(_x),y(_y) {};
};
int c[128];
ANS ans[17];
bool u[8][8];

void dfs(int pos)
{
     if (pos==16)
      { br++; return; }
     char C;
     for (char i='A'+(pos==0)*3; i<'F'-(pos==0); i++)
      if (c[i]>0)
       for (int j=1; j<5; j++)
        for (int k=1; k<5; k++)
         if (!u[j][k] && a[j][k]!=i && 
         a[j-1][k]!=i && a[j+1][k]!=i && a[j][k-1]!=i && a[j][k+1]!=i &&
         a[j+1][k+1]!=i && a[j+1][k-1]!=i && a[j-1][k-1]!=i && a[j-1][k+1]!=i)
          {
                       C=a[j][k];
                       a[j][k]=i;
                       c[i]--;
                       u[j][k]=1;
                       if (!br) ans[pos]=ANS(i,j,k);
                       dfs(pos+1);
                       u[j][k]=0;
                       c[i]++;
                       a[j][k]=C;
          }
}

int main()
{
    int i,j,k,l;
    FILE *f=fopen("wissqu.in","r");
    Repi(4)
     fscanf(f,"%s",a[i+1]+1);
    fclose(f);
    
    c['A']=3;
    c['B']=3;
    c['C']=3;
    c['D']=4;
    c['E']=3;
    dfs(0);
    
    f=fopen("wissqu.out","w");
    Repi(16)
     fprintf(f,"%c %d %d\n",ans[i].c,ans[i].x,ans[i].y);
    fprintf(f,"%d\n",br);
    fclose(f);
    
    printf("%.2lf\n",(double)clock()/(double)CLOCKS_PER_SEC);
    pause;
    
    return 0;
}
